/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/files/common/files","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/windows/electron-main/windows","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/theme/electron-main/themeMainService","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(H){for(var e=[],m=0,n=H.length;m<n;m++)e[m]=Z[H[m]];return e};define(Z[106],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(n,R){if(!n)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=m}),define(Z[107],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(C){return C?C.replace(/\$\((.*?)\)/g,(S,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=m;class n{constructor(S,f,E){this.id=S,this.definition=f,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function R(C,S){const f=["codicon","codicon-"+C];return S&&f.push("codicon-modifier-"+S),f}e.getClassNamesArray=R;var L;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function f(k){if(k instanceof n)return["codicon","codicon-"+k.id];const I=S.exec(k.id);if(!I)return f(n.error);let[,w,t]=I;const h=["codicon","codicon-"+w];return t&&h.push("codicon-modifier-"+t.substr(1)),h}C.asClassNameArray=f;function E(k){return f(k).join(" ")}C.asClassName=E;function P(k){return"."+f(k).join(".")}C.asCSSSelector=P})(L=e.CSSIcon||(e.CSSIcon={}))}),define(Z[46],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(C){return(S,f,E)=>{let P=null,k=null;if(typeof E.value=="function"?(P="value",k=E.value):typeof E.get=="function"&&(P="get",k=E.get),!k)throw new Error("not supported");E[P]=C(k,f)}}e.createDecorator=m;function n(C,S,f){let E=null,P=null;if(typeof f.value=="function"?(E="value",P=f.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(E="get",P=f.get),!P)throw new Error("not supported");const k=`$memoize$${S}`;f[E]=function(...I){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,I)}),this[k]}}e.memoize=n;function R(C,S,f){return m((E,P)=>{const k=`$debounce$${P}`,I=`$debounce$result$${P}`;return function(...w){this[I]||(this[I]=f?f():void 0),clearTimeout(this[k]),S&&(this[I]=S(this[I],...w),w=[this[I]]),this[k]=setTimeout(()=>{E.apply(this,w),this[I]=f?f():void 0},C)}})}e.debounce=R;function L(C,S,f){return m((E,P)=>{const k=`$throttle$timer$${P}`,I=`$throttle$result$${P}`,w=`$throttle$lastRun$${P}`,t=`$throttle$pending$${P}`;return function(...h){if(this[I]||(this[I]=f?f():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[I]=S(this[I],...h)),this[t])return;const y=this[w]+C;y<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[I]]),this[I]=f?f():void 0):(this[t]=!0,this[k]=setTimeout(()=>{this[t]=!1,this[w]=Date.now(),E.apply(this,[this[I]]),this[I]=f?f():void 0},y-Date.now()))}})}e.throttle=L}),define(Z[15],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(o=>{o(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=m,e.errorHandler=new m;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function R(u){f(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=R;function L(u){f(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=L;function C(u){if(u instanceof Error){let{name:l,message:o}=u;const d=u.stacktrace||u.stack;return{$isError:!0,name:l,message:o,stack:d}}return u}e.transformErrorForSerialization=C;const S="Canceled";function f(u){return u instanceof E?!0:u instanceof Error&&u.name===S&&u.message===S}e.isCancellationError=f;class E extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=E;function P(){const u=new Error(S);return u.name=u.message,u}e.canceled=P;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function I(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=I;function w(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function t(u){const l=new Error(`${u} has been disposed`);return l.name="DISPOSED",l}e.disposed=t;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=h;class y extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}e.NotImplementedError=y;class v extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}e.NotSupportedError=v;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=M;class g extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(l){if(l&&l instanceof Error){const o=new g;return o.name=l.name,o.message=l.message,o.stack=l.stack,o}return new g(l)}}e.ErrorNoTelemetry=g}),define(Z[30],x([0,1,15]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(A,_=0){return A[A.length-(1+_)]}e.tail=n;function R(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=R;function L(A,_,z=(X,se)=>X===se){if(A===_)return!0;if(!A||!_||A.length!==_.length)return!1;for(let X=0,se=A.length;X<se;X++)if(!z(A[X],_[X]))return!1;return!0}e.equals=L;function C(A,_,z){let X=0,se=A.length-1;for(;X<=se;){const le=(X+se)/2|0,re=z(A[le],_);if(re<0)X=le+1;else if(re>0)se=le-1;else return le}return-(X+1)}e.binarySearch=C;function S(A,_){let z=0,X=A.length;if(X===0)return 0;for(;z<X;){const se=Math.floor((z+X)/2);_(A[se])?X=se:z=se+1}return z}e.findFirstInSorted=S;function f(A,_,z){if(A=A|0,A>=_.length)throw new TypeError("invalid index");let X=_[Math.floor(_.length*Math.random())],se=[],le=[],re=[];for(let ae of _){const fe=z(ae,X);fe<0?se.push(ae):fe>0?le.push(ae):re.push(ae)}return A<se.length?f(A,se,z):A<se.length+re.length?re[0]:f(A-(se.length+re.length),le,z)}e.quickSelect=f;function E(A,_){const z=[];let X;for(const se of A.slice(0).sort(_))!X||_(X[0],se)!==0?(X=[se],z.push(X)):X.push(se);return z}e.groupBy=E;function P(A,_,z){const X=[];function se(ae,fe,he){if(fe===0&&he.length===0)return;const we=X[X.length-1];we&&we.start+we.deleteCount===ae?(we.deleteCount+=fe,we.toInsert.push(...he)):X.push({start:ae,deleteCount:fe,toInsert:he})}let le=0,re=0;for(;;){if(le===A.length){se(le,0,_.slice(re));break}if(re===_.length){se(le,A.length-le,[]);break}const ae=A[le],fe=_[re],he=z(ae,fe);he===0?(le+=1,re+=1):he<0?(se(le,1,[]),le+=1):he>0&&(se(le,0,[fe]),re+=1)}return X}e.sortedDiff=P;function k(A,_,z){const X=P(A,_,z),se=[],le=[];for(const re of X)se.push(...A.slice(re.start,re.start+re.deleteCount)),le.push(...re.toInsert);return{removed:se,added:le}}e.delta=k;function I(A,_,z){if(z===0)return[];const X=A.slice(0,z).sort(_);return t(A,_,X,z,A.length),X}e.top=I;function w(A,_,z,X,se){return z===0?Promise.resolve([]):new Promise((le,re)=>{(async()=>{const ae=A.length,fe=A.slice(0,z).sort(_);for(let he=z,we=Math.min(z+X,ae);he<ae;he=we,we=Math.min(we+X,ae)){if(he>z&&await new Promise(Re=>setTimeout(Re)),se&&se.isCancellationRequested)throw(0,m.canceled)();t(A,_,fe,he,we)}return fe})().then(le,re)})}e.topAsync=w;function t(A,_,z,X,se){for(const le=z.length;X<se;X++){const re=A[X];if(_(re,z[le-1])<0){z.pop();const ae=S(z,fe=>_(re,fe)<0);z.splice(ae,0,re)}}}function h(A){return A.filter(_=>!!_)}e.coalesce=h;function y(A){let _=0;for(let z=0;z<A.length;z++)A[z]&&(A[_]=A[z],_+=1);A.length=_}e.coalesceInPlace=y;function v(A,_,z){A.splice(z,0,A.splice(_,1)[0])}e.move=v;function M(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=M;function g(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=g;function u(A,_=z=>z){const z=new Set;return A.filter(X=>{const se=_(X);return z.has(se)?!1:(z.add(se),!0)})}e.distinct=u;function l(A){const _=new Set;return z=>{const X=A(z);return _.has(X)?!1:(_.add(X),!0)}}e.uniqueFilter=l;function o(A,_){const z=d(A,_);if(z!==-1)return A[z]}e.findLast=o;function d(A,_){for(let z=A.length-1;z>=0;z--){const X=A[z];if(_(X))return z}return-1}e.lastIndex=d;function r(A,_){return A.length>0?A[0]:_}e.firstOrDefault=r;function i(A,_){return A.length>0?A[A.length-1]:_}e.lastOrDefault=i;function s(A,_,z=(X,se)=>X===se){let X=0;for(let se=0,le=Math.min(A.length,_.length);se<le&&z(A[se],_[se]);se++)X++;return X}e.commonPrefixLength=s;function a(A){return[].concat(...A)}e.flatten=a;function c(A,_){let z=typeof _=="number"?A:0;typeof _=="number"?z=A:(z=0,_=A);const X=[];if(z<=_)for(let se=z;se<_;se++)X.push(se);else for(let se=z;se>_;se--)X.push(se);return X}e.range=c;function b(A,_,z){return A.reduce((X,se)=>(X[_(se)]=z?z(se):se,X),Object.create(null))}e.index=b;function p(A,_){return A.push(_),()=>D(A,_)}e.insert=p;function D(A,_){const z=A.indexOf(_);if(z>-1)return A.splice(z,1),_}e.remove=D;function F(A,_,z){const X=A.slice(0,_),se=A.slice(_);return X.concat(z,se)}e.arrayInsert=F;function U(A,_){let z;if(typeof _=="number"){let X=_;z=()=>{const se=Math.sin(X++)*179426549;return se-Math.floor(se)}}else z=Math.random;for(let X=A.length-1;X>0;X-=1){const se=Math.floor(z()*(X+1)),le=A[X];A[X]=A[se],A[se]=le}}e.shuffle=U;function Q(A,_){const z=A.indexOf(_);z>-1&&(A.splice(z,1),A.unshift(_))}e.pushToStart=Q;function te(A,_){const z=A.indexOf(_);z>-1&&(A.splice(z,1),A.push(_))}e.pushToEnd=te;function ie(A,_){for(const z of _)A.push(z)}e.pushMany=ie;function ee(A,_){return Array.isArray(A)?A.map(_):_(A)}e.mapArrayOrNot=ee;function $(A){return Array.isArray(A)?A:[A]}e.asArray=$;function Y(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=Y;function j(A,_){for(const z of A){const X=_(z);if(X!==void 0)return X}}e.mapFind=j;function q(A,_,z){const X=V(A,_),se=A.length,le=z.length;A.length=se+le;for(let re=se-1;re>=X;re--)A[re+le]=A[re];for(let re=0;re<le;re++)A[re+X]=z[re]}e.insertInto=q;function N(A,_,z,X){const se=V(A,_),le=A.splice(se,z);return q(A,se,X),le}e.splice=N;function V(A,_){return _<0?Math.max(_+A.length,0):Math.min(_,A.length)}function J(A,_){return(z,X)=>_(A(z),A(X))}e.compareBy=J;const B=(A,_)=>A-_;e.numberComparator=B;function K(A,_){if(A.length===0)return;let z=A[0];for(let X=1;X<A.length;X++){const se=A[X];_(se,z)>0&&(z=se)}return z}e.findMaxBy=K;function T(A,_){if(A.length===0)return;let z=A[0];for(let X=1;X<A.length;X++){const se=A[X];_(se,z)>=0&&(z=se)}return z}e.findLastMaxBy=T;function O(A,_){return K(A,(z,X)=>-_(z,X))}e.findMinBy=O;class W{constructor(_){this.items=_,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(_){let z=this.firstIdx;for(;z<this.items.length&&_(this.items[z]);)z++;const X=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,X}takeFromEndWhile(_){let z=this.lastIdx;for(;z>=0&&_(this.items[z]);)z--;const X=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,X}peek(){return this.items[this.firstIdx]}dequeue(){const _=this.items[this.firstIdx];return this.firstIdx++,_}takeCount(_){const z=this.items.slice(this.firstIdx,this.firstIdx+_);return this.firstIdx+=_,z}}e.ArrayQueue=W}),define(Z[43],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(n){const R=this;let L=!1,C;return function(){return L||(L=!0,C=n.apply(R,arguments)),C}}e.once=m}),define(Z[69],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(n){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=R;const L=Object.freeze([]);function C(){return L}n.empty=C;function*S(l){yield l}n.single=S;function f(l){return l||L}n.from=f;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function P(l){return l[Symbol.iterator]().next().value}n.first=P;function k(l,o){for(const d of l)if(o(d))return!0;return!1}n.some=k;function I(l,o){for(const d of l)if(o(d))return d}n.find=I;function*w(l,o){for(const d of l)o(d)&&(yield d)}n.filter=w;function*t(l,o){let d=0;for(const r of l)yield o(r,d++)}n.map=t;function*h(...l){for(const o of l)for(const d of o)yield d}n.concat=h;function*y(l){for(const o of l)for(const d of o)yield d}n.concatNested=y;function v(l,o,d){let r=d;for(const i of l)r=o(r,i);return r}n.reduce=v;function*M(l,o,d=l.length){for(o<0&&(o+=l.length),d<0?d+=l.length:d>l.length&&(d=l.length);o<d;o++)yield l[o]}n.slice=M;function g(l,o=Number.POSITIVE_INFINITY){const d=[];if(o===0)return[d,l];const r=l[Symbol.iterator]();for(let i=0;i<o;i++){const s=r.next();if(s.done)return[d,n.empty()];d.push(s.value)}return[d,{[Symbol.iterator](){return r}}]}n.consume=g;function u(l,o,d=(r,i)=>r===i){const r=l[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const s=r.next(),a=i.next();if(s.done!==a.done)return!1;if(s.done)return!0;if(!d(s.value,a.value))return!1}}n.equals=u})(m=e.Iterable||(e.Iterable={}))}),define(Z[44],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(o){o.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function C(o,d=!1){let r=0,i=o.length,s="",a=0,c=16,b=0;function p(ee){let $=0,Y=0;for(;$<ee;){const j=o.charCodeAt(r);if(j>=48&&j<=57)Y=Y*16+j-48;else if(j>=65&&j<=70)Y=Y*16+j-65+10;else if(j>=97&&j<=102)Y=Y*16+j-97+10;else break;r++,$++}return $<ee&&(Y=-1),Y}function D(ee){r=ee,s="",a=0,c=16,b=0}function F(){const ee=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&E(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&E(o.charCodeAt(r)))for(r++;r<o.length&&E(o.charCodeAt(r));)r++;else return b=3,o.substring(ee,r);let $=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&E(o.charCodeAt(r))){for(r++;r<o.length&&E(o.charCodeAt(r));)r++;$=r}else b=3;return o.substring(ee,$)}function U(){let ee="",$=r;for(;;){if(r>=i){ee+=o.substring($,r),b=2;break}const Y=o.charCodeAt(r);if(Y===34){ee+=o.substring($,r),r++;break}if(Y===92){if(ee+=o.substring($,r),r++,r>=i){b=2;break}switch(o.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const q=p(4);q>=0?ee+=String.fromCharCode(q):b=4;break}default:b=5}$=r;continue}if(Y>=0&&Y<=31)if(f(Y)){ee+=o.substring($,r),b=2;break}else b=6;r++}return ee}function Q(){if(s="",b=0,a=r,r>=i)return a=i,c=17;let ee=o.charCodeAt(r);if(S(ee)){do r++,s+=String.fromCharCode(ee),ee=o.charCodeAt(r);while(S(ee));return c=15}if(f(ee))return r++,s+=String.fromCharCode(ee),ee===13&&o.charCodeAt(r)===10&&(r++,s+=`
`),c=14;switch(ee){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,s=U(),c=10;case 47:{const $=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(o.charCodeAt(r));)r++;return s=o.substring($,r),c=12}if(o.charCodeAt(r+1)===42){r+=2;const Y=i-1;let j=!1;for(;r<Y;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,j=!0;break}r++}return j||(r++,b=1),s=o.substring($,r),c=13}return s+=String.fromCharCode(ee),r++,c=16}case 45:if(s+=String.fromCharCode(ee),r++,r===i||!E(o.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),c=11;default:for(;r<i&&te(ee);)r++,ee=o.charCodeAt(r);if(a!==r){switch(s=o.substring(a,r),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(ee),r++,c=16}}function te(ee){if(S(ee)||f(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ee;do ee=Q();while(ee>=12&&ee<=15);return ee}return{setPosition:D,getPosition:()=>r,scan:d?ie:Q,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>b}}e.createScanner=C;function S(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function f(o){return o===10||o===13||o===8232||o===8233}function E(o){return o>=48&&o<=57}var P;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(P||(P={}));function k(o,d){const r=[],i=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function b(p,D,F,U){a.value=p,a.offset=D,a.length=F,a.type=U,a.colonOffset=void 0,s=a}try{g(o,{onObjectBegin:(p,D)=>{if(d<=p)throw i;s=void 0,c=d>p,r.push("")},onObjectProperty:(p,D,F)=>{if(d<D||(b(p,D,F,"property"),r[r.length-1]=p,d<=D+F))throw i},onObjectEnd:(p,D)=>{if(d<=p)throw i;s=void 0,r.pop()},onArrayBegin:(p,D)=>{if(d<=p)throw i;s=void 0,r.push(0)},onArrayEnd:(p,D)=>{if(d<=p)throw i;s=void 0,r.pop()},onLiteralValue:(p,D,F)=>{if(d<D||(b(p,D,F,l(p)),d<=D+F))throw i},onSeparator:(p,D,F)=>{if(d<=D)throw i;if(p===":"&&s&&s.type==="property")s.colonOffset=D,c=!1,s=void 0;else if(p===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(c=!0,r[r.length-1]=""),s=void 0}}})}catch(p){if(p!==i)throw p}return{path:r,previousNode:s,isAtPropertyKey:c,matches:p=>{let D=0;for(let F=0;D<p.length&&F<r.length;F++)if(p[D]===r[F]||p[D]==="*")D++;else if(p[D]!=="**")return!1;return D===p.length}}}e.getLocation=k;function I(o,d=[],r=L.DEFAULT){let i=null,s=[];const a=[];function c(p){Array.isArray(s)?s.push(p):i!==null&&(s[i]=p)}return g(o,{onObjectBegin:()=>{const p={};c(p),a.push(s),s=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const p=[];c(p),a.push(s),s=p,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:c,onError:(p,D,F)=>{d.push({error:p,offset:D,length:F})}},r),s[0]}e.parse=I;function w(o,d=[],r=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function a(p){return i.children.push(p),p}g(o,{onObjectBegin:p=>{i=a({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,D,F)=>{i=a({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:D,length:F,parent:i})},onObjectEnd:(p,D)=>{i.length=p+D-i.offset,i=i.parent,s(p+D)},onArrayBegin:(p,D)=>{i=a({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,D)=>{i.length=p+D-i.offset,i=i.parent,s(p+D)},onLiteralValue:(p,D,F)=>{a({type:l(p),offset:D,length:F,parent:i,value:p}),s(D+F)},onSeparator:(p,D,F)=>{i.type==="property"&&(p===":"?i.colonOffset=D:p===","&&s(D))},onError:(p,D,F)=>{d.push({error:p,offset:D,length:F})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=w;function t(o,d){if(!o)return;let r=o;for(let i of d)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=t;function h(o){if(!o.parent||!o.parent.children)return[];const d=h(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;d.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&d.push(r)}return d}e.getNodePath=h;function y(o){switch(o.type){case"array":return o.children.map(y);case"object":{const d=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(d[r.children[0].value]=y(i))}return d}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=y;function v(o,d,r=!1){return d>=o.offset&&d<o.offset+o.length||r&&d===o.offset+o.length}e.contains=v;function M(o,d,r=!1){if(v(o,d,r)){const i=o.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=d;s++){const a=M(i[s],d,r);if(a)return a}return o}}e.findNodeAtOffset=M;function g(o,d,r=L.DEFAULT){const i=C(o,!1);function s(T){return T?()=>T(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(T){return T?O=>T(O,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(d.onObjectBegin),b=a(d.onObjectProperty),p=s(d.onObjectEnd),D=s(d.onArrayBegin),F=s(d.onArrayEnd),U=a(d.onLiteralValue),Q=a(d.onSeparator),te=s(d.onComment),ie=a(d.onError),ee=r&&r.disallowComments,$=r&&r.allowTrailingComma;function Y(){for(;;){const T=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:ee||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(T){case 12:case 13:ee?j(10):te();break;case 16:j(1);break;case 15:case 14:break;default:return T}}}function j(T,O=[],W=[]){if(ie(T),O.length+W.length>0){let A=i.getToken();for(;A!==17;){if(O.indexOf(A)!==-1){Y();break}else if(W.indexOf(A)!==-1)break;A=Y()}}}function q(T){const O=i.getTokenValue();return T?U(O):b(O),Y(),!0}function N(){switch(i.getToken()){case 11:{let T=0;try{T=JSON.parse(i.getTokenValue()),typeof T!="number"&&(j(2),T=0)}catch{j(2)}U(T);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return Y(),!0}function V(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(Q(":"),Y(),K()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function J(){c(),Y();let T=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(T||j(4,[],[]),Q(","),Y(),i.getToken()===2&&$)break}else T&&j(6,[],[]);V()||j(4,[],[2,5]),T=!0}return p(),i.getToken()!==2?j(7,[2],[]):Y(),!0}function B(){D(),Y();let T=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(T||j(4,[],[]),Q(","),Y(),i.getToken()===4&&$)break}else T&&j(6,[],[]);K()||j(4,[],[4,5]),T=!0}return F(),i.getToken()!==4?j(8,[4],[]):Y(),!0}function K(){switch(i.getToken()){case 3:return B();case 1:return J();case 10:return q(!0);default:return N()}}return Y(),i.getToken()===17?r.allowEmptyContent?!0:(j(4,[],[]),!1):K()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=g;function u(o,d){let r=C(o),i=[],s,a=0,c;do switch(c=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:a!==c&&i.push(o.substring(a,c)),d!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,d)),a=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=u;function l(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Z[108],x([0,1,44]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,P,k){let I,w,t,h,y;if(P){for(h=P.offset,y=h+P.length,t=h;t>0&&!f(E,t-1);)t--;let c=y;for(;c<E.length&&!f(E,c);)c++;w=E.substring(t,c),I=C(w,k)}else w=E,I=0,t=0,h=0,y=E.length;const v=S(k,E);let M=!1,g=0,u;k.insertSpaces?u=L(" ",k.tabSize||4):u="	";const l=(0,m.createScanner)(w,!1);let o=!1;function d(){return v+L(u,I+g)}function r(){let c=l.scan();for(M=!1;c===15||c===14;)M=M||c===14,c=l.scan();return o=c===16||l.getTokenError()!==0,c}const i=[];function s(c,b,p){!o&&b<y&&p>h&&E.substring(b,p)!==c&&i.push({offset:b,length:p-b,content:c})}let a=r();if(a!==17){const c=l.getTokenOffset()+t,b=L(u,I);s(b,t,c)}for(;a!==17;){let c=l.getTokenOffset()+l.getTokenLength()+t,b=r(),p="";for(;!M&&(b===12||b===13);){const F=l.getTokenOffset()+t;s(" ",c,F),c=l.getTokenOffset()+l.getTokenLength()+t,p=b===12?d():"",b=r()}if(b===2)a!==1&&(g--,p=d());else if(b===4)a!==3&&(g--,p=d());else{switch(a){case 3:case 1:g++,p=d();break;case 5:case 12:p=d();break;case 13:M?p=d():p=" ";break;case 6:p=" ";break;case 10:if(b===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?p=" ":b!==5&&b!==17&&(o=!0);break;case 16:o=!0;break}M&&(b===12||b===13)&&(p=d())}const D=l.getTokenOffset()+t;s(p,c,D),a=b}return i}e.format=n;function R(E,P){const k=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?k.replace(/\r\n|\r|\n/g,P.eol):k}e.toFormattedString=R;function L(E,P){let k="";for(let I=0;I<P;I++)k+=E;return k}function C(E,P){let k=0,I=0;const w=P.tabSize||4;for(;k<E.length;){const t=E.charAt(k);if(t===" ")I++;else if(t==="	")I+=w;else break;k++}return Math.floor(I/w)}function S(E,P){for(let k=0;k<P.length;k++){const I=P.charAt(k);if(I==="\r")return k+1<P.length&&P.charAt(k+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=S;function f(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=f}),define(Z[109],x([0,1,44,108]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,P,k){return L(E,P,void 0,k)}e.removeProperty=R;function L(E,P,k,I,w){const t=P.slice(),h=[],y=(0,m.parseTree)(E,h);let v,M;for(;t.length>0&&(M=t.pop(),v=(0,m.findNodeAtLocation)(y,t),v===void 0&&k!==void 0);)typeof M=="string"?k={[M]:k}:k=[k];if(v)if(v.type==="object"&&typeof M=="string"&&Array.isArray(v.children)){const g=(0,m.findNodeAtLocation)(v,[M]);if(g!==void 0)if(k===void 0){if(!g.parent)throw new Error("Malformed AST");const u=v.children.indexOf(g.parent);let l,o=g.parent.offset+g.parent.length;if(u>0){const d=v.children[u-1];l=d.offset+d.length}else l=v.offset+1,v.children.length>1&&(o=v.children[1].offset);return C(E,{offset:l,length:o-l,content:""},I)}else return C(E,{offset:g.offset,length:g.length,content:JSON.stringify(k)},I);else{if(k===void 0)return[];const u=`${JSON.stringify(M)}: ${JSON.stringify(k)}`,l=w?w(v.children.map(d=>d.children[0].value)):v.children.length;let o;if(l>0){const d=v.children[l-1];o={offset:d.offset+d.length,length:0,content:","+u}}else v.children.length===0?o={offset:v.offset+1,length:0,content:u}:o={offset:v.offset+1,length:0,content:u+","};return C(E,o,I)}}else if(v.type==="array"&&typeof M=="number"&&Array.isArray(v.children))if(k!==void 0){const g=`${JSON.stringify(k)}`;let u;if(v.children.length===0||M===0)u={offset:v.offset+1,length:0,content:v.children.length===0?g:g+","};else{const l=M===-1||M>v.children.length?v.children.length:M,o=v.children[l-1];u={offset:o.offset+o.length,length:0,content:","+g}}return C(E,u,I)}else{const g=M,u=v.children[g];let l;if(v.children.length===1)l={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===g){const o=v.children[g-1],d=o.offset+o.length,r=v.offset+v.length;l={offset:d,length:r-2-d,content:""}}else l={offset:u.offset,length:v.children[g+1].offset-u.offset,content:""};return C(E,l,I)}else throw new Error(`Can not add ${typeof M!="number"?"index":"property"} to parent of type ${v.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return C(E,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(k)},I)}}e.setProperty=L;function C(E,P,k){let I=S(E,P),w=P.offset,t=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;w>0&&!(0,n.isEOL)(I,w-1);)w--;for(;t<I.length&&!(0,n.isEOL)(I,t);)t++}const h=(0,n.format)(I,{offset:w,length:t-w},k);for(let v=h.length-1;v>=0;v--){const M=h[v];I=S(I,M),w=Math.min(w,M.offset),t=Math.max(t,M.offset+M.length),t+=M.content.length-M.length}const y=E.length-(I.length-t)-w;return[{offset:w,length:y,content:I.substring(w,t)}]}e.withFormatting=C;function S(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=S;function f(E,P){let k=P.slice(0).sort((w,t)=>{const h=w.offset-t.offset;return h===0?w.length-t.length:h}),I=E.length;for(let w=k.length-1;w>=0;w--){let t=k[w];if(t.offset+t.length<=I)E=S(E,t);else throw new Error("Overlapping edit");I=t.offset}return E}e.applyEdits=f}),define(Z[83],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var m;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(m=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,y){this._keyCodeToStr[h]=y,this._strToKeyCode[y.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const L=new R,C=new R,S=new R;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],E=Object.create(null),P=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>P[t]||0,toEnum:t=>E[t]||0,toString:t=>f[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",h=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let y=[],v=[];for(const M of h){const[g,u,l,o,d,r,i,s,a,c]=M;if(v[l]||(v[l]=!0,f[l]=o,E[o]=l,P[o.toLowerCase()]=l,u&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=d,d!==0&&d!==3&&d!==5&&d!==4&&d!==6&&d!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[d]=l))),!y[d]){if(y[d]=!0,!r)throw new Error(`String representation missing for key code ${d} around scan code ${o}`);L.define(d,r),C.define(d,a||r),S.define(d,c||a||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=d),s&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=d)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var k;(function(t){function h(l){return L.keyCodeToStr(l)}t.toString=h;function y(l){return L.strToKeyCode(l)}t.fromString=y;function v(l){return C.keyCodeToStr(l)}t.toUserSettingsUS=v;function M(l){return S.keyCodeToStr(l)}t.toUserSettingsGeneral=M;function g(l){return C.strToKeyCode(l)||S.strToKeyCode(l)}t.fromUserSettings=g;function u(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return L.keyCodeToStr(l)}t.toElectronAccelerator=u})(k=e.KeyCodeUtils||(e.KeyCodeUtils={}));var I;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(I=e.KeyMod||(e.KeyMod={}));function w(t,h){const y=(h&65535)<<16>>>0;return(t|y)>>>0}e.KeyChord=w}),define(Z[60],x([0,1,15]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(k){k[k.CtrlCmd=2048]="CtrlCmd",k[k.Shift=1024]="Shift",k[k.Alt=512]="Alt",k[k.WinCtrl=256]="WinCtrl",k[k.KeyCode=255]="KeyCode"})(n||(n={}));function R(k,I){if(k===0)return null;const w=(k&65535)>>>0,t=(k&4294901760)>>>16;return t!==0?new S([L(w,I),L(t,I)]):new S([L(w,I)])}e.createKeybinding=R;function L(k,I){const w=!!(k&2048),t=!!(k&256),h=I===2?t:w,y=!!(k&1024),v=!!(k&512),M=I===2?w:t,g=k&255;return new C(h,y,v,M,g)}e.createSimpleKeybinding=L;class C{constructor(I,w,t,h,y){this.ctrlKey=I,this.shiftKey=w,this.altKey=t,this.metaKey=h,this.keyCode=y}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.keyCode===I.keyCode}getHashCode(){const I=this.ctrlKey?"1":"0",w=this.shiftKey?"1":"0",t=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${I}${w}${t}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new S([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=C;class S{constructor(I){if(I.length===0)throw(0,m.illegalArgument)("parts");this.parts=I}getHashCode(){let I="";for(let w=0,t=this.parts.length;w<t;w++)w!==0&&(I+=";"),I+=this.parts[w].getHashCode();return I}equals(I){if(I===null||this.parts.length!==I.parts.length)return!1;for(let w=0;w<this.parts.length;w++)if(!this.parts[w].equals(I.parts[w]))return!1;return!0}}e.ChordKeybinding=S;class f{constructor(I,w,t,h,y){this.ctrlKey=I,this.shiftKey=w,this.altKey=t,this.metaKey=h,this.scanCode=y}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.scanCode===I.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=f;class E{constructor(I,w,t,h,y,v){this.ctrlKey=I,this.shiftKey=w,this.altKey=t,this.metaKey=h,this.keyLabel=y,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=E;class P{}e.ResolvedKeybinding=P}),define(Z[110],x([0,1,83,60]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(C){C=C.toLowerCase().trim();let S=!1,f=!1,E=!1,P=!1,k;do k=!1,/^ctrl(\+|\-)/.test(C)&&(S=!0,C=C.substr("ctrl-".length),k=!0),/^shift(\+|\-)/.test(C)&&(f=!0,C=C.substr("shift-".length),k=!0),/^alt(\+|\-)/.test(C)&&(E=!0,C=C.substr("alt-".length),k=!0),/^meta(\+|\-)/.test(C)&&(P=!0,C=C.substr("meta-".length),k=!0),/^win(\+|\-)/.test(C)&&(P=!0,C=C.substr("win-".length),k=!0),/^cmd(\+|\-)/.test(C)&&(P=!0,C=C.substr("cmd-".length),k=!0);while(k);let I;const w=C.indexOf(" ");return w>0?(I=C.substring(0,w),C=C.substring(w)):(I=C,C=""),{remains:C,ctrl:S,shift:f,alt:E,meta:P,key:I}}static parseSimpleKeybinding(C){const S=this._readModifiers(C),f=m.KeyCodeUtils.fromUserSettings(S.key);return[new n.SimpleKeybinding(S.ctrl,S.shift,S.alt,S.meta,f),S.remains]}static parseKeybinding(C,S){if(!C)return null;const f=[];let E;do[E,C]=this.parseSimpleKeybinding(C),f.push(E);while(C.length>0);return new n.ChordKeybinding(f)}static parseSimpleUserBinding(C){const S=this._readModifiers(C),f=S.key.match(/^\[([^\]]+)\]$/);if(f){const P=f[1],k=m.ScanCodeUtils.lowerCaseToEnum(P);return[new n.ScanCodeBinding(S.ctrl,S.shift,S.alt,S.meta,k),S.remains]}const E=m.KeyCodeUtils.fromUserSettings(S.key);return[new n.SimpleKeybinding(S.ctrl,S.shift,S.alt,S.meta,E),S.remains]}static parseUserBinding(C){if(!C)return[];const S=[];let f;for(;C.length>0;)[f,C]=this.parseSimpleUserBinding(C),S.push(f);return S}}e.KeybindingParser=R}),define(Z[111],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new m(()=>R(this.getValue()))}}e.Lazy=m}),define(Z[2],x([0,1,43,69]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function C(s){L=s}if(e.setDisposableTracker=C,R){const s="__is_disposable_tracked__";C(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==M.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==M.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function S(s){return L?.trackDisposable(s),s}function f(s){L?.markAsDisposed(s)}function E(s,a){L?.setParent(s,a)}function P(s,a){if(!!L)for(const c of s)L.setParent(c,a)}function k(s){return L?.markAsSingleton(s),s}e.markAsSingleton=k;class I extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=I;function w(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=w;function t(s){if(n.Iterable.is(s)){let a=[];for(const c of s)if(c)try{c.dispose()}catch(b){a.push(b)}if(a.length===1)throw a[0];if(a.length>1)throw new I(a);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=t;function h(...s){const a=y(()=>t(s));return P(s,a),a}e.combinedDisposable=h;function y(s){const a=S({dispose:(0,m.once)(()=>{f(a),s()})});return a}e.toDisposable=y;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new v,S(this),E(this._store,this)}dispose(){f(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=M,M.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=g;class u{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,f(this))},this}}e.SafeDisposable=l;class o{constructor(){this.references=new Map}acquire(a,...c){let b=this.references.get(a);b||(b={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,b));const{object:p}=b,D=(0,m.once)(()=>{--b.counter==0&&(this.destroyReferencedObject(a,b.object),this.references.delete(a))});return b.counter++,{object:p,dispose:D}}}e.ReferenceCollection=o;class d{constructor(a){this.referenceCollection=a}async acquire(a,...c){const b=this.referenceCollection.acquire(a,...c);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(p){throw b.dispose(),p}}}e.AsyncReferenceCollection=d;class r{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=r;function i(s){const a=new v;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(Z[112],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(L){this.element=L,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class n{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let L=this._first;for(;L!==m.Undefined;){const C=L.next;L.prev=m.Undefined,L.next=m.Undefined,L=C}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,C){const S=new m(L);if(this._first===m.Undefined)this._first=S,this._last=S;else if(C){const E=this._last;this._last=S,S.prev=E,E.next=S}else{const E=this._first;this._first=S,S.next=E,E.prev=S}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(S))}}shift(){if(this._first!==m.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==m.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==m.Undefined&&L.next!==m.Undefined){const C=L.prev;C.next=L.next,L.next.prev=C}else L.prev===m.Undefined&&L.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):L.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):L.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==m.Undefined;)yield L.element,L=L.next}}e.LinkedList=n}),function(){function H(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function C(f){L.push(f,Date.now())}function S(){const f=[];for(let E=0;E<L.length;E+=2)f.push({name:L[E],startTime:L[E+1]});return f}return{mark:C,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(R+C.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function m(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=m(n))}(),define(Z[3],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let n=!1,R=!1,L=!1,C=!1,S=!1,f=!1,E=!1,P=!1,k=!1,I,w=m,t,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const v=typeof y?.versions?.electron=="string",M=v&&y?.type==="renderer";if(e.isElectronSandboxed=M&&y?.sandboxed,typeof navigator=="object"&&!M)h=navigator.userAgent,n=h.indexOf("Windows")>=0,R=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,f=!0,I=navigator.language,w=I;else if(typeof y=="object"){n=y.platform==="win32",R=y.platform==="darwin",L=y.platform==="linux",C=L&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,E=v,k=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=m,w=m;const a=y.env.VSCODE_NLS_CONFIG;if(a)try{const c=JSON.parse(a),b=c.availableLanguages["*"];I=c.locale,w=b||m,t=c._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var g;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function u(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let l=0;R?l=1:n?l=3:L&&(l=2),e.isWindows=n,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=C,e.isNative=S,e.isElectron=E,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=k,e.platform=l,e.userAgent=h,e.language=w;var o;(function(a){function c(){return e.language}a.value=c;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=b;function p(){return e.language==="en"}a.isDefault=p})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let p=0,D=a.length;p<D;p++){const F=a[p];if(F.id===b.data.vscodeScheduleAsyncWork){a.splice(p,1),F.callback();return}}});let c=0;return b=>{const p=++c;a.push({id:p,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:p},"*")}}return a=>setTimeout(a)})();var d;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(d=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||P?2:n?1:3;let r=!0,i=!1;function s(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,r=new Uint16Array(a.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],x([0,1,3]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const R=m.globals.vscode.process;n={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Z[7],x([0,1,36]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,R=97,L=90,C=122,S=46,f=47,E=92,P=58,k=63;class I extends Error{constructor(u,l,o){let d;typeof l=="string"&&l.indexOf("not ")===0?(d="must not be",l=l.replace(/^not /,"")):d="must be";const r=u.indexOf(".")!==-1?"property":"argument";let i=`The "${u}" ${r} ${d} of type ${l}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function w(g,u){if(typeof g!="string")throw new I(u,"string",g)}function t(g){return g===f||g===E}function h(g){return g===f}function y(g){return g>=n&&g<=L||g>=R&&g<=C}function v(g,u,l,o){let d="",r=0,i=-1,s=0,a=0;for(let c=0;c<=g.length;++c){if(c<g.length)a=g.charCodeAt(c);else{if(o(a))break;a=f}if(o(a)){if(!(i===c-1||s===1))if(s===2){if(d.length<2||r!==2||d.charCodeAt(d.length-1)!==S||d.charCodeAt(d.length-2)!==S){if(d.length>2){const b=d.lastIndexOf(l);b===-1?(d="",r=0):(d=d.slice(0,b),r=d.length-1-d.lastIndexOf(l)),i=c,s=0;continue}else if(d.length!==0){d="",r=0,i=c,s=0;continue}}u&&(d+=d.length>0?`${l}..`:"..",r=2)}else d.length>0?d+=`${l}${g.slice(i+1,c)}`:d=g.slice(i+1,c),r=c-i-1;i=c,s=0}else a===S&&s!==-1?++s:s=-1}return d}function M(g,u){if(u===null||typeof u!="object")throw new I("pathObject","Object",u);const l=u.dir||u.root,o=u.base||`${u.name||""}${u.ext||""}`;return l?l===u.root?`${l}${o}`:`${l}${g}${o}`:o}e.win32={resolve(...g){let u="",l="",o=!1;for(let d=g.length-1;d>=-1;d--){let r;if(d>=0){if(r=g[d],w(r,"path"),r.length===0)continue}else u.length===0?r=m.cwd():(r=m.env[`=${u}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==u.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${u}\\`));const i=r.length;let s=0,a="",c=!1;const b=r.charCodeAt(0);if(i===1)t(b)&&(s=1,c=!0);else if(t(b))if(c=!0,t(r.charCodeAt(1))){let p=2,D=p;for(;p<i&&!t(r.charCodeAt(p));)p++;if(p<i&&p!==D){const F=r.slice(D,p);for(D=p;p<i&&t(r.charCodeAt(p));)p++;if(p<i&&p!==D){for(D=p;p<i&&!t(r.charCodeAt(p));)p++;(p===i||p!==D)&&(a=`\\\\${F}\\${r.slice(D,p)}`,s=p)}}}else s=1;else y(b)&&r.charCodeAt(1)===P&&(a=r.slice(0,2),s=2,i>2&&t(r.charCodeAt(2))&&(c=!0,s=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(o){if(u.length>0)break}else if(l=`${r.slice(s)}\\${l}`,o=c,c&&u.length>0)break}return l=v(l,!o,"\\",t),o?`${u}\\${l}`:`${u}${l}`||"."},normalize(g){w(g,"path");const u=g.length;if(u===0)return".";let l=0,o,d=!1;const r=g.charCodeAt(0);if(u===1)return h(r)?"\\":g;if(t(r))if(d=!0,t(g.charCodeAt(1))){let s=2,a=s;for(;s<u&&!t(g.charCodeAt(s));)s++;if(s<u&&s!==a){const c=g.slice(a,s);for(a=s;s<u&&t(g.charCodeAt(s));)s++;if(s<u&&s!==a){for(a=s;s<u&&!t(g.charCodeAt(s));)s++;if(s===u)return`\\\\${c}\\${g.slice(a)}\\`;s!==a&&(o=`\\\\${c}\\${g.slice(a,s)}`,l=s)}}}else l=1;else y(r)&&g.charCodeAt(1)===P&&(o=g.slice(0,2),l=2,u>2&&t(g.charCodeAt(2))&&(d=!0,l=3));let i=l<u?v(g.slice(l),!d,"\\",t):"";return i.length===0&&!d&&(i="."),i.length>0&&t(g.charCodeAt(u-1))&&(i+="\\"),o===void 0?d?`\\${i}`:i:d?`${o}\\${i}`:`${o}${i}`},isAbsolute(g){w(g,"path");const u=g.length;if(u===0)return!1;const l=g.charCodeAt(0);return t(l)||u>2&&y(l)&&g.charCodeAt(1)===P&&t(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let u,l;for(let r=0;r<g.length;++r){const i=g[r];w(i,"path"),i.length>0&&(u===void 0?u=l=i:u+=`\\${i}`)}if(u===void 0)return".";let o=!0,d=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++d;const r=l.length;r>1&&t(l.charCodeAt(1))&&(++d,r>2&&(t(l.charCodeAt(2))?++d:o=!1))}if(o){for(;d<u.length&&t(u.charCodeAt(d));)d++;d>=2&&(u=`\\${u.slice(d)}`)}return e.win32.normalize(u)},relative(g,u){if(w(g,"from"),w(u,"to"),g===u)return"";const l=e.win32.resolve(g),o=e.win32.resolve(u);if(l===o||(g=l.toLowerCase(),u=o.toLowerCase(),g===u))return"";let d=0;for(;d<g.length&&g.charCodeAt(d)===E;)d++;let r=g.length;for(;r-1>d&&g.charCodeAt(r-1)===E;)r--;const i=r-d;let s=0;for(;s<u.length&&u.charCodeAt(s)===E;)s++;let a=u.length;for(;a-1>s&&u.charCodeAt(a-1)===E;)a--;const c=a-s,b=i<c?i:c;let p=-1,D=0;for(;D<b;D++){const U=g.charCodeAt(d+D);if(U!==u.charCodeAt(s+D))break;U===E&&(p=D)}if(D!==b){if(p===-1)return o}else{if(c>b){if(u.charCodeAt(s+D)===E)return o.slice(s+D+1);if(D===2)return o.slice(s+D)}i>b&&(g.charCodeAt(d+D)===E?p=D:D===2&&(p=3)),p===-1&&(p=0)}let F="";for(D=d+p+1;D<=r;++D)(D===r||g.charCodeAt(D)===E)&&(F+=F.length===0?"..":"\\..");return s+=p,F.length>0?`${F}${o.slice(s,a)}`:(o.charCodeAt(s)===E&&++s,o.slice(s,a))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const u=e.win32.resolve(g);if(u.length<=2)return g;if(u.charCodeAt(0)===E){if(u.charCodeAt(1)===E){const l=u.charCodeAt(2);if(l!==k&&l!==S)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(y(u.charCodeAt(0))&&u.charCodeAt(1)===P&&u.charCodeAt(2)===E)return`\\\\?\\${u}`;return g},dirname(g){w(g,"path");const u=g.length;if(u===0)return".";let l=-1,o=0;const d=g.charCodeAt(0);if(u===1)return t(d)?g:".";if(t(d)){if(l=o=1,t(g.charCodeAt(1))){let s=2,a=s;for(;s<u&&!t(g.charCodeAt(s));)s++;if(s<u&&s!==a){for(a=s;s<u&&t(g.charCodeAt(s));)s++;if(s<u&&s!==a){for(a=s;s<u&&!t(g.charCodeAt(s));)s++;if(s===u)return g;s!==a&&(l=o=s+1)}}}}else y(d)&&g.charCodeAt(1)===P&&(l=u>2&&t(g.charCodeAt(2))?3:2,o=l);let r=-1,i=!0;for(let s=u-1;s>=o;--s)if(t(g.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(l===-1)return".";r=l}return g.slice(0,r)},basename(g,u){u!==void 0&&w(u,"ext"),w(g,"path");let l=0,o=-1,d=!0,r;if(g.length>=2&&y(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(l=2),u!==void 0&&u.length>0&&u.length<=g.length){if(u===g)return"";let i=u.length-1,s=-1;for(r=g.length-1;r>=l;--r){const a=g.charCodeAt(r);if(t(a)){if(!d){l=r+1;break}}else s===-1&&(d=!1,s=r+1),i>=0&&(a===u.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=g.length),g.slice(l,o)}for(r=g.length-1;r>=l;--r)if(t(g.charCodeAt(r))){if(!d){l=r+1;break}}else o===-1&&(d=!1,o=r+1);return o===-1?"":g.slice(l,o)},extname(g){w(g,"path");let u=0,l=-1,o=0,d=-1,r=!0,i=0;g.length>=2&&g.charCodeAt(1)===P&&y(g.charCodeAt(0))&&(u=o=2);for(let s=g.length-1;s>=u;--s){const a=g.charCodeAt(s);if(t(a)){if(!r){o=s+1;break}continue}d===-1&&(r=!1,d=s+1),a===S?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||d===-1||i===0||i===1&&l===d-1&&l===o+1?"":g.slice(l,d)},format:M.bind(null,"\\"),parse(g){w(g,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return u;const l=g.length;let o=0,d=g.charCodeAt(0);if(l===1)return t(d)?(u.root=u.dir=g,u):(u.base=u.name=g,u);if(t(d)){if(o=1,t(g.charCodeAt(1))){let p=2,D=p;for(;p<l&&!t(g.charCodeAt(p));)p++;if(p<l&&p!==D){for(D=p;p<l&&t(g.charCodeAt(p));)p++;if(p<l&&p!==D){for(D=p;p<l&&!t(g.charCodeAt(p));)p++;p===l?o=p:p!==D&&(o=p+1)}}}}else if(y(d)&&g.charCodeAt(1)===P){if(l<=2)return u.root=u.dir=g,u;if(o=2,t(g.charCodeAt(2))){if(l===3)return u.root=u.dir=g,u;o=3}}o>0&&(u.root=g.slice(0,o));let r=-1,i=o,s=-1,a=!0,c=g.length-1,b=0;for(;c>=o;--c){if(d=g.charCodeAt(c),t(d)){if(!a){i=c+1;break}continue}s===-1&&(a=!1,s=c+1),d===S?r===-1?r=c:b!==1&&(b=1):r!==-1&&(b=-1)}return s!==-1&&(r===-1||b===0||b===1&&r===s-1&&r===i+1?u.base=u.name=g.slice(i,s):(u.name=g.slice(i,r),u.base=g.slice(i,s),u.ext=g.slice(r,s))),i>0&&i!==o?u.dir=g.slice(0,i-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let u="",l=!1;for(let o=g.length-1;o>=-1&&!l;o--){const d=o>=0?g[o]:m.cwd();w(d,"path"),d.length!==0&&(u=`${d}/${u}`,l=d.charCodeAt(0)===f)}return u=v(u,!l,"/",h),l?`/${u}`:u.length>0?u:"."},normalize(g){if(w(g,"path"),g.length===0)return".";const u=g.charCodeAt(0)===f,l=g.charCodeAt(g.length-1)===f;return g=v(g,!u,"/",h),g.length===0?u?"/":l?"./":".":(l&&(g+="/"),u?`/${g}`:g)},isAbsolute(g){return w(g,"path"),g.length>0&&g.charCodeAt(0)===f},join(...g){if(g.length===0)return".";let u;for(let l=0;l<g.length;++l){const o=g[l];w(o,"path"),o.length>0&&(u===void 0?u=o:u+=`/${o}`)}return u===void 0?".":e.posix.normalize(u)},relative(g,u){if(w(g,"from"),w(u,"to"),g===u||(g=e.posix.resolve(g),u=e.posix.resolve(u),g===u))return"";const l=1,o=g.length,d=o-l,r=1,i=u.length-r,s=d<i?d:i;let a=-1,c=0;for(;c<s;c++){const p=g.charCodeAt(l+c);if(p!==u.charCodeAt(r+c))break;p===f&&(a=c)}if(c===s)if(i>s){if(u.charCodeAt(r+c)===f)return u.slice(r+c+1);if(c===0)return u.slice(r+c)}else d>s&&(g.charCodeAt(l+c)===f?a=c:c===0&&(a=0));let b="";for(c=l+a+1;c<=o;++c)(c===o||g.charCodeAt(c)===f)&&(b+=b.length===0?"..":"/..");return`${b}${u.slice(r+a)}`},toNamespacedPath(g){return g},dirname(g){if(w(g,"path"),g.length===0)return".";const u=g.charCodeAt(0)===f;let l=-1,o=!0;for(let d=g.length-1;d>=1;--d)if(g.charCodeAt(d)===f){if(!o){l=d;break}}else o=!1;return l===-1?u?"/":".":u&&l===1?"//":g.slice(0,l)},basename(g,u){u!==void 0&&w(u,"ext"),w(g,"path");let l=0,o=-1,d=!0,r;if(u!==void 0&&u.length>0&&u.length<=g.length){if(u===g)return"";let i=u.length-1,s=-1;for(r=g.length-1;r>=0;--r){const a=g.charCodeAt(r);if(a===f){if(!d){l=r+1;break}}else s===-1&&(d=!1,s=r+1),i>=0&&(a===u.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=s))}return l===o?o=s:o===-1&&(o=g.length),g.slice(l,o)}for(r=g.length-1;r>=0;--r)if(g.charCodeAt(r)===f){if(!d){l=r+1;break}}else o===-1&&(d=!1,o=r+1);return o===-1?"":g.slice(l,o)},extname(g){w(g,"path");let u=-1,l=0,o=-1,d=!0,r=0;for(let i=g.length-1;i>=0;--i){const s=g.charCodeAt(i);if(s===f){if(!d){l=i+1;break}continue}o===-1&&(d=!1,o=i+1),s===S?u===-1?u=i:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||o===-1||r===0||r===1&&u===o-1&&u===l+1?"":g.slice(u,o)},format:M.bind(null,"/"),parse(g){w(g,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return u;const l=g.charCodeAt(0)===f;let o;l?(u.root="/",o=1):o=0;let d=-1,r=0,i=-1,s=!0,a=g.length-1,c=0;for(;a>=o;--a){const b=g.charCodeAt(a);if(b===f){if(!s){r=a+1;break}continue}i===-1&&(s=!1,i=a+1),b===S?d===-1?d=a:c!==1&&(c=1):d!==-1&&(c=-1)}if(i!==-1){const b=r===0&&l?1:r;d===-1||c===0||c===1&&d===i-1&&d===r+1?u.base=u.name=g.slice(b,i):(u.name=g.slice(b,d),u.base=g.slice(b,i),u.ext=g.slice(d,i))}return r>0?u.dir=g.slice(0,r-1):l&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[84],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var n;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(L,...C){const S=C.reduce((P,k)=>(P[k]=!0,P),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(P=>!S[P]).forEach(P=>{for(let k=0;k<f.length;k++)if(P.search(f[k])!==-1){delete L[P];break}})}e.sanitizeProcessEnvironment=R}),define(Z[85],x([0,1,3]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=m.globals.performance&&typeof m.globals.performance.now=="function";class R{constructor(C){this._highResolution=n&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new R(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[4],x([0,1,15,43,2,112,85]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let S=!1,f=!1;var E;(function(r){r.None=()=>R.Disposable.None;function i(B){if(f){const{onListenerDidAdd:K}=B,T=t.create();let O=0;B.onListenerDidAdd=()=>{++O==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),T.print()),K?.()}}}function s(B){return(K,T=null,O)=>{let W=!1,A;return A=B(_=>{if(!W)return A?A.dispose():W=!0,K.call(T,_)},null,O),W&&A.dispose(),A}}r.once=s;function a(B,K,T){return U((O,W=null,A)=>B(_=>O.call(W,K(_)),null,A),T)}r.map=a;function c(B,K,T){return U((O,W=null,A)=>B(_=>{K(_),O.call(W,_)},null,A),T)}r.forEach=c;function b(B,K,T){return U((O,W=null,A)=>B(_=>K(_)&&O.call(W,_),null,A),T)}r.filter=b;function p(B){return B}r.signal=p;function D(...B){return(K,T=null,O)=>(0,R.combinedDisposable)(...B.map(W=>W(A=>K.call(T,A),null,O)))}r.any=D;function F(B,K,T,O){let W=T;return a(B,A=>(W=K(W,A),W),O)}r.reduce=F;function U(B,K){let T;const O={onFirstListenerAdd(){T=B(W.fire,W)},onLastListenerRemove(){T.dispose()}};K||i(O);const W=new y(O);return K&&K.add(W),W.event}function Q(B,K,T=100,O=!1,W,A){let _,z,X,se=0;const le={leakWarningThreshold:W,onFirstListenerAdd(){_=B(ae=>{se++,z=K(z,ae),O&&!X&&(re.fire(z),z=void 0),clearTimeout(X),X=setTimeout(()=>{const fe=z;z=void 0,X=void 0,(!O||se>1)&&re.fire(fe),se=0},T)})},onLastListenerRemove(){_.dispose()}};A||i(le);const re=new y(le);return A&&A.add(re),re.event}r.debounce=Q;function te(B,K=(O,W)=>O===W,T){let O=!0,W;return b(B,A=>{const _=O||!K(A,W);return O=!1,W=A,_},T)}r.latch=te;function ie(B,K,T){return[r.filter(B,K,T),r.filter(B,O=>!K(O),T)]}r.split=ie;function ee(B,K=!1,T=[]){let O=T.slice(),W=B(z=>{O?O.push(z):_.fire(z)});const A=()=>{O&&O.forEach(z=>_.fire(z)),O=null},_=new y({onFirstListenerAdd(){W||(W=B(z=>_.fire(z)))},onFirstListenerDidAdd(){O&&(K?setTimeout(A):A())},onLastListenerRemove(){W&&W.dispose(),W=null}});return _.event}r.buffer=ee;class ${constructor(K){this.event=K}map(K){return new $(a(this.event,K))}forEach(K){return new $(c(this.event,K))}filter(K){return new $(b(this.event,K))}reduce(K,T){return new $(F(this.event,K,T))}latch(){return new $(te(this.event))}debounce(K,T=100,O=!1,W){return new $(Q(this.event,K,T,O,W))}on(K,T,O){return this.event(K,T,O)}once(K,T,O){return s(this.event)(K,T,O)}}function Y(B){return new $(B)}r.chain=Y;function j(B,K,T=O=>O){const O=(...z)=>_.fire(T(...z)),W=()=>B.on(K,O),A=()=>B.removeListener(K,O),_=new y({onFirstListenerAdd:W,onLastListenerRemove:A});return _.event}r.fromNodeEventEmitter=j;function q(B,K,T=O=>O){const O=(...z)=>_.fire(T(...z)),W=()=>B.addEventListener(K,O),A=()=>B.removeEventListener(K,O),_=new y({onFirstListenerAdd:W,onLastListenerRemove:A});return _.event}r.fromDOMEventEmitter=q;function N(B){return new Promise(K=>s(B)(K))}r.toPromise=N;function V(B,K){return K(void 0),B(T=>K(T))}r.runAndSubscribe=V;function J(B,K){let T=null;function O(A){T?.dispose(),T=new R.DisposableStore,K(A,T)}O(void 0);const W=B(A=>O(A));return(0,R.toDisposable)(()=>{W.dispose(),T?.dispose()})}r.runAndSubscribeWithStore=J})(E=e.Event||(e.Event={}));class P{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${P._idPool++}`}start(i){this._stopWatch=new C.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let k=-1;function I(r){const i=k;return k=r,{dispose(){k=i}}}e.setGlobalLeakWarningThreshold=I;class w{constructor(i,s=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,s){let a=k;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||s<a)return;this._stacks||(this._stacks=new Map);const c=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let b,p=0;for(const[D,F]of this._stacks)(!b||p<F)&&(b=D,p=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${p}):`),console.warn(b)}return()=>{const b=this._stacks.get(i.value)||0;this._stacks.set(i.value,b-1)}}}class t{constructor(i){this.value=i}static create(){return new t(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(i,s,a){this.callback=i,this.callbackThis=s,this.stack=a,this.subscription=new R.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class y{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=k>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const s of i)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,s,a)=>{this._listeners||(this._listeners=new L.LinkedList);const c=this._listeners.isEmpty();c&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let b,p;this._leakageMon&&this._listeners.size>=30&&(p=t.create(),b=this._leakageMon.check(p,this._listeners.size+1)),S&&(p=p??t.create());const D=new h(i,s,p),F=this._listeners.push(D);c&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,s);const U=D.subscription.set(()=>{b&&b(),this._disposed||(F(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof R.DisposableStore?a.add(U):Array.isArray(a)&&a.push(U),U}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,a]=this._deliveryQueue.shift();try{s.invoke(a)}catch(c){(0,m.onUnexpectedError)(c)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class v extends y{async fireAsync(i,s,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const c of this._listeners)this._asyncDeliveryQueue.push([c,i]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[c,b]=this._asyncDeliveryQueue.shift(),p=[],D={...b,token:s,waitUntil:F=>{if(Object.isFrozen(p))throw new Error("waitUntil can NOT be called asynchronous");a&&(F=a(F,c.callback)),p.push(F)}};try{c.invoke(D)}catch(F){(0,m.onUnexpectedError)(F);continue}Object.freeze(p),await Promise.allSettled(p).then(F=>{for(const U of F)U.status==="rejected"&&(0,m.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=v;class M extends y{constructor(i){super(i);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=M;class g extends M{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=g;class u extends y{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=u;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const s={event:i,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const a=()=>{this.hasListeners&&this.unhook(s);const c=this.events.indexOf(s);this.events.splice(c,1)};return(0,R.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(s=>this.emitter.fire(s))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class o{constructor(){this.buffers=[]}wrapEvent(i){return(s,a,c)=>i(b=>{const p=this.buffers[this.buffers.length-1];p?p.push(()=>s.call(a,b)):s.call(a,b)},void 0,c)}bufferEvents(i){const s=[];this.buffers.push(s);const a=i();return this.buffers.pop(),s.forEach(c=>c()),a}}e.EventBufferer=o;class d{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=d}),define(Z[23],x([0,1,4]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(S,f){const E=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(E)}}});var R;(function(S){function f(E){return E===S.None||E===S.Cancelled||E instanceof L?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=C}),define(Z[113],x([0,1,23]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new m.CancellationTokenSource,S=this.task(C.token);return this.result={promise:S,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=n;class R{constructor(C){this.computeFn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const S=JSON.stringify(C);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.computeFn(C)),this.lastCache}}e.LRUCachedComputed=R}),define(Z[48],x([0,1,15,2]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(u){const l=u;return l?typeof l.read=="function":!1}e.isReadable=R;function L(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=L;function C(u){const l=u;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=C;function S(u,l){return new f(u,l)}e.newWriteableStream=S;class f{constructor(l,o){this.reducer=l,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(o=>o(l))}emitError(l){this.listeners.error.length===0?(0,m.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(o=>o(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,o){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(l,o){if(this.state.destroyed)return;let d;switch(l){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const r=d.indexOf(o);r>=0&&d.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(u,l){const o=[];let d;for(;(d=u.read())!==null;)o.push(d);return l(o)}e.consumeReadable=E;function P(u,l,o){const d=[];let r;for(;(r=u.read())!==null&&d.length<o;)d.push(r);return r===null&&d.length>0?l(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return u.read()}}}e.peekReadable=P;function k(u,l){return new Promise((o,d)=>{const r=[];I(u,{onData:i=>{l&&r.push(i)},onError:i=>{l?d(i):o(void 0)},onEnd:()=>{o(l?l(r):void 0)}})})}e.consumeStream=k;function I(u,l){let o=!1;return u.on("error",d=>{o||l.onError(d)}),u.on("end",()=>{o||l.onEnd()}),u.on("data",d=>{o||l.onData(d)}),(0,n.toDisposable)(()=>o=!0)}e.listenStream=I;function w(u,l){return new Promise((o,d)=>{const r=new n.DisposableStore,i=[],s=b=>{if(i.push(b),i.length>l)return r.dispose(),u.pause(),o({stream:u,buffer:i,ended:!1})},a=b=>d(b),c=()=>o({stream:u,buffer:i,ended:!0});r.add((0,n.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),r.add((0,n.toDisposable)(()=>u.removeListener("end",c))),u.on("end",c),r.add((0,n.toDisposable)(()=>u.removeListener("data",s))),u.on("data",s)})}e.peekStream=w;function t(u,l){const o=S(l);return o.end(u),o}e.toStream=t;function h(){const u=S(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=h;function y(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.toReadable=y;function v(u,l,o){const d=S(o);return I(u,{onData:r=>d.write(l.data(r)),onError:r=>d.error(l.error?l.error(r):r),onEnd:()=>d.end()}),d}e.transform=v;function M(u,l,o){let d=!1;return{read:()=>{const r=l.read();return d?r:(d=!0,r!==null?o([u,r]):u)}}}e.prefixedReadable=M;function g(u,l,o){let d=!1;const r=S(o);return I(l,{onData:i=>d?r.write(i):(d=!0,r.write(o([u,i]))),onError:i=>r.error(i),onEnd:()=>{d||(d=!0,r.write(u)),r.end()}}),r}e.prefixedStream=g}),define(Z[16],x([0,1,48]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let R,L;class C{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return n?new C(Buffer.allocUnsafe(b)):new C(new Uint8Array(b))}static wrap(b){return n&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new C(b)}static fromString(b,p){return!(p?.dontUseNodeBuffer||!1)&&n?new C(Buffer.from(b)):(R||(R=new TextEncoder),new C(R.encode(b)))}static fromByteArray(b){const p=C.alloc(b.length);for(let D=0,F=b.length;D<F;D++)p.buffer[D]=b[D];return p}static concat(b,p){if(typeof p=="undefined"){p=0;for(let U=0,Q=b.length;U<Q;U++)p+=b[U].byteLength}const D=C.alloc(p);let F=0;for(let U=0,Q=b.length;U<Q;U++){const te=b[U];D.set(te,F),F+=te.byteLength}return D}clone(){const b=C.alloc(this.byteLength);return b.set(this),b}toString(){return n?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(b,p){return new C(this.buffer.subarray(b,p))}set(b,p){if(b instanceof C)this.buffer.set(b.buffer,p);else if(b instanceof Uint8Array)this.buffer.set(b,p);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),p);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return E(this.buffer,b)}writeUInt32BE(b,p){P(this.buffer,b,p)}readUInt32LE(b){return k(this.buffer,b)}writeUInt32LE(b,p){I(this.buffer,b,p)}readUInt8(b){return w(this.buffer,b)}writeUInt8(b,p){t(this.buffer,b,p)}}e.VSBuffer=C;function S(c,b){return c[b+0]<<0>>>0|c[b+1]<<8>>>0}e.readUInt16LE=S;function f(c,b,p){c[p+0]=b&255,b=b>>>8,c[p+1]=b&255}e.writeUInt16LE=f;function E(c,b){return c[b]*2**24+c[b+1]*2**16+c[b+2]*2**8+c[b+3]}e.readUInt32BE=E;function P(c,b,p){c[p+3]=b,b=b>>>8,c[p+2]=b,b=b>>>8,c[p+1]=b,b=b>>>8,c[p]=b}e.writeUInt32BE=P;function k(c,b){return c[b+0]<<0>>>0|c[b+1]<<8>>>0|c[b+2]<<16>>>0|c[b+3]<<24>>>0}e.readUInt32LE=k;function I(c,b,p){c[p+0]=b&255,b=b>>>8,c[p+1]=b&255,b=b>>>8,c[p+2]=b&255,b=b>>>8,c[p+3]=b&255}e.writeUInt32LE=I;function w(c,b){return c[b]}e.readUInt8=w;function t(c,b,p){c[p]=b}e.writeUInt8=t;function h(c){return m.consumeReadable(c,b=>C.concat(b))}e.readableToBuffer=h;function y(c){return m.toReadable(c)}e.bufferToReadable=y;function v(c){return m.consumeStream(c,b=>C.concat(b))}e.streamToBuffer=v;async function M(c){return c.ended?C.concat(c.buffer):C.concat([...c.buffer,await v(c.stream)])}e.bufferedStreamToBuffer=M;function g(c){return m.toStream(c,b=>C.concat(b))}e.bufferToStream=g;function u(c){return m.transform(c,{data:b=>typeof b=="string"?C.fromString(b):C.wrap(b)},b=>C.concat(b))}e.streamToBufferReadableStream=u;function l(c){return m.newWriteableStream(b=>C.concat(b),c)}e.newWriteableBufferStream=l;function o(c,b){return m.prefixedReadable(c,b,p=>C.concat(p))}e.prefixedBufferReadable=o;function d(c,b){return m.prefixedStream(c,b,p=>C.concat(p))}e.prefixedBufferStream=d;function r(c){let b=0,p=0,D=0;const F=new Uint8Array(Math.floor(c.length/4*3)),U=te=>{switch(p){case 3:F[D++]=b|te,p=0;break;case 2:F[D++]=b|te>>>2,b=te<<6,p=3;break;case 1:F[D++]=b|te>>>4,b=te<<4,p=2;break;default:b=te<<2,p=1}};for(let te=0;te<c.length;te++){const ie=c.charCodeAt(te);if(ie>=65&&ie<=90)U(ie-65);else if(ie>=97&&ie<=122)U(ie-97+26);else if(ie>=48&&ie<=57)U(ie-48+52);else if(ie===43||ie===45)U(62);else if(ie===47||ie===95)U(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${c[te]}`)}}const Q=D;for(;p>0;)U(0);return C.wrap(F).slice(0,Q)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},b=!0,p=!1){const D=p?s:i;let F="";const U=c.byteLength%3;let Q=0;for(;Q<c.byteLength-U;Q+=3){const te=c[Q+0],ie=c[Q+1],ee=c[Q+2];F+=D[te>>>2],F+=D[(te<<4|ie>>>4)&63],F+=D[(ie<<2|ee>>>6)&63],F+=D[ee&63]}if(U===1){const te=c[Q+0];F+=D[te>>>2],F+=D[te<<4&63],b&&(F+="==")}else if(U===2){const te=c[Q+0],ie=c[Q+1];F+=D[te>>>2],F+=D[(te<<4|ie>>>4)&63],F+=D[ie<<2&63],b&&(F+="=")}return F}e.encodeBase64=a}),define(Z[27],x([0,1,113,111]),function(H,e,m,n){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=L;const C=/{(\d+)}/g;function S(G,...oe){return oe.length===0?G:G.replace(C,function(ce,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=oe.length?ce:oe[Se]})}e.format=S;const f=/{([^}]+)}/g;function E(G,oe){return G.replace(f,(ce,ge)=>oe[ge]??ce)}e.format2=E;function P(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function k(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function I(G,oe){let ce=0;const ge=oe.charCodeAt(0);for(let Se=G.length-1;Se>=0;Se--)G.charCodeAt(Se)===ge&&ce++;return ce}e.count=I;function w(G,oe,ce="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${ce}`}e.truncate=w;function t(G,oe=" "){const ce=h(G,oe);return y(ce,oe)}e.trim=t;function h(G,oe){if(!G||!oe)return G;const ce=oe.length;if(ce===0||G.length===0)return G;let ge=0;for(;G.indexOf(oe,ge)===ge;)ge=ge+ce;return G.substring(ge)}e.ltrim=h;function y(G,oe){if(!G||!oe)return G;const ce=oe.length,ge=G.length;if(ce===0||ge===0)return G;let Se=ge,Ae=-1;for(;Ae=G.lastIndexOf(oe,Se-1),!(Ae===-1||Ae+ce!==Se);){if(Ae===0)return"";Se=Ae}return G.substring(0,Se)}e.rtrim=y;function v(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function M(G){return G.replace(/\*/g,"")}e.stripWildcards=M;function g(G,oe,ce={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=k(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let ge="";return ce.global&&(ge+="g"),ce.matchCase||(ge+="i"),ce.multiline&&(ge+="m"),ce.unicode&&(ge+="u"),new RegExp(G,ge)}e.createRegExp=g;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function l(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function o(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=o;function d(G){return G.split(/\r\n|\r|\n/)}e.splitLines=d;function r(G){for(let oe=0,ce=G.length;oe<ce;oe++){const ge=G.charCodeAt(oe);if(ge!==32&&ge!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function i(G,oe=0,ce=G.length){for(let ge=oe;ge<ce;ge++){const Se=G.charCodeAt(ge);if(Se!==32&&Se!==9)return G.substring(oe,ge)}return G.substring(oe,ce)}e.getLeadingWhitespace=i;function s(G,oe=G.length-1){for(let ce=oe;ce>=0;ce--){const ge=G.charCodeAt(ce);if(ge!==32&&ge!==9)return ce}return-1}e.lastNonWhitespaceIndex=s;function a(G,oe){return G<oe?-1:G>oe?1:0}e.compare=a;function c(G,oe,ce=0,ge=G.length,Se=0,Ae=oe.length){for(;ce<ge&&Se<Ae;ce++,Se++){let Ve=G.charCodeAt(ce),Te=oe.charCodeAt(Se);if(Ve<Te)return-1;if(Ve>Te)return 1}const _e=ge-ce,Qe=Ae-Se;return _e<Qe?-1:_e>Qe?1:0}e.compareSubstring=c;function b(G,oe){return p(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=b;function p(G,oe,ce=0,ge=G.length,Se=0,Ae=oe.length){for(;ce<ge&&Se<Ae;ce++,Se++){let Ve=G.charCodeAt(ce),Te=oe.charCodeAt(Se);if(Ve===Te)continue;if(Ve>=128||Te>=128)return c(G.toLowerCase(),oe.toLowerCase(),ce,ge,Se,Ae);D(Ve)&&(Ve-=32),D(Te)&&(Te-=32);const je=Ve-Te;if(je!==0)return je}const _e=ge-ce,Qe=Ae-Se;return _e<Qe?-1:_e>Qe?1:0}e.compareSubstringIgnoreCase=p;function D(G){return G>=97&&G<=122}e.isLowerAsciiLetter=D;function F(G){return G>=65&&G<=90}e.isUpperAsciiLetter=F;function U(G,oe){return G.length===oe.length&&p(G,oe)===0}e.equalsIgnoreCase=U;function Q(G,oe){const ce=oe.length;return oe.length>G.length?!1:p(G,oe,0,ce)===0}e.startsWithIgnoreCase=Q;function te(G,oe){let ce,ge=Math.min(G.length,oe.length);for(ce=0;ce<ge;ce++)if(G.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return ge}e.commonPrefixLength=te;function ie(G,oe){let ce,ge=Math.min(G.length,oe.length);const Se=G.length-1,Ae=oe.length-1;for(ce=0;ce<ge;ce++)if(G.charCodeAt(Se-ce)!==oe.charCodeAt(Ae-ce))return ce;return ge}e.commonSuffixLength=ie;function ee(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ee;function $(G){return 56320<=G&&G<=57343}e.isLowSurrogate=$;function Y(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=Y;function j(G,oe,ce){const ge=G.charCodeAt(ce);if(ee(ge)&&ce+1<oe){const Se=G.charCodeAt(ce+1);if($(Se))return Y(ge,Se)}return ge}e.getNextCodePoint=j;function q(G,oe){const ce=G.charCodeAt(oe-1);if($(ce)&&oe>1){const ge=G.charCodeAt(oe-2);if(ee(ge))return Y(ge,ce)}return ce}class N{constructor(oe,ce=0){this._str=oe,this._len=oe.length,this._offset=ce}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=q(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=j(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=N;class V{constructor(oe,ce=0){this._iterator=new N(oe,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Ue.getInstance(),ce=this._iterator,ge=ce.offset;let Se=oe.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const Ae=ce.offset,_e=oe.getGraphemeBreakType(ce.nextCodePoint());if(ze(Se,_e)){ce.setOffset(Ae);break}Se=_e}return ce.offset-ge}prevGraphemeLength(){const oe=Ue.getInstance(),ce=this._iterator,ge=ce.offset;let Se=oe.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const Ae=ce.offset,_e=oe.getGraphemeBreakType(ce.prevCodePoint());if(ze(_e,Se)){ce.setOffset(Ae);break}Se=_e}return ge-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function J(G,oe){return new V(G,oe).nextGraphemeLength()}e.nextCharLength=J;function B(G,oe){return new V(G,oe).prevGraphemeLength()}e.prevCharLength=B;function K(G,oe){oe>0&&$(G.charCodeAt(oe))&&oe--;const ce=oe+J(G,oe);return[ce-B(G,ce),ce]}e.getCharContainingOffset=K;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(G){return T.test(G)}e.containsRTL=O;const W=/^[\t\n\r\x20-\x7E]*$/;function A(G){return W.test(G)}e.isBasicASCII=A,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=_;function z(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=z;function X(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=X;function se(G,oe){if(G.length<oe)return G;const ce=/\b/g;let ge=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<oe);)ge=ce.lastIndex,ce.lastIndex+=1;return G.substring(ge).replace(/^\s/,"")}e.lcut=se;const le=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function fe(G){return G&&(G=G.replace(le,""),G=G.replace(re,""),G=G.replace(ae,"")),G}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function we(G){return he(G)?G.substr(1):G}e.stripUTF8BOM=we;function Re(G,oe){if(!G||!oe||G.length<oe.length)return!1;const ce=oe.length,ge=G.toLowerCase();let Se=0,Ae=-1;for(;Se<ce;){const _e=ge.indexOf(oe[Se],Ae+1);if(_e<0)return!1;Ae=_e,Se++}return!0}e.fuzzyContains=Re;function ke(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=ke;function ve(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=ve;function be(G,oe=1){if(oe===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=be;function Ie(G){const oe=90-65+1;return G=G%(2*oe),G<oe?String.fromCharCode(97+G):String.fromCharCode(65+G-oe)}e.singleLetterHash=Ie;function We(G){return Ue.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=We;function ze(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}var qe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=ot()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,ge=ce.length/3;let Se=1;for(;Se<=ge;)if(oe<ce[3*Se])Se=2*Se;else if(oe>ce[3*Se+1])Se=2*Se+1;else return ce[3*Se+2];return 0}}Ue._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function at(G,oe){if(G===0)return 0;const ce=et(G,oe);if(ce!==void 0)return ce;const ge=new N(oe,G);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=at;function et(G,oe){const ce=new N(oe,G);let ge=ce.prevCodePoint();for(;Ze(ge)||ge===65039||ge===8419;){if(ce.offset===0)return;ge=ce.prevCodePoint()}if(!X(ge))return;let Se=ce.offset;return Se>0&&ce.prevCodePoint()===8205&&(Se=ce.offset),Se}function Ze(G){return 127995<=G&&G<=127999}var ht;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ht||(ht={})),e.noBreakWhitespace="\xA0";class Ge{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Ge.cache.get(Array.from(oe))}static getLocales(){return Ge._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ge,R=Ge,Ge.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.cache=new m.LRUCachedComputed(G=>{function oe(Te){const je=new Map;for(let Ke=0;Ke<Te.length;Ke+=2)je.set(Te[Ke],Te[Ke+1]);return je}function ce(Te,je){const Ke=new Map(Te);for(const[xe,tt]of je)Ke.set(xe,tt);return Ke}function ge(Te,je){if(!Te)return je;const Ke=new Map;for(const[xe,tt]of Te)je.has(xe)&&Ke.set(xe,tt);return Ke}const Se=R.ambiguousCharacterData.getValue();let Ae=G.filter(Te=>!Te.startsWith("_")&&Te in Se);Ae.length===0&&(Ae=["_default"]);let _e;for(const Te of Ae){const je=oe(Se[Te]);_e=ge(_e,je)}const Qe=oe(Se._common),Ve=ce(Qe,_e);return new Ge(Ve)}),Ge._locales=new n.Lazy(()=>Object.keys(Ge.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class Ye{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ye.getRawData())),this._data}static isInvisibleCharacter(oe){return Ye.getData().has(oe)}static get codePoints(){return Ye.getData()}}e.InvisibleCharacters=Ye,Ye._data=void 0}),define(Z[70],x([0,1,27]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return R(v,0)}e.hash=n;function R(v,M){switch(typeof v){case"object":return v===null?L(349,M):Array.isArray(v)?f(v,M):E(v,M);case"string":return S(v,M);case"boolean":return C(v,M);case"number":return L(v,M);case"undefined":return L(937,M);default:return L(617,M)}}e.doHash=R;function L(v,M){return(M<<5)-M+v|0}e.numberHash=L;function C(v,M){return L(v?433:863,M)}function S(v,M){M=L(149417,M);for(let g=0,u=v.length;g<u;g++)M=L(v.charCodeAt(g),M);return M}e.stringHash=S;function f(v,M){return M=L(104579,M),v.reduce((g,u)=>R(u,g),M)}function E(v,M){return M=L(181387,M),Object.keys(v).sort().reduce((g,u)=>(g=S(u,g),R(v[u],g)),M)}class P{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=R(M,this._value),this._value}}e.Hasher=P;var k;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function I(v,M,g=32){const u=g-M,l=~((1<<u)-1);return(v<<M|(l&v)>>>u)>>>0}function w(v,M=0,g=v.byteLength,u=0){for(let l=0;l<g;l++)v[M+l]=u}function t(v,M,g="0"){for(;v.length<M;)v=g+v;return v}function h(v,M=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(g=>g.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),M/4)}e.toHexString=h;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const g=M.length;if(g===0)return;const u=this._buff;let l=this._buffLen,o=this._leftoverHighSurrogate,d,r;for(o!==0?(d=o,r=-1,o=0):(d=M.charCodeAt(0),r=0);;){let i=d;if(m.isHighSurrogate(d))if(r+1<g){const s=M.charCodeAt(r+1);m.isLowSurrogate(s)?(r++,i=m.computeCodePoint(d,s)):i=65533}else{o=d;break}else m.isLowSurrogate(d)&&(i=65533);if(l=this._push(u,l,i),r++,r<g)d=M.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=o}_push(M,g,u){return u<128?M[g++]=u:u<2048?(M[g++]=192|(u&1984)>>>6,M[g++]=128|(u&63)>>>0):u<65536?(M[g++]=224|(u&61440)>>>12,M[g++]=128|(u&4032)>>>6,M[g++]=128|(u&63)>>>0):(M[g++]=240|(u&1835008)>>>18,M[g++]=128|(u&258048)>>>12,M[g++]=128|(u&4032)>>>6,M[g++]=128|(u&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=y._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)M.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)M.setUint32(c,I(M.getUint32(c-12,!1)^M.getUint32(c-32,!1)^M.getUint32(c-56,!1)^M.getUint32(c-64,!1),1),!1);let u=this._h0,l=this._h1,o=this._h2,d=this._h3,r=this._h4,i,s,a;for(let c=0;c<80;c++)c<20?(i=l&o|~l&d,s=1518500249):c<40?(i=l^o^d,s=1859775393):c<60?(i=l&o|l&d|o&d,s=2400959708):(i=l^o^d,s=3395469782),a=I(u,5)+i+r+s+M.getUint32(c*4,!1)&4294967295,r=d,d=o,o=I(l,30),l=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var Ct=this&&this.__classPrivateFieldSet||function(H,e,m,n,R){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!R:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?R.call(H,m):R?R.value=m:e.set(H,m),m},Je=this&&this.__classPrivateFieldGet||function(H,e,m,n){if(m==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!n:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?n:m==="a"?n.call(H):n?n.value:e.get(H)};define(Z[35],x([0,1,30,27]),function(H,e,m,n){"use strict";var R,L,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(r,i,s){let a=r.get(i);return a===void 0&&(a=s,r.set(i,a)),a}e.getOrSet=S;function f(r){const i=[];return r.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=f;function E(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=P;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class I{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var w;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(w||(w={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(y||(y={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new I(void 0,!i))}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new k)}clear(){this._root=void 0}fill(i,s){if(s){const a=s.slice(0);(0,m.shuffle)(a);for(let c of a)this.set(c,i)}else{const a=i.slice(0);(0,m.shuffle)(a);for(let c of a)this.set(c[0],c[1])}}set(i,s){const a=this._iter.reset(i);let c;this._root||(this._root=new h,this._root.segment=a.value());const b=[];for(c=this._root;;){const D=a.cmp(c.segment);if(D>0)c.left||(c.left=new h,c.left.segment=a.value()),b.push([-1,c]),c=c.left;else if(D<0)c.right||(c.right=new h,c.right.segment=a.value()),b.push([1,c]),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new h,c.mid.segment=a.value()),b.push([0,c]),c=c.mid;else break}const p=c.value;c.value=s,c.key=i;for(let D=b.length-1;D>=0;D--){const F=b[D][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const Q=b[D][0],te=b[D+1][0];if(Q===1&&te===1)b[D][1]=F.rotateLeft();else if(Q===-1&&te===-1)b[D][1]=F.rotateRight();else if(Q===1&&te===-1)F.right=b[D+1][1]=b[D+1][1].rotateRight(),b[D][1]=F.rotateLeft();else if(Q===-1&&te===1)F.left=b[D+1][1]=b[D+1][1].rotateLeft(),b[D][1]=F.rotateRight();else throw new Error;if(D>0)switch(b[D-1][0]){case-1:b[D-1][1].left=b[D][1];break;case 1:b[D-1][1].right=b[D][1];break;case 0:b[D-1][1].mid=b[D][1];break}else this._root=b[0][1]}}return p}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const c=s.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),c=[];let b=this._root;for(;b;){const p=a.cmp(b.segment);if(p>0)c.push([-1,b]),b=b.left;else if(p<0)c.push([1,b]),b=b.right;else if(a.hasNext())a.next(),c.push([0,b]),b=b.mid;else break}if(!!b){if(s?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const p=this._min(b.right),{key:D,value:F,segment:U}=p;this._delete(p.key,!1),b.key=D,b.value=F,b.segment=U}else{const p=b.left??b.right;if(c.length>0){const[D,F]=c[c.length-1];switch(D){case-1:F.left=p;break;case 0:F.mid=p;break;case 1:F.right=p;break}}else this._root=p}for(let p=c.length-1;p>=0;p--){const D=c[p][1];D.updateHeight();const F=D.balanceFactor();if(F>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),c[p][1]=D.rotateLeft()):F<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),c[p][1]=D.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let a=this._root,c;for(;a;){const b=s.cmp(a.segment);if(b>0)a=a.left;else if(b<0)a=a.right;else if(s.hasNext())s.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const c=s.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=v;class M{constructor(i,s){this.uri=i,this.value=s}}class g{constructor(i,s){this[R]="ResourceMap",i instanceof g?(this.map=new Map(i.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=i??g.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new M(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[a,c]of this.map)i(c.value,c.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=g,g.defaultToKey=r=>r.toString();var u;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class l{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let c=this._map.get(i);if(c)c.value=s,a!==0&&this.touch(c,a);else{switch(c={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const a=this._state;let c=this._head;for(;c;){if(s?i.bind(s)(c.value,c.key,this):i(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.key,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return c}values(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.value,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return c}entries(){const i=this,s=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:[a.key,a.value],done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,c=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=l;class o extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class d{constructor(i){C.set(this,void 0),Ct(this,C,i,"f")}get size(){return Je(this,C,"f").size}forEach(i,s){Je(this,C,"f").forEach(i,s)}get(i){return Je(this,C,"f").get(i)}has(i){return Je(this,C,"f").has(i)}entries(){return Je(this,C,"f").entries()}keys(){return Je(this,C,"f").keys()}values(){return Je(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Je(this,C,"f").entries()}}e.ReadonlyMapView=d}),define(Z[71],x([0,1,35]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new m.LRUCache(1e4);function R(E){return f(E,"NFC",n)}e.normalizeNFC=R;const L=new m.LRUCache(1e4);function C(E){return f(E,"NFD",L)}e.normalizeNFD=C;const S=/[^\u0000-\u0080]/;function f(E,P,k){if(!E)return E;const I=k.get(E);if(I)return I;let w;return S.test(E)?w=E.normalize(P):w=E,k.set(E,w),w}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return C(P).replace(E,"")}}()}),define(Z[14],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(c){return Array.isArray(c)}e.isArray=m;function n(c){return typeof c=="string"}e.isString=n;function R(c){return Array.isArray(c)&&c.every(b=>n(b))}e.isStringArray=R;function L(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=L;function C(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=C;function S(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=S;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=f;function E(c){return c===!0||c===!1}e.isBoolean=E;function P(c){return typeof c=="undefined"}e.isUndefined=P;function k(c){return!I(c)}e.isDefined=k;function I(c){return P(c)||c===null}e.isUndefinedOrNull=I;function w(c,b){if(!c)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=w;function t(c){if(I(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=t;function h(...c){const b=[];for(let p=0;p<c.length;p++){const D=c[p];if(I(D))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);b.push(D)}return b}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function v(c){if(!L(c))return!1;for(let b in c)if(y.call(c,b))return!1;return!0}e.isEmptyObject=v;function M(c){return typeof c=="function"}e.isFunction=M;function g(...c){return c.length>0&&c.every(M)}e.areFunctions=g;function u(c,b){const p=Math.min(c.length,b.length);for(let D=0;D<p;D++)l(c[D],b[D])}e.validateConstraints=u;function l(c,b){if(n(b)){if(typeof c!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(M(b)){try{if(c instanceof b)return}catch{}if(!I(c)&&c.constructor===b||b.length===1&&b.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function o(c){let b=[],p=Object.getPrototypeOf(c);for(;Object.prototype!==p;)b=b.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return b}e.getAllPropertyNames=o;function d(c){const b=[];for(const p of o(c))typeof c[p]=="function"&&b.push(p);return b}e.getAllMethodNames=d;function r(c,b){const p=F=>function(){const U=Array.prototype.slice.call(arguments,0);return b(F,U)};let D={};for(const F of c)D[F]=p(F);return D}e.createProxyObject=r;function i(c){return c===null?void 0:c}e.withNullAsUndefined=i;function s(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=s;function a(c,b="Unreachable"){throw new Error(b)}e.assertNever=a}),define(Z[28],x([0,1,7,3,27,14]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(s){return s===47||s===92}e.isPathSeparator=C;function S(s){return s.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=S;function f(s){return s.indexOf("/")===-1&&(s=S(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=f;function E(s,a=m.posix.sep){if(!s)return"";const c=s.length,b=s.charCodeAt(0);if(C(b)){if(C(s.charCodeAt(1))&&!C(s.charCodeAt(2))){let D=3;const F=D;for(;D<c&&!C(s.charCodeAt(D));D++);if(F!==D&&!C(s.charCodeAt(D+1))){for(D+=1;D<c;D++)if(C(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,a)}}return a}else if(v(b)&&s.charCodeAt(1)===58)return C(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<c;p++)if(C(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=E;function P(s){if(!n.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let c=2;const b=c;for(;c<s.length&&(a=s.charCodeAt(c),a!==92);c++);return!(b===c||(a=s.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=P;const k=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,a=n.isWindows){const c=a?k:I;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||a&&w.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function h(s,a,c){const b=s===a;return!c||b?b:!s||!a?!1:(0,R.equalsIgnoreCase)(s,a)}e.isEqual=h;function y(s,a,c,b=m.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let D=a.length;return a.charAt(a.length-1)===b&&D--,s.charAt(D)===b}return a.charAt(a.length-1)!==b&&(a+=b),s.indexOf(a)===0}e.isEqualOrParent=y;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function M(s,a){return n.isWindows&&s.endsWith(":")&&(s+=m.sep),(0,m.isAbsolute)(s)||(s=(0,m.join)(a,s)),s=(0,m.normalize)(s),n.isWindows?(s=(0,R.rtrim)(s,m.sep),s.endsWith(":")&&(s+=m.sep)):(s=(0,R.rtrim)(s,m.sep),s||(s=m.sep)),s}e.sanitizeFilePath=M;function g(s){const a=(0,m.normalize)(s);return n.isWindows?s.length>3?!1:u(a)&&(s.length===2||a.charCodeAt(2)===92):a===m.posix.sep}e.isRootOrDriveLetter=g;function u(s,a){return(a!==void 0?a:n.isWindows)?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function l(s){return u(s)?s[0]:void 0}e.getDriveLetter=l;function o(s,a,c){return a.length>s.length?-1:s===a?0:(c&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=o;function d(s){const a=s.split(":");let c,b,p;for(const D of a){const F=Number(D);(0,L.isNumber)(F)?b===void 0?b=F:p===void 0&&(p=F):c=c?[c,D].join(":"):D}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:b!==void 0?b:void 0,column:p!==void 0?p:b!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,a,c=8){let b="";for(let D=0;D<c;D++)b+=r.charAt(Math.floor(Math.random()*r.length));let p;return a?p=`${a}-${b}`:p=b,s?(0,m.join)(s,p):p}e.randomPath=i}),define(Z[49],x([0,1,14]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const y=Array.isArray(h)?[]:{};return Object.keys(h).forEach(v=>{h[v]&&typeof h[v]=="object"?y[v]=n(h[v]):y[v]=h[v]}),y}e.deepClone=n;function R(h){if(!h||typeof h!="object")return h;const y=[h];for(;y.length>0;){const v=y.shift();Object.freeze(v);for(const M in v)if(L.call(v,M)){const g=v[M];typeof g=="object"&&!Object.isFrozen(g)&&!(0,m.isTypedArray)(g)&&y.push(g)}}return h}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function C(h,y){return S(h,y,new Set)}e.cloneAndChange=C;function S(h,y,v){if((0,m.isUndefinedOrNull)(h))return h;const M=y(h);if(typeof M!="undefined")return M;if((0,m.isArray)(h)){const g=[];for(const u of h)g.push(S(u,y,v));return g}if((0,m.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const g={};for(let u in h)L.call(h,u)&&(g[u]=S(h[u],y,v));return v.delete(h),g}return h}function f(h,y,v=!0){return(0,m.isObject)(h)?((0,m.isObject)(y)&&Object.keys(y).forEach(M=>{M in h?v&&((0,m.isObject)(h[M])&&(0,m.isObject)(y[M])?f(h[M],y[M],v):h[M]=y[M]):h[M]=y[M]}),h):y}e.mixin=f;function E(h,y){if(h===y)return!0;if(h==null||y===null||y===void 0||typeof h!=typeof y||typeof h!="object"||Array.isArray(h)!==Array.isArray(y))return!1;let v,M;if(Array.isArray(h)){if(h.length!==y.length)return!1;for(v=0;v<h.length;v++)if(!E(h[v],y[v]))return!1}else{const g=[];for(M in h)g.push(M);g.sort();const u=[];for(M in y)u.push(M);if(u.sort(),!E(g,u))return!1;for(v=0;v<g.length;v++)if(!E(h[g[v]],y[g[v]]))return!1}return!0}e.equals=E;function P(h){const y=new Set;return JSON.stringify(h,(v,M)=>{if((0,m.isObject)(M)||Array.isArray(M)){if(y.has(M))return"[Circular]";y.add(M)}return M})}e.safeStringify=P;function k(h,y,v){const M=y(h);return typeof M=="undefined"?v:M}e.getOrDefault=k;function I(h,y){const v=Object.create(null);return!h||!y||Object.keys(y).forEach(g=>{const u=h[g],l=y[g];E(u,l)||(v[g]=l)}),v}e.distinct=I;function w(h,y){const v=y.toLowerCase(),M=Object.keys(h).find(g=>g.toLowerCase()===v);return M?h[M]:h[y]}e.getCaseInsensitive=w;function t(h,y){const v=Object.create(null);for(const[M,g]of Object.entries(h))y(M,g)&&(v[M]=g);return v}e.filter=t}),define(Z[8],x([0,1,7,3]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,C=/^\/\//;function S(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!R.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!L.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,i){return!r&&!i?"file":r}function E(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const P="",k="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(i,s,a,c,b,p=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=f(i,p),this.authority=s||P,this.path=E(this.scheme,a||P),this.query=c||P,this.fragment=b||P,S(this,p))}static isUri(i){return i instanceof w?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:a,path:c,query:b,fragment:p}=i;return s===void 0?s=this.scheme:s===null&&(s=P),a===void 0?a=this.authority:a===null&&(a=P),c===void 0?c=this.path:c===null&&(c=P),b===void 0?b=this.query:b===null&&(b=P),p===void 0?p=this.fragment:p===null&&(p=P),s===this.scheme&&a===this.authority&&c===this.path&&b===this.query&&p===this.fragment?this:new h(s,a,c,b,p)}static parse(i,s=!1){const a=I.exec(i);return a?new h(a[2]||P,d(a[4]||P),d(a[5]||P),d(a[7]||P),d(a[9]||P),s):new h(P,P,P,P,P)}static file(i){let s=P;if(n.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const a=i.indexOf(k,2);a===-1?(s=i.substring(2),i=k):(s=i.substring(2,a),i=i.substring(a)||k)}return new h("file",s,i,P,P)}static from(i){const s=new h(i.scheme,i.authority,i.path,i.query,i.fragment);return S(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return n.isWindows&&i.scheme==="file"?a=w.file(m.win32.join(g(i,!0),...s)).path:a=m.posix.join(i.path,...s),i.with({path:a})}toString(i=!1){return u(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof w)return i;{const s=new h(i);return s._formatted=i.external,s._fsPath=i._sep===t?i.fsPath:null,s}}else return i}}e.URI=w;const t=n.isWindows?1:void 0;class h extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,i){let s,a=-1;for(let c=0;c<r.length;c++){const b=r.charCodeAt(c);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)a!==-1&&(s+=encodeURIComponent(r.substring(a,c)),a=-1),s!==void 0&&(s+=r.charAt(c));else{s===void 0&&(s=r.substr(0,c));const p=y[b];p!==void 0?(a!==-1&&(s+=encodeURIComponent(r.substring(a,c)),a=-1),s+=p):a===-1&&(a=c)}}return a!==-1&&(s+=encodeURIComponent(r.substring(a))),s!==void 0?s:r}function M(r){let i;for(let s=0;s<r.length;s++){const a=r.charCodeAt(s);a===35||a===63?(i===void 0&&(i=r.substr(0,s)),i+=y[a]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function g(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function u(r,i){const s=i?M:v;let a="",{scheme:c,authority:b,path:p,query:D,fragment:F}=r;if(c&&(a+=c,a+=":"),(b||c==="file")&&(a+=k,a+=k),b){let U=b.indexOf("@");if(U!==-1){const Q=b.substr(0,U);b=b.substr(U+1),U=Q.indexOf(":"),U===-1?a+=s(Q,!1):(a+=s(Q.substr(0,U),!1),a+=":",a+=s(Q.substr(U+1),!1)),a+="@"}b=b.toLowerCase(),U=b.indexOf(":"),U===-1?a+=s(b,!1):(a+=s(b.substr(0,U),!1),a+=b.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}a+=s(p,!0)}return D&&(a+="?",a+=s(D,!1)),F&&(a+="#",a+=i?F:v(F,!1)),a}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(r){return r.match(o)?r.replace(o,i=>l(i)):r}}),define(Z[114],x([0,1,8]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function R(E){const P=[];let k;try{const I=JSON.parse(E.arguments),w=I[I.length-1];w&&w.__$stack&&(I.pop(),k=w.__$stack),P.push(...I)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:k}}e.parse=R;function L(E){if(typeof E!="string")return L(R(E).stack);const P=E;if(P){const k=C(P),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(I&&I.length===4)return{uri:m.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=L;function C(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function S(E,P){const{args:k,stack:I}=R(E),w=typeof k[0]=="string"&&k.length===1;let t=C(I);t&&(t=`(${t.trim()})`);let h=[];if(typeof k[0]=="string"?t&&w?h=[`%c[${P}] %c${k[0]} %c${t}`,f("blue"),f(""),f("grey")]:h=[`%c[${P}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:h=[`%c[${P}]%`,f("blue"),...k],t&&!w&&h.push(t),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}e.log=S;function f(E){return`color: ${E}`}}),define(Z[115],x([0,1,16,27,8]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(E){return JSON.stringify(E,S)}e.stringify=L;function C(E){let P=JSON.parse(E);return P=f(P),P}e.parse=C;function S(E,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,n.regExpFlags)(P)}:P}function f(E,P=0){if(!E||P>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof m.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let k=0;k<E.length;++k)E[k]=f(E[k],P+1);else for(const k in E)Object.hasOwnProperty.call(E,k)&&(E[k]=f(E[k],P+1))}return E}e.revive=f}),define(Z[10],x([0,1,3,8]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,E,P){this._hosts[f]=E,this._ports[f]=P}setConnectionToken(f,E){this._connectionTokens[f]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(f){if(this._delegate)return this._delegate(f);const E=f.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const k=this._ports[E],I=this._connectionTokens[E];let w=`path=${encodeURIComponent(f.path)}`;return typeof I=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),n.URI.from({scheme:m.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${P}:${k}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new L;class C{asBrowserUri(f,E){const P=this.toUri(f,E);return P.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===R.file&&(m.isNative||m.isWebWorker&&m.globals.origin===`${R.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?P.with({scheme:R.vscodeFileResource,authority:P.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(f,E){const P=this.toUri(f,E);return P.scheme===R.vscodeFileResource?P.with({scheme:R.file,authority:P.authority!==C.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(f,E){return n.URI.isUri(f)?f:n.URI.parse(E.toUrl(f))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(Z[17],x([0,1,28,10,7,3,27,8]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(w){return(0,S.uriToFsPath)(w,!0)}e.originalFSPath=f;class E{constructor(t){this._ignorePathCasing=t}compare(t,h,y=!1){return t===h?0:(0,C.compare)(this.getComparisonKey(t,y),this.getComparisonKey(h,y))}isEqual(t,h,y=!1){return t===h?!0:!t||!h?!1:this.getComparisonKey(t,y)===this.getComparisonKey(h,y)}getComparisonKey(t,h=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,h,y=!1){if(t.scheme===h.scheme){if(t.scheme===n.Schemas.file)return m.isEqualOrParent(f(t),f(h),this._ignorePathCasing(t))&&t.query===h.query&&(y||t.fragment===h.fragment);if((0,e.isEqualAuthority)(t.authority,h.authority))return m.isEqualOrParent(t.path,h.path,this._ignorePathCasing(t),"/")&&t.query===h.query&&(y||t.fragment===h.fragment)}return!1}joinPath(t,...h){return S.URI.joinPath(t,...h)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return R.posix.basename(t.path)}extname(t){return R.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let h;return t.scheme===n.Schemas.file?h=S.URI.file(R.dirname(f(t))).path:(h=R.posix.dirname(t.path),t.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),h="/")),t.with({path:h})}normalizePath(t){if(!t.path.length)return t;let h;return t.scheme===n.Schemas.file?h=S.URI.file(R.normalize(f(t))).path:h=R.posix.normalize(t.path),t.with({path:h})}relativePath(t,h){if(t.scheme!==h.scheme||!(0,e.isEqualAuthority)(t.authority,h.authority))return;if(t.scheme===n.Schemas.file){const M=R.relative(f(t),f(h));return L.isWindows?m.toSlashes(M):M}let y=t.path||"/",v=h.path||"/";if(this._ignorePathCasing(t)){let M=0;for(const g=Math.min(y.length,v.length);M<g&&!(y.charCodeAt(M)!==v.charCodeAt(M)&&y.charAt(M).toLowerCase()!==v.charAt(M).toLowerCase());M++);y=v.substr(0,M)+y.substr(M)}return R.posix.relative(y,v)}resolvePath(t,h){if(t.scheme===n.Schemas.file){const y=S.URI.file(R.resolve(f(t),h));return t.with({authority:y.authority,path:y.path})}return h=m.toPosixPath(h),t.with({path:R.posix.resolve(t.path,h)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,h){return t===h||t!==void 0&&h!==void 0&&(0,C.equalsIgnoreCase)(t,h)}hasTrailingPathSeparator(t,h=R.sep){if(t.scheme===n.Schemas.file){const y=f(t);return y.length>m.getRoot(y).length&&y[y.length-1]===h}else{const y=t.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,h=R.sep){return(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,h=R.sep){let y=!1;if(t.scheme===n.Schemas.file){const v=f(t);y=v!==void 0&&v.length===m.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=t.path;y=v.length===1&&v.charCodeAt(v.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path+"/"}):t}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(w=>w.scheme===n.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new E(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(w,t){const h=[];for(let y=0;y<w.length;y++){const v=t(w[y]);w.some((M,g)=>g===y?!1:(0,e.isEqualOrParent)(v,t(M)))||h.push(w[y])}return h}e.distinctParents=P;var k;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function t(h){const y=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(g=>{const[u,l]=g.split(":");u&&l&&y.set(u,l)});const M=h.path.substring(0,h.path.indexOf(";"));return M&&y.set(w.META_DATA_MIME,M),y}w.parseMetaData=t})(k=e.DataUri||(e.DataUri={}));function I(w,t,h){if(t){let y=w.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),w.with({scheme:h,authority:t,path:y})}return w.with({scheme:h})}e.toLocalResource=I}),define(Z[9],x([0,1,23,15,4,2,17,3]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(O){return!!O&&typeof O.then=="function"}e.isThenable=f;function E(O){const W=new m.CancellationTokenSource,A=O(W.token),_=new Promise((z,X)=>{const se=W.token.onCancellationRequested(()=>{se.dispose(),W.dispose(),X(new n.CancellationError)});Promise.resolve(A).then(le=>{se.dispose(),W.dispose(),z(le)},le=>{se.dispose(),W.dispose(),X(le)})});return new class{cancel(){W.cancel()}then(z,X){return _.then(z,X)}catch(z){return this.then(void 0,z)}finally(z){return _.finally(z)}}}e.createCancelablePromise=E;function P(O,W,A){return new Promise((_,z)=>{const X=W.onCancellationRequested(()=>{X.dispose(),_(A)});O.then(_,z).finally(()=>X.dispose())})}e.raceCancellation=P;function k(O,W){return new Promise((A,_)=>{const z=W.onCancellationRequested(()=>{z.dispose(),_(new n.CancellationError)});O.then(A,_).finally(()=>z.dispose())})}e.raceCancellationError=k;async function I(O){let W=-1;const A=O.map((z,X)=>z.then(se=>(W=X,se))),_=await Promise.race(A);return O.forEach((z,X)=>{X!==W&&z.cancel()}),_}e.raceCancellablePromises=I;function w(O,W,A){let _;const z=setTimeout(()=>{_?.(void 0),A?.()},W);return Promise.race([O.finally(()=>clearTimeout(z)),new Promise(X=>_=X)])}e.raceTimeout=w;function t(O){return new Promise((W,A)=>{const _=O();f(_)?_.then(W,A):W(_)})}e.asPromise=t;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(A,A).then(_)})}return new Promise((A,_)=>{this.queuedPromise.then(A,_)})}return this.activePromise=W(),new Promise((A,_)=>{this.activePromise.then(z=>{this.activePromise=null,A(z)},z=>{this.activePromise=null,_(z)})})}}e.Throttler=h;class y{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=y;class v{constructor(){this.promiseMap=new Map}queue(W,A){const z=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(W)===z&&this.promiseMap.delete(W)});return this.promiseMap.set(W,z),z}}e.SequencerByKey=v;const M=(O,W)=>{let A=!0;const _=setTimeout(()=>{A=!1,W()},O);return{isTriggered:()=>A,dispose:()=>{clearTimeout(_),A=!1}}},g=O=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,O())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(W){this.defaultDelay=W,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,A=this.defaultDelay){this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,X)=>{this.doResolve=z,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=A===e.MicrotaskDelay?g(_):M(A,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class l{constructor(W){this.delayer=new u(W),this.throttler=new h}trigger(W,A){return this.delayer.trigger(()=>this.throttler.queue(W),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class o{constructor(){this._isOpen=!1,this._promise=new Promise((W,A)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class d extends o{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function r(O,W){return W?new Promise((A,_)=>{const z=setTimeout(()=>{X.dispose(),A()},O),X=W.onCancellationRequested(()=>{clearTimeout(z),X.dispose(),_(new n.CancellationError)})}):E(A=>r(O,A))}e.timeout=r;function i(O,W=0){const A=setTimeout(O,W);return(0,L.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=i;function s(O){const W=[];let A=0;const _=O.length;function z(){return A<_?O[A++]():null}function X(se){se!=null&&W.push(se);const le=z();return le?le.then(X):Promise.resolve(W)}return Promise.resolve(null).then(X)}e.sequence=s;function a(O,W=_=>!!_,A=null){let _=0;const z=O.length,X=()=>{if(_>=z)return Promise.resolve(A);const se=O[_++];return Promise.resolve(se()).then(re=>W(re)?Promise.resolve(re):X())};return X()}e.first=a;function c(O,W=_=>!!_,A=null){if(O.length===0)return Promise.resolve(A);let _=O.length;const z=()=>{_=-1;for(const X of O)X.cancel?.()};return new Promise((X,se)=>{for(const le of O)le.then(re=>{--_>=0&&W(re)?(z(),X(re)):_===0&&X(A)}).catch(re=>{--_>=0&&(z(),se(re))})})}e.firstParallel=c;class b{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(W){return this._size++,new Promise((A,_)=>{this.outstandingPromises.push({factory:W,c:A,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const A=W.factory();A.then(W.c,W.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=b;class p extends b{constructor(){super(1)}}e.Queue=p;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const W=new N;return this.drainers.add(W),W.p}isDrained(){for(const[,W]of this.queues)if(W.size>0)return!1;return!0}queueFor(W,A=C.extUri){const _=A.getComparisonKey(W);let z=this.queues.get(_);return z||(z=new p,R.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,z)),z}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const W of this.drainers)W.complete();this.drainers.clear()}dispose(){for(const[,W]of this.queues)W.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class F{constructor(W,A){this._token=-1,typeof W=="function"&&typeof A=="number"&&this.setIfNotSet(W,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},A)}setIfNotSet(W,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},A))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,A){this.cancel(),this._token=setInterval(()=>{W()},A)}}e.IntervalTimer=U;class Q{constructor(W,A){this.timeoutToken=-1,this.runner=W,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class te{constructor(W,A){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=A,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=te;class ie extends Q{constructor(W,A){super(W,A);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ie;class ee extends L.Disposable{constructor(W,A){super();this.options=W,this.handler=A,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.options.maxBufferedWork)return!1}else if(this.pending+W.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ee,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=O=>{(0,S.setTimeout0)(()=>{if(W)return;const A=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(O,W)=>{const A=requestIdleCallback(O,typeof W=="number"?{timeout:W}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(A))}}}}();class ${constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function Y(O,W,A){let _;for(let z=0;z<A;z++)try{return await O()}catch(X){_=X,await r(W)}throw _}e.retry=Y;class j{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,A,_){return this._pending={taskId:W,cancel:()=>_?.(),promise:A},A.then(()=>this.donePending(W),()=>this.donePending(W)),A}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let A,_;const z=new Promise((X,se)=>{A=X,_=se});this._next={run:W,promise:z,promiseResolve:A,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=j;class q{constructor(W,A=()=>Date.now()){this.interval=W,this.nowFn=A,this.lastIncrementTime=0,this.value=0}increment(){const W=this.nowFn();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,A)=>{this.completeCallback=W,this.errorCallback=A})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(A=>{this.completeCallback(W),this.resolved=!0,A()})}error(W){return new Promise(A=>{this.errorCallback(W),this.rejected=!0,A()})}cancel(){new Promise(W=>{this.errorCallback(new n.CancellationError),this.rejected=!0,W()})}}e.DeferredPromise=N;var V;(function(O){async function W(_){let z;const X=await Promise.all(_.map(se=>se.then(le=>le,le=>{z||(z=le)})));if(typeof z!="undefined")throw z;return X}O.settled=W;function A(_){return new Promise(async(z,X)=>{try{await _(z,X)}catch(se){X(se)}})}O.withAsyncBody=A})(V=e.Promises||(e.Promises={}));var J;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(J||(J={}));class B{constructor(W){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const A={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(W(A)),this.resolve()}catch(_){this.reject(_)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}static fromArray(W){return new B(A=>{A.emitMany(W)})}static fromPromise(W){return new B(async A=>{A.emitMany(await W)})}static fromPromises(W){return new B(async A=>{await Promise.all(W.map(async _=>A.emitOne(await _)))})}static merge(W){return new B(async A=>{await Promise.all(W.map(async _=>{for await(const z of _)A.emitOne(z)}))})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(W<this._results.length)return{done:!1,value:this._results[W++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(W,A){return new B(async _=>{for await(const z of W)_.emitOne(A(z))})}map(W){return B.map(this,W)}static filter(W,A){return new B(async _=>{for await(const z of W)A(z)&&_.emitOne(z)})}filter(W){return B.filter(this,W)}static coalesce(W){return B.filter(W,A=>!!A)}coalesce(){return B.coalesce(this)}static async toPromise(W){const A=[];for await(const _ of W)A.push(_);return A}toPromise(){return B.toPromise(this)}emitOne(W){this._state===0&&(this._results.push(W),this._onStateChanged.fire())}emitMany(W){this._state===0&&(this._results=this._results.concat(W),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(W){this._state===0&&(this._state=2,this._error=W,this._onStateChanged.fire())}}e.AsyncIterableObject=B,B.EMPTY=B.fromArray([]);class K extends B{constructor(W,A){super(A);this._source=W}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function T(O){const W=new m.CancellationTokenSource,A=O(W.token);return new K(W,async _=>{const z=W.token.onCancellationRequested(()=>{z.dispose(),W.dispose(),_.reject(new n.CancellationError)});try{for await(const X of A){if(W.token.isCancellationRequested)return;_.emitOne(X)}z.dispose(),W.dispose()}catch(X){z.dispose(),W.dispose(),_.reject(X)}})}e.createCancelableAsyncIterable=T}),define(Z[116],x([0,1,9,28,35,7,3,27]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function f(){return Object.create(null)}e.getEmptyExpression=f,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",P="[^/\\\\]",k=/\//g;function I(j,q){switch(j){case 0:return"";case 1:return`${P}*?`;default:return`(?:${E}|${P}+${E}${q?`|${E}${P}+`:""})*?`}}function w(j,q){if(!j)return[];const N=[];let V=!1,J=!1,B="";for(const K of j){switch(K){case q:if(!V&&!J){N.push(B),B="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":J=!0;break;case"]":J=!1;break}B+=K}return B&&N.push(B),N}e.splitGlobAware=w;function t(j){if(!j)return"";let q="";const N=w(j,e.GLOB_SPLIT);if(N.every(V=>V===e.GLOBSTAR))q=".*";else{let V=!1;N.forEach((J,B)=>{if(J===e.GLOBSTAR){if(V)return;q+=I(2,B===N.length-1)}else{let K=!1,T="",O=!1,W="";for(const A of J){if(A!=="}"&&K){T+=A;continue}if(O&&(A!=="]"||!W)){let _;A==="-"?_=A:(A==="^"||A==="!")&&!W?_="^":A===e.GLOB_SPLIT?_="":_=(0,S.escapeRegExpCharacters)(A),W+=_;continue}switch(A){case"{":K=!0;continue;case"[":O=!0;continue;case"}":{q+=`(?:${w(T,",").map(X=>t(X)).join("|")})`,K=!1,T="";break}case"]":{q+="["+W+"]",O=!1,W="";break}case"?":q+=P;continue;case"*":q+=I(1);continue;default:q+=(0,S.escapeRegExpCharacters)(A)}}B<N.length-1&&(N[B+1]!==e.GLOBSTAR||B+2<N.length)&&(q+=E)}V=J===e.GLOBSTAR})}return q}const h=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,M=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new R.LRUCache(1e4),o=function(){return!1},d=function(){return null};function r(j,q){if(!j)return d;let N;typeof j!="string"?N=j.pattern:N=j,N=N.trim();const V=`${N}_${!!q.trimForExclusions}`;let J=l.get(V);if(J)return i(J,j);let B;return h.test(N)?J=a(N.substr(4),N):(B=y.exec(s(N,q)))?J=c(B[1],N):(q.trimForExclusions?M:v).test(N)?J=b(N,q):(B=g.exec(s(N,q)))?J=p(B[1].substr(1),N,!0):(B=u.exec(s(N,q)))?J=p(B[1],N,!1):J=D(N),l.set(V,J),i(J,j)}function i(j,q){return typeof q=="string"?j:function(N,V){return(0,n.isEqualOrParent)(N,q.base,!C.isLinux)?j(N.substr(q.base.length+1),V):null}}function s(j,q){return q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function a(j,q){return function(N,V){return typeof N=="string"&&N.endsWith(j)?q:null}}function c(j,q){const N=`/${j}`,V=`\\${j}`,J=function(K,T){return typeof K!="string"?null:T?T===j?q:null:K===j||K.endsWith(N)||K.endsWith(V)?q:null},B=[j];return J.basenames=B,J.patterns=[q],J.allBasenames=B,J}function b(j,q){const N=Y(j.slice(1,-1).split(",").map(T=>r(T,q)).filter(T=>T!==d),j),V=N.length;if(!V)return d;if(V===1)return N[0];const J=function(T,O){for(let W=0,A=N.length;W<A;W++)if(N[W](T,O))return j;return null},B=N.find(T=>!!T.allBasenames);B&&(J.allBasenames=B.allBasenames);const K=N.reduce((T,O)=>O.allPaths?T.concat(O.allPaths):T,[]);return K.length&&(J.allPaths=K),J}function p(j,q,N){const V=L.sep===L.posix.sep,J=V?j:j.replace(k,L.sep),B=L.sep+J,K=L.posix.sep+j;let T;return N?T=function(O,W){return typeof O=="string"&&(O===J||O.endsWith(B)||!V&&(O===j||O.endsWith(K)))?q:null}:T=function(O,W){return typeof O=="string"&&(O===J||!V&&O===j)?q:null},T.allPaths=[(N?"*/":"./")+j],T}function D(j){try{const q=new RegExp(`^${t(j)}$`);return function(N){return q.lastIndex=0,typeof N=="string"&&q.test(N)?j:null}}catch{return d}}function F(j,q,N){return!j||typeof q!="string"?!1:U(j)(q,void 0,N)}e.match=F;function U(j,q={}){if(!j)return o;if(typeof j=="string"||Q(j)){const N=r(j,q);if(N===d)return o;const V=function(J,B){return!!N(J,B)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return ee(j,q)}e.parse=U;function Q(j){const q=j;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=Q;function te(j){return j.allBasenames||[]}e.getBasenameTerms=te;function ie(j){return j.allPaths||[]}e.getPathTerms=ie;function ee(j,q){const N=Y(Object.getOwnPropertyNames(j).map(T=>$(T,j[T],q)).filter(T=>T!==d)),V=N.length;if(!V)return d;if(!N.some(T=>!!T.requiresSiblings)){if(V===1)return N[0];const T=function(A,_){for(let z=0,X=N.length;z<X;z++){const se=N[z](A,_);if(se)return se}return null},O=N.find(A=>!!A.allBasenames);O&&(T.allBasenames=O.allBasenames);const W=N.reduce((A,_)=>_.allPaths?A.concat(_.allPaths):A,[]);return W.length&&(T.allPaths=W),T}const J=function(T,O,W){let A;for(let _=0,z=N.length;_<z;_++){const X=N[_];X.requiresSiblings&&W&&(O||(O=(0,L.basename)(T)),A||(A=O.substr(0,O.length-(0,L.extname)(T).length)));const se=X(T,O,A,W);if(se)return se}return null},B=N.find(T=>!!T.allBasenames);B&&(J.allBasenames=B.allBasenames);const K=N.reduce((T,O)=>O.allPaths?T.concat(O.allPaths):T,[]);return K.length&&(J.allPaths=K),J}function $(j,q,N){if(q===!1)return d;const V=r(j,N);if(V===d)return d;if(typeof q=="boolean")return V;if(q){const J=q.when;if(typeof J=="string"){const B=(K,T,O,W)=>{if(!W||!V(K,T))return null;const A=J.replace("$(basename)",O),_=W(A);return(0,m.isThenable)(_)?_.then(z=>z?j:null):_?j:null};return B.requiresSiblings=!0,B}}return V}function Y(j,q){const N=j.filter(T=>!!T.basenames);if(N.length<2)return j;const V=N.reduce((T,O)=>{const W=O.basenames;return W?T.concat(W):T},[]);let J;if(q){J=[];for(let T=0,O=V.length;T<O;T++)J.push(q)}else J=N.reduce((T,O)=>{const W=O.patterns;return W?T.concat(W):T},[]);const B=function(T,O){if(typeof T!="string")return null;if(!O){let A;for(A=T.length;A>0;A--){const _=T.charCodeAt(A-1);if(_===47||_===92)break}O=T.substr(A)}const W=V.indexOf(O);return W!==-1?J[W]:null};B.basenames=V,B.patterns=J,B.allBasenames=V;const K=j.filter(T=>!T.basenames);return K.push(B),K}}),define(Z[33],x([0,1,28,10,7,3,17,27,8]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function E(i,s,a){if(typeof i=="string"&&(i=f.URI.file(i)),a){const b=a.getWorkspaceFolder(i);if(b){const p=a.getWorkspace().folders.length>1;let D;if((0,C.isEqual)(b.uri,i)?D="":D=(0,C.relativePath)(b.uri,i),p){const F=b.name?b.name:(0,C.basename)(b.uri);D=D?F+" \u2022 "+D:F}return D}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,R.normalize)(k(i.fsPath));let c=(0,R.normalize)(i.fsPath);return!L.isWindows&&s?.userHome&&(c=w(c,s.userHome.fsPath)),c}e.getPathLabel=E;function P(i){if(!i)return;typeof i=="string"&&(i=f.URI.file(i));const s=(0,C.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return L.isWindows&&(0,m.isRootOrDriveLetter)(s)?k(s):s}e.getBaseLabel=P;function k(i,s){return(0,m.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let I=Object.create(null);function w(i,s){if(L.isWindows||!i||!s)return i;let a=I.original===s?I.normalized:void 0;return a||(a=`${(0,S.rtrim)(s,R.posix.sep)}${R.posix.sep}`,I={original:s,normalized:a}),(L.isLinux?i.startsWith(a):(0,S.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=w;function t(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=t;const h="\u2026",y="\\\\",v="~";function M(i,s=R.sep){const a=new Array(i.length);let c=!1;for(let b=0;b<i.length;b++){let p=i[b];if(p===""){a[b]=`.${s}`;continue}if(!p){a[b]=p;continue}c=!0;let D="";p.indexOf(y)===0?(D=p.substr(0,p.indexOf(y)+y.length),p=p.substr(p.indexOf(y)+y.length)):p.indexOf(s)===0?(D=p.substr(0,p.indexOf(s)+s.length),p=p.substr(p.indexOf(s)+s.length)):p.indexOf(v)===0&&(D=p.substr(0,p.indexOf(v)+v.length),p=p.substr(p.indexOf(v)+v.length));const F=p.split(s);for(let U=1;c&&U<=F.length;U++)for(let Q=F.length-U;c&&Q>=0;Q--){c=!1;let te=F.slice(Q,Q+U).join(s);for(let ie=0;!c&&ie<i.length;ie++)if(ie!==b&&i[ie]&&i[ie].indexOf(te)>-1){const ee=Q+U===F.length,$=Q>0&&i[ie].indexOf(s)>-1?s+te:te,Y=i[ie].endsWith($);c=!ee||Y}if(!c){let ie="";(F[0].endsWith(":")||D!=="")&&(Q===1&&(Q=0,U++,te=F[0]+s+te),Q>0&&(ie=F[0]+s),ie=D+ie),Q>0&&(ie=ie+h+s),ie=ie+te,Q+U<F.length&&(ie=ie+s+h),a[b]=ie}}c&&(a[b]=p)}return a}e.shorten=M;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function u(i,s=Object.create(null)){const a=[];let c=!1,b="";for(const p of i)if(p==="$"||c&&p==="{")b&&a.push({value:b,type:g.TEXT}),b="",c=!0;else if(p==="}"&&c){const D=s[b];if(typeof D=="string")D.length&&a.push({value:D,type:g.VARIABLE});else if(D){const F=a[a.length-1];(!F||F.type!==g.SEPARATOR)&&a.push({value:D.label,type:g.SEPARATOR})}b="",c=!1}else b+=p;return b&&!c&&a.push({value:b,type:g.TEXT}),a.filter((p,D)=>{if(p.type===g.SEPARATOR){const F=a[D-1],U=a[D+1];return[F,U].every(Q=>Q&&(Q.type===g.VARIABLE||Q.type===g.TEXT)&&Q.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=u;function l(i,s){return L.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function o(i,s){return L.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):L.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function d(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=d;function r(i){const s=i.indexOf("/")!==-1?R.posix:R.win32,a=s.basename(i),c=s.dirname(i);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(Z[117],x([0,1,8]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const I=this._uriTransformer.transformIncoming(k);return I===k?k:n(m.URI.from(I))}transformOutgoing(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:n(m.URI.from(I))}transformOutgoingURI(k){const I=this._uriTransformer.transformOutgoing(k);return I===k?k:m.URI.from(I)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function L(P,k,I){if(!P||I>200)return null;if(typeof P=="object"){if(P instanceof m.URI)return k.transformOutgoing(P);for(let w in P)if(Object.hasOwnProperty.call(P,w)){const t=L(P[w],k,I+1);t!==null&&(P[w]=t)}}return null}function C(P,k){const I=L(P,k,0);return I===null?P:I}e.transformOutgoingURIs=C;function S(P,k,I,w){if(!P||w>200)return null;if(typeof P=="object"){if(P.$mid===1)return I?m.URI.revive(k.transformIncoming(P)):k.transformIncoming(P);for(let t in P)if(Object.hasOwnProperty.call(P,t)){const h=S(P[t],k,I,w+1);h!==null&&(P[t]=h)}}return null}function f(P,k){const I=S(P,k,!1,0);return I===null?P:I}e.transformIncomingURIs=f;function E(P,k){const I=S(P,k,!0,0);return I===null?P:I}e.transformAndReviveIncomingURIs=E}),define(Z[31],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(f){return m.test(f)}e.isUUID=n;const R=new Uint8Array(16),L=[];for(let f=0;f<256;f++)L.push(f.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(f){for(let E=0;E<f.length;E++)f[E]=Math.floor(Math.random()*256);return f};function S(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let f=0,E="";return E+=L[R[f++]],E+=L[R[f++]],E+=L[R[f++]],E+=L[R[f++]],E+="-",E+=L[R[f++]],E+=L[R[f++]],E+="-",E+=L[R[f++]],E+=L[R[f++]],E+="-",E+=L[R[f++]],E+=L[R[f++]],E+="-",E+=L[R[f++]],E+=L[R[f++]],E+=L[R[f++]],E+=L[R[f++]],E+=L[R[f++]],E+=L[R[f++]],E}e.generateUuid=S}),define(Z[118],x([0,1,15,4,2,3,14,27]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const f="$initialize";let E=!1;function P(r){!L.isWeb||(E||(E=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=P;var k;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(k||(k={}));class I{constructor(i,s,a,c){this.vsWorker=i,this.req=s,this.method=a,this.args=c,this.type=0}}class w{constructor(i,s,a,c){this.vsWorker=i,this.seq=s,this.res=a,this.err=c,this.type=1}}class t{constructor(i,s,a,c){this.vsWorker=i,this.req=s,this.eventName=a,this.arg=c,this.type=2}}class h{constructor(i,s,a){this.vsWorker=i,this.req=s,this.event=a,this.type=3}}class y{constructor(i,s){this.vsWorker=i,this.req=s,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,s){const a=String(++this._lastSentReq);return new Promise((c,b)=>{this._pendingReplies[a]={resolve:c,reject:b},this._send(new I(this._workerId,a,i,s))})}listen(i,s){let a=null;const c=new n.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,c),this._send(new t(this._workerId,a,i,s))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new y(this._workerId,a)),a=null}});return c.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let s=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let a=i.err;i.err.$isError&&(a=new Error,a.name=i.err.name,a.message=i.err.message,a.stack=i.err.stack),s.reject(a);return}s.resolve(i.res)}_handleRequestMessage(i){let s=i.req;this._handler.handleMessage(i.method,i.args).then(c=>{this._send(new w(this._workerId,s,c,void 0))},c=>{c.detail instanceof Error&&(c.detail=(0,m.transformErrorForSerialization)(c.detail)),this._send(new w(this._workerId,s,void 0,(0,m.transformErrorForSerialization)(c)))})}_handleSubscribeEventMessage(i){const s=i.req,a=this._handler.handleEvent(i.eventName,i.arg)(c=>{this._send(new h(this._workerId,s,c))});this._pendingEvents.set(s,a)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let s=[];if(i.type===0)for(let a=0;a<i.args.length;a++)i.args[a]instanceof ArrayBuffer&&s.push(i.args[a]);else i.type===1&&i.res instanceof ArrayBuffer&&s.push(i.res);this._handler.sendMessage(i,s)}}class M extends R.Disposable{constructor(i,s,a){super();let c=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{c&&c(U)})),this._protocol=new v({sendMessage:(U,Q)=>{this._worker.postMessage(U,Q)},handleMessage:(U,Q)=>{if(typeof a[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(a[U].apply(a,Q))}catch(te){return Promise.reject(te)}},handleEvent:(U,Q)=>{if(u(U)){const te=a[U].call(a,Q);if(typeof te!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return te}if(g(U)){const te=a[U];if(typeof te!="function")throw new Error(`Missing event ${U} on main thread host.`);return te}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let b=null;typeof L.globals.require!="undefined"&&typeof L.globals.require.getConfig=="function"?b=L.globals.require.getConfig():typeof L.globals.requirejs!="undefined"&&(b=L.globals.requirejs.s.contexts._.config);const p=C.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(f,[this._worker.getId(),JSON.parse(JSON.stringify(b)),s,p]);const D=(U,Q)=>this._request(U,Q),F=(U,Q)=>this._protocol.listen(U,Q);this._lazyProxy=new Promise((U,Q)=>{c=Q,this._onModuleLoaded.then(te=>{U(l(te,D,F))},te=>{Q(te),this._onError("Worker failed to load "+s,te)})})}getProxyObject(){return this._lazyProxy}_request(i,s){return new Promise((a,c)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,s).then(a,c)},c)})}_onError(i,s){console.error(i),console.info(s)}}e.SimpleWorkerClient=M;function g(r){return r[0]==="o"&&r[1]==="n"&&S.isUpperAsciiLetter(r.charCodeAt(2))}function u(r){return/^onDynamic/.test(r)&&S.isUpperAsciiLetter(r.charCodeAt(9))}function l(r,i,s){const a=p=>function(){const D=Array.prototype.slice.call(arguments,0);return i(p,D)},c=p=>function(D){return s(p,D)};let b={};for(const p of r){if(u(p)){b[p]=c(p);continue}if(g(p)){b[p]=s(p,void 0);continue}b[p]=a(p)}return b}class o{constructor(i,s){this._requestHandlerFactory=s,this._requestHandler=null,this._protocol=new v({sendMessage:(a,c)=>{i(a,c)},handleMessage:(a,c)=>this._handleMessage(a,c),handleEvent:(a,c)=>this._handleEvent(a,c)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,s){if(i===f)return this.initialize(s[0],s[1],s[2],s[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,s))}catch(a){return Promise.reject(a)}}_handleEvent(i,s){if(!this._requestHandler)throw new Error("Missing requestHandler");if(u(i)){const a=this._requestHandler[i].call(this._requestHandler,s);if(typeof a!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return a}if(g(i)){const a=this._requestHandler[i];if(typeof a!="function")throw new Error(`Missing event ${i} on request handler.`);return a}throw new Error(`Malformed event name ${i}`)}initialize(i,s,a,c){this._protocol.setWorkerId(i);const D=l(c,(F,U)=>this._protocol.sendMessage(F,U),(F,U)=>this._protocol.listen(F,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve(C.getAllMethodNames(this._requestHandler))):(s&&(typeof s.baseUrl!="undefined"&&delete s.baseUrl,typeof s.paths!="undefined"&&typeof s.paths.vs!="undefined"&&delete s.paths.vs,typeof s.trustedTypesPolicy!==void 0&&delete s.trustedTypesPolicy,s.catchError=!0,L.globals.require.config(s)),new Promise((F,U)=>{(L.globals.require||H)([a],te=>{if(this._requestHandler=te.create(D),!this._requestHandler){U(new Error("No RequestHandler!"));return}F(C.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=o;function d(r){return new o(r,null)}e.create=d}),define(Z[119],x([0,1,61,29,43]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function L(C,S){if(await new Promise((P,k)=>{const I=n.createReadStream(C),w=m.createHash("sha1");I.pipe(w);const t=(0,R.once)((h,y)=>{I.removeAllListeners(),w.removeAllListeners(),h?k(h):P(y)});I.once("error",t),I.once("end",t),w.once("error",t),w.once("data",h=>t(void 0,h.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.checksum=L}),define(Z[120],x([0,1,249]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(L="utf8"){this.stringDecoder=new m.StringDecoder(L),this.remaining=null}write(L){const C=[],S=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(S.length<1)return C;let f=0,E,P=f;for(;P<S.length;)if(E=S.charCodeAt(P),E===13||E===10){if(C.push(S.substring(f,P)),P++,P<S.length){const k=E;E=S.charCodeAt(P),(k===13&&E===10||k===10&&E===13)&&P++}f=P}else P++;return this.remaining=f<S.length?S.substr(f):null,C}end(){return this.remaining}}e.LineDecoder=n}),define(Z[121],x([0,1,26]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(C){const S=C.replace(/\-/g,":").toLowerCase();return!n.has(S)}function L(){const C=(0,m.networkInterfaces)();for(let S in C){const f=C[S];if(f){for(const{mac:E}of f)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(Z[72],x([0,1,26,15,35,31,121]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,k=0;const I=(0,m.networkInterfaces)();for(let w in I){const t=I[w];if(t)for(const{mac:h,internal:y}of t)y||(k+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(P+=1))}this._value=k>0?P/k:0}return this._value}};let S;async function f(){return S||(S=(async()=>await E()||L.generateUuid())()),S}e.getMachineId=f;async function E(){try{const P=await new Promise((I,w)=>{H(["crypto"],I,w)}),k=(0,C.getMac)();return P.createHash("sha256").update(k,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(Z[24],x([0,1,29,26,122,9,28,71,7,3,17,8]),function(H,e,m,n,R,L,C,S,f,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function w(ee,$=I.UNLINK){if((0,C.isRootOrDriveLetter)(ee))throw new Error("rimraf - will refuse to recursively delete root");return $===I.UNLINK?h(ee):t(ee)}async function t(ee){try{const $=(0,C.randomPath)((0,n.tmpdir)());try{await m.promises.rename(ee,$)}catch{return h(ee)}h($).catch(Y=>{})}catch($){if($.code!=="ENOENT")throw $}}async function h(ee){return(0,R.promisify)(m.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function y(ee){if((0,C.isRootOrDriveLetter)(ee))throw new Error("rimraf - will refuse to recursively delete root");m.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function v(ee,$){return u(await($?M(ee):(0,R.promisify)(m.readdir)(ee)))}async function M(ee){try{return await(0,R.promisify)(m.readdir)(ee,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const $=[],Y=await v(ee);for(const j of Y){let q=!1,N=!1,V=!1;try{const J=await e.Promises.lstat((0,f.join)(ee,j));q=J.isFile(),N=J.isDirectory(),V=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}$.push({name:j,isFile:()=>q,isDirectory:()=>N,isSymbolicLink:()=>V})}return $}function g(ee){return u(m.readdirSync(ee))}e.readdirSync=g;function u(ee){return ee.map($=>typeof $=="string"?E.isMacintosh?(0,S.normalizeNFC)($):$:($.name=E.isMacintosh?(0,S.normalizeNFC)($.name):$.name,$))}async function l(ee){const $=await v(ee),Y=[];for(const j of $)await d.existsDirectory((0,f.join)(ee,j))&&Y.push(j);return Y}function o(ee,$=1e3){return new Promise(Y=>{let j=!1;const q=setInterval(()=>{j||(j=!0,m.access(ee,N=>{j=!1,N&&(clearInterval(q),Y(void 0))}))},$)})}e.whenDeleted=o;var d;(function(ee){async function $(q){let N;try{if(N=await e.Promises.lstat(q),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(E.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw J}throw V}}ee.stat=$;async function Y(q){try{const{stat:N,symbolicLink:V}=await ee.stat(q);return N.isFile()&&V?.dangling!==!0}catch{}return!1}ee.existsFile=Y;async function j(q){try{const{stat:N,symbolicLink:V}=await ee.stat(q);return N.isDirectory()&&V?.dangling!==!0}catch{}return!1}ee.existsDirectory=j})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new L.ResourceQueue;function i(ee,$,Y){return r.queueFor(k.URI.file(ee),P.extUriBiasedIgnorePathCase).queue(()=>{const j=b(Y);return new Promise((q,N)=>a(ee,$,j,V=>V?N(V):q()))})}let s=!0;function a(ee,$,Y,j){if(!s)return m.writeFile(ee,$,{mode:Y.mode,flag:Y.flag},j);m.open(ee,Y.flag,Y.mode,(q,N)=>{if(q)return j(q);m.writeFile(N,$,V=>{if(V)return m.close(N,()=>j(V));m.fdatasync(N,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),s=!1),m.close(N,B=>j(B))))})})}function c(ee,$,Y){const j=b(Y);if(!s)return m.writeFileSync(ee,$,{mode:j.mode,flag:j.flag});const q=m.openSync(ee,j.flag,j.mode);try{m.writeFileSync(q,$);try{m.fdatasyncSync(q)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),s=!1}}finally{m.closeSync(q)}}e.writeFileSync=c;function b(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function p(ee,$){if(ee!==$)try{await e.Promises.rename(ee,$)}catch(Y){if(ee.toLowerCase()!==$.toLowerCase()&&Y.code==="EXDEV"||ee.endsWith("."))await D(ee,$,{preserveSymlinks:!1}),await w(ee,I.MOVE);else throw Y}}async function D(ee,$,Y){return U(ee,$,{root:{source:ee,target:$},options:Y,handledSourcePaths:new Set})}const F=511;async function U(ee,$,Y){if(Y.handledSourcePaths.has(ee))return;Y.handledSourcePaths.add(ee);const{stat:j,symbolicLink:q}=await d.stat(ee);if(q){if(Y.options.preserveSymlinks)try{return await ie(ee,$,Y)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(q.dangling)return}return j.isDirectory()?Q(ee,$,j.mode&F,Y):te(ee,$,j.mode&F)}async function Q(ee,$,Y,j){await e.Promises.mkdir($,{recursive:!0,mode:Y});const q=await v(ee);for(const N of q)await U((0,f.join)(ee,N),(0,f.join)($,N),j)}async function te(ee,$,Y){await e.Promises.copyFile(ee,$),await e.Promises.chmod($,Y)}async function ie(ee,$,Y){let j=await e.Promises.readlink(ee);(0,C.isEqualOrParent)(j,Y.root.source,!E.isLinux)&&(j=(0,f.join)(Y.root.target,j.substr(Y.root.source.length+1))),await e.Promises.symlink(j,$)}e.Promises=new class{get access(){return(0,R.promisify)(m.access)}get stat(){return(0,R.promisify)(m.stat)}get lstat(){return(0,R.promisify)(m.lstat)}get utimes(){return(0,R.promisify)(m.utimes)}get read(){return(ee,$,Y,j,q)=>new Promise((N,V)=>{m.read(ee,$,Y,j,q,(J,B,K)=>J?V(J):N({bytesRead:B,buffer:K}))})}get readFile(){return(0,R.promisify)(m.readFile)}get write(){return(ee,$,Y,j,q)=>new Promise((N,V)=>{m.write(ee,$,Y,j,q,(J,B,K)=>J?V(J):N({bytesWritten:B,buffer:K}))})}get appendFile(){return(0,R.promisify)(m.appendFile)}get fdatasync(){return(0,R.promisify)(m.fdatasync)}get truncate(){return(0,R.promisify)(m.truncate)}get rename(){return(0,R.promisify)(m.rename)}get copyFile(){return(0,R.promisify)(m.copyFile)}get open(){return(0,R.promisify)(m.open)}get close(){return(0,R.promisify)(m.close)}get symlink(){return(0,R.promisify)(m.symlink)}get readlink(){return(0,R.promisify)(m.readlink)}get chmod(){return(0,R.promisify)(m.chmod)}get mkdir(){return(0,R.promisify)(m.mkdir)}get unlink(){return(0,R.promisify)(m.unlink)}get rmdir(){return(0,R.promisify)(m.rmdir)}get realpath(){return(0,R.promisify)(m.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return w}get move(){return p}get copy(){return D}}}),define(Z[86],x([0,1,29,7,3,27,24]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(I){if(R.isLinux)return I;const w=(0,n.dirname)(I);if(I===w)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const y=(0,C.readdirSync)(w).filter(v=>v.toLowerCase()===t);if(y.length===1){const v=S(w);if(v)return(0,n.join)(v,y[0])}else if(y.length>1){const v=y.indexOf(t);if(v>=0){const M=S(w);if(M)return(0,n.join)(M,y[v])}}}catch{}return null}e.realcaseSync=S;async function f(I){if(R.isLinux)return I;const w=(0,n.dirname)(I);if(I===w)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const y=(await C.Promises.readdir(w)).filter(v=>v.toLowerCase()===t);if(y.length===1){const v=await f(w);if(v)return(0,n.join)(v,y[0])}else if(y.length>1){const v=y.indexOf(t);if(v>=0){const M=await f(w);if(M)return(0,n.join)(M,y[v])}}}catch{}return null}e.realcase=f;async function E(I){try{return await C.Promises.realpath(I)}catch{const t=k(I);return await C.Promises.access(t,m.constants.R_OK),t}}e.realpath=E;function P(I){try{return m.realpathSync(I)}catch{const t=k(I);return m.accessSync(t,m.constants.R_OK),t}}e.realpathSync=P;function k(I){return(0,L.rtrim)((0,n.normalize)(I),n.sep)}}),define(Z[123],x([0,1,62]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(S,f,E,P=1){let k=!1;return new Promise(I=>{const w=setTimeout(()=>{if(!k)return k=!0,I(0)},E);R(S,f,P,t=>{if(!k)return k=!0,clearTimeout(w),I(t)})})}e.findFreePort=n;function R(S,f,E,P){if(f===0)return P(0);const k=new m.Socket;k.once("connect",()=>(C(k),R(S+E,f-1,E,P))),k.once("data",()=>{}),k.once("error",I=>(C(k),I.code!=="ECONNREFUSED"?R(S+E,f-1,E,P):P(S))),k.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(S,f,E){let P=!1,k,I=1;const w=m.createServer({pauseOnConnect:!0});function t(h,y){P||(P=!0,w.removeAllListeners(),w.close(),k&&clearTimeout(k),y(h))}return new Promise(h=>{k=setTimeout(()=>{t(0,h)},E),w.on("listening",()=>{t(S,h)}),w.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&I<f?(S++,I++,w.listen(S,"127.0.0.1")):t(0,h)}),w.on("close",()=>{t(0,h)}),w.listen(S,"127.0.0.1")})}e.findFreePortFaster=L;function C(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),define(Z[124],x([0,1,26,7,24]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,C=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(f||(f={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class k{constructor(l,o,d){this.exePath=l,this.displayName=o,this.knownToExist=d}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:u=!1}={}){return u?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:u=!1,findPreview:l=!1}={}){const o=I({useAlternateBitness:u});if(!o)return null;const d=n.join(o,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(d))return null;let r=-1,i=null;for(const c of await R.Promises.readdir(d)){let b=-1;if(l){const D=c.indexOf("-");if(D<0)continue;const F=c.substring(0,D);if(!L.test(F)||c.substring(D+1)!=="preview")continue;b=parseInt(F,10)}else{if(!L.test(c))continue;b=parseInt(c,10)}if(b<=r)continue;const p=n.join(d,c,"pwsh.exe");!await R.SymlinkSupport.existsFile(p)||(i=p,r=b)}if(!i)return null;const s=o.includes("x86")?" (x86)":"",a=l?" Preview":"";return new k(i,`PowerShell${a}${s}`,!0)}async function t({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:o,pwshMsixName:d}=u?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await R.Promises.readdir(l))if(o.test(r)){const i=n.join(l,r,"pwsh.exe");return new k(i,d)}return null}function h(){const u=n.join(m.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function y(){const u=n.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}async function*v(){let u=await w();u&&(yield u),u=await w({useAlternateBitness:!0}),u&&(yield u),u=await t(),u&&(yield u),u=h(),u&&(yield u),u=await w({findPreview:!0}),u&&(yield u),u=await t({findPreview:!0}),u&&(yield u),u=await w({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=y(),u&&(yield u)}async function*M(){for await(const u of v())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=M;async function g(){for await(const u of M())return u;return null}e.getFirstAvailablePowerShellInstallation=g}),define(Z[87],x([0,1,45,10]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(C){return new Promise((S,f)=>{let E;const P=new Map;function k(w,t,h,y,v){const M=P.get(t);if(w===C||M){const g={name:I(h),cmd:h,pid:w,ppid:t,load:y,mem:v};P.set(w,g),w===C&&(E=g),M&&(M.children||(M.children=[]),M.children.push(g),M.children.length>1&&(M.children=M.children.sort((u,l)=>u.pid-l.pid)))}}function I(w){const t=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,M=/--crashes-directory/,g=/\\pipe\\winpty-control/,u=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(M.exec(w))return"electron-crash-reporter";if(g.exec(w))return"winpty-process";if(u.exec(w))return"console-window-host (Windows internal process)";let o=l.exec(w);if(o&&o.length===2)return o[1]==="renderer"?t.exec(w)?"shared-process":h.exec(w)?"issue-reporter":y.exec(w)?"process-explorer":"window":o[1]==="utility"&&v.exec(w)?"utility-network-service":o[1];const d=/[a-zA-Z-]+\.js/g;let r="";do o=d.exec(w),o&&(r+=o+" ");while(o);return r&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${r}`:w}if(process.platform==="win32"){const w=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,h)=>{H(["windows-process-tree"],t,h)}).then(t=>{t.getProcessList(C,h=>{t.getProcessCpuUsage(h,y=>{const v=new Map;y.forEach(M=>{const g=w(M.commandLine||"");v.set(M.pid,{name:I(g),cmd:g,pid:M.pid,ppid:M.ppid,load:M.cpu||0,mem:M.memory||0})}),E=v.get(C),E?(v.forEach(M=>{const g=v.get(M.ppid);g&&(g.children||(g.children=[]),g.children.push(M))}),v.forEach(M=>{M.children&&(M.children=M.children.sort((g,u)=>g.pid-u.pid))}),S(E)):f(new Error(`Root process ${C} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let w=function(){let t=[E];const h=[];for(;t.length;){const v=t.shift();v&&(h.push(v.pid),v.children&&(t=t.concat(v.children)))}let y=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);y+=" "+h.join(" "),(0,m.exec)(y,{},(v,M,g)=>{if(v||g)f(v||new Error(g.toString()));else{const u=M.toString().split(`
`);for(let l=0;l<h.length;l++){const o=P.get(h[l]);o.load=parseFloat(u[l])}if(!E){f(new Error(`Root process ${C} not found`));return}S(E)}})};(0,m.exec)("which ps",{},(t,h,y)=>{if(t||y)if(process.platform!=="linux")f(t||new Error(y.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,m.exec)(v,{},(M,g,u)=>{M||u?f(M||new Error(u.toString())):(L(g,k),w())})}else{const v=h.toString().trim(),M="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${v} ${M}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,u,l)=>{g||l&&!l.includes("screen size is bogus")?f(g||new Error(l.toString())):(L(u,k),process.platform==="linux"?w():E?S(E):f(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=R;function L(C,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=C.toString().split(`
`);for(const P of E){const k=f.exec(P.trim());k&&k.length===6&&S(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(Z[125],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[126],x([0,1,12,14,125]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function L(){m.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(S,f,E,P,k)=>{const I=C(S,P,E);I.popup({window:(0,n.withNullAsUndefined)(m.BrowserWindow.fromWebContents(S.sender)),x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{I&&S.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=L;function C(S,f,E){const P=new m.Menu;return E.forEach(k=>{let I;k.type==="separator"?I=new m.MenuItem({type:k.type}):Array.isArray(k.submenu)?I=new m.MenuItem({submenu:C(S,f,k.submenu),label:k.label}):I=new m.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(w,t,h)=>S.sender.send(f,k.id,h)}),P.append(I)}),P}});var ue=this&&this.__decorate||function(H,e,m,n){var R=arguments.length,L=R<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,m):n,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(H,e,m,n);else for(var S=H.length-1;S>=0;S--)(C=H[S])&&(L=(R<3?C(L):R>3?C(e,m,L):C(e,m))||L);return R>3&&L&&Object.defineProperty(e,m,L),L};define(Z[37],x([0,1,30,9,16,23,46,15,4,2,115,27,14]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function y(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(v||(v={}));class M{constructor(V){this.buffer=V,this.pos=0}read(V){const J=this.buffer.slice(this.pos,this.pos+V);return this.pos+=J.byteLength,J}}class g{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var u;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(u||(u={}));function l(N){const V=R.VSBuffer.alloc(4);return V.writeUInt32BE(N,0),V}function o(N){return N.read(4).readUInt32BE(0)}function d(N){const V=R.VSBuffer.alloc(1);return V.writeUInt8(N,0),V}const r={Undefined:d(u.Undefined),String:d(u.String),Buffer:d(u.Buffer),VSBuffer:d(u.VSBuffer),Array:d(u.Array),Object:d(u.Object)},i=typeof Buffer!="undefined";function s(N,V){if(typeof V=="undefined")N.write(r.Undefined);else if(typeof V=="string"){const J=R.VSBuffer.fromString(V);N.write(r.String),N.write(l(J.byteLength)),N.write(J)}else if(i&&Buffer.isBuffer(V)){const J=R.VSBuffer.wrap(V);N.write(r.Buffer),N.write(l(J.byteLength)),N.write(J)}else if(V instanceof R.VSBuffer)N.write(r.VSBuffer),N.write(l(V.byteLength)),N.write(V);else if(Array.isArray(V)){N.write(r.Array),N.write(l(V.length));for(const J of V)s(N,J)}else{const J=R.VSBuffer.fromString(JSON.stringify(V));N.write(r.Object),N.write(l(J.byteLength)),N.write(J)}}function a(N){switch(N.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return N.read(o(N)).toString();case u.Buffer:return N.read(o(N)).buffer;case u.VSBuffer:return N.read(o(N));case u.Array:{const J=o(N),B=[];for(let K=0;K<J;K++)B.push(a(N));return B}case u.Object:return JSON.parse(N.read(o(N)).toString())}}class c{constructor(V,J,B=null,K=1e3){this.protocol=V,this.ctx=J,this.logger=B,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(V,J){this.channels.set(V,J),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const J=this.send([V.type]);this.logger?.logOutgoing(J,0,1,y(V.type));return}case 201:case 202:case 204:case 203:{const J=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(J,V.id,1,y(V.type),V.data);return}}}send(V,J=void 0){const B=new g;return s(B,V),s(B,J),this.sendBuffer(B.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const J=new M(V),B=a(J),K=a(J),T=B[0];switch(T){case 100:return this.logger?.logIncoming(V.byteLength,B[1],1,`${t(T)}: ${B[2]}.${B[3]}`,K),this.onPromise({type:T,id:B[1],channelName:B[2],name:B[3],arg:K});case 102:return this.logger?.logIncoming(V.byteLength,B[1],1,`${t(T)}: ${B[2]}.${B[3]}`,K),this.onEventListen({type:T,id:B[1],channelName:B[2],name:B[3],arg:K});case 101:return this.logger?.logIncoming(V.byteLength,B[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:B[1]});case 103:return this.logger?.logIncoming(V.byteLength,B[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:B[1]})}}onPromise(V){const J=this.channels.get(V.channelName);if(!J){this.collectPendingRequest(V);return}const B=new L.CancellationTokenSource;let K;try{K=J.call(this.ctx,V.name,V.arg,B.token)}catch(W){K=Promise.reject(W)}const T=V.id;K.then(W=>{this.sendResponse({id:T,data:W,type:201}),this.activeRequests.delete(V.id)},W=>{W instanceof Error?this.sendResponse({id:T,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:T,data:W,type:203}),this.activeRequests.delete(V.id)});const O=(0,E.toDisposable)(()=>B.cancel());this.activeRequests.set(V.id,O)}onEventListen(V){const J=this.channels.get(V.channelName);if(!J){this.collectPendingRequest(V);return}const B=V.id,T=J.listen(this.ctx,V.name,V.arg)(O=>this.sendResponse({id:B,data:O,type:204}));this.activeRequests.set(V.id,T)}disposeActiveRequest(V){const J=this.activeRequests.get(V.id);J&&(J.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let J=this.pendingRequests.get(V.channelName);J||(J=[],this.pendingRequests.set(V.channelName,J));const B=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:V,timeoutTimer:B})}flushPendingRequests(V){const J=this.pendingRequests.get(V);if(J){for(const B of J)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var b;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(V,J=null){this.protocol=V,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=J}getChannel(V){const J=this;return{call(B,K,T){return J.isDisposed?Promise.reject(S.canceled()):J.requestPromise(V,B,K,T)},listen(B,K){return J.isDisposed?f.Event.None:J.requestEvent(V,B,K)}}}requestPromise(V,J,B,K=L.CancellationToken.None){const T=this.lastRequestId++,W={id:T,type:100,channelName:V,name:J,arg:B};if(K.isCancellationRequested)return Promise.reject(S.canceled());let A;return new Promise((z,X)=>{if(K.isCancellationRequested)return X(S.canceled());const se=()=>{const fe=he=>{switch(he.type){case 201:this.handlers.delete(T),z(he.data);break;case 202:{this.handlers.delete(T);const we=new Error(he.data.message);we.stack=he.data.stack,we.name=he.data.name,X(we);break}case 203:this.handlers.delete(T),X(he.data);break}};this.handlers.set(T,fe),this.sendRequest(W)};let le=null;this.state===v.Idle?se():(le=(0,n.createCancelablePromise)(fe=>this.whenInitialized()),le.then(()=>{le=null,se()}));const re=()=>{le?(le.cancel(),le=null):this.sendRequest({id:T,type:101}),X(S.canceled())},ae=K.onCancellationRequested(re);A=(0,E.combinedDisposable)((0,E.toDisposable)(re),ae),this.activeRequests.add(A)}).finally(()=>{this.activeRequests.delete(A)})}requestEvent(V,J,B){const K=this.lastRequestId++,O={id:K,type:102,channelName:V,name:J,arg:B};let W=null;const A=new f.Emitter({onFirstListenerAdd:()=>{W=(0,n.createCancelablePromise)(z=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(A),this.sendRequest(O)})},onLastListenerRemove:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(A),this.sendRequest({id:K,type:103}))}}),_=z=>A.fire(z.data);return this.handlers.set(K,_),A.event}sendRequest(V){switch(V.type){case 100:case 102:{const J=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger&&this.logger.logOutgoing(J,V.id,0,`${t(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const J=this.send([V.type,V.id]);this.logger&&this.logger.logOutgoing(J,V.id,0,t(V.type));return}}}send(V,J=void 0){const B=new g;return s(B,V),s(B,J),this.sendBuffer(B.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const J=new M(V),B=a(J),K=a(J),T=B[0];switch(T){case 200:return this.logger&&this.logger.logIncoming(V.byteLength,0,0,y(T)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(V.byteLength,B[1],0,y(T),K),this.onResponse({type:B[0],id:B[1],data:K})}}onResponse(V){if(V.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const J=this.handlers.get(V.id);J&&J(V)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([C.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class D{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:J,onDidClientDisconnect:B})=>{f.Event.once(J.onMessage)(T=>{const O=new M(T),W=a(O),A=new c(J,W),_=new p(J);this.channels.forEach((X,se)=>A.registerChannel(se,X));const z={channelServer:A,channelClient:_,ctx:W};this._connections.add(z),this._onDidAddConnection.fire(z),B(()=>{A.dispose(),_.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const V=[];return this._connections.forEach(J=>V.push(J)),V}getChannel(V,J){const B=this;return{call(K,T,O){let W;if((0,I.isFunction)(J)){let _=(0,m.getRandomElement)(B.connections.filter(J));W=_?Promise.resolve(_):f.Event.toPromise(f.Event.filter(B.onDidAddConnection,J))}else W=J.routeCall(B,K,T);const A=W.then(_=>_.channelClient.getChannel(V));return U(A).call(K,T,O)},listen(K,T){if((0,I.isFunction)(J))return B.getMulticastEvent(V,J,K,T);const O=J.routeEvent(B,K,T).then(W=>W.channelClient.getChannel(V));return U(O).listen(K,T)}}}getMulticastEvent(V,J,B,K){const T=this;let O=new E.DisposableStore;const W=new f.Emitter({onFirstListenerAdd:()=>{O=new E.DisposableStore;const A=new f.EventMultiplexer,_=new Map,z=se=>{const re=se.channelClient.getChannel(V).listen(B,K),ae=A.add(re);_.set(se,ae)},X=se=>{const le=_.get(se);!le||(le.dispose(),_.delete(se))};T.connections.filter(J).forEach(z),f.Event.filter(T.onDidAddConnection,J)(z,void 0,O),T.onDidRemoveConnection(X,void 0,O),A.event(W.fire,W,O),O.add(A)},onLastListenerRemove:()=>{O.dispose()}});return W.event}registerChannel(V,J){this.channels.set(V,J),this._connections.forEach(B=>{B.channelServer.registerChannel(V,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class F{constructor(V,J,B=null){const K=new g;s(K,J),V.send(K.buffer),this.channelClient=new p(V,B),this.channelServer=new c(V,J,B)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,J){this.channelServer.registerChannel(V,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(N){return{call(V,J,B){return N.then(K=>K.call(V,J,B))},listen(V,J){const B=new f.Relay;return N.then(K=>B.input=K.listen(V,J)),B.event}}}e.getDelayedChannel=U;function Q(N){let V=!1;return{call(J,B,K){return V?N.call(J,B,K):(0,n.timeout)(0).then(()=>V=!0).then(()=>N.call(J,B,K))},listen(J,B){if(V)return N.listen(J,B);const K=new f.Relay;return(0,n.timeout)(0).then(()=>V=!0).then(()=>K.input=N.listen(J,B)),K.event}}}e.getNextTickChannel=Q;class te{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const J of V.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await f.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=te;var ie;(function(N){function V(T,O){const W=T,A=O&&O.disableMarshalling,_=new Map;for(const z in W)B(z)&&_.set(z,f.Event.buffer(W[z],!0));return new class{listen(z,X,se){const le=_.get(X);if(le)return le;if(K(X)){const re=W[X];if(typeof re=="function")return re.call(W,se)}throw new Error(`Event not found: ${X}`)}call(z,X,se){const le=W[X];if(typeof le=="function"){if(!A&&Array.isArray(se))for(let re=0;re<se.length;re++)se[re]=(0,P.revive)(se[re]);return le.apply(W,se)}throw new Error(`Method not found: ${X}`)}}}N.fromService=V;function J(T,O){const W=O&&O.disableMarshalling;return new Proxy({},{get(A,_){if(typeof _=="string")return O?.properties?.has(_)?O.properties.get(_):K(_)?function(z){return T.listen(_,z)}:B(_)?T.listen(_):async function(...z){let X;O&&!(0,I.isUndefinedOrNull)(O.context)?X=[O.context,...z]:X=z;const se=await T.call(_,X);return W?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(_)}`)}})}N.toService=J;function B(T){return T[0]==="o"&&T[1]==="n"&&k.isUpperAsciiLetter(T.charCodeAt(2))}function K(T){return/^onDynamic/.test(T)&&k.isUpperAsciiLetter(T.charCodeAt(9))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let V=N.toString();if(V!=="[object Object]")return V}return N}function Y(N){return Array.isArray(N)?N.map($):$(N)}function j(N,V,J,B,K,T,O){O=Y(O);const W=ee[K],A=W[B%W.length];let _=[`%c[${N}]%c[${String(V).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(T)?(_=_.concat(O),_.push(")")):_.push(O),console.log.apply(console,_)}e.logWithColors=j;class q{constructor(V,J){this._outgoingPrefix=V,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,J,B,K,T){this._totalOutgoing+=V,j(this._outgoingPrefix,this._totalOutgoing,V,J,B,K,T)}logIncoming(V,J,B,K,T){this._totalIncoming+=V,j(this._incomingPrefix,this._totalIncoming,V,J,B,K,T)}}e.IPCLogger=q}),define(Z[127],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(R,L){this.sender=R,this.onMessage=L}send(R){try{this.sender.send("vscode:message",R.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(Z[128],x([0,1,16,4,37]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(f){this.port=f,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>m.VSBuffer.wrap(E.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class C extends R.IPCClient{constructor(f,E){const P=new L(f);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=C}),define(Z[88],x([0,1,16,4,2,37]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let a=0;function c(p,D){if(!s.has(p)){const F=String(++a);s.set(p,F)}return s.get(p)}function b(p,D,F,U){if(!i.enableDiagnostics)return;const Q=c(p,D);if(U instanceof m.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const te=m.VSBuffer.alloc(U.byteLength);te.set(U),i.records.push({timestamp:Date.now(),id:Q,label:D,type:F,buff:te})}else i.records.push({timestamp:Date.now(),id:Q,label:D,type:F,data:U})}i.traceSocketEvent=b})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=m.VSBuffer.alloc(0)),E}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const D=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),D}if(this._chunks[0].byteLength>s){const D=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),D}let c=m.VSBuffer.alloc(s),b=0,p=0;for(;s>0;){const D=this._chunks[p];if(D.byteLength>s){const F=D.slice(0,s);c.set(F,b),b+=s,a&&(this._chunks[p]=D.slice(s),this._totalLength-=s),s-=s}else c.set(D,b),b+=D.byteLength,a?(this._chunks.shift(),this._totalLength-=D.byteLength):p++,s-=D.byteLength}return c}}e.ChunkStream=k;var I;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(I||(I={}));function w(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(s,a,c,b){this.type=s,this.id=a,this.ack=c,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends R.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,b=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new h(c,b,p,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=m.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const c=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,c}_bufferTake(){const s=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class M extends R.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new h(1,0,0,s))}}e.Protocol=M;class g extends L.IPCClient{constructor(s,a,c=null){super(s,a,c);this.protocol=s}static fromSocket(s,a){return new g(new M(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],a=0,c=this._first;for(;c;)s[a++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new l(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class d{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<d._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=d._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const s=Date.now(),a=(1+d._HISTORY_LENGTH)*1e3;let c=0;for(let b=0;b<d._HISTORY_LENGTH;b++)s-this.lastRuns[b]<=a&&c++;return 1-c/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class r{constructor(s,a=null,c=d.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(b=>this._receiveMessage(b))),this._socketDisposables.push(this._socket.onClose(b=>this._onSocketClose.fire(b))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new h(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new h(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new h(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,P());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let c=0,b=a.length;c<b;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,b=a.length;c<b;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new h(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const a=new h(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,b=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&b>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const p=Math.max(2e4-a,2e4-c,2e4-b,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(Z[129],x([0,1,12,16,4,2,37,127]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(P,k){const I=R.Event.fromNodeEventEmitter(m.ipcMain,k,(t,h)=>({event:t,message:h})),w=R.Event.filter(I,({event:t})=>t.sender.id===P);return R.Event.map(w,({message:t})=>t&&n.VSBuffer.wrap(t))}class E extends C.IPCServer{constructor(){super(E.getOnDidClientConnect())}static getOnDidClientConnect(){const k=R.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:I})=>I);return R.Event.map(k,I=>{const w=I.id,t=E.Clients.get(w);t&&t.dispose();const h=new R.Emitter;E.Clients.set(w,(0,L.toDisposable)(()=>h.fire()));const y=f(w,"vscode:message"),v=R.Event.any(R.Event.signal(f(w,"vscode:disconnect")),h.event);return{protocol:new S.Protocol(I,y),onDidClientDisconnect:v}})}}e.Server=E,E.Clients=new Map}),define(Z[89],x([0,1,12,4,31,128]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class C extends L.Client{constructor(E,P){super({addEventListener:(k,I)=>E.addListener(k,I),removeEventListener:(k,I)=>E.removeListener(k,I),postMessage:k=>E.postMessage(k),start:()=>E.start(),close:()=>E.close()},P)}}e.Client=C;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const E=(0,R.generateUuid)();f.webContents.send("vscode:createMessageChannel",E);const P=n.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(I,w)=>({nonce:w,port:I.ports[0]})),{port:k}=await n.Event.toPromise(n.Event.once(n.Event.filter(P,I=>I.nonce===E)));return k}e.connect=S}),define(Z[90],x([0,1,9,4,2,14]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=e.StorageHint||(e.StorageHint={}));function S(k){const I=k;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var f;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(I,w=Object.create(null)){super();this.database=I,this.options=w,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new m.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((w,t)=>this.accept(t,w)),I.deleted?.forEach(w=>this.accept(w,void 0))}accept(I,w){if(this.state===f.Closed)return;let t=!1;(0,L.isUndefinedOrNull)(w)?t=this.cache.delete(I):this.cache.get(I)!==w&&(this.cache.set(I,w),t=!0),t&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,w){const t=this.cache.get(I);return(0,L.isUndefinedOrNull)(t)?w:t}getBoolean(I,w){const t=this.get(I);return(0,L.isUndefinedOrNull)(t)?w:t==="true"}getNumber(I,w){const t=this.get(I);return(0,L.isUndefinedOrNull)(t)?w:parseInt(t,10)}async set(I,w){if(this.state===f.Closed)return;if((0,L.isUndefinedOrNull)(w))return this.delete(I);const t=String(w);if(this.cache.get(I)!==t)return this.cache.set(I,t),this.pendingInserts.set(I,t),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===f.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((w,t)=>this.items.set(t,w)),I.delete&&I.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=P}),define(Z[130],x([0,1,9,4,35,7,24]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(P,k=Object.create(null)){this.path=P,this.options=k,this.name=(0,L.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const P=await this.whenConnected,k=new Map;return(await this.all(P,"SELECT * FROM ItemTable")).forEach(w=>k.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(P){const k=await this.whenConnected;return this.doUpdateItems(k,P)}doUpdateItems(P,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,R.mapToString)(k.insert):"0"}), delete(${k.delete?(0,R.setToString)(k.delete):"0"})`),this.transaction(P,()=>{const I=k.insert,w=k.delete;if(I&&I.size>0){const t=[];t.push([]);let h=0;I.forEach((y,v)=>{let M=t[h];M.length>S.MAX_HOST_PARAMETERS&&(h++,M=[],t.push(M)),M.push(v,y)}),t.forEach(y=>{this.prepare(P,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,v=>v.run(y),()=>{const v=[];let M=0;return I.forEach((g,u)=>{v.push(u),M+=g.length}),`Keys: ${v.join(", ")} Length: ${M}`})})}if(w&&w.size){const t=[];t.push([]);let h=0;w.forEach(y=>{let v=t[h];v.length>S.MAX_HOST_PARAMETERS&&(h++,v=[],t.push(v)),v.push(y)}),t.forEach(y=>{this.prepare(P,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,v=>v.run(y),()=>{const v=[];return w.forEach(M=>{v.push(M)}),`Keys: ${v.join(", ")}`})})}})}async close(P){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,P)}doClose(P,k){return new Promise((I,w)=>{P.db.close(t=>(t&&this.handleSQLiteError(P,`[storage ${this.name}] close(): ${t}`),this.path===S.IN_MEMORY_PATH?I():!P.isErroneous&&!P.isInMemory?this.backup().then(I,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),I())):typeof k=="function"?C.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const y=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:k()}).then(()=>y(),v=>(y(),Promise.reject(v)))})).then(I,w):w(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const P=this.toBackupPath(this.path);return C.Promises.copy(this.path,P,{preserveSymlinks:!1})}toBackupPath(P){return`${P}.backup`}async checkIntegrity(P){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${P})`);const k=await this.whenConnected,I=await this.get(k,P?"PRAGMA integrity_check":"PRAGMA quick_check"),w=P?I.integrity_check:I.quick_check;return k.isErroneous?`${w} (last error: ${k.lastError})`:k.isInMemory?`${w} (in-memory!)`:w}async connect(P,k=!0){this.logger.trace(`[storage ${this.name}] open(${P}, retryOnBusy: ${k})`);try{return await this.doConnect(P)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&k)return await(0,m.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(P,!1);try{await C.Promises.unlink(P);try{await C.Promises.rename(this.toBackupPath(P),P)}catch{}return await this.doConnect(P)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(P,k){P.isErroneous=!0,P.lastError=k,this.logger.error(k)}doConnect(P){return new Promise((k,I)=>{new Promise((w,t)=>{H(["@vscode/sqlite3"],w,t)}).then(w=>{const t={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(P,h=>h?t.db?t.db.close(()=>I(h)):I(h):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(t),y=>t.db.close(()=>I(y)))),isInMemory:P===S.IN_MEMORY_PATH};t.db.on("error",h=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&t.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},I)})}exec(P,k){return new Promise((I,w)=>{P.db.exec(k,t=>t?(this.handleSQLiteError(P,`[storage ${this.name}] exec(): ${t}`),w(t)):I())})}get(P,k){return new Promise((I,w)=>{P.db.get(k,(t,h)=>t?(this.handleSQLiteError(P,`[storage ${this.name}] get(): ${t}`),w(t)):I(h))})}all(P,k){return new Promise((I,w)=>{P.db.all(k,(t,h)=>t?(this.handleSQLiteError(P,`[storage ${this.name}] all(): ${t}`),w(t)):I(h))})}transaction(P,k){return new Promise((I,w)=>{P.db.serialize(()=>{P.db.run("BEGIN TRANSACTION"),k(),P.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(P,`[storage ${this.name}] transaction(): ${t}`),w(t)):I())})})}prepare(P,k,I,w){const t=P.db.prepare(k),h=y=>{this.handleSQLiteError(P,`[storage ${this.name}] prepare(): ${y} (${k}). Details: ${w()}`)};t.on("error",h),I(t),t.finalize(y=>{y&&h(y),t.removeListener("error",h)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class f{constructor(P){P&&typeof P.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=P.logTrace),P&&typeof P.logError=="function"&&(this.logError=P.logError)}get isTracing(){return!!this.logTrace}trace(P){this.logTrace&&this.logTrace(P)}error(P){this.logError&&this.logError(P)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[131],x([13,11]),function(H,e){return H.create("vs/base/common/date",e)}),define(Z[132],x([0,1,131]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,R=n*60,L=R*24,C=L*7,S=L*30,f=L*365;function E(k,I,w){typeof k!="number"&&(k=k.getTime());const t=Math.round((new Date().getTime()-k)/1e3);if(t<-30)return(0,m.localize)(0,null,E(new Date().getTime()+t*1e3,!1));if(t<30)return(0,m.localize)(1,null);let h;return t<n?(h=t,I?h===1?w?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):w?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h):h===1?w?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):w?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):t<R?(h=Math.floor(t/n),I?h===1?w?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):w?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h):h===1?w?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):w?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):t<L?(h=Math.floor(t/R),I?h===1?w?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):w?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h):h===1?w?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):w?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):t<C?(h=Math.floor(t/L),I?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h)):t<S?(h=Math.floor(t/C),I?h===1?w?(0,m.localize)(30,null,h):(0,m.localize)(31,null,h):w?(0,m.localize)(32,null,h):(0,m.localize)(33,null,h):h===1?w?(0,m.localize)(34,null,h):(0,m.localize)(35,null,h):w?(0,m.localize)(36,null,h):(0,m.localize)(37,null,h)):t<f?(h=Math.floor(t/S),I?h===1?w?(0,m.localize)(38,null,h):(0,m.localize)(39,null,h):w?(0,m.localize)(40,null,h):(0,m.localize)(41,null,h):h===1?w?(0,m.localize)(42,null,h):(0,m.localize)(43,null,h):w?(0,m.localize)(44,null,h):(0,m.localize)(45,null,h)):(h=Math.floor(t/f),I?h===1?w?(0,m.localize)(46,null,h):(0,m.localize)(47,null,h):w?(0,m.localize)(48,null,h):(0,m.localize)(49,null,h):h===1?w?(0,m.localize)(50,null,h):(0,m.localize)(51,null,h):w?(0,m.localize)(52,null,h):(0,m.localize)(53,null,h))}e.fromNow=E;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Z[133],x([13,11]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Z[39],x([0,1,30,14,133]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(k,I){return I&&(k.stack||k.stacktrace)?R.localize(0,null,S(k),C(k.stack)||C(k.stacktrace)):S(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function f(k=null,I=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const w=m.coalesce(k),t=f(w[0],I);return w.length>1?R.localize(4,null,t,w.length):t}if(n.isString(k))return k;if(k.detail){const w=k.detail;if(w.error)return L(w.error,I);if(w.exception)return L(w.exception,I)}return k.stack?L(k,I):k.message?k.message:R.localize(5,null)}e.toErrorMessage=f;function E(k){const I=k;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=E;function P(k,I=Object.create(null)){const w=new Error(k);return I.actions&&(w.actions=I.actions),w}e.createErrorWithActions=P}),define(Z[134],x([13,11]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(Z[135],x([0,1,134]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(C,S,f=S){this.modifierLabels=[null],this.modifierLabels[2]=C,this.modifierLabels[1]=S,this.modifierLabels[3]=f}toLabel(C,S,f){if(S.length===0)return null;const E=[];for(let P=0,k=S.length;P<k;P++){const I=S[P],w=f(I);if(w===null)return null;E[P]=R(I,w,this.modifierLabels[C])}return E.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(L,C,S){if(C===null)return"";const f=[];return L.ctrlKey&&f.push(S.ctrlKey),L.shiftKey&&f.push(S.shiftKey),L.altKey&&f.push(S.altKey),L.metaKey&&f.push(S.metaKey),C!==""&&f.push(C),f.join(S.separator)}}),define(Z[136],x([13,11]),function(H,e){return H.create("vs/base/node/processes",e)}),define(Z[73],x([0,1,45,28,10,49,7,3,36,84,14,120,24,136]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(o,d){if(S.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};d&&(r.cwd=d);const i=m.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],r);return new Promise(s=>{i.once("error",a=>{s({success:!1,error:a})}),i.once("exit",(a,c)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(S.isLinux||S.isMacintosh)try{const r=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(i=>{m.execFile(r,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,c)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function y(o){!o||(delete o.DEBUG,S.isMacintosh&&delete o.DYLD_LIBRARY_PATH,S.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function v(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=v;class M{constructor(d,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=d,this.args=r,this.shell=i,this.options=s;else{const a=d;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(f.env).forEach(c=>{a[c]=f.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let d=this.cmd.toLowerCase();const r=d.lastIndexOf(C.sep);return r!==-1&&(d=d.substring(r+1)),M.WellKnowCommands[d]?d:"other"}start(d){return S.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(f.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(r=>{let i,s;const a=new Promise((c,b)=>{i=c,s=b});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=m.exec(c,this.options,(b,p,D)=>{this.childProcess=null;const F=b;F&&F.killed?s({killed:this.terminateRequested,stdout:p.toString(),stderr:D.toString()}):this.handleExec(i,d,b,p,D)})}else{let c=null;const b=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,i,d,s);const D={terminated:this.terminateRequested};P.isNumber(p)&&(D.cmdCode=p),i(D)};if(this.shell&&S.isWindows){const p=L.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let D=!1,F=!1;const U=[];let Q=this.ensureQuotes(this.cmd);U.push(Q.value),D=Q.quoted,this.args&&this.args.forEach(ie=>{Q=this.ensureQuotes(ie),U.push(Q.value),F=F&&Q.quoted});const te=["/s","/c"];D?F?te.push('"'+U.join(" ")+'"'):U.length>1?te.push('"'+U[0]+'" '+U.slice(1).join(" ")):te.push('"'+U[0]+'"'):te.push(U.join(" ")),c=m.spawn(v(),te,p)}else this.cmd&&(c=m.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",p=>{this.childProcess=null,s({terminated:this.terminateRequested,error:p})}),c.pid&&(this.childProcess.on("close",b),this.handleSpawn(c,i,d,s,!0)))}return a})}handleClose(d,r,i,s){}ensureQuotes(d){return M.regexp.test(d)?{value:'"'+d+'"',quoted:!0}:{value:d,quoted:d.length>0&&d[0]==='"'&&d[d.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(d=>d.pid,d=>-1):new Promise(d=>{this.pidResolve=d})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(d=>(this.terminateRequested=!0,h(d,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),d=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(d=>{if(!this.shell||!S.isWindows)return d(!1);const r=m.spawn(v(),["/s","/c"]);r.on("error",i=>d(!0)),r.on("exit",i=>d(!1))})}}e.AbstractProcess=M,M.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},M.regexp=/^[^"].* .*[^"]/;class g extends M{constructor(d,r,i,s){super(d,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(d,r,i,s,a){[s,a].forEach((c,b)=>{const p=new k.LineDecoder;p.write(c).forEach(U=>{r({line:U,source:b===0?0:1})});const F=p.end();F&&r({line:F,source:b===0?0:1})}),d({terminated:this.terminateRequested,error:i})}handleSpawn(d,r,i,s,a){const c=new k.LineDecoder,b=new k.LineDecoder;d.stdout.on("data",p=>{c.write(p).forEach(F=>i({line:F,source:0}))}),d.stderr.on("data",p=>{b.write(p).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=b}handleClose(d,r,i,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&i({line:c,source:1})}}e.LineProcess=g;function u(o){let d=[],r=!1;const i=function(s){if(r){d.push(s);return}(!o.send(s,c=>{if(c&&console.error(c),r=!1,d.length>0){const b=d.slice(0);d=[],b.forEach(p=>i(p))}})||S.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=u;var l;(function(o){async function d(r,i,s){if(C.isAbsolute(r))return r;if(i===void 0&&(i=f.cwd()),C.dirname(r)!=="."||(s===void 0&&P.isString(f.env.PATH)&&(s=f.env.PATH.split(C.delimiter)),s===void 0||s.length===0))return C.join(i,r);async function c(b){if(await I.Promises.exists(b)){let p;try{p=await I.Promises.stat(b)}catch(D){D.message.startsWith("EACCES")&&(p=await I.Promises.lstat(b))}return p?!p.isDirectory():!1}return!1}for(let b of s){let p;if(C.isAbsolute(b)?p=C.join(b,r):p=C.join(i,b,r),await c(p))return p;let D=p+".com";if(await c(D)||(D=p+".exe",await c(D)))return D}return C.join(i,r)}o.findExecutable=d})(l=e.win32||(e.win32={}))}),define(Z[137],x([0,1,26,3,124,73]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(w,t){return w===1?n.isWindows?k():L.getWindowsShell(t):E(w,t)}e.getSystemShell=C;function S(w,t){return w===1?n.isWindows?I(t):L.getWindowsShell(t):E(w,t)}e.getSystemShellSync=S;let f=null;function E(w,t){if(n.isLinux&&w===2||n.isMacintosh&&w===3)return"/bin/bash";if(!f){let h;if(n.isWindows)h="/bin/bash";else{if(h=t.SHELL,!h)try{h=(0,m.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}f=h}return f}let P=null;async function k(){return P||(P=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),P}function I(w){if(P)return P;const t=n.isWindows&&parseFloat((0,m.release)())>=10,h=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${w.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?y:L.getWindowsShell(w)}}),define(Z[138],x([0,1,45,9,16,23,114,15,4,2,49,73,37]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends I.ChannelServer{constructor(y){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",v=>R.VSBuffer.wrap(Buffer.from(v,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=w;class t{constructor(y,v){this.modulePath=y,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const M=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(M),this.child=null,this._client=null}getChannel(y){const v=this;return{call(M,g,u){return v.requestPromise(y,M,g,u)},listen(M,g){return v.requestEvent(y,M,g)}}}requestPromise(y,v,M,g=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(y),l=(0,n.createCancelablePromise)(r=>u.call(v,M,r)),o=g.onCancellationRequested(()=>l.cancel()),d=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(d),l.finally(()=>{o.dispose(),this.activeRequests.delete(d),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(y,v,M){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let g;const u=new f.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(y).listen(v,M)(u.fire,u),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,k.removeDangerousEnvVariables)(v.env),this.child=(0,m.fork)(this.modulePath,y,v);const M=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,C.isRemoteConsoleLog)(i)){(0,C.log)(i,`IPC Library: ${this.options.serverName}`);return}M.fire(R.VSBuffer.wrap(Buffer.from(i,"base64")))});const u=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&u.send(i.buffer.toString("base64")),o=M.event,d={send:l,onMessage:o};this._client=new I.ChannelClient(d);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,E.dispose)(a)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(y){let v=this.channels.get(y);return v||(v=this.client.getChannel(y),this.channels.set(y,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[139],x([13,11]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(Z[140],x([13,11]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[141],x([13,11]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[142],x([13,11]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(Z[143],x([13,11]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(Z[144],x([13,11]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[145],x([13,11]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Z[146],x([13,11]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Z[147],x([13,11]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Z[148],x([13,11]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[149],x([13,11]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[150],x([13,11]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[151],x([13,11]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[152],x([13,11]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[153],x([13,11]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Z[154],x([13,11]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(Z[155],x([13,11]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[156],x([13,11]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[157],x([13,11]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(Z[158],x([13,11]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[159],x([13,11]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(Z[160],x([13,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[161],x([13,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[162],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function m(R){return R&&R.hasOwnProperty("folderUri")}e.isFolderBackupInfo=m;function n(R){return R&&R.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=n}),define(Z[163],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function m(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=m}),define(Z[164],x([0,1,4,2]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(S,f,E){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:E[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:E[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:E[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:E[0],port:E[1],subId:E[2]}))}throw new Error("Method not implemented.")}listen(S,f,E){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class L extends n.Disposable{constructor(S){super();this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,f,E){this.channel.call("attach",[S,f,E])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,f){this.channel.call("terminate",[S,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.channel.call("openExtensionDevelopmentHostWindow",[S,f])}}e.ExtensionHostDebugChannelClient=L}),define(Z[165],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(C){this.driver=C}listen(C,S){throw new Error(`No event found: ${S}`)}call(C,S,f){switch(S){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${S}`)}}e.WindowDriverChannel=m;class n{constructor(C){this.channel=C}click(C,S,f){return this.channel.call("click",[C,S,f])}doubleClick(C){return this.channel.call("doubleClick",C)}setValue(C,S){return this.channel.call("setValue",[C,S])}getTitle(){return this.channel.call("getTitle")}isActiveElement(C){return this.channel.call("isActiveElement",C)}getElements(C,S){return this.channel.call("getElements",[C,S])}getElementXY(C,S,f){return this.channel.call("getElementXY",[C,S,f])}typeInEditor(C,S){return this.channel.call("typeInEditor",[C,S])}getTerminalBuffer(C){return this.channel.call("getTerminalBuffer",C)}writeInTerminal(C,S){return this.channel.call("writeInTerminal",[C,S])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class R{constructor(C){this.channel=C}registerWindowDriver(C){return this.channel.call("registerWindowDriver",C)}reloadWindowDriver(C){return this.channel.call("reloadWindowDriver",C)}}e.WindowDriverRegistryChannelClient=R}),define(Z[166],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class m{constructor(R){this.machineId=R}encryption(){return new Promise((R,L)=>H(["vscode-encrypt"],R,L))}async encrypt(R){try{return(await this.encryption()).encrypt(this.machineId,R)}catch{return R}}async decrypt(R){try{return(await this.encryption()).decrypt(this.machineId,R)}catch{return R}}}e.EncryptionMainService=m}),define(Z[167],x([0,1,132,46,10,7,36,17,8]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(h,y,v){this._args=h,this.paths=y,this.productService=v}get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",H).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,m.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(f.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=C.env.VSCODE_PORTABLE;return h?f.URI.file((0,L.join)(h,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.resolve)(h):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,L.resolve)(h):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.resolve)(h);const y=C.env.VSCODE_EXTENSIONS;if(y)return y;const v=C.env.VSCODE_PORTABLE;return v?(0,L.join)(v,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,L.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,L.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],E.prototype,"appRoot",null),ue([n.memoize],E.prototype,"userHome",null),ue([n.memoize],E.prototype,"userDataPath",null),ue([n.memoize],E.prototype,"appSettingsHome",null),ue([n.memoize],E.prototype,"tmpDir",null),ue([n.memoize],E.prototype,"cacheHome",null),ue([n.memoize],E.prototype,"userRoamingDataHome",null),ue([n.memoize],E.prototype,"settingsResource",null),ue([n.memoize],E.prototype,"userDataSyncHome",null),ue([n.memoize],E.prototype,"userDataSyncLogResource",null),ue([n.memoize],E.prototype,"sync",null),ue([n.memoize],E.prototype,"machineSettingsResource",null),ue([n.memoize],E.prototype,"globalStorageHome",null),ue([n.memoize],E.prototype,"workspaceStorageHome",null),ue([n.memoize],E.prototype,"localHistoryHome",null),ue([n.memoize],E.prototype,"keybindingsResource",null),ue([n.memoize],E.prototype,"keyboardLayoutResource",null),ue([n.memoize],E.prototype,"argvResource",null),ue([n.memoize],E.prototype,"snippetsHome",null),ue([n.memoize],E.prototype,"isExtensionDevelopment",null),ue([n.memoize],E.prototype,"untitledWorkspacesHome",null),ue([n.memoize],E.prototype,"installSourcePath",null),ue([n.memoize],E.prototype,"builtinExtensionsPath",null),ue([n.memoize],E.prototype,"extensionsPath",null),ue([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],E.prototype,"extensionDevelopmentKind",null),ue([n.memoize],E.prototype,"extensionTestsLocationURI",null),ue([n.memoize],E.prototype,"debugExtensionHost",null),ue([n.memoize],E.prototype,"serviceMachineIdResource",null),ue([n.memoize],E.prototype,"telemetryLogResource",null),ue([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(t,h){return w(t["inspect-extensions"],t["inspect-brk-extensions"],5870,h,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=P;function k(t,h){return w(t["inspect-search"],t["inspect-brk-search"],5876,h,t.extensionEnvironment)}e.parseSearchPort=k;function I(t,h){return w(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,h,t.extensionEnvironment)}e.parsePtyHostPort=I;function w(t,h,y,v,M,g){const l=Number(h||t)||(v?null:y),o=l?Boolean(!!h):!1;let d;if(g)try{d=JSON.parse(g)}catch{}return{port:l,break:o,debugId:M,env:d}}}),define(Z[91],x([0,1,250,3,142]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function S(t,h,y=C){const v={},M=["_"],g=[];for(let d in h){const r=h[d];r.alias&&(v[d]=r.alias),r.type==="string"||r.type==="string[]"?(M.push(d),r.deprecates&&M.push(...r.deprecates)):r.type==="boolean"&&(g.push(d),r.deprecates&&g.push(...r.deprecates))}const u=m(t,{string:M,boolean:g,alias:v}),l={},o=u;l._=u._.map(d=>String(d)).filter(d=>d.length>0),delete o._;for(let d in h){const r=h[d];r.alias&&delete o[r.alias];let i=o[d];if(r.deprecates)for(const s of r.deprecates)o.hasOwnProperty(s)&&(i||(i=o[s],i&&y.onDeprecatedOption(s,r.deprecationMessage||(0,R.localize)(33,null))),delete o[s]);typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),y.onMultipleValues(d,i)),l[d]=i,r.deprecationMessage&&y.onDeprecatedOption(d,r.deprecationMessage)),delete o[d]}for(let d in o)y.onUnknownOption(d);return l}e.parseArgs=S;function f(t,h){let y="";return h.args&&(Array.isArray(h.args)?y=` <${h.args.join("> <")}>`:y=` <${h.args}>`),h.alias?`-${h.alias} --${t}${y}`:`--${t}${y}`}function E(t,h){let y=0,v=[];for(const l in t){const o=t[l],d=f(l,o);y=Math.max(y,d.length),v.push([d,o.description])}let M=y+2+1;if(h-M<25)return v.reduce((l,o)=>l.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let g=h-M-1,u=[];for(const l of v){let o=l[0],d=k(l[1],g),r=P(M-o.length-2);u.push("  "+o+r+d[0]);for(let i=1;i<d.length;i++)u.push(P(M)+d[i])}return u}e.formatOptions=E;function P(t){return" ".repeat(t)}function k(t,h){let y=[];for(;t.length;){let v=t.length<h?t.length:t.lastIndexOf(" ",h),M=t.slice(0,v).trim();t=t.slice(v),y.push(M)}return y}function I(t,h,y,v,M){const g=process.stdout.isTTY&&process.stdout.columns||80,u=M?.noInputFiles!==!0?`[${(0,R.localize)(34,null)}...]`:"",l=[`${t} ${y}`];l.push(""),l.push(`${(0,R.localize)(35,null)}: ${h} [${(0,R.localize)(36,null)}]${u}`),l.push(""),M?.noPipe!==!0&&(n.isWindows?l.push((0,R.localize)(37,null,h)):l.push((0,R.localize)(38,null,h)),l.push(""));const o={};for(const d in v){const r=v[d];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[d]=r}}for(let d in o){const r=d;let i=o[r];i&&(l.push(L[r]),l.push(...E(i,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=I;function w(t,h){return`${t||(0,R.localize)(39,null)}
${h||(0,R.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=w}),define(Z[168],x([0,1,62,164,91]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends n.ExtensionHostDebugBroadcastChannel{constructor(S){super();this.windowsMainService=S}call(S,f,E){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(E[0],E[1]):super.call(S,f,E)}async openExtensionDevelopmentHostWindow(S,f){const E=(0,R.parseArgs)(S,R.OPTIONS);E.debugRenderer=f;const P=E.extensionDevelopmentPath;if(!P)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:E});if(!f)return{success:!0};const I=k.win;if(!I)return{success:!0};const w=I.webContents.debugger;let t=w.isAttached()?1/0:0;const h=(0,m.createServer)(y=>{t++==0&&w.attach();let v=!1;const M=l=>{v||y.write(JSON.stringify(l)+"\0")},g=(l,o,d,r)=>M({method:o,params:d,sessionId:r});I.on("close",()=>{w.removeListener("message",g),y.end(),v=!0}),w.addListener("message",g);let u=Buffer.alloc(0);y.on("data",l=>{u=Buffer.concat([u,l]);for(let o=u.indexOf(0);o!==-1;o=u.indexOf(0)){let d;try{const r=u.slice(0,o).toString("utf8");u=u.slice(o+1),d=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}w.sendCommand(d.method,d.params,d.sessionId).then(r=>M({id:d.id,sessionId:d.sessionId,result:r})).catch(r=>M({id:d.id,sessionId:d.sessionId,error:{code:0,message:r.message}}))}}),y.on("error",l=>{console.error("error on cdp pipe:",l)}),y.on("close",()=>{v=!0,--t==0&&w.detach()})});return await new Promise(y=>h.listen(0,y)),I.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(Z[50],x([0,1,251,143,91]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function C(I,w){const t={onUnknownOption:y=>{console.warn((0,n.localize)(0,null,y))},onMultipleValues:(y,v)=>{console.warn((0,n.localize)(1,null,y,v))},onDeprecatedOption:(y,v)=>{console.warn((0,n.localize)(2,null,y,v))}},h=(0,R.parseArgs)(I,R.OPTIONS,w?t:void 0);return h.goto&&h._.forEach(y=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,n.localize)(3,null))),h["max-memory"]&&m(parseInt(h["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),h}function S(I){const w=I.findIndex(t=>!/^-/.test(t));if(w>-1)return[...I.slice(0,w),...I.slice(w+1)]}function f(I){let[,...w]=I;process.env.VSCODE_DEV&&(w=S(w)||[]);const t=!k(process.env);return C(w,t)}e.parseMainProcessArgv=f;function E(I){const[,,...w]=I;return C(w,!0)}e.parseCLIProcessArgv=E;function P(I,...w){const t=I.indexOf("--");return t===-1?I.push(...w):I.splice(t,0,...w),I}e.addArg=P;function k(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function H(e,m,n,R){function L(S){const f=C(S),E=[f];return e.isAbsolute(f)||E.unshift(R),e.resolve(...E)}function C(S){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const P=S["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(k,"AppData","Roaming")}break;case"darwin":E=e.join(m.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[169],x([0,252,26,10,17,36]),function(e,m,n,R,L,C){const S=L.dirname(R.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(L.joinPath(S,"package.json").fsPath);return H(m,n,f.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),n=require("os");module.exports=H(m,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[170],x([0,1,26,167,169]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends n.AbstractNativeEnvironmentService{constructor(S,f){super(S,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,R.getUserDataPath)(S)},f)}}e.NativeEnvironmentService=L}),define(Z[171],x([0,1,29,26,28]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function L(C){const S=(0,R.randomPath)((0,n.tmpdir)());try{return(0,m.writeFileSync)(S,""),C&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){C&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=L}),define(Z[172],x([0,1,16,31]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,C,S){let f=S&&S.get("storage.serviceMachineId",0)||null;if(f)return f;try{const P=(await C.readFile(L.serviceMachineIdResource)).value.toString();f=(0,n.isUUID)(P)?P:null}catch{f=null}if(!f){f=(0,n.generateUuid)();try{await C.writeFile(L.serviceMachineIdResource,m.VSBuffer.fromString(f))}catch{}}return S&&S.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=R}),define(Z[74],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(R,L=[],C=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=m}),define(Z[173],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=m;class n{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let C of this._nodes.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const S=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(C);S.outgoing.set(this._hashFn(C),f),f.incoming.set(this._hashFn(L),S)}removeNode(L){const C=this._hashFn(L);this._nodes.delete(C);for(let S of this._nodes.values())S.outgoing.delete(C),S.incoming.delete(C)}lookupOrInsertNode(L){const C=this._hashFn(L);let S=this._nodes.get(C);return S||(S=new m(L),this._nodes.set(C,S)),S}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[C,S]of this._nodes)L.push(`${C}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,C]of this._nodes){const S=new Set([L]),f=this._findCycle(C,S);if(f)return f}}_findCycle(L,C){for(let[S,f]of L.outgoing){if(C.has(S))return[...C,S].join(" -> ");C.add(S);const E=this._findCycle(f,C);if(E)return E;C.delete(S)}}}e.Graph=n}),define(Z[5],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(m=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function n(C,S,f){S[m.DI_TARGET]===S?S[m.DI_DEPENDENCIES].push({id:C,index:f}):(S[m.DI_DEPENDENCIES]=[{id:C,index:f}],S[m.DI_TARGET]=S)}function R(C){if(m.serviceIds.has(C))return m.serviceIds.get(C);const S=function(f,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(S,f,P)};return S.toString=()=>C,m.serviceIds.set(C,S),S}e.createDecorator=R;function L(C){return C}e.refineServiceDecorator=L}),define(Z[51],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService")}),define(Z[18],x([0,1,14,8,5]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof n.URI)}e.isConfigurationOverrides=L;function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||m.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=C;var S;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function E(v,M){const g=Object.create(null);for(let u in v)P(g,u,v[u],M);return g}e.toValuesTree=E;function P(v,M,g,u){const l=M.split("."),o=l.pop();let d=v;for(let r=0;r<l.length;r++){let i=l[r],s=d[i];switch(typeof s){case"undefined":s=d[i]=Object.create(null);break;case"object":break;default:u(`Ignoring ${M} as ${l.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}d=s}if(typeof d=="object"&&d!==null)try{d[o]=g}catch{u(`Ignoring ${M} as ${l.join(".")} is ${JSON.stringify(d)}`)}else u(`Ignoring ${M} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=P;function k(v,M){const g=M.split(".");I(v,g)}e.removeFromValueTree=k;function I(v,M){const g=M.shift();if(M.length===0){delete v[g];return}if(Object.keys(v).indexOf(g)!==-1){const u=v[g];typeof u=="object"&&!Array.isArray(u)&&(I(u,M),Object.keys(u).length===0&&delete v[g])}}function w(v,M,g){function u(d,r){let i=d;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const l=M.split("."),o=u(v,l);return typeof o=="undefined"?g:o}e.getConfigurationValue=w;function t(v,M,g){Object.keys(M).forEach(u=>{u!=="__proto__"&&(u in v?m.isObject(v[u])&&m.isObject(M[u])?t(v[u],M[u],g):g&&(v[u]=M[u]):v[u]=M[u])})}e.merge=t;function h(v,M,g){const u=v.inspect(M),l=v.inspect(g);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:u.defaultValue}e.getMigratedSettingValue=h;function y(v){return v.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(Z[63],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,m.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,m.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(L,C){return this.secretVault[L]?.[C]??null}async setPassword(L,C,S){this.secretVault[L]=this.secretVault[L]??{},this.secretVault[L][C]=S}async deletePassword(L,C){return this.secretVault[L]?.[C]?(delete this.secretVault[L][C],Object.keys(this.secretVault[L]).length===0&&delete this.secretVault[L],!0):!1}async findPassword(L){return JSON.stringify(this.secretVault[L])??null}async findCredentials(L){const C=[];for(const S of Object.keys(this.secretVault[L]||{}))C.push({account:S,password:this.secretVault[L][S]});return C}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(Z[75],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n;class R{async getPerformanceInfo(C,S){return{}}async getSystemInfo(C,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,S){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=R}),define(Z[92],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService")}),define(Z[52],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[174],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(Z[175],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,m.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[93],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(Z[176],x([0,1,45,10,7,3,84,24,73,144,93]),function(H,e,m,n,R,L,C,S,f,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=E.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends I{openTerminal(u,l){return this.spawnTerminal(m,u,f.getWindowsShell(),l)}spawnTerminal(u,l,o,d){const r=l.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const i=R.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return u.spawn(r,d?[d]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((a,c)=>{const b=y(process),p=u.spawn(o,s,{cwd:d,env:b});p.on("error",c),p.on("exit",()=>a())})}runInTerminal(u,l,o,d,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:w.getDefaultTerminalWindows();return new Promise((s,a)=>{const c=`"${l} - ${k}"`,b=`""${o.join('" "')}" & pause"`,p=["/c","start",c,"/wait",i,"/c",b],D=Object.assign({},y(process),d);Object.keys(D).filter(Q=>D[Q]===null).forEach(Q=>delete D[Q]);const F={cwd:l,env:D,windowsVerbatimArguments:!0};m.spawn(w.CMD,p,F).on("error",Q=>{a(v(Q))}),s(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class t extends I{openTerminal(u,l){return this.spawnTerminal(m,u,l)}runInTerminal(u,l,o,d,r){const i=r.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(i===P.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const c=i===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,H).fsPath,"-t",u||k,"-w",l];for(let U of o)p.push("-a"),p.push(U);if(d){const U=Object.assign({},y(process),d);for(let Q in U){const te=U[Q];te===null?(p.push("-u"),p.push(Q)):(p.push("-e"),p.push(`${Q}=${te}`))}}let D="";const F=m.spawn(t.OSASCRIPT,p);F.on("error",U=>{a(v(U))}),F.stderr.on("data",U=>{D+=U.toString()}),F.on("exit",U=>{if(U===0)s(void 0);else if(D){const Q=D.split(`
`,1);a(new Error(Q[0]))}else a(new Error(E.localize(1,null,c,U)))})}else a(new Error(E.localize(2,null,i)))})}spawnTerminal(u,l,o){const d=l.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",d];o&&s.push(o);const a=y(process),c=u.spawn("/usr/bin/open",s,{cwd:o,env:a});c.on("error",i),c.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class h extends I{openTerminal(u,l){return this.spawnTerminal(m,u,l)}runInTerminal(u,l,o,d,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{let c=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const p=`${M(o)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;c.push(`''${p}''`);const D=Object.assign({},y(process),d);Object.keys(D).filter(te=>D[te]===null).forEach(te=>delete D[te]);const F={cwd:l,env:D};let U="";const Q=m.spawn(b,c,F);Q.on("error",te=>{a(v(te))}),Q.stderr.on("data",te=>{U+=te.toString()}),Q.on("exit",te=>{if(te===0)s(void 0);else if(U){const ie=U.split(`
`,1);a(new Error(ie[0]))}else a(new Error(E.localize(4,null,b,te)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await S.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{u?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,l,o){const d=l.linuxExec?Promise.resolve(l.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{d.then(s=>{const a=y(process),c=u.spawn(s,[],{cwd:o,env:a});c.on("error",i),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=E.localize(3,null);function y(g){const u={...g.env};return(0,C.sanitizeProcessEnvironment)(u),u}function v(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(E.localize(5,null,g.path)):g}function M(g){let u="";for(let l of g)l.indexOf(" ")>=0?u+='"'+l+'"':u+=l,u+=" ";return u}}),define(Z[21],x([0,1,15,35,7,27,14,8,146,5]),function(H,e,m,n,R,L,C,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(q){return q.create===!0}e.isFileOpenForWriteOptions=P;var k;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var I;(function(q){q[q.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var w;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function t(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=t;function h(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=y;function v(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function M(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=M;function g(q){return t(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var u;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(N,V){super(N);this.code=V}}e.FileSystemProviderError=l;function o(q,N){const V=new l(q.toString(),N);return r(V,N),V}e.createFileSystemProviderError=o;function d(q){return q||o((0,f.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=d;function r(q,N){return q.name=N?`${N} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=r;function i(q){if(!q)return u.Unknown;if(q instanceof l)return q.code;const N=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!N)return u.Unknown;switch(N[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=i;function s(q){if(q instanceof F)return q.fileOperationResult;switch(i(q)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class c{constructor(N,V,J){this.resource=N,this.operation=V,this.target=J}isOperation(N){return this.operation===N}}e.FileOperationEvent=c;var b;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(b=e.FileChangeType||(e.FileChangeType={}));class p{constructor(N,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const J=new Map;for(const B of N){const K=J.get(B.type);switch(K?K.push([B.resource,B]):J.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,K]of J)switch(B){case 1:this.added=n.TernarySearchTree.forUris(()=>V),this.added.fill(K);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>V),this.updated.fill(K);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>V),this.deleted.fill(K);break}}contains(N,...V){return this.doContains(N,{includeChildren:!1},...V)}affects(N,...V){return this.doContains(N,{includeChildren:!0},...V)}doContains(N,V,...J){if(!N)return!1;const B=J.length>0;return!!((!B||J.includes(1))&&(this.added?.get(N)||V.includeChildren&&this.added?.findSuperstr(N))||(!B||J.includes(0))&&(this.updated?.get(N)||V.includeChildren&&this.updated?.findSuperstr(N))||(!B||J.includes(2))&&(this.deleted?.findSubstr(N)||V.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=p;function D(q,N,V){return!q||!N||q===N||N.length>q.length?!1:(N.charAt(N.length-1)!==R.sep&&(N+=R.sep),V?(0,L.startsWithIgnoreCase)(q,N):q.indexOf(N)===0)}e.isParent=D;class F extends m.ErrorNoTelemetry{constructor(N,V,J){super(N);this.fileOperationResult=V,this.options=J}}e.FileOperationError=F;class U extends F{constructor(N,V,J){super(N,2,J);this.stat=V}}e.NotModifiedSinceFileOperationError=U;var Q;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var te;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(te=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ie(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=ie;async function ee(q,N){if(!N.hasProvider(S.URI.from({scheme:q.scheme})))return new Promise(V=>{const J=N.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===q.scheme&&B.added&&(J.dispose(),V())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(N){return(0,C.isNumber)(N)||(N=0),N<$.KB?(0,f.localize)(1,null,N.toFixed(0)):N<$.MB?(0,f.localize)(2,null,(N/$.KB).toFixed(2)):N<$.GB?(0,f.localize)(3,null,(N/$.MB).toFixed(2)):N<$.TB?(0,f.localize)(4,null,(N/$.GB).toFixed(2)):(0,f.localize)(5,null,(N/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var Y;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function j(q){return{maxFileSize:q===0?300*$.MB:16*$.GB,maxHeapSize:q===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=j}),define(Z[177],x([0,1,16,39,15,4,2,48,8,31,21]),function(H,e,m,n,R,L,C,S,f,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends C.Disposable{constructor(w,t){super();this.channel=w,this.extraCapabilities=t,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,t){const{buffer:h}=await this.channel.call("readFile",[w,t]);return h}readFileStream(w,t,h){const y=(0,S.newWriteableStream)(M=>m.VSBuffer.concat(M.map(g=>m.VSBuffer.wrap(g))).buffer),v=this.channel.listen("readFileStream",[w,t])(M=>{if(M instanceof m.VSBuffer)y.write(M.buffer);else{if(M==="end")y.end();else{let g=M;g instanceof Error||(g=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(g),P.FileSystemProviderErrorCode.Unknown)),y.error(g),y.end()}v.dispose()}});return h.onCancellationRequested(()=>{y.error((0,R.canceled)()),y.end(),v.dispose()}),y}writeFile(w,t,h){return this.channel.call("writeFile",[w,m.VSBuffer.wrap(t),h])}open(w,t){return this.channel.call("open",[w,t])}close(w){return this.channel.call("close",[w])}async read(w,t,h,y,v){const[M,g]=await this.channel.call("read",[w,t,v]);return h.set(M.buffer.slice(0,g),y),g}write(w,t,h,y,v){return this.channel.call("write",[w,t,m.VSBuffer.wrap(h),y,v])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,t){return this.channel.call("delete",[w,t])}rename(w,t,h){return this.channel.call("rename",[w,t,h])}copy(w,t,h){return this.channel.call("copy",[w,t,h])}cloneFile(w,t){return this.channel.call("cloneFile",[w,t])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const t=w;this._onDidChange.fire(t.map(h=>({resource:f.URI.revive(h.resource),type:h.type})))}else{const t=w;this._onDidWatchError.fire(t)}}))}watch(w,t){const h=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,h,w,t]),(0,C.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=k}),define(Z[94],x([0,1,16,15,147,21]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(P,k,I,w,t,h){let y;try{await S(P,k,I,w,t,h)}catch(v){y=v}finally{y&&t.errorTransformer&&(y=t.errorTransformer(y)),typeof y!="undefined"&&I.error(y),I.end()}}e.readFileIntoStream=C;async function S(P,k,I,w,t,h){f(h);const y=await P.open(k,{create:!1});try{f(h);let v=0,M=0,g=t&&typeof t.length=="number"?t.length:void 0,u=m.VSBuffer.alloc(Math.min(t.bufferSize,typeof g=="number"?g:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,o=0;do M=await P.read(y,l,u.buffer,o,u.byteLength-o),l+=M,o+=M,v+=M,typeof g=="number"&&(g-=M),o===u.byteLength&&(await I.write(w(u)),u=m.VSBuffer.alloc(Math.min(t.bufferSize,typeof g=="number"?g:t.bufferSize)),o=0);while(M>0&&(typeof g!="number"||g>0)&&f(h)&&E(v,t));if(o>0){let d=o;typeof g=="number"&&(d=Math.min(o,g)),I.write(w(u.slice(0,d)))}}catch(v){throw(0,L.ensureFileSystemProviderError)(v)}finally{await P.close(y)}}function f(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function E(P,k){if(k?.limits){if(typeof k.limits.memory=="number"&&P>k.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&P>k.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[64],x([0,1,2,3,8,21]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(w){return w.recursive===!0}e.isRecursiveWatchRequest=C;class S extends m.Disposable{constructor(t,h,y,v){super();this.onFileChanges=t,this.onLogMessage=h,this.verboseLogging=y,this.options=v,this.watcherDisposables=this._register(new m.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new m.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),t.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),t.add(this.watcher.onDidError(h=>this.onError(h)))}onError(t){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class f extends S{constructor(t,h,y){super(t,h,y,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=f;class E extends S{constructor(t,h,y){super(t,h,y,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function P(w){return w.map(t=>({type:t.type,resource:R.URI.file(t.path)}))}e.toFileChanges=P;function k(w){const t=new I;for(const h of w)t.processEvent(h);return t.coalesce()}e.coalesceEvents=k;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const h=this.mapPathToChange.get(this.toKey(t));let y=!1;if(h){const v=h.type,M=t.type;h.path!==t.path&&(t.type===2||t.type===1)?y=!0:v===1&&M===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(h)):v===2&&M===1?h.type=0:v===1&&M===0||(h.type=M)}else y=!0;y&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],h=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(t.push(y),!1):!0).sort((y,v)=>y.path.length-v.path.length).filter(y=>h.some(v=>(0,L.isParent)(y.path,v,!n.isLinux))?!1:(h.push(y.path),!0)).concat(t)}}}),define(Z[178],x([0,1,29,9,23,28,116,2,71,7,3,86,24,64]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends S.Disposable{constructor(v,M,g,u){super();this.request=v,this.onDidFilesChange=M,this.onLogMessage=g,this.verboseLogging=u,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,C.parse)(l)),this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const M=await I.Promises.stat(v);this._register(await this.doWatch(v,M.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let M=v.path;try{M=await I.Promises.realpath(v.path),v.path===M&&(M=await(0,k.realcase)(v.path)??v.path),v.path!==M&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${M})`)}catch{}return M}async doWatch(v,M){if(P.isMacintosh&&(0,L.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const g=new R.CancellationTokenSource(this.cts.token);let u=new S.DisposableStore;try{const l=(0,E.basename)(v),o=(0,m.watch)(v);u.add((0,S.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${v}'`);const d=new Set;if(M)try{for(const i of await I.Promises.readdir(v))d.add(i)}catch(i){this.error(i)}const r=new Map;u.add((0,S.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),o.on("error",(i,s)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),o.on("change",(i,s)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let a="";if(s&&(a=s.toString(),P.isMacintosh&&(a=(0,f.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(M)if(i==="rename"){r.get(a)?.dispose();const c=setTimeout(async()=>{if(r.delete(a),a===l&&!await I.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.existsChildStrictCase((0,E.join)(v,a));if(g.token.isCancellationRequested)return;let p;b?d.has(a)?p=0:(p=1,d.add(a)):(d.delete(a),p=2),this.onFileChange({path:(0,E.join)(this.request.path,a),type:p})},t.FILE_DELETE_HANDLER_DELAY);r.set(a,(0,S.toDisposable)(()=>clearTimeout(c)))}else{let c;d.has(a)?c=0:(c=1,d.add(a)),this.onFileChange({path:(0,E.join)(this.request.path,a),type:c})}else if(i==="rename"||a!==l){const c=setTimeout(async()=>{const b=await I.Promises.exists(v);g.token.isCancellationRequested||(b?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,S.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await I.Promises.exists(v)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${l.toString()})`)}return(0,S.toDisposable)(()=>{g.dispose(!0),u.dispose()})}async onFileChange(v,M=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!M&&this.excludes.some(g=>g(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,w.coalesceEvents)(g);if(u.length>0){if(this.verboseLogging)for(const o of u)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(P.isLinux)return I.Promises.exists(v);try{const M=(0,E.basename)(v);return(await I.Promises.readdir((0,E.dirname)(v))).some(u=>u===M)}catch(M){return this.trace(M),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function h(y,v,M,g,u=512){const l=await I.Promises.open(y,"r"),o=Buffer.allocUnsafe(u),d=new R.CancellationTokenSource(g);let r,i=!1;const s={path:y,excludes:[],recursive:!1},a=new t(s,c=>{(async()=>{for(const{type:b}of c)if(b===0){if(i)return;i=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await I.Promises.read(l,o,0,u,null);if(!p||d.token.isCancellationRequested)break;v(o.slice(0,p))}}catch(p){r=new Error(p),d.dispose(!0)}finally{i=!1}}})()});return await a.ready,M(),new Promise((c,b)=>{d.token.onCancellationRequested(async()=>{a.dispose();try{await I.Promises.close(l)}catch(p){r=new Error(p)}r?b(r):c()})})}e.watchFileContents=h}),define(Z[179],x([0,1,30,4,2,3,178]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends R.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const P=this.normalizeRequests(E),k=P.filter(w=>{const t=this.watchers.get(w.path);return t?!(0,m.equals)(t.request.excludes,w.excludes):!0}),I=Array.from(this.watchers.values()).filter(({request:w})=>!P.find(t=>t.path===w.path&&(0,m.equals)(t.excludes,w.excludes))).map(({request:w})=>w.path);k.length&&this.trace(`Request to start watching: ${k.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const w of I)this.stopWatching(w);for(const w of k)this.startWatching(w)}startWatching(E){const P=new C.NodeJSFileWatcherLibrary(E,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),k={request:E,instance:P};this.watchers.set(E.path,k)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const P=this.watchers.get(E);P&&(this.watchers.delete(E),P.instance.dispose())}normalizeRequests(E){const P=new Map;for(const k of E){const I=L.isLinux?k.path:k.path.toLowerCase();P.set(I,k)}return Array.from(P.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,P]of this.watchers)P.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,P){return P?`[File Watcher (node.js)] ${E} (path: ${P.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=S}),define(Z[180],x([0,1,64,179]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends m.AbstractNonRecursiveWatcherClient{constructor(C,S,f){super(C,S,f);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(Z[181],x([0,1,10,37,138,64]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends L.AbstractUniversalWatcherClient{constructor(f,E,P){super(f,E,P);this.init()}createWatcher(f){const E=f.add(new R.Client(m.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(E.onDidProcessExit(({code:P,signal:k})=>this.onError(`terminated by itself with code ${P}, signal: ${k}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(Z[76],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...R){this._entries=new Map;for(let[L,C]of R)this.set(L,C)}set(R,L){const C=this._entries.get(R);return this._entries.set(R,L),C}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=m}),define(Z[182],x([0,1,9,15,74,173,5,76]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class E extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class P{constructor(t=new S.ServiceCollection,h=!1,y){this._activeInstantiations=new Set,this._services=t,this._strict=h,this._parent=y,this._services.set(C.IInstantiationService,this)}createChild(t){return new P(t,this._strict,this)}invokeFunction(t,...h){let y=I.traceInvocation(t),v=!1;try{return t({get:g=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(g,y);if(!u)throw new Error(`[invokeFunction] unknown service '${g}'`);return u}},...h)}finally{v=!0,y.stop()}}createInstance(t,...h){let y,v;return t instanceof R.SyncDescriptor?(y=I.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(h),y)):(y=I.traceCreation(t),v=this._createInstance(t,h,y)),y.stop(),v}_createInstance(t,h=[],y){let v=C._util.getServiceDependencies(t).sort((u,l)=>u.index-l.index),M=[];for(const u of v){let l=this._getOrCreateServiceInstance(u.id,y);l||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${u.id}.`,!1),M.push(l)}let g=v.length>0?v[0].index:h.length;if(h.length!==g){console.trace(`[createInstance] First service dependency of ${t.name} at position ${g+1} conflicts with ${h.length} static arguments`);let u=g-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,g)}return new t(...[...h,...M])}_setServiceInstance(t,h){if(this._services.get(t)instanceof R.SyncDescriptor)this._services.set(t,h);else if(this._parent)this._parent._setServiceInstance(t,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let h=this._services.get(t);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):h}_getOrCreateServiceInstance(t,h){let y=this._getServiceInstanceOrDescriptor(t);return y instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,y,h.branch(t,!0)):(h.branch(t,!1),y)}_safeCreateAndCacheServiceInstance(t,h,y){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,h,y)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,h,y){const v=new L.Graph(u=>u.id.toString());let M=0;const g=[{id:t,desc:h,_trace:y}];for(;g.length;){const u=g.pop();if(v.lookupOrInsertNode(u),M++>1e3)throw new E(v);for(let l of C._util.getServiceDependencies(u.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(l.id);if(o||this._throwIfStrict(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`,!0),o instanceof R.SyncDescriptor){const d={id:l.id,desc:o,_trace:u._trace.branch(l.id,!0)};v.insertEdge(u,d),g.push(d)}}}for(;;){const u=v.roots();if(u.length===0){if(!v.isEmpty())throw new E(v);break}for(const{data:l}of u){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const d=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,d)}v.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,h,y=[],v,M){if(this._services.get(t)instanceof R.SyncDescriptor)return this._createServiceInstance(h,y,v,M);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,h,y,v,M);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(t,h=[],y,v){if(y){const M=new m.IdleValue(()=>this._createInstance(t,h,v));return new Proxy(Object.create(null),{get(g,u){if(u in g)return g[u];let l=M.value,o=l[u];return typeof o!="function"||(o=o.bind(l),g[u]=o),o},set(g,u,l){return M.value[u]=l,!0}})}else return this._createInstance(t,h,v)}_throwIfStrict(t,h){if(h&&console.warn(h),this._strict)throw new Error(t)}}e.InstantiationService=P;var k;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(k||(k={}));class I{constructor(t,h){this.type=t,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return f?new I(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(t){return f?new I(0,t.name):I._None}branch(t,h){let y=new I(2,t.toString());return this._dep.push([t,h,y]),y}stop(){let t=Date.now()-this._start;I._totals+=t;let h=!1;function y(M,g){let u=[],l=new Array(M+1).join("	");for(const[o,d,r]of g._dep)if(d&&r){h=!0,u.push(`${l}CREATES -> ${o}`);let i=y(M+1,r);i&&u.push(i)}else u.push(`${l}uses -> ${o}`);return u.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(t>2||h)&&console.log(v.join(`
`))}}e.Trace=I,I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(Z[183],x([0,1,15,135,60]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class L extends R.ResolvedKeybinding{constructor(S,f){super();if(f.length===0)throw(0,m.illegalArgument)("parts");this._os=S,this._parts=f}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,S=>this._getLabel(S))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,S=>this._getAriaLabel(S))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,S=>this._getElectronAccelerator(S))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,S=>this._getUserSettingsLabel(S))}isWYSIWYG(){return this._parts.every(S=>this._isWYSIWYG(S))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(S=>this._getPart(S))}_getPart(S){return new R.ResolvedKeybindingPart(S.ctrlKey,S.shiftKey,S.altKey,S.metaKey,this._getLabel(S),this._getAriaLabel(S))}getDispatchParts(){return this._parts.map(S=>this._getDispatchPart(S))}getSingleModifierDispatchParts(){return this._parts.map(S=>this._getSingleModifierDispatchPart(S))}}e.BaseResolvedKeybinding=L}),define(Z[184],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class m{constructor(L,C,S,f,E,P,k){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=L,this.keypressParts=L?n(L.getDispatchParts()):[],L&&this.keypressParts.length===0&&(this.keypressParts=n(L.getSingleModifierDispatchParts())),this.bubble=C?C.charCodeAt(0)===94:!1,this.command=this.bubble?C.substr(1):C,this.commandArgs=S,this.when=f,this.isDefault=E,this.extensionId=P,this.isBuiltinExtension=k}}e.ResolvedKeybindingItem=m;function n(R){let L=[];for(let C=0,S=R.length;C<S;C++){const f=R[C];if(!f)return L;L.push(f)}return L}e.removeElementsAfterNulls=n}),define(Z[185],x([0,1,83,60,183,184]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class C extends R.BaseResolvedKeybinding{constructor(f,E){super(E,f.parts)}_keyCodeToUILabel(f){if(this._os===2)switch(f){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(f)}_getLabel(f){return f.isDuplicateModifierCase()?"":this._keyCodeToUILabel(f.keyCode)}_getAriaLabel(f){return f.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(f.keyCode)}_getElectronAccelerator(f){return m.KeyCodeUtils.toElectronAccelerator(f.keyCode)}_getUserSettingsLabel(f){if(f.isDuplicateModifierCase())return"";const E=m.KeyCodeUtils.toUserSettingsUS(f.keyCode);return E&&E.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(f){return C.getDispatchStr(f)}static getDispatchStr(f){if(f.isModifierKey())return null;let E="";return f.ctrlKey&&(E+="ctrl+"),f.shiftKey&&(E+="shift+"),f.altKey&&(E+="alt+"),f.metaKey&&(E+="meta+"),E+=m.KeyCodeUtils.toString(f.keyCode),E}_getSingleModifierDispatchPart(f){return f.keyCode===5&&!f.shiftKey&&!f.altKey&&!f.metaKey?"ctrl":f.keyCode===4&&!f.ctrlKey&&!f.altKey&&!f.metaKey?"shift":f.keyCode===6&&!f.ctrlKey&&!f.shiftKey&&!f.metaKey?"alt":f.keyCode===57&&!f.ctrlKey&&!f.shiftKey&&!f.altKey?"meta":null}static _scanCodeToKeyCode(f){const E=m.IMMUTABLE_CODE_TO_KEY_CODE[f];if(E!==-1)return E;switch(f){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(f){if(!f)return null;if(f instanceof n.SimpleKeybinding)return f;const E=this._scanCodeToKeyCode(f.scanCode);return E===0?null:new n.SimpleKeybinding(f.ctrlKey,f.shiftKey,f.altKey,f.metaKey,E)}static resolveUserBinding(f,E){const P=(0,L.removeElementsAfterNulls)(f.map(k=>this._resolveSimpleUserBinding(k)));return P.length>0?[new C(new n.ChordKeybinding(P),E)]:[]}}e.USLayoutResolvedKeybinding=C}),define(Z[6],x([0,1,39,4,2,3,5]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function S(){return new Date().toISOString()}var f;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function E(d,r,i){switch(r){case f.Trace:d.trace(i);break;case f.Debug:d.debug(i);break;case f.Info:d.info(i);break;case f.Warning:d.warn(i);break;case f.Error:d.error(i);break;case f.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}e.log=E;function P(d){let r="";for(let i=0;i<d.length;i++){let s=d[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(i>0?" ":"")+s}return r}e.format=P;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class I extends k{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,P([r,...i]))}debug(r,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,P([r,...i]))}info(r,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,P([r,...i]))}warn(r,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,P([r,...i]))}error(r,...i){if(this.checkLogLevel(f.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(f.Error,P(s))}else this.log(f.Error,P([r,...i]))}critical(r,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,P([r,...i]))}flush(){}}e.AbstractMessageLogger=I;class w extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!L.isWindows}trace(r,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,r,...i):console.log(`[main ${S()}]`,r,...i))}debug(r,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,r,...i):console.log(`[main ${S()}]`,r,...i))}info(r,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,r,...i):console.log(`[main ${S()}]`,r,...i))}warn(r,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,r,...i):console.warn(`[main ${S()}]`,r,...i))}error(r,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,r,...i):console.error(`[main ${S()}]`,r,...i))}critical(r,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,r,...i):console.error(`[main ${S()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class t extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class h extends k{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,m.toErrorMessage)(r,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class y extends k{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const s of this.logServices)s.trace(r,...i)}debug(r,...i){for(const s of this.logServices)s.debug(r,...i)}info(r,...i){for(const s of this.logServices)s.info(r,...i)}warn(r,...i){for(const s of this.logServices)s.warn(r,...i)}error(r,...i){for(const s of this.logServices)s.error(r,...i)}critical(r,...i){for(const s of this.logServices)s.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=y;class v extends R.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=v;class M extends R.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,i?.always?f.Trace:this.logLevel,i),this.loggers.set(r.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class g{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return f.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=g;function u(d){if(d.verbose)return f.Trace;if(typeof d.logLevel=="string"){const r=l(d.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function l(d){switch(d){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=l;function o(d){switch(d){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var ne=this&&this.__param||function(H,e){return function(m,n){e(m,n,H)}};define(Z[186],x([0,1,63,4,2,6,3]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let S=class mt extends R.Disposable{constructor(E){super();this.logService=E,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(E,P){const k=await this.withKeytar(),I=await k.getPassword(E,P);if(I)try{let{content:w,hasNextChunk:t}=JSON.parse(I);if(!w||!t)return I;let h=1;for(;t;){const y=await k.getPassword(E,`${P}-${h}`),v=JSON.parse(y);w+=v.content,t=v.hasNextChunk,h++}return w}catch{return I}return I}async setPassword(E,P,k){const I=await this.withKeytar(),w=3,t=async(h,y,v)=>{let M=0,g;for(;M<w;)try{await I.setPassword(h,y,v);return}catch(u){g=u,this.logService.warn("Error attempting to set a password: ",u),M++,await new Promise(l=>setTimeout(l,200))}throw g};if(C.isWindows&&k.length>mt.MAX_PASSWORD_LENGTH){let h=0,y=0,v=!0;for(;v;){const M=k.substring(h,h+mt.PASSWORD_CHUNK_SIZE);h+=mt.PASSWORD_CHUNK_SIZE,v=k.length-h>0;const g={content:M,hasNextChunk:v};await t(E,y?`${P}-${y}`:P,JSON.stringify(g)),y++}}else await t(E,P,k);this._onDidChangePassword.fire({service:E,account:P})}async deletePassword(E,P){const I=await(await this.withKeytar()).deletePassword(E,P);return I&&this._onDidChangePassword.fire({service:E,account:P}),I}async findPassword(E){return(await this.withKeytar()).findPassword(E)}async findCredentials(E){return(await this.withKeytar()).findCredentials(E)}clear(){return this._keytarCache instanceof m.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};S.MAX_PASSWORD_LENGTH=2500,S.PASSWORD_CHUNK_SIZE=S.MAX_PASSWORD_LENGTH-100,S=ue([ne(0,L.ILogService)],S),e.BaseCredentialsMainService=S}),define(Z[187],x([0,1,30,9,15,4,2,7,64,6]),function(H,e,m,n,R,L,C,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends C.Disposable{constructor(I,w){super();this.logService=I,this.options=w,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(I,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,w):this.watchNonRecursive(I,w)}watchUniversal(I,w){const t={path:this.toFilePath(I),excludes:w.excludes,recursive:w.recursive},h=(0,m.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,C.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,R.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,f.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const w of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const w of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(w)&&I.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,w){const t={path:this.toFilePath(I),excludes:w.excludes,recursive:!1},h=(0,m.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,C.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,R.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,f.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,S.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(Z[188],x([0,1,30,9,16,23,4,70,69,2,35,10,65,17,48,145,21,94,6]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,o){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`);const d=new E.DisposableStore;return this.provider.set(l,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:o}),d.add(o.onDidChangeFile(r=>this._onDidFilesChange.fire(new y.FileChangesEvent(r,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&d.add(o.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),d.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:o}),this.provider.delete(l),(0,E.dispose)(d)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(d){o.push(d)}}),!this.provider.has(l)&&await n.Promises.settled(o)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,o){const d=this.provider.get(l.scheme);return!!(d&&d.capabilities&o)}listCapabilities(){return f.Iterable.map(this.provider,([l,o])=>({scheme:l,capabilities:o.capabilities}))}async withProvider(l){if(!(0,w.isAbsolutePath)(l))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const o=this.provider.get(l.scheme);if(!o){const d=new Error;throw d.name="ENOPRO",d.message=(0,h.localize)(1,null,l.toString()),d}return o}async withReadProvider(l){const o=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasReadWriteCapability)(o)||(0,y.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const o=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,o){try{return await this.doResolveFile(l,o)}catch(d){throw(0,y.toFileSystemProviderErrorCode)(d)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(d)}}async doResolveFile(l,o){const d=await this.withProvider(l),r=this.isPathCaseSensitive(d),i=o?.resolveTo,s=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,c=await d.stat(l);let b;return this.toFileStat(d,l,c,void 0,!!a,(p,D)=>(b||(b=P.TernarySearchTree.forUris(()=>!r),b.set(l,!0),i&&b.fill(!0,i)),b.get(p.resource)||b.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&s?D===1:!1))}async toFileStat(l,o,d,r,i,s){const{providerExtUri:a}=this.getExtUri(l),c={resource:o,name:a.basename(o),isFile:(d.type&y.FileType.File)!=0,isDirectory:(d.type&y.FileType.Directory)!=0,isSymbolicLink:(d.type&y.FileType.SymbolicLink)!=0,mtime:d.mtime,ctime:d.ctime,size:d.size,readonly:Boolean((d.permissions??0)&y.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,y.etag)({mtime:d.mtime,size:d.size}),children:void 0};if(c.isDirectory&&s(c,r)){try{const b=await l.readdir(o),p=await n.Promises.settled(b.map(async([D,F])=>{try{const U=a.joinPath(o,D),Q=i?await l.stat(U):{type:F};return await this.toFileStat(l,U,Q,b.length,i,s)}catch(U){return this.logService.trace(U),null}}));c.children=(0,m.coalesce)(p)}catch(b){this.logService.trace(b),c.children=[]}return c}return c}async resolveAll(l){return n.Promises.settled(l.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(d){return this.logService.trace(d),{stat:void 0,success:!1}}}))}async stat(l){const o=await this.withProvider(l),d=await o.stat(l);return this.toFileStat(o,l,d,void 0,!0,()=>!1)}async exists(l){const o=await this.withProvider(l);try{return!!await o.stat(l)}catch{return!1}}async canCreateFile(l,o){try{await this.doValidateCreateFile(l,o)}catch(d){return d}return!0}async doValidateCreateFile(l,o){if(!o?.overwrite&&await this.exists(l))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,o)}async createFile(l,o=R.VSBuffer.fromString(""),d){await this.doValidateCreateFile(l,d);const r=await this.writeFile(l,o);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,r)),r}async writeFile(l,o,d){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,l,d)||await this.mkdirp(r,i.dirname(l));let a;if((0,y.hasReadWriteCapability)(r)&&!(o instanceof R.VSBuffer))if((0,t.isReadableStream)(o)){const c=await(0,t.peekStream)(o,3);c.ended?a=R.VSBuffer.concat(c.buffer):a=c}else a=(0,t.peekReadable)(o,c=>R.VSBuffer.concat(c),3);else a=o;!(0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)&&a instanceof R.VSBuffer?await this.doWriteUnbuffered(r,l,d,a):await this.doWriteBuffered(r,l,d,a instanceof R.VSBuffer?(0,R.bufferToReadable)(a):a),this._onDidRunOperation.fire(new y.FileOperationEvent(l,4))}catch(s){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),d)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,o,d){if(!!d?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(o)));let i;try{i=await l.stat(o)}catch{return}if((i.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(o)),0,d);if(this.throwIfFileIsReadonly(o,i),typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==y.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&d.mtime<i.mtime&&d.etag!==(0,y.etag)({mtime:d.mtime,size:i.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,d);return i}async readFile(l,o,d){const r=await this.withReadProvider(l);return o?.atomic?this.doReadFileAtomic(r,l,o,d):this.doReadFile(r,l,o,d)}async doReadFileAtomic(l,o,d,r){return new Promise((i,s)=>{this.writeQueue.queueFor(o,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,o,d,r);i(a)}catch(a){s(a)}})})}async doReadFile(l,o,d,r){const i=await this.doReadFileStream(l,o,{...d,preferUnbuffered:!0},r);return{...i,value:await(0,R.streamToBuffer)(i.value)}}async readFileStream(l,o,d){const r=await this.withReadProvider(l);return this.doReadFileStream(r,l,o,d)}async doReadFileStream(l,o,d,r){const i=new L.CancellationTokenSource(r),s=this.validateReadFile(o,d).then(c=>c,c=>{throw i.cancel(),c});let a;try{return typeof d?.etag=="string"&&d.etag!==y.ETAG_DISABLED&&await s,d?.atomic&&(0,y.hasFileAtomicReadCapability)(l)||!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&d?.preferUnbuffered?a=this.readFileUnbuffered(l,o,d):(0,y.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,o,i.token,d):a=this.readFileBuffered(l,o,i.token,d),{...await s,value:a}}catch(c){a&&await(0,t.consumeStream)(a);const b=(0,h.localize)(8,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(c).toString());throw c instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(b,c.stat,d):new y.FileOperationError(b,(0,y.toFileOperationResult)(c),d)}}readFileStreamed(l,o,d,r=Object.create(null)){const i=l.readFileStream(o,r,d);return(0,t.transform)(i,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(l,o,d,r=Object.create(null)){const i=(0,R.newWriteableBufferStream)();return(0,v.readFileIntoStream)(l,o,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)},d),i}readFileUnbuffered(l,o,d){const r=(0,t.newWriteableStream)(i=>R.VSBuffer.concat(i));return(async()=>{try{let i;d?.atomic&&(0,y.hasFileAtomicReadCapability)(l)?i=await l.readFile(o,{atomic:!0}):i=await l.readFile(o),typeof d?.position=="number"&&(i=i.slice(d.position)),typeof d?.length=="number"&&(i=i.slice(0,d.length)),this.validateReadFileLimits(o,i.byteLength,d),r.end(R.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(l,o){const d=await this.resolve(l,{resolveMetadata:!0});if(d.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,o);if(typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&o.etag===d.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),d,o);return this.validateReadFileLimits(l,d.size,o),d}validateReadFileLimits(l,o,d){if(d?.limits){let r;if(typeof d.limits.memory=="number"&&o>d.limits.memory&&(r=9),typeof d.limits.size=="number"&&o>d.limits.size&&(r=7),typeof r=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,o,d){return this.doCanMoveCopy(l,o,"move",d)}async canCopy(l,o,d){return this.doCanMoveCopy(l,o,"copy",d)}async doCanMoveCopy(l,o,d,r){if(l.toString()!==o.toString())try{const i=d==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,l,s,o,d,r)}catch(i){return i}return!0}async move(l,o,d){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,l,i,o,"move",!!d),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,s==="move"?2:3,a)),a}async copy(l,o,d){const r=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,l,i,o,"copy",!!d),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,s==="copy"?3:2,a)),a}async doMoveCopy(l,o,d,r,i,s){if(o.toString()===r.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,o,d,r,i,s);if(a&&!c&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(d,this.getExtUri(d).providerExtUri.dirname(r)),i==="copy"){if(l===d&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(o,r,{overwrite:s});else{const b=await this.resolve(o);b.isDirectory?await this.doCopyFolder(l,b,d,r):await this.doCopyFile(l,o,d,r)}return i}else return l===d?(await l.rename(o,r,{overwrite:s}),i):(await this.doMoveCopy(l,o,d,r,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(l,o,d,r){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(d))return this.doPipeBuffered(l,o,d,r);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(d))return this.doPipeBufferedToUnbuffered(l,o,d,r);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(d))return this.doPipeUnbufferedToBuffered(l,o,d,r);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(d))return this.doPipeUnbuffered(l,o,d,r)}async doCopyFolder(l,o,d,r){await d.mkdir(r),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async i=>{const s=this.getExtUri(d).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),d,s):this.doCopyFile(l,i.resource,d,s)}))}async doValidateMoveCopy(l,o,d,r,i,s){let a=!1;if(l===d){const{providerExtUri:b,isPathCaseSensitive:p}=this.getExtUri(l);if(p||(a=b.isEqual(o,r)),a&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!a&&b.isEqualOrParent(r,o))throw new Error((0,h.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!a){if(!s)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(l===d){const{providerExtUri:b}=this.getExtUri(l);if(b.isEqualOrParent(o,r))throw new Error((0,h.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const o=this.isPathCaseSensitive(l);return{providerExtUri:o?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(o,l);const d=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,d)),d}async mkdirp(l,o){const d=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(o,r.dirname(o));)try{if(((await l.stat(o)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,y.toFileSystemProviderErrorCode)(i)!==y.FileSystemProviderErrorCode.FileNotFound)throw i;d.push(r.basename(o)),o=r.dirname(o)}for(let i=d.length-1;i>=0;i--){o=r.joinPath(o,d[i]);try{await l.mkdir(o)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,o){try{await this.doValidateDelete(l,o)}catch(d){return d}return!0}async doValidateDelete(l,o){const d=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!o?.useTrash&&!(d.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let i;try{i=await d.stat(l)}catch{}if(i)this.throwIfFileIsReadonly(l,i);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!o?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return d}async del(l,o){const d=await this.doValidateDelete(l,o),r=!!o?.useTrash,i=!!o?.recursive;await d.delete(l,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}async cloneFile(l,o){const d=await this.withProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(d===r&&this.getExtUri(d).providerExtUri.isEqual(l,o))return;if(d===r&&(0,y.hasFileCloneCapability)(d))return d.cloneFile(l,o);await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(o));const i=this.writeQueue.queueFor(l,this.getExtUri(d).providerExtUri);return d===r&&(0,y.hasFileFolderCopyCapability)(d)?i.queue(()=>d.copy(l,o,{overwrite:!0})):i.queue(()=>this.doCopyFile(d,l,r,o))}watch(l,o={recursive:!1,excludes:[]}){const d=new E.DisposableStore;let r=!1,i=()=>{r=!0};return d.add((0,E.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(l,o);r?(0,E.dispose)(s):i=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),d}async doWatch(l,o){const d=await this.withProvider(l),r=(0,S.hash)([this.getExtUri(d).providerExtUri.getComparisonKey(l),o]);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:d.watch(l,o)},this.activeWatchers.set(r,i)),i.count+=1,(0,E.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,E.dispose)(i.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,o,d,r){return this.writeQueue.queueFor(o,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(o,{create:!0,unlock:d?.unlock??!1});try{(0,t.isReadableStream)(r)||(0,t.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,i,r):await this.doWriteReadableBufferedQueued(l,i,r)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,o,d){let r=0,i;if((0,t.isReadableBufferedStream)(d)){if(d.buffer.length>0){const s=R.VSBuffer.concat(d.buffer);await this.doWriteBuffer(l,o,s,s.byteLength,r,0),r+=s.byteLength}if(d.ended)return;i=d.stream}else i=d;return new Promise((s,a)=>{(0,t.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(l,o,c,c.byteLength,r,0)}catch(b){return a(b)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>a(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,o,d){let r=0,i;for(;(i=d.read())!==null;)await this.doWriteBuffer(l,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(l,o,d,r,i,s){let a=0;for(;a<r;)a+=await l.write(o,i+a,d.buffer,s+a,r-a)}async doWriteUnbuffered(l,o,d,r){return this.writeQueue.queueFor(o,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,o,d,r))}async doWriteUnbufferedQueued(l,o,d,r){let i;r instanceof R.VSBuffer?i=r:(0,t.isReadableStream)(r)?i=await(0,R.streamToBuffer)(r):(0,t.isReadableBufferedStream)(r)?i=await(0,R.bufferedStreamToBuffer)(r):i=(0,R.readableToBuffer)(r),await l.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:d?.unlock??!1})}async doPipeBuffered(l,o,d,r){return this.writeQueue.queueFor(r,this.getExtUri(d).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,o,d,r))}async doPipeBufferedQueued(l,o,d,r){let i,s;try{i=await l.open(o,{create:!1}),s=await d.open(r,{create:!0,unlock:!1});const a=R.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,b=0,p=0;do p=await l.read(i,c,a.buffer,b,a.byteLength-b),await this.doWriteBuffer(d,s,a,p,c,b),c+=p,b+=p,b===a.byteLength&&(b=0);while(p>0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof s=="number"?d.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,o,d,r){return this.writeQueue.queueFor(r,this.getExtUri(d).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,o,d,r))}async doPipeUnbufferedQueued(l,o,d,r){return d.writeFile(r,await l.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,o,d,r){return this.writeQueue.queueFor(r,this.getExtUri(d).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,o,d,r))}async doPipeUnbufferedToBufferedQueued(l,o,d,r){const i=await d.open(r,{create:!0,unlock:!1});try{const s=await l.readFile(o);await this.doWriteBuffer(d,i,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await d.close(i)}}async doPipeBufferedToUnbuffered(l,o,d,r){const i=await(0,R.streamToBuffer)(this.readFileBuffered(l,o,L.CancellationToken.None));await this.doWriteUnbuffered(d,r,void 0,i)}throwIfFileSystemIsReadonly(l,o){if(l.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(o)),6);return l}throwIfFileIsReadonly(l,o){if((o.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===k.Schemas.file?l.fsPath:l.toString(!0)}};g=ue([ne(0,M.ILogService)],g),e.FileService=g}),define(Z[77],x([0,1,29,253,9,35,16,4,28,2,7,3,17,48,24,149,21,94,187,39,181,180]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(m)}catch(d){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(d)}`)}})();class o extends M.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new L.ResourceMap(s=>I.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:s}=await t.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await t.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,I.joinPath)(r,a.name))).type:c=this.toType(a),s.push([a.name,c])}catch(c){this.logService.trace(c)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let s;return i?.dangling?s=y.FileType.Unknown:r.isFile()?s=y.FileType.File:r.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,i&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(r){const i=this.toFilePath(r);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const a=new R.Barrier;return this.resourceLocks.set(r,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(r)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const a=this.toFilePath(r);return await t.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(r,i,s){const a=(0,w.newWriteableStream)(c=>C.VSBuffer.concat(c.map(b=>C.VSBuffer.wrap(b))).buffer);return(0,v.readFileIntoStream)(this,r,a,c=>c.buffer,{...i,bufferSize:256*1024},s),a}async writeFile(r,i,s){let a;try{const c=this.toFilePath(r);if(!s.create||!s.overwrite){if(await t.Promises.exists(c)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,h.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,h.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(r,c)}finally{typeof a=="number"&&await this.close(a)}}async open(r,i){const s=this.toFilePath(r);let a;(0,y.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(r));let c;try{if((0,y.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:p}=await t.SymlinkSupport.stat(s);p.mode&128||await t.Promises.chmod(s,p.mode|128)}catch(p){this.logService.trace(p)}let b;if((0,y.isFileOpenForWriteOptions)(i)){if(k.isWindows)try{await t.Promises.truncate(s,0),b="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}b||(b="w")}else b="r";c=await t.Promises.open(s,b)}catch(b){throw a?.dispose(),(0,y.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,b):this.toFileSystemProviderError(b)}if(this.mapHandleToPos.set(c,0),(0,y.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,r),a){const b=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.mapHandleToLock.set(c,a),b&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),b.dispose())}return c}async close(r){const i=this.mapHandleToLock.get(r);try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await t.Promises.fdatasync(r)}catch(s){this.canFlush=!1,this.logService.error(s)}return await t.Promises.close(r)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(r)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.mapHandleToLock.delete(r)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,a,c){const b=this.normalizePos(r,i);let p=null;try{p=(await t.Promises.read(r,s,a,c,b)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(r,b,p)}return p}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,s){const a=this.mapHandleToPos.get(r);typeof a=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,a+s):this.mapHandleToPos.delete(r)))}async write(r,i,s,a,c){return(0,R.retry)(()=>this.doWrite(r,i,s,a,c),100,3)}async doWrite(r,i,s,a,c){const b=this.normalizePos(r,i);let p=null;try{p=(await t.Promises.write(r,s,a,c,b)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),D)}finally{this.updatePos(r,b,p)}return p}async mkdir(r){try{await t.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const s=this.toFilePath(r);i.recursive?await t.Promises.rm(s,t.RimRafMode.MOVE):await t.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,i,s){const a=this.toFilePath(r),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(r,i,"move",s.overwrite),await t.Promises.move(a,c)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,h.localize)(2,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(c)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(r,i,s){const a=this.toFilePath(r),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(r,i,"copy",s.overwrite),await t.Promises.copy(a,c,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,h.localize)(3,null,(0,P.basename)(a),(0,P.basename)((0,P.dirname)(c)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(r,i,s,a){const c=this.toFilePath(r),b=this.toFilePath(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,f.isEqual)(c,b,!0)),p&&s==="copy")throw(0,y.createFileSystemProviderError)((0,h.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!p&&await t.Promises.exists(b)){if(!a)throw(0,y.createFileSystemProviderError)((0,h.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(r,i){return this.doCloneFile(r,i,!1)}async doCloneFile(r,i,s){const a=this.toFilePath(r),c=this.toFilePath(i),b=!!(this.capabilities&1024);if((0,f.isEqual)(a,c,!b))return;const p=new E.DisposableStore;try{const[D,F]=await Promise.all([this.createResourceLock(r),this.createResourceLock(i)]);p.add(D),p.add(F),s&&await t.Promises.mkdir((0,P.dirname)(c),{recursive:!0}),await t.Promises.copyFile(a,c)}catch(D){if(D.code==="ENOENT"&&!s)return this.doCloneFile(r,i,!0);throw this.toFileSystemProviderError(D)}finally{p.dispose()}}createUniversalWatcher(r,i,s){return new u.UniversalWatcherClient(a=>r(a),a=>i(a),s)}createNonRecursiveWatcher(r,i,s){return new l.NodeJSWatcherClient(a=>r(a),a=>i(a),s)}toFileSystemProviderError(r){if(r instanceof y.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=y.FileSystemProviderErrorCode.NoPermissions;break;default:i=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let s=this.toFileSystemProviderError(i);if(r&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await t.SymlinkSupport.stat(this.toFilePath(r));a.mode&128||(s=(0,y.createFileSystemProviderError)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=o}),define(Z[189],x([0,1,4,77,2,16,48,23]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends R.Disposable{constructor(k,I){super();this.provider=k,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,I,w){const t=this.getUriTransformer(k);switch(I){case"stat":return this.stat(t,w[0]);case"readdir":return this.readdir(t,w[0]);case"open":return this.open(t,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(t,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(t,w[0],w[1],w[2]);case"rename":return this.rename(t,w[0],w[1],w[2]);case"copy":return this.copy(t,w[0],w[1],w[2]);case"cloneFile":return this.cloneFile(t,w[0],w[1]);case"mkdir":return this.mkdir(t,w[0]);case"delete":return this.delete(t,w[0],w[1]);case"watch":return this.watch(t,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${I} not found`)}listen(k,I,w){const t=this.getUriTransformer(k);switch(I){case"fileChange":return this.onFileChange(t,w[0]);case"readFileStream":return this.onReadFileStream(t,w[0],w[1])}throw new Error(`Unknown event ${I}`)}stat(k,I){const w=this.transformIncoming(k,I,!0);return this.provider.stat(w)}readdir(k,I){const w=this.transformIncoming(k,I);return this.provider.readdir(w)}async readFile(k,I,w){const t=this.transformIncoming(k,I,!0),h=await this.provider.readFile(t,w);return L.VSBuffer.wrap(h)}onReadFileStream(k,I,w){const t=this.transformIncoming(k,I,!0),h=new S.CancellationTokenSource,y=new m.Emitter({onLastListenerRemove:()=>{h.cancel()}}),v=this.provider.readFileStream(t,w,h.token);return(0,C.listenStream)(v,{onData:M=>y.fire(L.VSBuffer.wrap(M)),onError:M=>y.fire(M),onEnd:()=>{y.fire("end"),y.dispose(),h.dispose()}}),y.event}writeFile(k,I,w,t){const h=this.transformIncoming(k,I);return this.provider.writeFile(h,w.buffer,t)}open(k,I,w){const t=this.transformIncoming(k,I,!0);return this.provider.open(t,w)}close(k){return this.provider.close(k)}async read(k,I,w){const t=L.VSBuffer.alloc(w),h=0,y=await this.provider.read(k,I,t.buffer,h,w);return[t,y]}write(k,I,w,t,h){return this.provider.write(k,I,w.buffer,t,h)}mkdir(k,I){const w=this.transformIncoming(k,I);return this.provider.mkdir(w)}delete(k,I,w){const t=this.transformIncoming(k,I);return this.provider.delete(t,w)}rename(k,I,w,t){const h=this.transformIncoming(k,I),y=this.transformIncoming(k,w);return this.provider.rename(h,y,t)}copy(k,I,w,t){const h=this.transformIncoming(k,I),y=this.transformIncoming(k,w);return this.provider.copy(h,y,t)}cloneFile(k,I,w){const t=this.transformIncoming(k,I),h=this.transformIncoming(k,w);return this.provider.cloneFile(t,h)}onFileChange(k,I){const w=new m.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(k,w))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return w.event}async watch(k,I,w,t,h){const y=this.sessionToWatcher.get(I);if(y){const v=this.transformIncoming(k,t),M=y.watch(w,v,h);this.watchRequests.set(I+w,M)}}async unwatch(k,I){const w=k+I,t=this.watchRequests.get(w);t&&((0,R.dispose)(t),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class E extends R.Disposable{constructor(k,I,w,t){super();this.uriTransformer=k,this.logService=w,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(k){const I=this._register(new m.Emitter);this._register(I.event(w=>{k.fire(w.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>I.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>k.fire(w)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,I,w){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(w.excludes=[...w.excludes,...t]),this.watcherRequests.set(k,this.fileWatcher.watch(I,w)),(0,R.toDisposable)(()=>{(0,R.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=E}),define(Z[190],x([0,1,12,148,3,8,21,7,189,117]),function(H,e,m,n,R,L,C,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class P extends f.AbstractDiskFileSystemProviderChannel{constructor(w,t,h){super(w,t);this.environmentService=h}getUriTransformer(w){return E.DefaultURITransformer}transformIncoming(w,t){return L.URI.revive(t)}async delete(w,t,h){if(!h.useTrash)return super.delete(w,t,h);const y=this.transformIncoming(w,t),v=(0,S.normalize)(y.fsPath);try{await m.shell.trashItem(v)}catch{throw(0,C.createFileSystemProviderError)(R.isWindows?(0,n.localize)(0,null,(0,S.basename)(v)):(0,n.localize)(1,null,(0,S.basename)(v)),C.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(w,t){return new k(w,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=P;class k extends f.AbstractSessionFileWatcher{watch(w,t,h){if(h.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(w,t,h)}}}),define(Z[95],x([0,1,6]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(L,C){switch(C){case m.LogLevel.Trace:return L.trace;case m.LogLevel.Debug:return L.debug;case m.LogLevel.Info:return L.info;case m.LogLevel.Warning:return L.warn;case m.LogLevel.Error:return L.error;case m.LogLevel.Critical:return L.critical;default:throw new Error("Invalid log level")}}class R extends m.AbstractLogger{constructor(C=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(C),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}set logger(C){this._logger=C;for(const{level:S,args:f}of this.buffer)n(C,S).apply(C,f);this.buffer=[]}_log(C,...S){this._logger?n(this._logger,C).apply(this._logger,S):this.getLevel()<=C&&this.buffer.push({level:C,args:S})}trace(C,...S){this._log(m.LogLevel.Trace,C,...S)}debug(C,...S){this._log(m.LogLevel.Debug,C,...S)}info(C,...S){this._log(m.LogLevel.Info,C,...S)}warn(C,...S){this._log(m.LogLevel.Warning,C,...S)}error(C,...S){this._log(m.LogLevel.Error,C,...S)}critical(C,...S){this._log(m.LogLevel.Critical,C,...S)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(Z[191],x([0,1,9,16,17,21,5,95,6]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const E=5*L.ByteSize.MB;let P=class extends f.AbstractLogger{constructor(w,t,h,y,v){super();this.name=w,this.resource=t,this.donotUseFormatters=y,this.fileService=v,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new m.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=w.stack,this._log(f.LogLevel.Error,(0,f.format)(t))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,t){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>E&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=t:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(h))})}getCurrentTimestamp(){const w=y=>y<10?`0${y}`:y,t=y=>y<10?`00${y}`:y<100?`0${y}`:y,h=new Date;return`${h.getFullYear()}-${w(h.getMonth()+1)}-${w(h.getDate())} ${w(h.getHours())}:${w(h.getMinutes())}:${w(h.getSeconds())}.${t(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,R.joinPath)((0,R.dirname)(this.resource),`${(0,R.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(w){switch(w){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};P=ue([ne(4,L.IFileService)],P),e.FileLogger=P;let k=class extends f.AbstractLoggerService{constructor(w,t,h){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=t,this.fileService=h}doCreateLogger(w,t,h){const y=new S.BufferLogService(t);return(0,L.whenProviderRegistered)(w,this.fileService).then(()=>y.logger=this.instantiationService.createInstance(P,h?.name||(0,R.basename)(w),w,y.getLevel(),!!h?.donotUseFormatters)),y}};k=ue([ne(0,f.ILogService),ne(1,C.IInstantiationService),ne(2,L.IFileService)],k),e.FileLoggerService=k}),define(Z[192],x([0,1,4,8,6]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(I){this.service=I,this.onDidChangeLogLevel=m.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(I,w,t){switch(w){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=L;class C{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){C.setLevel(this.channel,I)}static setLevel(I,w){return I.call("setLevel",w)}}e.LogLevelChannelClient=C;class S{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,w){throw new Error(`Event not found: ${w}`)}async call(I,w,t){switch(w){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${w}`)}createLogger(I,w){this.loggers.set(I.toString(),this.loggerService.createLogger(I,w))}consoleLog(I,w){let t=console.log;switch(I){case R.LogLevel.Error:t=console.error;break;case R.LogLevel.Warning:t=console.warn;break;case R.LogLevel.Info:t=console.info;break}t.call(console,...w)}log(I,w){const t=this.loggers.get(I.toString());if(!t)throw new Error("Create the logger before logging");for(const[h,y]of w)(0,R.log)(t,h,y)}}e.LoggerChannel=S;class f extends R.AbstractLoggerService{constructor(I,w,t){super(I,w);this.channel=t}createConsoleMainLogger(){return new R.AdapterLogger({log:(I,w)=>{this.channel.call("consoleLog",[I,w])}})}doCreateLogger(I,w,t){return new E(this.channel,I,w,t)}}e.LoggerChannelClient=f;class E extends R.AbstractMessageLogger{constructor(I,w,t,h){super(h?.always);this.channel=I,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[w,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,w){const t=[[I,w]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(I){this.channel.call("log",[this.file,I])}}class P extends R.LogService{constructor(I,w){super(w);this.parent=I,this._register(I.onDidChangeLogLevel(t=>w.setLevel(t)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=P}),define(Z[96],x([0,1,21,6]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function R(S,f,E,P,k){try{const I=await new Promise((t,h)=>{H(["spdlog"],t,h)});I.setFlushOn(n.LogLevel.Trace);const w=await I.createAsyncRotatingLogger(S,f,E,P);return k&&w.clearFormatters(),w}catch(I){console.error(I)}return null}function L(S,f,E){switch(f){case n.LogLevel.Trace:S.trace(E);break;case n.LogLevel.Debug:S.debug(E);break;case n.LogLevel.Info:S.info(E);break;case n.LogLevel.Warning:S.warn(E);break;case n.LogLevel.Error:S.error(E);break;case n.LogLevel.Critical:S.critical(E);break;default:throw new Error("Invalid log level")}}class C extends n.AbstractMessageLogger{constructor(f,E,P,k,I){super();this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(f,E,P,k),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(f,E,P,k){const I=P?6:1,w=30/I*m.ByteSize.MB,t=await R(f,E,w,I,k);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:h,message:y}of this.buffer)L(this._logger,h,y);this.buffer=[]}}log(f,E){this._logger?L(this._logger,f,E):this.getLevel()<=f&&this.buffer.push({level:f,message:E})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(Z[193],x([0,1,10,17,31,21,191,6,96]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let E=class extends S.AbstractLoggerService{constructor(k,I){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=I}doCreateLogger(k,I,w){return k.scheme===m.Schemas.file?new f.SpdLogLogger(w?.name||(0,R.generateUuid)(),k.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,I):new C.FileLogger(w?.name??(0,n.basename)(k),k,I,!!w?.donotUseFormatters,this.fileService)}};E=ue([ne(0,S.ILogService),ne(1,L.IFileService)],E),e.LoggerService=E}),define(Z[194],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(C){return C.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function n(C){return C.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function R(C){return C.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function L(C){return!m(C)&&!n(C)&&!R(C)}e.isMenubarMenuItemAction=L}),define(Z[53],x([0,1,10,3,36,17]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const S=n.globals.vscode.context.configuration();if(S)C=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const S=(0,L.dirname)(m.FileAccess.asFileUri("",H));C=H.__$__nodeRequire((0,L.joinPath)(S,"product.json").fsPath);const f=H.__$__nodeRequire((0,L.joinPath)(S,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:f.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(Z[19],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[195],x([0,1,61,6,19]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let L=class{constructor(S,f){this.productService=S,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(S,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const E=/^(.*)#([^#]+)$/.exec(f);if(!E)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,P,k]=E;let I=this.trustedExtensionUrlPublicKeys.get(S);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[S],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.trustedExtensionUrlPublicKeys.set(S,[...I])}const w=Buffer.from(decodeURIComponent(k),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const t=w.slice(0,6),h=w.readUIntBE(0,6),y=Date.now()-h;if(y<0||y>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const v=w.slice(6),M=m.createVerify("SHA256");M.write(t),M.write(Buffer.from(P)),M.end();for(let g=0;g<I.length;g++){let u=I[g];if(u!==null){if(typeof u=="string")try{u=m.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),I[g]=u}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${S}:`,l),I[g]=null;continue}if(M.verify(u,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};L=ue([ne(0,R.IProductService),ne(1,n.ILogService)],L),e.ExtensionUrlTrustService=L}),define(Z[54],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(Z[196],x([0,1,12,2,35,10,7,3,8,31,52,6]),function(H,e,m,n,R,L,C,S,f,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends n.Disposable{constructor(t,h){super();this.logService=h,this.validRoots=R.TernarySearchTree.forPaths(!S.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(t.appRoot),this.addValidFileRoot(t.extensionsPath),this.addValidFileRoot(t.globalStorageHome.fsPath),this.addValidFileRoot(t.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=m.session;t.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(h,y)=>this.handleResourceRequest(h,y)),t.protocol.interceptFileProtocol(L.Schemas.file,(h,y)=>this.handleFileRequest(h,y)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(t){const h=(0,C.normalize)(t);return this.validRoots.get(h)?n.Disposable.None:(this.validRoots.set(h,!0),(0,n.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(t,h){const y=f.URI.parse(t.url);return this.logService.error(`Refused to load resource ${y.fsPath} from ${L.Schemas.file}: protocol (original URL: ${t.url})`),h({error:-3})}handleResourceRequest(t,h){const y=this.requestToNormalizedFilePath(t);return this.validRoots.findSubstr(y)?h({path:y}):this.validExtensions.has((0,C.extname)(y))?h({path:y}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${y} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),h({error:-3}))}requestToNormalizedFilePath(t){const h=f.URI.parse(t.url),y=L.FileAccess.asFileUri(h);return(0,C.normalize)(y.fsPath)}createIPCObjectUrl(){let t;const h=f.URI.from({scheme:"vscode",path:(0,E.generateUuid)()}),y=h.toString(),v=async()=>t;return m.ipcMain.handle(y,v),this.logService.trace(`IPC Object URL: Registered new channel ${y}.`),{resource:h,update:M=>t=M,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${y}.`),m.ipcMain.removeHandler(y)}}}};I=ue([ne(0,P.INativeEnvironmentService),ne(1,k.ILogService)],I),e.ProtocolMainService=I}),define(Z[40],x([0,1,106,14]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(C,S){m.ok(n.isString(C)),m.ok(n.isObject(S)),m.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,S)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new R}),define(Z[197],x([0,1,4,40]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class L{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,E){this.schemasById[R(f)]=E,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new L;n.Registry.add(e.Extensions.JSONContribution,C)}),define(Z[55],x([0,1,30,4,14,140,18,197,40]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=f.Registry.as(S.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,d=!0){this.registerConfigurations([o],d)}registerConfigurations(o,d=!0){const r=this.doRegisterConfigurations(o,d);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const d=this.doDeregisterConfigurations(o);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:o,remove:d}){const r=[];r.push(...this.doDeregisterConfigurations(d)),r.push(...this.doRegisterConfigurations(o,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(r)})}registerDefaultConfigurations(o){const d=[],r=[];for(const{overrides:i,source:s}of o)for(const a in i)if(d.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c={...this.configurationDefaultsOverrides.get(a)?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:c});const b=(0,C.getLanguageTagSettingPlainKey)(a),p={type:"object",default:c,description:L.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:R.isString(s)?void 0:s};r.push(...h(a)),this.configurationProperties[a]=p,this.defaultLanguageConfigurationOverridesNode.properties[a]=p}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:s});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const d=[];for(const{overrides:r,source:i}of o)for(const s in r){const a=this.configurationDefaultsOverrides.get(s),c=R.isString(i)?i:i?.id,b=R.isString(a?.source)?a?.source:a?.source?.id;if(c===b)if(d.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const p=this.configurationProperties[s];p&&(this.updatePropertyDefaultValue(s,p),this.updateSchema(s,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const d of o)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,d){const r=[];return o.forEach(i=>{r.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),r}doDeregisterConfigurations(o){const d=[],r=i=>{if(i.properties)for(const s in i.properties)d.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s]);i.allOf&&i.allOf.forEach(s=>r(s))};for(const i of o){r(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return d}validateAndRegisterProperties(o,d=!0,r,i,s=3){s=R.isUndefinedOrNull(o.scope)?s:o.scope;let a=[],c=o.properties;if(c)for(let p in c){if(d&&g(p)){delete c[p];continue}const D=c[p];if(D.source=r,D.defaultDefaultValue=c[p].default,this.updatePropertyDefaultValue(p,D),e.OVERRIDE_PROPERTY_REGEX.test(p)?D.scope=void 0:(D.scope=R.isUndefinedOrNull(D.scope)?s:D.scope,D.restricted=R.isUndefinedOrNull(D.restricted)?!!i?.includes(p):D.restricted),c[p].hasOwnProperty("included")&&!c[p].included){this.excludedConfigurationProperties[p]=c[p],delete c[p];continue}else this.configurationProperties[p]=c[p];!c[p].deprecationMessage&&c[p].markdownDeprecationMessage&&(c[p].deprecationMessage=c[p].markdownDeprecationMessage),a.push(p)}let b=o.allOf;if(b)for(let p of b)a.push(...this.validateAndRegisterProperties(p,d,r,i,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const d=r=>{let i=r.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let s=r.allOf;s&&s.forEach(d)};d(o)}updateSchema(o,d){switch(e.allSettings.properties[o]=d,d.scope){case 1:e.applicationSettings.properties[o]=d;break;case 2:e.machineSettings.properties[o]=d;break;case 6:e.machineOverridableSettings.properties[o]=d;break;case 3:e.windowSettings.properties[o]=d;break;case 4:e.resourceSettings.properties[o]=d;break;case 5:e.resourceSettings.properties[o]=d,this.resourceLanguageSettingsSchema.properties[o]=d;break}}removeFromSchema(o,d){switch(delete e.allSettings.properties[o],d.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const d=`[${o}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,d){const r=this.configurationDefaultsOverrides.get(o);let i=r?.value,s=r?.source;R.isUndefined(i)&&(i=d.defaultDefaultValue,s=void 0),R.isUndefined(i)&&(i=v(d.type)),d.default=i,d.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",t=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(l){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let d=t.exec(l);for(;d?.length;){const r=d[1].trim();r&&o.push(r),d=t.exec(l)}}return(0,m.distinct)(o)}e.overrideIdentifiersFromKey=h;function y(l){return l.reduce((o,d)=>`${o}[${d}]`,"")}e.keyFromOverrideIdentifiers=y;function v(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const M=new I;f.Registry.add(e.Extensions.Configuration,M);function g(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):M.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):null:L.localize(6,null)}e.validateProperty=g;function u(){const l=[],o=M.getConfigurationProperties();for(const d of Object.keys(o))l.push([d,o[d].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=u}),define(Z[198],x([0,1,30,4,44,2,35,49,14,8,18,55,40]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,P.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return m.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return m.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=S.deepClone(this.contents),s=S.deepClone(this.overrides),a=[...this.keys];for(const c of r){this.mergeContents(i,c.contents);for(const b of c.overrides){const[p]=s.filter(D=>m.equals(D.identifiers,b.identifiers));p?(this.mergeContents(p.contents,b.contents),p.keys.push(...b.keys),p.keys=m.distinct(p.keys)):s.push(S.deepClone(b))}for(const b of c.keys)a.indexOf(b)===-1&&a.push(b)}return new w(i,a,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const a of m.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[a],b=i[a];b&&(typeof c=="object"&&typeof b=="object"?(c=S.deepClone(c),this.mergeContents(c,b)):c=b),s[a]=c}return new w(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&f.isObject(r[s])&&f.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=S.deepClone(i[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?S.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const a=c=>{c&&(s?this.mergeContents(s,c):s=S.deepClone(c))};for(const c of this.overrides)m.equals(c.identifiers,[r])?i=c.contents:c.identifiers.includes(r)&&a(c.contents);return a(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,P.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class t extends w{constructor(r={}){const i=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),a=Object.create(null),c=[];for(const b in i){const p=r[b],D=p!==void 0?p:i[b].default;(0,P.addToValueTree)(a,b,D,F=>console.error(`Conflict in default settings: ${F}`))}for(const b of Object.keys(a))k.OVERRIDE_PROPERTY_REGEX.test(b)&&c.push({identifiers:(0,k.overrideIdentifiersFromKey)(b),keys:Object.keys(a[b]),contents:(0,P.toValuesTree)(a[b],p=>console.error(`Conflict in default settings file: ${p}`))});super(a,s,c)}}e.DefaultConfigurationModel=t;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!f.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:a,overrides:c,restricted:b}=this.doParseRaw(r,i);this._configurationModel=new w(s,a,c),this._restrictedConfigurations=b||[]}doParseContent(r){let i={},s=null,a=[],c=[],b=[];function p(F){Array.isArray(a)?a.push(F):s!==null&&(a[s]=F)}let D={onObjectBegin:()=>{let F={};p(F),c.push(a),a=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let F=[];p(F),c.push(a),a=F,s=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:p,onError:(F,U,Q)=>{b.push({error:F,offset:U,length:Q})}};if(r)try{R.visit(r,D),i=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(r,i){const s=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.filter(r,s,!0,i);r=a.raw;const c=(0,P.toValuesTree)(r,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),b=Object.keys(r),p=this.toOverrides(r,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:b,overrides:p,restricted:a.restricted}}filter(r,i,s,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[]};const c={},b=[];for(let p in r)if(k.OVERRIDE_PROPERTY_REGEX.test(p)&&s){const D=this.filter(r[p],i,!1,a);c[p]=D.raw,b.push(...D.restricted)}else{const D=i[p],F=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&b.push(p),(F===void 0||a.scopes===void 0||a.scopes.includes(F))&&(a.skipRestricted&&D?.restricted||(c[p]=r[p]))}return{raw:c,restricted:b}}toOverrides(r,i){const s=[];for(const a of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const c={};for(const b in r[a])c[b]=r[a][b];s.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,i)})}return s}}e.ConfigurationModelParser=h;class y extends L.Disposable{constructor(r,i,s,a){super();this.userSettingsResource=r,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class v{constructor(r,i,s=new w,a=new w,c=new C.ResourceMap,b=new w,p=new C.ResourceMap,D=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=b,this._memoryConfigurationByResource=p,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(r)}updateValue(r,i,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new w,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(r):a.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const a=this.getConsolidateConfigurationModel(i,s),c=this.getFolderConfigurationModelForResource(i.resource,s),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),D=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),Q=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,te=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,ie=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(r):b.getValue(r),ee=a.getValue(r),$=m.distinct(m.flatten(a.overrides.map(Y=>Y.identifiers))).filter(Y=>a.getOverrideValue(r,Y)!==void 0);return{defaultValue:p,userValue:D,userLocalValue:F,userRemoteValue:U,workspaceValue:Q,workspaceFolderValue:te,memoryValue:ie,value:ee,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:te!==void 0?{value:c?.freeze().getValue(r),override:i.overrideIdentifier?c?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:b.getValue(r),override:i.overrideIdentifier?b.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:a,updated:c,removed:b}=l(this._defaultConfiguration,r);i=[...a,...c,...b]}for(const a of i)for(const c of(0,k.overrideIdentifiersFromKey)(a)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=r.getKeysForOverrideIdentifier(c),D=[...p.filter(F=>b.indexOf(F)===-1),...b.filter(F=>p.indexOf(F)===-1),...b.filter(F=>!S.equals(this._defaultConfiguration.override(c).getValue(F),r.override(c).getValue(F)))];s.push([c,D])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:a,overrides:c}=l(this.localUserConfiguration,r),b=[...i,...s,...a];return b.length&&this.updateLocalUserConfiguration(r),{keys:b,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:a,overrides:c}=l(this.remoteUserConfiguration,r);let b=[...i,...s,...a];return b.length&&this.updateRemoteUserConfiguration(r),{keys:b,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:a,overrides:c}=l(this.workspaceConfiguration,r);let b=[...i,...s,...a];return b.length&&this.updateWorkspaceConfiguration(r),{keys:b,overrides:c}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:a,updated:c,removed:b,overrides:p}=l(s,i);let D=[...a,...c,...b];return(D.length||!s)&&this.updateFolderConfiguration(r,i),{keys:D,overrides:p}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:a,removed:c,overrides:b}=l(i,void 0);return{keys:[...s,...a,...c],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let s=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const a=i.getFolder(r);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const c=this._memoryConfigurationByResource.get(r);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(r);a?(i=s.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:a,keys:c}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:a,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((b,p)=>(b.set(E.URI.revive(p[0]),this.parseConfigurationModel(p[1])),b),new C.ResourceMap);return new v(i,s,new w,a,c,new w,new C.ResourceMap,!1)}static parseConfigurationModel(r){return new w(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=v;function M(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const r=new Set,i=new Map;for(const a of d)a.keys.forEach(c=>r.add(c)),a.overrides.forEach(([c,b])=>{const p=(0,C.getOrSet)(i,c,new Set);b.forEach(D=>p.add(D))});const s=[];return i.forEach((a,c)=>s.push([c,[...a.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=M;class g{constructor(r,i,s,a){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(p=>c.add(p)),r.overrides.forEach(([,p])=>p.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const b=new w;this.affectedKeys.forEach(p=>b.setValue(p,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!S.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,P.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(r=r[a],!r)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=g;class u extends g{constructor(r,i,s,a){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=u;function l(d,r){const{added:i,removed:s,updated:a}=o(r,d),c=[],b=d?.getAllOverrideIdentifiers()||[],p=r?.getAllOverrideIdentifiers()||[];if(r){const D=p.filter(F=>!b.includes(F));for(const F of D)c.push([F,r.getKeysForOverrideIdentifier(F)])}if(d){const D=b.filter(F=>!p.includes(F));for(const F of D)c.push([F,d.getKeysForOverrideIdentifier(F)])}if(r&&d){for(const D of b)if(p.includes(D)){const F=o({contents:d.getOverrideValue(void 0,D)||{},keys:d.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});c.push([D,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:s,updated:a,overrides:c}}function o(d,r){const i=d?r?d.keys.filter(c=>r.keys.indexOf(c)===-1):[...d.keys]:[],s=r?d?r.keys.filter(c=>d.keys.indexOf(c)===-1):[...r.keys]:[],a=[];if(d&&r){for(const c of r.keys)if(d.keys.indexOf(c)!==-1){const b=(0,P.getConfigurationValue)(r.contents,c),p=(0,P.getConfigurationValue)(d.contents,c);S.equals(b,p)||a.push(c)}}return{added:i,removed:s,updated:a}}}),define(Z[199],x([0,1,9,4,2,17,18,198,55,40]),function(H,e,m,n,R,L,C,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends R.Disposable{constructor(I,w){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,w)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new m.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,w){const t=typeof I=="string"?I:void 0,h=(0,C.isConfigurationOverrides)(I)?I:(0,C.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(t,h,void 0)}updateValue(I,w,t,h){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(t,w,1)}onDidDefaultConfigurationChange(I){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,I);this.trigger(t,w,6)}trigger(I,w,t){const h=new S.ConfigurationChangeEvent(I,{data:w},this.configuration);h.source=t,h.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(Z[200],x([0,1,15,5]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends m.ErrorNoTelemetry{constructor(S,f=R.Unknown,E){super(S);this._message=S,this._code=f,this._detail=E,this.isHandled=f===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(S){return S instanceof L&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof L&&S._code===R.NoResolverFound}static isHandled(S){return S instanceof L&&S.isHandled}}e.RemoteAuthorityResolverError=L}),define(Z[201],x([0,1,9,16,23,15,4,2,31,88,200]),function(H,e,m,n,R,L,C,S,f,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const k=30*1e3;var I;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function w(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(B){const K=new R.CancellationTokenSource;return setTimeout(()=>K.cancel(),B),K.token}function h(B,K){if(B.isCancellationRequested||K.isCancellationRequested)return R.CancellationToken.Cancelled;const T=new R.CancellationTokenSource;return B.onCancellationRequested(()=>T.cancel()),K.onCancellationRequested(()=>T.cancel()),T.token}class y{constructor(K){this._state="pending",this._disposables=new S.DisposableStore,this.promise=new Promise((T,O)=>{this._resolvePromise=T,this._rejectPromise=O}),K.isCancellationRequested?this._timeout():this._disposables.add(K.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(K){this._state==="pending"?this._disposables.add(K):K.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const K=new Error("Time limit reached");return K.code="ETIMEDOUT",K.syscall="connect",K}resolve(K){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(K))}reject(K){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(K))}}function v(B,K){const T=new y(K);return T.registerDisposable(B.onControlMessage(O=>{const W=JSON.parse(O.toString()),A=j(W);A?T.reject(A):T.resolve(W)})),T.promise}function M(B,K,T,O,W,A,_){const z=new y(_);return K.connect(T,O,W,A,(X,se)=>{z.didTimeout?(X&&B.error(X),se?.dispose()):X||!se?z.reject(X):z.resolve(se)}),z.promise}function g(B,K){const T=new y(K);return B.then(O=>{T.didTimeout||T.resolve(O)},O=>{T.didTimeout||T.reject(O)}),T.promise}async function u(B,K,T,O){const W=V(B,K);B.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let A;try{A=await M(B.logService,B.socketFactory,B.host,B.port,`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${w(K)}-${B.reconnectionToken}`,O)}catch(le){throw B.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),B.logService.error(le),le}B.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let _,z;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(A,null),_=B.reconnectionProtocol,z=!1):(_=new E.PersistentProtocol(A,null),z=!0),B.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const X=await g(B.signService.createNewMessage((0,f.generateUuid)()),O),se={type:"auth",auth:B.connectionToken||"00000000000000000000",data:X.data};_.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const le=await v(_,h(O,t(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(B.logService.trace(`${W} 4/6. received SignRequest control message.`),!await g(B.signService.validate(X,le.signedData),O)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ae=await g(B.signService.sign(le.data),O),fe={type:"connectionType",commit:B.commit,signedData:ae,desiredConnectionType:K};return T&&(fe.args=T),B.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(n.VSBuffer.fromString(JSON.stringify(fe))),{protocol:_,ownsProtocol:z}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(B.logService.error(`${W} the handshake timed out. Error:`),B.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${W} received error control message when negotiating connection. Error:`),B.logService.error(le)),z&&Y(_),le}}async function l(B,K,T,O){const W=Date.now(),A=V(B,K),{protocol:_,ownsProtocol:z}=await u(B,K,T,O),X=new y(O);return X.registerDisposable(_.onControlMessage(se=>{const le=JSON.parse(se.toString()),re=j(le);re?(B.logService.error(`${A} received error control message when negotiating connection. Error:`),B.logService.error(re),z&&Y(_),X.reject(re)):(B.reconnectionProtocol&&B.reconnectionProtocol.endAcceptReconnection(),B.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${J(W)}!`),X.resolve({protocol:_,firstMessage:le}))})),X.promise}async function o(B,K){const{protocol:T}=await l(B,1,void 0,K);return{protocol:T}}async function d(B,K,T){const{protocol:O,firstMessage:W}=await l(B,2,K,T),A=W&&W.debugPort;return{protocol:O,debugPort:A}}async function r(B,K,T){const O=Date.now(),W=V(B,3),{protocol:A}=await u(B,3,K,T);return B.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${J(O)}!`),A}async function i(B,K,T){const{host:O,port:W,connectionToken:A}=await B.addressProvider.getAddress();return{commit:B.commit,host:O,port:W,connectionToken:A,reconnectionToken:K,reconnectionProtocol:T,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function s(B,K,T){try{const O=(0,f.generateUuid)(),W=await i(B,O,null),{protocol:A}=await o(W,R.CancellationToken.None);return new ee(B,K,T,O,A)}catch(O){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(O),ie.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentManagement=s;async function a(B,K){try{const T=(0,f.generateUuid)(),O=await i(B,T,null),{protocol:W,debugPort:A}=await d(O,K,R.CancellationToken.None);return new $(B,K,T,W,A)}catch(T){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(T),ie.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentExtensionHost=a;async function c(B,K,T){const O=await i(B,(0,f.generateUuid)(),null);return await r(O,{host:K,port:T},R.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function b(B){return(0,m.createCancelablePromise)(K=>new Promise((T,O)=>{const W=setTimeout(T,B*1e3);K.onCancellationRequested(()=>{clearTimeout(W),T()})}))}var p;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(p=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class D{constructor(K,T){this.reconnectionToken=K,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=D;class F{constructor(K,T,O,W){this.reconnectionToken=K,this.millisSinceLastIncomingData=T,this.durationSeconds=O,this.cancellableTimer=W,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class U{constructor(K,T,O){this.reconnectionToken=K,this.millisSinceLastIncomingData=T,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=U;class Q{constructor(K,T,O){this.reconnectionToken=K,this.millisSinceLastIncomingData=T,this.attempt=O,this.type=4}}e.ConnectionGainEvent=Q;class te{constructor(K,T,O,W){this.reconnectionToken=K,this.millisSinceLastIncomingData=T,this.attempt=O,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=te;class ie extends S.Disposable{constructor(K,T,O,W,A){super();this._connectionType=K,this._options=T,this.reconnectionToken=O,this.protocol=W,this._reconnectionFailureIsFatal=A,this._onDidStateChange=this._register(new C.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(W.onSocketClose(_=>{const z=N(this._connectionType,this.reconnectionToken,!0);_?_.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${_.hadError}).`),_.error&&this._options.logService.error(_.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this._options.logService.error(_.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(W.onSocketTimeout(()=>{const _=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${_} received socket timeout event.`),this._beginReconnecting()})),ie._instances.push(this),this._register((0,S.toDisposable)(()=>{const _=ie._instances.indexOf(this);_>=0&&ie._instances.splice(_,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ie._permanentFailureMillisSinceLastIncomingData,ie._permanentFailureAttempt,ie._permanentFailureHandled)}static triggerPermanentFailure(K,T,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=K,this._permanentFailureAttempt=T,this._permanentFailureHandled=O,this._instances.forEach(W=>W._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(K=>K._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(K=>K._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ie._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const K=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${K} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new D(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const W=O<T.length?T[O]:T[T.length-1];try{if(W>0){const _=b(W);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,_)),this._options.logService.info(`${K} waiting for ${W} seconds before reconnecting...`);try{await _}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${K} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${K} resolving connection...`);const A=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${K} connecting to ${A.host}:${A.port}...`),await this._reconnect(A,t(k)),this._options.logService.info(`${K} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(A){if(A.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${K} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(A),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${K} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(A),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(A)){this._options.logService.info(`${K} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(A);continue}if((A.code==="ETIMEDOUT"||A.code==="ENETUNREACH"||A.code==="ECONNREFUSED"||A.code==="ECONNRESET")&&A.syscall==="connect"){this._options.logService.info(`${K} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(A);continue}if((0,L.isCancellationError)(A)){this._options.logService.info(`${K} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(A);continue}if(A instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${K} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(A),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,P.RemoteAuthorityResolverError.isHandled(A));break}this._options.logService.error(`${K} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(A),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(K,T,O){this._reconnectionFailureIsFatal?ie.triggerPermanentFailure(K,T,O):this._gotoPermanentFailure(K,T,O)}_gotoPermanentFailure(K,T,O){this._onDidStateChange.fire(new te(this.reconnectionToken,K,T,O)),Y(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie._permanentFailureMillisSinceLastIncomingData=0,ie._permanentFailureAttempt=0,ie._permanentFailureHandled=!1,ie._instances=[];class ee extends ie{constructor(K,T,O,W,A){super(1,K,W,A,!0);this.client=this._register(new E.Client(A,{remoteAuthority:T,clientId:O},K.ipcLogger))}async _reconnect(K,T){await o(K,T)}}e.ManagementPersistentConnection=ee;class $ extends ie{constructor(K,T,O,W,A){super(2,K,O,W,!1);this._startArguments=T,this.debugPort=A}async _reconnect(K,T){await d(K,this._startArguments,T)}}e.ExtensionHostPersistentConnection=$;function Y(B){try{B.acceptDisconnect();const K=B.getSocket();B.dispose(),K.dispose()}catch(K){(0,L.onUnexpectedError)(K)}}function j(B){if(B&&B.type==="error"){const K=new Error(`Connection error: ${B.reason}`);return K.code="VSCODE_CONNECTION_ERROR",K}return null}function q(B,K){for(;B.length<K;)B+=" ";return B}function N(B,K,T){return`[remote-connection][${q(w(B),13)}][${K.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function V(B,K){return`${N(K,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function J(B){return`${Date.now()-B} ms`}}),define(Z[78],x([0,1,10]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(L){return L.scheme===m.Schemas.vscodeRemote?L.authority:void 0}e.getRemoteAuthority=n;function R(L){if(!L)return;const C=L.indexOf("+");return C<0?L:L.substr(0,C)}e.getRemoteName=R}),define(Z[56],x([0,1,16,153,55,5,40]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function S(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=S;function f(t){return t.res.statusCode===204}async function E(t){if(!S(t))throw new Error("Server returned "+t.res.statusCode);return f(t)?null:(await(0,m.streamToBuffer)(t.stream)).toString()}e.asText=E;async function P(t){if(!S(t))throw new Error("Server returned "+t.res.statusCode);if(f(t))return null;const y=(await(0,m.streamToBuffer)(t.stream)).toString();try{return JSON.parse(y)}catch(v){throw v.message+=`:
`+y,v}}e.asJson=P;function k(t){w(t)}e.updateProxyConfigurationsScope=k;let I;function w(t){const h=C.Registry.as(R.Extensions.Configuration),y=I;I={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[I],remove:y?[y]:[]})}w(2)}),define(Z[202],x([0,1,203,14]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(C,S){return C.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:C.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function L(C,S,f={}){const E=(0,m.parse)(C),P=f.proxyUrl||R(E,S);if(!P)return null;const k=(0,m.parse)(P);if(!/^https?:$/.test(k.protocol||""))return null;const I={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,n.isBoolean)(f.strictSSL)?f.strictSSL:!0};return E.protocol==="http:"?new(await new Promise((w,t)=>{H(["http-proxy-agent"],w,t)}))(I):new(await new Promise((w,t)=>{H(["https-proxy-agent"],w,t)}))(I)}e.getProxyAgent=L}),define(Z[97],x([0,1,45,7,154,23,39,15,3,31,137,50,9]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let t;async function h(v,M,g){return M["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(g)&&!M["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(g)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=I.Promises.withAsyncBody(async(u,l)=>{const o=new L.CancellationTokenSource,d=setTimeout(()=>{o.dispose(!0),l(new Error((0,R.localize)(0,null)))},w);try{u(await y(v,o.token))}catch(r){!(0,S.isCancellationError)(r)&&!o.token.isCancellationRequested?l(new Error((0,R.localize)(1,null,(0,C.toErrorMessage)(r)))):u({})}finally{clearTimeout(d),o.dispose()}})),t)}e.getResolvedShellEnv=h;async function y(v,M){const g=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",g);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",u);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(l+"(.*)"+l),d={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",d);const r=await(0,P.getSystemShell)(f.OS,d);return v.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(M.isCancellationRequested)return s((0,S.canceled)());const a=(0,n.basename)(r);let c,b;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${p} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,b=["-Login","-Command"]):(c=`'${process.execPath}' ${p} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?b=["-ic"]:b=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),c);const D=(0,m.spawn)(r,[...b,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:d});M.onCancellationRequested(()=>(D.kill(),s((0,S.canceled)()))),D.on("error",Q=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(Q)),s(Q)});const F=[];D.stdout.on("data",Q=>F.push(Q));const U=[];D.stderr.on("data",Q=>U.push(Q)),D.on("close",(Q,te)=>{const ie=Buffer.concat(F).toString("utf8");v.trace("getUnixShellEnvironment#raw",ie);const ee=Buffer.concat(U).toString("utf8");if(ee.trim()&&v.trace("getUnixShellEnvironment#stderr",ee),Q||te)return s(new Error((0,R.localize)(2,null,Q,te)));const $=o.exec(ie),Y=$?$[1]:"{}";try{const j=JSON.parse(Y);g?j.ELECTRON_RUN_AS_NODE=g:delete j.ELECTRON_RUN_AS_NODE,u?j.ELECTRON_NO_ATTACH_CONSOLE=u:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){v.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(j)),s(j)}})})}}),define(Z[79],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[204],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>H(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),C=new L.validator;if(C){const S=String(m._nextId++);return this.validators.set(S,C),{id:S,data:C.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const C=this.validators.get(R.id);if(!C)return!1;this.validators.delete(R.id);try{return C.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),C=new L.signer;if(C)return C.sign(R)}catch{}return R}}e.SignService=m,m._nextId=1}),define(Z[38],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,m.createDecorator)("stateMainService")}),define(Z[20],x([0,1,12,9,4,2,3,36,14,5,6,38]),function(H,e,m,n,R,L,C,S,f,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var I;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(I=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class wt extends L.Disposable{constructor(y,v){super();this.logService=y,this.stateMainService=v,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(wt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(wt.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),C.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};m.app.addListener("before-quit",y);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!C.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",v),m.app.once("will-quit",M=>{this.logService.trace("Lifecycle#app.on(will-quit)"),M.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",y),m.app.removeListener("window-all-closed",v),m.app.quit()})})}fireOnWillShutdown(y){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const v=[];return this._onWillShutdown.fire({reason:y,join(M){v.push(M)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(v)}catch(M){this.logService.error(M)}try{await this.stateMainService.close()}catch(M){this.logService.error(M)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.logService.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let v=this.phaseWhen.get(y);v||(v=new n.Barrier,this.phaseWhen.set(y,v)),await v.wait()}registerWindow(y){const v=new L.DisposableStore;this.windowCounter++,v.add(y.onWillLoad(g=>this._onWillLoadWindow.fire({window:y,workspace:g.workspace,reason:g.reason})));const M=(0,f.assertIsDefined)(y.win);M.on("close",g=>{const u=y.id;if(this.windowToCloseRequest.has(u)){this.windowToCloseRequest.delete(u);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),g.preventDefault(),this.unload(y,1).then(l=>{if(l){this.windowToCloseRequest.delete(u);return}this.windowToCloseRequest.add(u),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${u}`),this._onBeforeCloseWindow.fire(y),y.close()})}),M.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!C.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(y,v){await this.unload(y,3)||y.reload(v)}unload(y,v){const M=this.mapWindowIdToPendingUnload.get(y.id);if(M)return M;const g=this.doUnload(y,v).finally(()=>{this.mapWindowIdToPendingUnload.delete(y.id)});return this.mapWindowIdToPendingUnload.set(y.id,g),g}async doUnload(y,v){if(!y.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${y.id}`);const M=this._quitRequested?2:v;let g=await this.onBeforeUnloadWindowInRenderer(y,M);return g?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(g)):(await this.onWillUnloadWindowInRenderer(y,M),!1)}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,v){return new Promise(M=>{const g=this.oneTimeListenerTokenGenerator++,u=`vscode:ok${g}`,l=`vscode:cancel${g}`;m.ipcMain.once(u,()=>{M(!1)}),m.ipcMain.once(l,()=>{M(!0)}),y.send("vscode:onBeforeUnload",{okChannel:u,cancelChannel:l,reason:v})})}onWillUnloadWindowInRenderer(y,v){return new Promise(M=>{const u=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(u,()=>M()),y.send("vscode:onWillUnload",{replyChannel:u,reason:v})})}quit(y){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${y}`),y&&this.stateMainService.setItem(wt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(y){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(y?.addArgs&&v.push(...y.addArgs),y?.removeArgs)for(const u of y.removeArgs){const l=v.indexOf(u);l>=0&&v.splice(l,1)}const M=()=>{try{if(C.isWindows){const u=(0,S.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.logService.error(u)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:v})};m.app.once("quit",M),await this.quit(!0)&&m.app.removeListener("quit",M)}async kill(y){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const v of m.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let M;v.webContents&&!v.webContents.isDestroyed()?M=new Promise(g=>v.once("closed",g)):M=Promise.resolve(),v.destroy(),await M}})()]),m.app.exit(y)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ue([ne(0,P.ILogService),ne(1,k.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[205],x([0,1,4,2,5,20]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let C=class extends n.Disposable{constructor(E){super();this._onDidChangeKeyboardLayout=this._register(new m.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,E.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const E=await new Promise((P,k)=>{H(["native-keymap"],P,k)});this._keyboardLayoutData=S(E),E.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=S(E),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};C=ue([ne(0,L.ILifecycleMainService)],C),e.KeyboardLayoutMainService=C;function S(f){const E=f.getKeyMap(),P=f.getCurrentKeyboardLayout();return{keyboardMapping:E,keyboardLayoutInfo:P}}}),define(Z[98],x([0,1,9,4,2,65,14,90,5]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var P;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var I;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class w extends R.Disposable{constructor(v={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new m.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,m.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,M){M===E?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:M,target:this.getKeyTargets(v)[M]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,M,g){return this.getStorage(M)?.get(v,g)}getBoolean(v,M,g){return this.getStorage(M)?.getBoolean(v,g)}getNumber(v,M,g){return this.getStorage(M)?.getNumber(v,g)}store(v,M,g,u){if((0,C.isUndefinedOrNull)(M)){this.remove(v,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,g,u),this.getStorage(g)?.set(v,M)})}remove(v,M){this.withPausedEmitters(()=>{this.updateKeyTarget(v,M,void 0),this.getStorage(M)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,M){const g=[],u=this.getKeyTargets(v);for(const l of Object.keys(u))u[l]===M&&g.push(l);return g}updateKeyTarget(v,M,g){const u=this.getKeyTargets(M);typeof g=="number"?u[v]!==g&&(u[v]=g,this.getStorage(M)?.set(E,JSON.stringify(u))):typeof u[v]=="number"&&(delete u[v],this.getStorage(M)?.set(E,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const M=this.get(E,v);if(M)try{return JSON.parse(M)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=P.NONE){this._onWillSaveState.fire({reason:v});const M=this.getStorage(0),g=this.getStorage(1);switch(v){case P.NONE:await m.Promises.settled([M?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await m.Promises.settled([M?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,M=this.getStorage(1)?.items??new Map;return h(v,M,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends w{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function h(y,v,M,g){const u=a=>{try{return JSON.parse(a)}catch{return a}},l=new Map,o=new Map;y.forEach((a,c)=>{l.set(c,a),o.set(c,u(a))});const d=new Map,r=new Map;v.forEach((a,c)=>{d.set(c,a),r.set(c,u(a))}),console.group(`Storage: Global (path: ${M})`);let i=[];l.forEach((a,c)=>{i.push({key:c,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${g})`);let s=[];d.forEach((a,c)=>{s.push({key:c,value:a})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=h}),define(Z[206],x([0,1,3,36,8,31]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(E){if(m.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function S(E,P,k,I,w,t,h,y,v,M){const g=Object.create(null);g["common.machineId"]=h,g.sessionID=(0,L.generateUuid)()+Date.now(),g.commitHash=w,g.version=t,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,m.PlatformToString)(m.platform),g["common.nodePlatform"]=n.platform,g["common.nodeArch"]=I,g["common.product"]=M||"desktop";const u=f(y||[]);u&&(g["common.msftInternal"]=u);let l=0;const o=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),m.isLinuxSnap&&(g["common.snap"]="true");const d=C(k);d&&(g["common.platformDetail"]=d);try{const r=await E.readFile(R.URI.file(v));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=S;function f(E){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const k=P.toLowerCase();return E.some(I=>k===I)}e.verifyMicrosoftInternalDomain=f}),define(Z[34],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[207],x([0,1,26,69,9,44,10,7,3,8,72,24,87,75,21,19,34]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function M(d,r){const i=`${d}::${r.join(":")}`,s=v.get(i);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,b=new Map,p=2e4;function D(U,Q,te,ie){const ee=Q.substring(U.length+1);return R.Promises.withAsyncBody(async $=>{let Y;try{Y=await k.Promises.readdir(Q,{withFileTypes:!0})}catch{$();return}if(ie.count>=p){ie.count+=Y.length,ie.maxReached=!0,$();return}let j=Y.length;if(j===0){$();return}let q=Y;ie.count+Y.length>p&&(ie.maxReached=!0,j=p-ie.count,q=Y.slice(0,j)),ie.count+=Y.length;for(const N of q)if(N.isDirectory()){if(te.includes(N.name)||await D(U,(0,S.join)(Q,N.name),te,ie),--j==0){$();return}}else{const V=N.name.lastIndexOf(".");if(V>=0){const J=N.name.substring(V+1);J&&c.set(J,(c.get(J)??0)+1)}for(const J of a)J.relativePathPattern?.test(ee)!==!1&&J.filePattern.test(N.name)&&b.set(J.tag,(b.get(J.tag)??0)+1);if(--j==0){$();return}}})}const F=R.Promises.withAsyncBody(async U=>{const Q={count:0,maxReached:!1};await D(d,d,r,Q);const te=await l(d);U({configFiles:g(b),fileTypes:g(c),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:te})});return v.set(i,F),F}e.collectWorkspaceStats=M;function g(d){return[...n.Iterable.map(d.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function u(){const d={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},r=m.cpus();return r&&r.length>0&&(d.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),d}e.getMachineInfo=u;async function l(d){try{const r=new Map,i=(0,S.join)(d,".vscode","launch.json"),s=await k.Promises.readFile(i),a=[],c=(0,L.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,L.getNodeType)(c)==="object"&&c.configurations)for(const b of c.configurations){const p=b.type;p&&(r.has(p)?r.set(p,r.get(p)+1):r.set(p,1))}return g(r)}catch{return[]}}e.collectLaunchConfigs=l;let o=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const s=m.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(m.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||i.push(`Load (avg):       ${m.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,I.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[a,c]=s,b=this.formatProcessList(r,a);return i.forEach(p=>{if((0,w.isRemoteDiagnosticError)(p))b+=`
${p.errorMessage}`,c+=`
${p.errorMessage}`;else if(b+=`

Remote: ${p.hostName}`,p.processes&&(b+=`
${this.formatProcessList(r,p.processes)}`),p.workspaceMetadata){c+=`
|  Remote: ${p.hostName}`;for(const D of Object.keys(p.workspaceMetadata)){const F=p.workspaceMetadata[D];let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),c+=`|    Folder (${D}): ${U}`,c+=this.formatWorkspaceStats(F)}}}),{processInfo:b,workspaceInfo:c}})}async getSystemInfo(r,i){const{memory:s,vmHint:a,os:c,cpus:b}=u(),p={os:c,memory:s,cpus:b,vmHint:a,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return f.isWindows||(p.load=`${m.loadavg().map(D=>Math.round(D)).join(", ")}`),f.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(r,i){const s=[];return(0,I.listProcesses)(r.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,a)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),i.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.formatMachineInfo(c.machineInfo)),c.processes&&s.push(this.formatProcessList(r,c.processes)),c.workspaceMetadata)for(const b of Object.keys(c.workspaceMetadata)){const p=c.workspaceMetadata[b];let D=`${p.fileCount} files`;p.maxFilesReached&&(D=`more than ${D}`),s.push(`Folder (${b}): ${D}`),s.push(this.formatWorkspaceStats(p))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const i=[],s=60;let a=0;const c=(F,U)=>{const Q=` ${F}(${U})`;a+Q.length>s?(i.push(b),b="|                 ",a=b.length):a+=Q.length,b+=Q};let b="|      File types:";const p=10;let D=r.fileTypes.length>p?p:r.fileTypes.length;for(let F=0;F<D;F++){const U=r.fileTypes[F];c(U.name,U.count)}if(i.push(b),r.configFiles.length>=0&&(b="|      Conf files:",a=0,r.configFiles.forEach(F=>{c(F.name,F.count)}),i.push(b)),r.launchConfigFiles.length>0){let F="|      Launch Configs:";r.launchConfigFiles.forEach(U=>{F+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),i.push(F)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],s=[];return r.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const b=E.URI.revive(c);if(b.scheme===C.Schemas.file){const p=b.fsPath;s.push(M(p,["node_modules",".git"]).then(D=>{let F=`${D.fileCount} files`;D.maxFilesReached&&(F=`more than ${F}`),i.push(`|    Folder (${(0,S.basename)(p)}): ${F}`),i.push(this.formatWorkspaceStats(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${p} (${D.toString()})`)}))}else i.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(r,i){const s=new Map;r.windows.forEach(c=>s.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,s,a,i,0),a.join(`
`)}formatProcessItem(r,i,s,a,c){const b=c===0;let p;b?p=a.pid===r?`${this.productService.applicationName} main`:"remote agent":(p=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(p=`${p} (${i.get(a.pid)})`));const D=process.platform==="win32"?a.mem:m.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(a.children)&&a.children.forEach(F=>this.formatProcessItem(r,i,s,F,c+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:s}of r.folders){const a=E.URI.revive(s);if(a.scheme!==C.Schemas.file)continue;const c=a.fsPath;try{(await M(c,["node_modules",".git"])).fileTypes.forEach(p=>i.add(p.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const s=E.URI.revive(i);if(s.scheme!==C.Schemas.file)continue;const a=s.fsPath;try{const c=await M(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:b.name,count:b.count})}),c.launchConfigFiles.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:b.name,count:b.count})}),c.configFiles.forEach(b=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};o=ue([ne(0,y.ITelemetryService),ne(1,h.IProductService)],o),e.DiagnosticsService=o}),define(Z[208],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(L){this.appenders=L}listen(L,C){throw new Error(`Event not found: ${C}`)}call(L,C,{eventName:S,data:f}){return this.appenders.forEach(E=>E.log(S,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class n{constructor(L){this.channel=L}log(L,C){return this.channel.call("log",{eventName:L,data:C}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(Z[66],x([0,1,49,14,18,34]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(M,g){return Promise.resolve(void 0)}publicLog2(M,g){return this.publicLog(M,g)}publicLogError(M,g){return Promise.resolve(void 0)}publicLogError2(M,g){return this.publicLogError(M,g)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class S{async publicLog(M,g,u){}async publicLogError(M,g,u){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(v,M){return M.onDidChangeConfiguration(g=>{g.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(g.source),configurationKeys:t(g.sourceConfig)})})}e.configurationTelemetry=f;function E(v,M){return!(M.disableTelemetry||!v.enableTelemetry||M.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(v){const M=v.getValue(L.TELEMETRY_SETTING_ID),g=v.getValue("telemetry.enableCrashReporter");if(v.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return 0;switch(M??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function k(v){const M=Object.create(null),g=Object.create(null),u=Object.create(null);w(v,u);for(let l in u){l=l.length>150?l.substr(l.length-149):l;const o=u[l];typeof o=="number"?g[l]=o:typeof o=="boolean"?g[l]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${o.length}`),M[l]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(M[l]=o)}return{properties:M,measurements:g}}e.validateTelemetryData=k;function I(v){if(!v)return"none";let M="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{v.indexOf(`${u}+`)===0&&(M=u)}),M}e.cleanRemoteAuthority=I;function w(v,M,g=0,u){if(!!v)for(let l of Object.getOwnPropertyNames(v)){const o=v[l],d=u?u+l:l;Array.isArray(o)?M[d]=(0,m.safeStringify)(o):o instanceof Date?M[d]=o.toISOString():(0,n.isObject)(o)?g<2?w(o,M,g+1,d+"."):M[d]=(0,m.safeStringify)(o):M[d]=o}}function t(v){if(!v)return[];const M=[];return h(M,"",v),M}function h(v,M,g){g&&typeof g=="object"&&!Array.isArray(g)?Object.keys(g).forEach(u=>h(v,M?`${M}.${u}`:u,g[u])):v.push(M)}function y(v){return[v.appRoot,v.extensionsPath,v.userHome.fsPath,v.tmpDir.fsPath,v.userDataPath]}e.getPiiPathsFromEnvironment=y}),define(Z[209],x([0,1,172,66]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,C,S,f,E,P){const k={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${C.nameShort})`},I=await(0,m.getServiceMachineId)(S,E,P);return(0,n.supportsTelemetry)(C,S)&&(0,n.getTelemetryLevel)(f)===3&&(k["X-Market-User-Id"]=I),k}e.resolveMarketplaceHeaders=R}),define(Z[210],x([0,1,2,49,3,27,155,18,55,53,19,40,34,66]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let t=class{constructor(v,M,g){this._configurationService=M,this._productService=g,this._experimentProperties={},this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,M){this._experimentProperties[v]=M}_updateTelemetryLevel(){this._telemetryLevel=(0,w.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const M=v.usage?3:v.error?2:0;this._telemetryLevel=Math.min(this._telemetryLevel,M)}}get telemetryLevel(){return this._telemetryLevel}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties;let M=v.sessionID,g=v["common.machineId"],u=v["common.firstSessionDate"],l=v["common.msftInternal"];return{sessionId:M,machineId:g,firstSessionDate:u,msftInternal:l}}dispose(){this._disposables.dispose()}_log(v,M,g,u){return this.telemetryLevel<M?Promise.resolve(void 0):this._commonProperties.then(l=>{g=(0,n.mixin)(g,l),g=(0,n.mixin)(g,this._experimentProperties),g=(0,n.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,u)}),this._appenders.forEach(o=>o.log(v,g))},l=>{console.error(l)})}publicLog(v,M,g){return this._log(v,3,M,g)}publicLog2(v,M,g){return this.publicLog(v,M,g)}publicLogError(v,M){return this._sendErrorTelemetry?this._log(v,2,M,!0):Promise.resolve(void 0)}publicLogError2(v,M){return this.publicLogError(v,M)}_anonymizeFilePaths(v){let M=v;const g=[];for(let d of this._cleanupPatterns)for(;;){const r=d.exec(v);if(!r)break;g.push([r.index,d.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(M="";;){const d=l.exec(v);if(!d)break;!u.test(d[0])&&g.every(([r,i])=>d.index<r||d.index>=i)&&(M+=v.substring(o,d.index)+"<REDACTED: user-file-path>",o=l.lastIndex)}return o<v.length&&(M+=v.substr(o)),M}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const M=v.toLowerCase(),g=/@[a-zA-Z0-9-.]+/,u=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,l=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return u.test(M)?"<REDACTED: secret>":g.test(M)?"<REDACTED: email>":l.test(M)?"<REDACTED: token>":v}_cleanupInfo(v,M){let g=v;M&&(g=this._anonymizeFilePaths(g));for(let u of this._cleanupPatterns)g=g.replace(u,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};t.IDLE_START_EVENT_NAME="UserIdleStart",t.IDLE_STOP_EVENT_NAME="UserIdleStop",t=ue([ne(1,S.IConfigurationService),ne(2,P.IProductService)],t),e.TelemetryService=t;function h(){const y=(0,C.localize)(0,null,E.default.nameLong),v=E.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),M=R.isWeb?"":(0,C.localize)(3,null),g=(0,C.localize)(4,null),u=(0,C.localize)(5,null),l=(0,C.localize)(6,null),o=(0,C.localize)(7,null),d=`
|       | ${g} | ${u} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${y} ${v} ${M}

&nbsp;

${o}
${d}

&nbsp;

${r}
`}k.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,C.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,C.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[211],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var m;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(m=e.ColorScheme||(e.ColorScheme={}));function n(R){return R===m.HIGH_CONTRAST_DARK||R===m.HIGH_CONTRAST_LIGHT}e.isHighContrast=n}),define(Z[212],x([0,1,107,4,2,5,40,211]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var f;(function(y){function v(M){return M&&typeof M=="object"&&typeof M.id=="string"}y.isThemeColor=v})(f=e.ThemeColor||(e.ThemeColor={}));function E(y){return{id:y}}e.themeColorFromId=E;var P;(function(y){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||f.isThemeColor(i.color))}y.isThemeIcon=v;const M=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function g(i){const s=M.exec(i);if(!s)return;let[,a]=s;return{id:a}}y.fromString=g;function u(i){return{id:i}}y.fromId=u;function l(i,s){let a=i.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),s&&(a=`${a}~${s}`),{id:a}}y.modify=l;function o(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}y.getModifier=o;function d(i,s){return i.id===s.id&&i.color?.id===s.color?.id}y.isEqual=d;function r(i,s){return{id:i.id,color:s?E(s):void 0}}y.asThemeIcon=r,y.asClassNameArray=m.CSSIcon.asClassNameArray,y.asClassName=m.CSSIcon.asClassName,y.asCSSSelector=m.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function k(y){switch(y){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case S.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const M=this.themingParticipants.indexOf(v);this.themingParticipants.splice(M,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new I;C.Registry.add(e.Extensions.ThemingContribution,w);function t(y){return w.onColorThemeChange(y)}e.registerThemingParticipant=t;class h extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(M=>this.onThemeChange(M)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,M){let g=this.theme.getColor(v);return g&&M&&(g=M(g,this.theme)),g?g.toString():null}}e.Themable=h}),define(Z[57],x([0,1,12,4,2,3,18,5,38]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",P="#1E1E1E",k="#000000",I="#FFFFFF",w="theme",t="themeBackground",h="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let y=class extends R.Disposable{constructor(M,g){super();this.stateMainService=M,this.configurationService=g,this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,m.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(L.isWindows){if(m.nativeTheme.shouldUseHighContrastColors)return{dark:m.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isMacintosh){if(m.nativeTheme.shouldUseInvertedColorScheme||m.nativeTheme.shouldUseHighContrastColors)return{dark:m.nativeTheme.shouldUseDarkColors!==m.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isLinux&&m.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:m.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const M=this.getColorScheme();if(M.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return M.dark?k:I;let g=this.stateMainService.getItem(t,null);if(!g)switch(this.stateMainService.getItem(w,"vs-dark").split(" ")[0]){case"vs":g=E;break;case"hc-black":g=k;break;case"hc-light":g=I;break;default:g=P}return L.isMacintosh&&g.toUpperCase()===P&&(g="#171717"),g}saveWindowSplash(M,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:h,data:g}]),typeof M=="number"&&this.updateBackgroundColor(M,g)}updateBackgroundColor(M,g){for(const u of m.BrowserWindow.getAllWindows())if(u.id===M){u.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(h)}};y=ue([ne(0,f.IStateMainService),ne(1,C.IConfigurationService)],y),e.ThemeMainService=y}),define(Z[99],x([0,1,4,3,5,6]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var C;(function(t){t.Http="http",t.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(S=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=k;function I(t,h){return h?h!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=I;let w=class{constructor(h){this.logService=h,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],y=Array.from(this._tunnels.values());for(let v of y){const M=Array.from(v.values());for(let g of M){const u=await g.value;u&&h.push(u)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:y}of h.values())await y.then(v=>v?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,y,v,M,g=!1,u=S.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${v} on local port ${M}.`),!h)return;y||(y="localhost");const o=this.retainOrCreateTunnel(h,y,v,M,g,u,l);return o?o.then(d=>{if(!d){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(d);return(d.tunnelRemoteHost!==y||d.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const y=this._tunnels.get(h.tunnelRemoteHost);if(y){const v=y.get(h.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async tryDisposeTunnel(h,y,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${y}.`);const M=v.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(y),M}}async closeTunnel(h,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${y} `);const v=this._tunnels.get(h);if(v&&v.has(y)){const M=v.get(y);M.refcount=0,await this.tryDisposeTunnel(h,y,M)}}addTunnelToMap(h,y,v){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(y,{refcount:1,value:v})}async removeEmptyTunnelFromMap(h,y){const v=this._tunnels.get(h);v&&(await v.get(y)||v.delete(y),v.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,y){let v=[h];P(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const M=v.map(g=>this._tunnels.get(g));for(const g of M){const u=g?.get(y);if(u)return u}}canTunnel(h){return!!E(h)}createWithProvider(h,y,v,M,g,u,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${v} on local port ${M}.`);const d={elevationRequired:g?I(M===void 0?v:M):!1},r={remoteAddress:{host:y,port:v},localAddressPort:M,privacy:u,public:u!==S.Private,protocol:l},i=h.forwardPort(r,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(y,v,i),i}};w=ue([ne(0,L.ILogService)],w),e.AbstractTunnelService=w}),define(Z[41],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(n=e.StateType||(e.StateType={}));var R;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(L,C)=>({type:"idle",updateType:L,error:C}),CheckingForUpdates:L=>({type:"checking for updates",explicit:L}),AvailableForDownload:L=>({type:"available for download",update:L}),Downloading:L=>({type:"downloading",update:L}),Downloaded:L=>({type:"downloaded",update:L}),Updating:L=>({type:"updating",update:L}),Ready:L=>({type:"ready",update:L})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(Z[213],x([0,1,3,156,55,40]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:m.isWindows&&!m.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[214],x([0,1,4,41]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(S){this.service=S}listen(S,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,E){switch(f){case"checkForUpdates":return this.service.checkForUpdates(E);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=R;class L{constructor(S){this.channel=S,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(S){this._state=S,this._onStateChange.fire(S)}checkForUpdates(S){return this.channel.call("checkForUpdates",S)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=L}),define(Z[100],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(Z[215],x([0,1,8]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(S){this.handler=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,E){switch(f){case"handleURL":return this.handler.handleURL(m.URI.revive(E[0]),E[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=n;class R{constructor(S){this.channel=S}handleURL(S,f){return this.channel.call("handleURL",[S.toJSON(),f])}}e.URLHandlerChannelClient=R;class L{constructor(S){this.next=S}async routeCall(S,f,E,P){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(E){const k=m.URI.revive(E);if(k&&k.query){const I=/\bwindowId=(\d+)/.exec(k.query);if(I){const w=I[1],t=new RegExp(`window:${w}`),h=S.connections.find(y=>t.test(y.ctx));if(h)return h}}}return this.next.routeCall(S,f,E,P)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=L}),define(Z[216],x([0,1,9,2,8,19]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(E,P){const k=[...this.handlers.values()];return(0,m.first)(k.map(I=>()=>I.handleURL(E,P)),void 0,!1).then(I=>I||!1)}registerHandler(E){return this.handlers.add(E),(0,n.toDisposable)(()=>this.handlers.delete(E))}}e.AbstractURLService=C;let S=class extends C{constructor(E){super();this.productService=E}create(E){let{authority:P,path:k,query:I,fragment:w}=E||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return P&&k&&k.indexOf("/")!==0&&(k=`/${k}`),R.URI.from({scheme:this.productService.urlProtocol,authority:P,path:k,query:I,fragment:w})}};S=ue([ne(0,L.IProductService)],S),e.NativeURLService=S}),define(Z[217],x([0,1,12,9,4,2,3,8]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(P){try{return S.URI.parse(P)}catch{return null}}class E{constructor(k,I,w,t,h){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=L.Disposable.None,this.disposables=new L.DisposableStore,this.uris=k,C.isWindows){const M=t.isBuilt?[]:[`"${t.appRoot}"`];M.push("--open-url","--"),m.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,M)}const y=R.Event.map(R.Event.fromNodeEventEmitter(m.app,"open-url",(M,g)=>({event:M,url:g})),({event:M,url:g})=>(M.preventDefault(),g));this.disposables.add(y(M=>{const g=f(M);!g||this.urlService.open(g,{originalUrl:M})})),w.getWindows().filter(M=>M.isReady).length>0?this.flush():R.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||k.push(I);k.length!==0&&(this.uris=k,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=E}),define(Z[218],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService")}),define(Z[219],x([0,1,12,2,10,8]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends n.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(R.Schemas.vscodeWebview,f)}handleWebviewRequest(f,E){try{const P=L.URI.parse(f.url),k=C.validWebviewFilePaths.get(P.path);if(typeof k=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${k}`,w=R.FileAccess.asFileUri(I,H);return E(decodeURIComponent(w.fsPath))}else return E({error:-10})}catch{}return E({error:-2})}}e.WebviewProtocolProvider=C,C.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[67],x([0,1,3]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(E){return!!E.workspaceUri}e.isWorkspaceToOpen=n;function R(E){return!!E.folderUri}e.isFolderToOpen=R;function L(E){return!!E.fileUri}e.isFileToOpen=L;function C(E){const P=S(E),k=E.getValue("window.menuBarVisibility");return k==="default"||P==="native"&&k==="compact"||m.isMacintosh&&m.isNative?"classic":k}e.getMenuBarVisibility=C;function S(E){if(m.isWeb)return"custom";const P=E.getValue("window");if(P){if(m.isMacintosh&&P.nativeTabs===!0||m.isMacintosh&&P.nativeFullScreen===!1)return"native";const w=E.getValue("workbench.colorCustomizations");if(w?.["window.activeBorder"]||w?.["window.inactiveBorder"])return"custom";const t=P.titleBarStyle;if(t==="native"||t==="custom")return t}return m.isLinux?"native":"custom"}e.getTitleBarStyle=S;function f(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=f}),define(Z[101],x([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var m;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(m=e.LoadReason||(e.LoadReason={}));var n;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(n=e.UnloadReason||(e.UnloadReason={}));const R=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=R;var L;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(L=e.WindowMode||(e.WindowMode={}));var C;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(C=e.WindowError||(e.WindowError={}))}),define(Z[32],x([0,1,5]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,m.createDecorator)("windowsMainService");var n;(function(R){R[R.CLI=0]="CLI",R[R.DOCK=1]="DOCK",R[R.MENU=2]="MENU",R[R.DIALOG=3]="DIALOG",R[R.DESKTOP=4]="DESKTOP",R[R.API=5]="API"})(n=e.OpenContext||(e.OpenContext={}))}),define(Z[220],x([0,1,12,23,4,70,2,31,63,92,6,19,32]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let t=class extends C.Disposable{constructor(y,v,M,g,u){super();this.logService=y,this.windowsMainService=v,this.credentialsService=M,this.encryptionMainService=g,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=R.Event.fromNodeEventEmitter(m.app,"login",(v,M,g,u,l)=>({event:v,webContents:M,req:g,authInfo:u,callback:l}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:v,req:M,callback:g}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&M.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}g(u?.username,u?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(y);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const v=String((0,L.hash)({scheme:y.scheme,host:y.host,port:y.port}));let M,g;try{const d=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(d){const r=JSON.parse(await this.encryptionMainService.decrypt(d));M=r.username,g=r.password}}catch(d){this.logService.error(d)}if(this.state!==w.StoredCredentialsUsed&&typeof M=="string"&&typeof g=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:M,password:g};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const l={authInfo:y,username:this.sessionCredentials?.username??M,password:this.sessionCredentials?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,S.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,l),this.state=w.LoginDialogShown;const o=await new Promise(d=>{const r=async(i,s,a)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",r),a){const c={username:a.username,password:a.password};try{if(a.remember){const b=await this.encryptionMainService.encrypt(JSON.stringify(c));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,b)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(b){this.logService.error(b)}d({username:c.username,password:c.password})}else d(void 0)};u.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=o,o}};t=ue([ne(0,P.ILogService),ne(1,I.IWindowsMainService),ne(2,f.ICredentialsMainService),ne(3,E.IEncryptionMainService),ne(4,k.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[221],x([0,1,63,6,52,19,32,186]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends S.BaseCredentialsMainService{constructor(P,k,I,w){super(P);this.environmentMainService=k,this.productService=I,this.windowsMainService=w}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new m.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((P,k)=>{H(["keytar"],P,k)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(P){throw this.windowsMainService.sendToFocused("vscode:showCredentialsError",P.message??P),P}return this._keytarCache}};f=ue([ne(0,n.ILogService),ne(1,R.INativeEnvironmentService),ne(2,L.IProductService),ne(3,C.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(Z[222],x([0,1,12,4,2,219,32]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends R.Disposable{constructor(E){super();this.windowsMainService=E,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new L.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(E,P){let k;if(typeof E.windowId=="number"){const{windowId:I}=E,w=this.windowsMainService.getWindowById(I);if(!w?.win)throw new Error(`Invalid windowId: ${I}`);k=w.win.webContents}else{const{webContentsId:I}=E;if(k=m.webContents.fromId(I),!k)throw new Error(`Invalid webContentsId: ${I}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(P)}async findInFrame(E,P,k,I){const t=this.getFrameByName(E,P);if(typeof t.findInFrame=="function"){t.findInFrame(k,{findNext:I.findNext,forward:I.forward});const h=(y,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),t.removeListener("found-in-frame",h))};t.on("found-in-frame",h)}}async stopFindInFrame(E,P,k){const w=this.getFrameByName(E,P);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(E,P){const k=this.windowsMainService.getWindowById(E.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${E}`);const I=k.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===P);if(!I)throw new Error(`Unknown frame: ${P}`);return I}};S=ue([ne(0,C.IWindowsMainService)],S),e.WebviewMainService=S}),define(Z[223],x([0,1,9,4,2]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:S,onDidFocusWindow:f,getActiveWindowId:E}){super();this.disposables=this._register(new R.DisposableStore),n.Event.latch(n.Event.any(S,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,m.createCancelablePromise)(()=>E()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(S){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=S}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[25],x([0,1,159,7,35,17,8,5,10]),function(H,e,m,n,R,L,C,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function E(r){const i=r;return typeof i?.id=="string"&&C.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=E;function P(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=P;function k(r){const i=r;return typeof i?.id=="string"&&C.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=k;function I(r){const i=r;if(i?.uri)return{id:i.id,uri:C.URI.revive(i.uri)};const s=r;if(s?.configPath)return{id:s.id,configPath:C.URI.revive(s.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=I;var w;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function t(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=t;function h(r){const i=r;return!!(i&&typeof i=="object"&&C.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class y{constructor(i,s,a,c,b){this._id=i,this._transient=a,this._configuration=c,this._ignorePathCasing=b,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class v{constructor(i,s){this.raw=s,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function M(r){return new v({uri:r,index:0,name:(0,L.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=M,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,m.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(r,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function l(r){let i;return C.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=l;function o(r,i){return!u(r,i)&&!l(r)}e.isSavedWorkspace=o;function d(r){return(typeof r=="string"?(0,n.extname)(r):(0,L.extname)(r))===g}e.hasWorkspaceFileExtension=d}),define(Z[47],x([0,1,12,9,70,33,2,71,7,3,14,24,141,5,6,38,25]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let v=class bt{constructor(g,u){this.stateMainService=g,this.logService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(g,u){return this.doPick({...g,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},u)}pickFolder(g,u){return this.doPick({...g,pickFolders:!0,title:(0,I.localize)(1,null)},u)}pickFile(g,u){return this.doPick({...g,pickFiles:!0,title:(0,I.localize)(2,null)},u)}pickWorkspace(g,u){const l=(0,I.localize)(3,null),o=(0,L.mnemonicButtonLabel)((0,I.localize)(4,null)),d=y.WORKSPACE_FILTER;return this.doPick({...g,pickFiles:!0,title:l,filters:d,buttonLabel:o},u)}async doPick(g,u){const l={title:g.title,buttonLabel:g.buttonLabel,filters:g.filters};l.defaultPath=g.defaultPath||this.stateMainService.getItem(bt.workingDirPickerStorageKey),(typeof g.pickFiles=="boolean"||typeof g.pickFolders=="boolean")&&(l.properties=void 0,g.pickFiles&&g.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",g.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&l.properties.push("treatPackageAsDirectory");const o=u||m.BrowserWindow.getFocusedWindow(),d=await this.showOpenDialog(l,(0,P.withNullAsUndefined)(o));if(d&&d.filePaths&&d.filePaths.length>0)return this.stateMainService.setItem(bt.workingDirPickerStorageKey,(0,f.dirname)(d.filePaths[0])),d.filePaths}getWindowDialogQueue(g){if(g){let u=this.windowDialogQueues.get(g.id);return u||(u=new n.Queue,this.windowDialogQueues.set(g.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(g,u){return this.getWindowDialogQueue(u).queue(async()=>u?m.dialog.showMessageBox(u,g):m.dialog.showMessageBox(g))}async showSaveDialog(g,u){const l=this.acquireFileDialogLock(g,u);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(u).queue(async()=>{let o;return u?o=await m.dialog.showSaveDialog(u,g):o=await m.dialog.showSaveDialog(g),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,C.dispose)(l)}}normalizePath(g){return g&&E.isMacintosh&&(g=(0,S.normalizeNFC)(g)),g}normalizePaths(g){return g.map(u=>this.normalizePath(u))}async showOpenDialog(g,u){g.defaultPath&&(await k.Promises.exists(g.defaultPath)||(g.defaultPath=void 0));const l=this.acquireFileDialogLock(g,u);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(u).queue(async()=>{let o;return u?o=await m.dialog.showOpenDialog(u,g):o=await m.dialog.showOpenDialog(g),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,C.dispose)(l)}}acquireFileDialogLock(g,u){if(!u)return C.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",g);let l=this.windowFileDialogLocks.get(u.id);l||(l=new Set,this.windowFileDialogLocks.set(u.id,l));const o=(0,R.hash)(g);if(!l.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",g),l.add(o),(0,C.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",g),l?.delete(o),l?.size===0&&this.windowFileDialogLocks.delete(u.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([ne(0,h.IStateMainService),ne(1,t.ILogService)],v),e.DialogMainService=v}),define(Z[224],x([0,1,4,2,25]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class L extends n.Disposable{constructor(S,f){super();this.logService=S,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(S,f)=>(S?S.push(f):S=[f],S),L.STORAGE_CHANGE_DEBOUNCE_TIME)(S=>{S.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(S))}))}serializeGlobalStorageEvents(S){const f=new Map,E=new Set;return S.forEach(P=>{const k=this.storageMainService.globalStorage.get(P.key);typeof k=="string"?f.set(P.key,k):E.add(P.key)}),{changed:Array.from(f.entries()),deleted:Array.from(E.values())}}listen(S,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(S,f,E){const P=(0,R.reviveIdentifier)(E.workspace),k=await this.withStorageInitialized(P);switch(f){case"getItems":return Array.from(k.items.entries());case"updateItems":{const I=E;if(I.insert)for(const[w,t]of I.insert)k.set(w,t);I.delete&&I.delete.forEach(w=>k.delete(w));break}case"close":{if(P)return k.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(S){const f=S?this.storageMainService.workspaceStorage(S):this.storageMainService.globalStorage;try{await f.init()}catch(E){this.logService.error(`StorageIPC#init: Unable to init ${S?"workspace":"global"} storage due to ${E}`)}return f}}e.StorageDatabaseChannel=L,L.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[225],x([0,1,9,4,2,7,24,90,130,6,98,34,25]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends R.Disposable{constructor(M){super();this.logService=M,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new S.Storage(new S.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new m.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=S.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===S.StorageState.None)try{const M=await this.doCreate();this._storage.dispose(),this._storage=M,this._register(M.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(M);const g=M.getBoolean(P.IS_NEW_KEY);g===void 0?M.set(P.IS_NEW_KEY,!0):g&&M.set(P.IS_NEW_KEY,!1)}catch(M){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${M}`)}finally{this.state=S.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?M=>this.logService.trace(M):void 0,logError:M=>this.logService.error(M)}}doInit(M){return M.init()}get items(){return this._storage.items}get(M,g){return this._storage.get(M,g)}set(M,g){return this._storage.set(M,g)}delete(M){return this._storage.delete(M)}async close(){this.initializePromise&&await this.initializePromise,this.state=S.StorageState.Closed,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends w{constructor(M,g,u){super(g);this.options=M,this.environmentService=u}async doCreate(){let M;return this.options.useInMemoryStorage?M=f.SQLiteStorageDatabase.IN_MEMORY_PATH:M=(0,L.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new S.Storage(new f.SQLiteStorageDatabase(M,{logging:this.createLoggingOptions()}))}async doInit(M){await super.doInit(M),this.updateTelemetryState(M)}updateTelemetryState(M){M.get(k.firstSessionDateStorageKey,void 0)===void 0&&M.set(k.firstSessionDateStorageKey,new Date().toUTCString());const u=M.get(k.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();M.set(k.lastSessionDateStorageKey,typeof u=="undefined"?null:u),M.set(k.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class h extends w{constructor(M,g,u,l){super(u);this.workspace=M,this.options=g,this.environmentService=l}async doCreate(){const{storageFilePath:M,wasCreated:g}=await this.prepareWorkspaceStorageFolder();return new S.Storage(new f.SQLiteStorageDatabase(M,{logging:this.createLoggingOptions()}),{hint:g?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const M=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),g=(0,L.join)(M,h.WORKSPACE_STORAGE_NAME);return await C.Promises.exists(M)?{storageFilePath:g,wasCreated:!1}:(await C.Promises.mkdir(M,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(M),{storageFilePath:g,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(M){let g;if((0,I.isSingleFolderWorkspaceIdentifier)(this.workspace)?g={folder:this.workspace.uri.toString()}:(0,I.isWorkspaceIdentifier)(this.workspace)&&(g={workspace:this.workspace.configPath.toString()}),g)try{const u=(0,L.join)(M,h.WORKSPACE_META_NAME);await C.Promises.exists(u)||await C.Promises.writeFile(u,JSON.stringify(g,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class y extends w{async doCreate(){return new S.Storage(new S.InMemoryStorageDatabase)}}e.InMemoryStorageMain=y}),define(Z[102],x([0,1,17,8,25]),function(H,e,m,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function L(f,E,P){for(const I of f){const w=I.openedWorkspace;if((0,R.isWorkspaceIdentifier)(w)){const t=P(w);if(t){if(t.folders.some(h=>m.extUriBiasedIgnorePathCase.isEqualOrParent(E,h.uri)))return I}else if(m.extUriBiasedIgnorePathCase.isEqualOrParent(E,w.configPath))return I}}const k=f.filter(I=>(0,R.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqualOrParent(E,I.openedWorkspace.uri));if(k.length)return k.sort((I,w)=>-(I.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=L;function C(f,E){for(const P of f)if((0,R.isWorkspaceIdentifier)(P.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.configPath,E)||(0,R.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(P.openedWorkspace.uri,E))return P}e.findWindowOnWorkspaceOrFolder=C;function S(f,E){const P=k=>E.some(I=>m.extUriBiasedIgnorePathCase.isEqual(n.URI.file(I),n.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(I=>P(I)))return k}e.findWindowOnExtensionDevelopmentPath=S}),define(Z[226],x([0,1,12,2,3,17,8,18,20,6,38,32,101,25]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let t=class Et extends n.Disposable{constructor(u,l,o,d,r){super();this.windowsMainService=u,this.stateMainService=l,this.lifecycleMainService=o,this.logService=d,this.configurationService=r,this._state=h(this.stateMainService.getItem(Et.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let d=this.windowsMainService.getLastActiveWindow();(!d||d.isExtensionDevelopmentHost)&&(d=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),d&&(u.lastActiveWindow=this.toWindowState(d))}const l=this.windowsMainService.getWindows().find(d=>d.isExtensionDevelopmentHost&&!d.isExtensionTestHost);l&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(d=>!d.isExtensionDevelopmentHost).map(d=>this.toWindowState(d)));const o=v(u);this.stateMainService.setItem(Et.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(o=>{const d=(0,w.isWorkspaceIdentifier)(u.openedWorkspace)&&o.workspace?.id===u.openedWorkspace.id,r=(0,w.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&o.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(o.folderUri,u.openedWorkspace.uri);(d||r)&&(o.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(u){return{workspace:(0,w.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,w.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const l=this.doGetNewWindowState(u),o=this.configurationService.getValue("window");let d;return l.hasDefaultState?d=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):(d=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),d&&R.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(d=!1)),l.mode===3&&!d&&(l.mode=1),l}doGetNewWindowState(u){const l=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,w.isWorkspaceIdentifier)(a)){const b=this.state.openedWindows.filter(p=>p.workspace&&p.workspace.id===a.id).map(p=>p.uiState);if(b.length)return b[0]}if((0,w.isSingleFolderWorkspaceIdentifier)(a)){const b=this.state.openedWindows.filter(p=>p.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(p.folderUri,a.uri)).map(p=>p.uiState);if(b.length)return b[0]}else if(u.backupPath){const b=this.state.openedWindows.filter(p=>p.backupPath===u.backupPath).map(p=>p.uiState);if(b.length)return b[0]}const c=this.lastClosedState||this.state.lastActiveWindow;if(!l&&c)return c.uiState}let o;const d=m.screen.getAllDisplays();if(d.length===1)o=d[0];else{if(R.isMacintosh){const a=m.screen.getCursorScreenPoint();o=m.screen.getDisplayNearestPoint(a)}!o&&l&&(o=m.screen.getDisplayMatching(l.getBounds())),o||(o=m.screen.getPrimaryDisplay()||d[0])}let r=(0,I.defaultWindowState)();r.x=Math.round(o.bounds.x+o.bounds.width/2-r.width/2),r.y=Math.round(o.bounds.y+o.bounds.height/2-r.height/2);const i=this.configurationService.getValue("window");let s=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")r.mode=0,s=!1;else if(i.newWindowDimensions==="fullscreen")r.mode=3,s=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&l){const a=l.serializeWindowState();a.mode===3?r.mode=3:r=a,s=r.mode!==3&&i.newWindowDimensions==="offset"}}return s&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const l=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;l.some(o=>o.x===u.x||o.y===u.y);)u.x+=30,u.y+=30;return u}};t.windowsStateStorageKey="windowsState",t=ue([ne(0,k.IWindowsMainService),ne(1,P.IStateMainService),ne(2,f.ILifecycleMainService),ne(3,E.ILogService),ne(4,S.IConfigurationService)],t),e.WindowsStateHandler=t;function h(g){const u={openedWindows:[]},l=g||{openedWindows:[]};return l.lastActiveWindow&&(u.lastActiveWindow=y(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=y(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(u.openedWindows=l.openedWindows.map(o=>y(o))),u}e.restoreWindowsState=h;function y(g){const u={uiState:g.uiState};return g.backupPath&&(u.backupPath=g.backupPath),g.remoteAuthority&&(u.remoteAuthority=g.remoteAuthority),g.folder&&(u.folderUri=C.URI.parse(g.folder)),g.workspaceIdentifier&&(u.workspace={id:g.workspaceIdentifier.id,configPath:C.URI.parse(g.workspaceIdentifier.configURIPath)}),u}function v(g){return{lastActiveWindow:g.lastActiveWindow&&M(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&M(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(u=>M(u))}}e.getWindowsStateStoreData=v;function M(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(Z[80],x([0,1,28,44,109,33,10,7,3,17,8,5,78,25]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function t(p){return p.hasOwnProperty("workspace")}e.isRecentWorkspace=t;function h(p){return p.hasOwnProperty("folderUri")}e.isRecentFolder=h;function y(p){return p.hasOwnProperty("fileUri")}e.isRecentFile=y;function v(p){return M(p)||g(p)}e.isStoredWorkspaceFolder=v;function M(p){const D=p;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function g(p){const D=p;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function u(p,D,F,U,Q=!f.isWindows,te){if(p.scheme!==U.scheme)return{name:F,uri:p.toString(!0)};let ie=D?void 0:te.relativePath(U,p);if(ie!==void 0)ie.length===0?ie=".":f.isWindows&&p.scheme===C.Schemas.file&&!Q&&(ie=ie.replace(/\//g,"\\"));else if(p.scheme===C.Schemas.file)ie=p.fsPath,f.isWindows&&(ie=(0,L.normalizeDriveLetter)(ie),Q&&(ie=(0,m.toSlashes)(ie)));else{if(!te.isEqualAuthority(p.authority,U.authority))return{name:F,uri:p.toString(!0)};ie=p.path}return{name:F,path:ie}}e.getStoredWorkspaceFolder=u;function l(p,D,F){let U=[],Q=new Set;const te=F.dirname(D);for(let ie of p){let ee;if(M(ie))ie.path&&(ee=F.resolvePath(te,ie.path));else if(g(ie))try{ee=P.URI.parse(ie.uri),ee.path[0]!=="/"&&(ee=ee.with({path:"/"+ee.path}))}catch($){console.warn($)}if(ee){let $=F.getComparisonKey(ee);if(!Q.has($)){Q.add($);const Y=ie.name||F.basenameOrAuthority(ee);U.push(new w.WorkspaceFolder({uri:ee,name:Y,index:U.length},ie))}}}return U}e.toWorkspaceFolders=l;function o(p,D,F,U,Q){let te=d(D,p);const ie=Q.dirname(D),ee=Q.dirname(U),$=[],Y=r(te.folders);for(const V of te.folders){const J=M(V)?Q.resolvePath(ie,V.path):P.URI.parse(V.uri);let B;F?B=!1:B=!M(V)||(0,S.isAbsolute)(V.path),$.push(u(J,B,V.name,ee,Y,Q))}const j={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},q=R.setProperty(p,["folders"],$,j);let N=R.applyEdits(p,q);return(0,E.isEqualAuthority)(te.remoteAuthority,(0,I.getRemoteAuthority)(U))&&(N=R.applyEdits(N,R.removeProperty(N,["remoteAuthority"],j))),N}e.rewriteWorkspaceFileForNewLocation=o;function d(p,D){let F=n.parse(D);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(U=>v(U));else throw new Error(`${p} looks like an invalid workspace file.`);return F}function r(p){return f.isWindows?p.some(D=>M(D)&&D.path.indexOf("/")>=0):!0}e.useSlashForPath=r;function i(p){return p.workspace&&typeof p.workspace=="object"&&typeof p.workspace.id=="string"&&typeof p.workspace.configPath=="string"}function s(p){return typeof p.folderUri=="string"}function a(p){return typeof p.fileUri=="string"}function c(p,D){const F={workspaces:[],files:[]};if(p){const U=function(te,ie){for(let ee=0;ee<te.length;ee++)try{ie(te[ee],ee)}catch($){D.warn(`Error restoring recent entry ${JSON.stringify(te[ee])}: ${$.toString()}. Skip entry.`)}},Q=p;if(Array.isArray(Q.entries))U(Q.entries,te=>{const ie=te.label,ee=te.remoteAuthority;i(te)?F.workspaces.push({label:ie,remoteAuthority:ee,workspace:{id:te.workspace.id,configPath:P.URI.parse(te.workspace.configPath)}}):s(te)?F.workspaces.push({label:ie,remoteAuthority:ee,folderUri:P.URI.parse(te.folderUri)}):a(te)&&F.files.push({label:ie,remoteAuthority:ee,fileUri:P.URI.parse(te.fileUri)})});else{const te=p;Array.isArray(te.workspaces3)&&U(te.workspaces3,(ie,ee)=>{const $=Array.isArray(te.workspaceLabels)&&te.workspaceLabels[ee]||void 0;typeof ie=="object"&&typeof ie.id=="string"&&typeof ie.configURIPath=="string"?F.workspaces.push({label:$,workspace:{id:ie.id,configPath:P.URI.parse(ie.configURIPath)}}):typeof ie=="string"&&F.workspaces.push({label:$,folderUri:P.URI.parse(ie)})}),Array.isArray(te.files2)&&U(te.files2,(ie,ee)=>{const $=Array.isArray(te.fileLabels)&&te.fileLabels[ee]||void 0;typeof ie=="string"&&F.files.push({label:$,fileUri:P.URI.parse(ie)})})}}return F}e.restoreRecentlyOpened=c;function b(p){const D={entries:[]};for(const F of p.workspaces)h(F)?D.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):D.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of p.files)D.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return D}e.toStoreData=b}),define(Z[103],x([0,1,61,29,10,3,17]),function(H,e,m,n,R,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function S(E){function P(){let k=E.scheme===R.Schemas.file?(0,C.originalFSPath)(E):E.toString();return L.isLinux||(k=k.toLowerCase()),(0,m.createHash)("md5").update(k).digest("hex")}return{id:P(),configPath:E}}e.getWorkspaceIdentifier=S;function f(E,P){function k(){if(E.scheme!==R.Schemas.file)return(0,m.createHash)("md5").update(E.toString()).digest("hex");if(!P)try{P=(0,n.statSync)(E.fsPath)}catch{return}let w;return L.isLinux?w=P.ino:L.isMacintosh?w=P.birthtime.getTime():L.isWindows&&(typeof P.birthtimeMs=="number"?w=Math.floor(P.birthtimeMs):w=P.birthtime.getTime()),(0,m.createHash)("md5").update(E.fsPath).update(w?String(w):"").digest("hex")}const I=k();if(typeof I=="string")return{id:I,uri:E}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[227],x([0,1,15,4,10,6,254,118,20,85]),function(H,e,m,n,R,L,C,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class P{constructor(t,h){this._worker=new C.Worker(R.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",H).fsPath),this._worker.on("message",t),this._worker.on("error",h),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,h){this._worker.postMessage(t,h)}dispose(){this._worker.terminate()}}let k=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};k=ue([ne(0,L.ILogService)],k);let I=class{constructor(t,h){this._logService=t,this._shutdown=!1,this._proxy=null;const y={create:(v,M,g)=>{const u=new P(M,g);return u.onError(l=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(l)}),u.onMessageError(l=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(l)}),u.onExit(l=>this._logService.info(`ExtensionHostStarterWorker exited with code ${l}.`)),u.postMessage(v,[]),u}};this._worker=new S.SimpleWorkerClient(y,"vs/platform/extensions/node/extensionHostStarterWorker",new k(this._logService)),this._initialize(),h.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();return t.createExtensionHost()}async start(t,h){const y=E.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();const M=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),g=await v.start(t,h),u=y.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${u} ms.`),clearTimeout(M),g}async enableInspectPort(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();return h.enableInspectPort(t)}async kill(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,m.canceled)();return h.kill(t)}};I=ue([ne(0,L.ILogService),ne(1,f.ILifecycleMainService)],I),e.WorkerMainProcessExtensionHostStarter=I}),define(Z[58],x([0,1,61,62,26,16,15,4,2,7,3,31,37,88,228]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(D,F=""){this.debugLabel=F,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,C.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(D,F){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(D){const F=U=>{this.traceSocketEvent("read",U),D(L.VSBuffer.wrap(U))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(D){const F=U=>{this.traceSocketEvent("close",{hadError:U}),D({type:0,hadError:U,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(D){const F=()=>{this.traceSocketEvent("nodeEndReceived"),D()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(D){if(!this.socket.destroyed)try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,C.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,C.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=h;var y;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(v||(v={}));class M extends f.Disposable{constructor(D,F,U,Q){super();this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:U?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new g(this,F,U,Q,this._onData,(te,ie)=>this._write(te,ie))),this._register(this._flowManager.onError(te=>{console.error(te),(0,C.onUnexpectedError)(te),this._onClose.fire({type:0,hadError:!0,error:te})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(te=>this._acceptChunk(te))),this._register(this.socket.onClose(te=>this._onClose.fire(te)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(D,F){this.socket.traceSocketEvent(D,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this._onData.event(D)}onClose(D){return this._onClose.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){this._flowManager.writeMessage(D)}_write(D,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let U=2;D.byteLength<126?U+=0:D.byteLength<2**16?U+=2:U+=8;const Q=L.VSBuffer.alloc(U);if(F?Q.writeUInt8(194,0):Q.writeUInt8(130,0),D.byteLength<126)Q.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){Q.writeUInt8(126,1);let te=1;Q.writeUInt8(D.byteLength>>>8&255,++te),Q.writeUInt8(D.byteLength>>>0&255,++te)}else{Q.writeUInt8(127,1);let te=1;Q.writeUInt8(0,++te),Q.writeUInt8(0,++te),Q.writeUInt8(0,++te),Q.writeUInt8(0,++te),Q.writeUInt8(D.byteLength>>>24&255,++te),Q.writeUInt8(D.byteLength>>>16&255,++te),Q.writeUInt8(D.byteLength>>>8&255,++te),Q.writeUInt8(D.byteLength>>>0&255,++te)}this.socket.write(L.VSBuffer.concat([Q,D]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(D){if(D.byteLength!==0){for(this._incomingData.acceptChunk(D);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),U=F.readUInt8(0),Q=(U&128)>>>7,te=(U&64)>>>6,ie=F.readUInt8(1),ee=(ie&128)>>>7,$=ie&127;this._state.state=2,this._state.readLen=2+(ee?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(te)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),U=F.readUInt8(1),Q=(U&128)>>>7;let te=U&127,ie=1;te===126?te=F.readUInt8(++ie)*2**8+F.readUInt8(++ie):te===127&&(te=F.readUInt8(++ie)*0+F.readUInt8(++ie)*0+F.readUInt8(++ie)*0+F.readUInt8(++ie)*0+F.readUInt8(++ie)*2**24+F.readUInt8(++ie)*2**16+F.readUInt8(++ie)*2**8+F.readUInt8(++ie));let ee=0;Q&&(ee=F.readUInt8(++ie)*2**24+F.readUInt8(++ie)*2**16+F.readUInt8(++ie)*2**8+F.readUInt8(++ie)),this._state.state=3,this._state.readLen=te,this._state.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),o(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=M;class g extends f.Disposable{constructor(D,F,U,Q,te,ie){super();this._tracer=D,this._onData=te,this._writeFn=ie,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new S.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new u(this._tracer,Q,U,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ee=>this._onError.fire(ee))),this._register(this._zlibDeflateStream.onError(ee=>this._onError.fire(ee)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(D){this._writeQueue.push(D),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const D=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,D);this._writeFn(F,!0)}else this._writeFn(D,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(D,F){return new Promise((U,Q)=>{D.write(F),D.flush(te=>U(te))})}acceptFrame(D,F,U){this._readQueue.push({data:D,isCompressed:F,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const D=this._readQueue.shift();if(this._zlibInflateStream&&D.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,D.data,D.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(D.data)}this._isProcessingReadQueue=!1}}_inflateFrame(D,F,U){return new Promise((Q,te)=>{D.write(F),U&&D.write(L.VSBuffer.fromByteArray([0,0,255,255])),D.flush(ie=>Q(ie))})}}class u extends f.Disposable{constructor(D,F,U,Q){super();this._tracer=D,this._recordInflateBytes=F,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",te=>{this._tracer.traceSocketEvent("zlibInflateError",{message:te?.message,code:te?.code}),this._onError.fire(te)}),this._zlibInflate.on("data",te=>{this._tracer.traceSocketEvent("zlibInflateData",te),this._pendingInflateData.push(L.VSBuffer.wrap(te))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(D){this._recordInflateBytes&&this._recordedInflateBytes.push(D.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",D),this._zlibInflate.write(D.buffer)}flush(D){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,D(F)})}}class l extends f.Disposable{constructor(D,F){super();this._tracer=D,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(L.VSBuffer.wrap(U))})}write(D){this._tracer.traceSocketEvent("zlibDeflateWrite",D.buffer),this._zlibDeflate.write(D.buffer)}flush(D){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),D(F)})}}function o(p,D){if(D===0)return;let F=p.byteLength>>>2;for(let $=0;$<F;$++){const Y=p.readUInt32BE($*4);p.writeUInt32BE(Y^D,$*4)}let U=F*4,Q=p.byteLength-U;const te=D>>>24&255,ie=D>>>16&255,ee=D>>>8&255;Q>=1&&p.writeUInt8(p.readUInt8(U)^te,U),Q>=2&&p.writeUInt8(p.readUInt8(U+1)^ie,U+1),Q>=3&&p.writeUInt8(p.readUInt8(U+2)^ee,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function r(){const p=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let D;return e.XDG_RUNTIME_DIR?D=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):D=(0,E.join)((0,R.tmpdir)(),`vscode-ipc-${p}.sock`),s(D),D}e.createRandomIPCHandle=r;function i(p,D,F){const U=(0,m.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${F}-${D}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${F}-${D}.sock`):Q=(0,E.join)(p,`${F}-${D}.sock`),s(Q),Q}e.createStaticIPCHandle=i;function s(p){const D=d[P.platform];typeof D=="number"&&p.length>=D&&console.warn(`WARNING: IPC handle "${p}" is longer than ${D} chars, try a shorter --user-data-dir`)}class a extends I.IPCServer{constructor(D){super(a.toClientConnectionEvent(D));this.server=D}static toClientConnectionEvent(D){const F=S.Event.fromNodeEventEmitter(D,"connection");return S.Event.map(F,U=>({protocol:new w.Protocol(new h(U,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function c(p){return new Promise((D,F)=>{const U=(0,n.createServer)();U.on("error",F),U.listen(p,()=>{U.removeListener("error",F),D(new a(U))})})}e.serve=c;function b(p,D){return new Promise((F,U)=>{const Q=(0,n.createConnection)(p,()=>{Q.removeListener("error",U),F(w.Client.fromSocket(new h(Q,`ipc-client${D}`),D))});Q.once("error",U)})}e.connect=b}),define(Z[229],x([0,1,58]),function(H,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(f){this.driver=f}listen(f,E){throw new Error("No event found")}call(f,E,P){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(P);case"startTracing":return this.driver.startTracing(P[0],P[1]);case"stopTracing":return this.driver.stopTracing(P[0],P[1],P[2]);case"reloadWindow":return this.driver.reloadWindow(P);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(P[0],P[1]);case"click":return this.driver.click(P[0],P[1],P[2],P[3]);case"doubleClick":return this.driver.doubleClick(P[0],P[1]);case"setValue":return this.driver.setValue(P[0],P[1],P[2]);case"getTitle":return this.driver.getTitle(P[0]);case"isActiveElement":return this.driver.isActiveElement(P[0],P[1]);case"getElements":return this.driver.getElements(P[0],P[1],P[2]);case"getElementXY":return this.driver.getElementXY(P[0],P[1],P[2]);case"typeInEditor":return this.driver.typeInEditor(P[0],P[1],P[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(P[0],P[1]);case"writeInTerminal":return this.driver.writeInTerminal(P[0],P[1],P[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(P);case"getLocalizedStrings":return this.driver.getLocalizedStrings(P)}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=n;class R{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}startTracing(f,E){return this.channel.call("startTracing",[f,E])}stopTracing(f,E,P){return this.channel.call("stopTracing",[f,E,P])}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,E){return this.channel.call("dispatchKeybinding",[f,E])}click(f,E,P,k){return this.channel.call("click",[f,E,P,k])}doubleClick(f,E){return this.channel.call("doubleClick",[f,E])}setValue(f,E,P){return this.channel.call("setValue",[f,E,P])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,E){return this.channel.call("isActiveElement",[f,E])}getElements(f,E,P){return this.channel.call("getElements",[f,E,P])}getElementXY(f,E,P,k){return this.channel.call("getElementXY",[f,E,P,k])}typeInEditor(f,E,P){return this.channel.call("typeInEditor",[f,E,P])}getTerminalBuffer(f,E){return this.channel.call("getTerminalBuffer",[f,E])}writeInTerminal(f,E,P){return this.channel.call("writeInTerminal",[f,E,P])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=R;class L{constructor(f){this.registry=f}listen(f,E){throw new Error(`Event not found: ${E}`)}call(f,E,P){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(P);case"reloadWindowDriver":return this.registry.reloadWindowDriver(P)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=L;async function C(S){const f=await(0,m.connect)(S,"driverClient"),E=f.getChannel("driver"),P=new R(E);return{client:f,driver:P}}e.connect=C}),define(Z[22],x([0,1,46,7,58,52,170,5]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,S.refineServiceDecorator)(L.IEnvironmentService);class f extends C.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,R.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([m.memoize],f.prototype,"cachedLanguagesPath",null),ue([m.memoize],f.prototype,"backupHome",null),ue([m.memoize],f.prototype,"backupWorkspacesPath",null),ue([m.memoize],f.prototype,"mainIPCHandle",null),ue([m.memoize],f.prototype,"mainLockfile",null),ue([m.memoize],f.prototype,"sandbox",null),ue([m.memoize],f.prototype,"driverVerbose",null),ue([m.memoize],f.prototype,"disableUpdates",null),ue([m.memoize],f.prototype,"disableKeytar",null),ue([m.memoize],f.prototype,"codeCachePath",null),ue([m.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[230],x([0,1,61,29,28,10,7,3,17,8,24,163,18,22,21,6,162,25]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let M=class{constructor(u,l,o){this.configurationService=l,this.logService=o,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(d,r)=>(0,R.isEqual)(d,r,!S.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await P.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let l=[];try{Array.isArray(u.rootURIWorkspaces)&&(l=u.rootURIWorkspaces.map(d=>({workspace:{id:d.id,configPath:E.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(l);let o=[];try{Array.isArray(u.folderWorkspaceInfos)?o=u.folderWorkspaceInfos.map(d=>({folderUri:E.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(o=u.folderURIWorkspaces.map(d=>({folderUri:E.URI.parse(d),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(o),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,l){this.workspaces.some(d=>u.workspace.id===d.workspace.id)||(this.workspaces.push(u),this.saveSync());const o=this.getBackupPath(u.workspace.id);return l&&this.moveBackupFolderSync(o,l),o}moveBackupFolderSync(u,l){if(n.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),n.existsSync(l))try{n.renameSync(l,u)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}unregisterWorkspaceBackupSync(u){const l=u.id,o=this.workspaces.findIndex(d=>d.workspace.id===l);o!==-1&&(this.workspaces.splice(o,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(l=>this.backupUriComparer.isEqual(u.folderUri,l.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const l=this.folders.findIndex(o=>this.backupUriComparer.isEqual(u,o.folderUri));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(u,l){const o=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(d=>!!d.backupFolder&&this.backupPathComparer.isEqual(d.backupFolder,o))||(this.emptyWindows.push({backupFolder:o,remoteAuthority:l}),this.saveSync()),this.getBackupPath(o)}unregisterEmptyWindowBackupSync(u){const l=this.emptyWindows.findIndex(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,u));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(u){return(0,C.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const l=new Set,o=[];for(let d of u){const r=d.workspace;if(!(0,v.isWorkspaceIdentifier)(r))return[];if(!l.has(r.id)){l.add(r.id);const i=this.getBackupPath(r.id);await this.doHasBackups(i)?r.configPath.scheme!==L.Schemas.file||await P.Promises.exists(r.configPath.fsPath)?o.push(d):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return o}async validateFolders(u){if(!Array.isArray(u))return[];const l=[],o=new Set;for(let d of u){const r=d.folderUri,i=this.backupUriComparer.getComparisonKey(r);if(!o.has(i)){o.add(i);const s=this.getBackupPath(this.getFolderHash(d));await this.doHasBackups(s)?r.scheme!==L.Schemas.file||await P.Promises.exists(r.fsPath)?l.push(d):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const l=[],o=new Set;for(let d of u){const r=d.backupFolder;if(typeof r!="string")return[];if(!o.has(r)){o.add(r);const i=this.getBackupPath(r);await this.doHasBackups(i)?l.push(d):await this.deleteStaleBackup(i)}}return l}async deleteStaleBackup(u){try{await P.Promises.exists(u)&&await P.Promises.rm(u,P.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(d=>!!d.backupFolder&&this.backupPathComparer.isEqual(d.backupFolder,l));)l=this.getRandomEmptyWindowId();const o=this.getBackupPath(l);try{await P.Promises.rename(u,o)}catch(d){return this.logService.error(`Backup: Could not rename backup folder: ${d.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(d=>!!d.backupFolder&&this.backupPathComparer.isEqual(d.backupFolder,l));)l=this.getRandomEmptyWindowId();const o=this.getBackupPath(l);try{n.renameSync(u,o)}catch(d){return this.logService.error(`Backup: Could not rename backup folder: ${d.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const u=[];for(const l of this.workspaces)await this.hasBackups(l)&&u.push(l);for(const l of this.folders)await this.hasBackups(l)&&u.push(l);return u}hasBackups(u){let l;return(0,k.isEmptyWindowBackupInfo)(u)?l=u.backupFolder:(0,y.isFolderBackupInfo)(u)?l=this.getBackupPath(this.getFolderHash(u)):l=this.getBackupPath(u.workspace.id),this.doHasBackups(l)}async doHasBackups(u){try{const l=await P.Promises.readdir(u);for(const o of l)try{if((await P.Promises.readdir((0,C.join)(u,o))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await P.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const l=u.folderUri;let o;return l.scheme===L.Schemas.file?o=S.isLinux?l.fsPath:l.fsPath.toLowerCase():o=l.toString().toLowerCase(),(0,m.createHash)("md5").update(o).digest("hex")}};M=ue([ne(0,w.IEnvironmentMainService),ne(1,I.IConfigurationService),ne(2,h.ILogService)],M),e.BackupMainService=M}),define(Z[231],x([0,1,9,4,110,60,2,3,37,58,165,229,22,185,20,32,21,8,7,16,6]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function l(r){return r<21}let o=class{constructor(i,s,a,c,b,p,D){this.windowServer=i,this.options=s,this.windowsMainService=a,this.lifecycleMainService=c,this.fileService=b,this.environmentMainService=p,this.logService=D,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(s=>s.id).filter(s=>this.registeredWindowIds.has(s)&&!this.reloadingWindowIds.has(s))}async capturePage(i){const s=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!s?.win)throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,s){}async stopTracing(i,s,a){if(!a)return;const c=await this.capturePage(i),b=Buffer.from(c,"base64");await this.fileService.writeFile(v.URI.file((0,M.join)(this.environmentMainService.logsPath,`${s}.png`)),g.VSBuffer.wrap(b))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const s=this.windowsMainService.getWindowById(i);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(s)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,s){await this.whenUnfrozen(i);const a=R.KeybindingParser.parseUserBinding(s);for(let c of a)await this._dispatchKeybinding(i,c)}async _dispatchKeybinding(i,s){if(s instanceof L.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const a=this.windowsMainService.getWindowById(i);if(!a?.win)throw new Error("Invalid window");const c=a.win.webContents,b=new L.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),D=new w.USLayoutResolvedKeybinding(b.toChord(),S.OS).getElectronAccelerator(),F=[];s.ctrlKey&&F.push("ctrl"),s.metaKey&&F.push("meta"),s.shiftKey&&F.push("shift"),s.altKey&&F.push("alt"),c.sendInputEvent({type:"keyDown",keyCode:D,modifiers:F}),l(s.keyCode)||c.sendInputEvent({type:"char",keyCode:D,modifiers:F}),c.sendInputEvent({type:"keyUp",keyCode:D,modifiers:F}),await(0,m.timeout)(100)}async click(i,s,a,c){await(await this.getWindowDriver(i)).click(s,a,c)}async doubleClick(i,s){await(await this.getWindowDriver(i)).doubleClick(s)}async setValue(i,s,a){await(await this.getWindowDriver(i)).setValue(s,a)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,s){return await(await this.getWindowDriver(i)).isActiveElement(s)}async getElements(i,s,a){return await(await this.getWindowDriver(i)).getElements(s,a)}async getElementXY(i,s,a,c){return await(await this.getWindowDriver(i)).getElementXY(s,a,c)}async typeInEditor(i,s,a){await(await this.getWindowDriver(i)).typeInEditor(s,a)}async getTerminalBuffer(i,s){return await(await this.getWindowDriver(i)).getTerminalBuffer(s)}async writeInTerminal(i,s,a){await(await this.getWindowDriver(i)).writeInTerminal(s,a)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const s=`window:${i}`,a=new f.StaticRouter(b=>b===s),c=this.windowServer.getChannel("windowDriver",a);return new P.WindowDriverChannelClient(c)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};o=ue([ne(2,h.IWindowsMainService),ne(3,t.ILifecycleMainService),ne(4,y.IFileService),ne(5,I.IEnvironmentMainService),ne(6,u.ILogService)],o),e.Driver=o;async function d(r,i,s,a){const c=s.driverVerbose,b=a.createInstance(o,r,{verbose:c}),p=new k.WindowDriverRegistryChannel(b);r.registerChannel("windowDriverRegistry",p);const D=await(0,E.serve)(i),F=new k.DriverChannel(b);return D.registerChannel("driver",F),(0,C.combinedDisposable)(D,r)}e.serve=d}),define(Z[232],x([0,1,62,58]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,C,S,f){const E=k=>f(k,void 0),P=m.createConnection({host:R,port:L},()=>{P.removeListener("error",E);const k=Buffer.alloc(16);for(let h=0;h<16;h++)k[h]=Math.round(Math.random()*256);const I=k.toString("base64"),w=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}/?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];P.write(w.join(`\r
`)+`\r
\r
`);const t=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",t),f(void 0,new n.NodeSocket(P,S)))};P.on("data",t)});P.setNoDelay(!0),P.once("error",E)}}}),define(Z[233],x([0,1,203,9,16,15,2,14,18,52,97,6,202,228]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends C.Disposable{constructor(y,v,M){super();this.environmentService=v,this.logService=M,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,v){this.logService.trace("RequestService#request",y.url);const{proxyUrl:M,strictSSL:g}=this;let u;try{u=await(0,P.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(d){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",d))}const l={...process.env,...u},o=y.agent?y.agent:await(0,I.getProxyAgent)(y.url||"",l,{proxyUrl:M,strictSSL:g});return y.agent=o,y.strictSSL=g,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization}),this._request(y,v)}async getNodeRequest(y){return((0,m.parse)(y.url).protocol==="https:"?await new Promise((g,u)=>{H(["https"],g,u)}):await new Promise((g,u)=>{H(["http"],g,u)})).request}_request(y,v){return n.Promises.withAsyncBody(async(M,g)=>{let u;const l=(0,m.parse)(y.url),o=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),d={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,S.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(d.auth=y.user+":"+y.password),u=o(d,r=>{const i=(0,S.isNumber)(y.followRedirects)?y.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...y,url:r.headers.location,followRedirects:i-1},v).then(M,g);else{let s=r;r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,w.createGunzip)())),M({res:r,stream:(0,R.streamToBufferReadableStream)(s)})}}),u.on("error",g),y.timeout&&u.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&u.write(y.data),u.end(),v.onCancellationRequested(()=>{u.abort(),g((0,L.canceled)())})})}async resolveProxy(y){}};t=ue([ne(0,f.IConfigurationService),ne(1,E.INativeEnvironmentService),ne(2,k.ILogService)],t),e.RequestService=t}),define(Z[234],x([0,1,12,233]),function(H,e,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(C){return m.net.request}class L extends n.RequestService{request(S,f){return super.request({...S||{},getRawRequest:R},f)}}e.RequestMainService=L}),define(Z[235],x([0,1,12,9,4,2,10,14,89,22,20,6,53,54,57,39]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let y=class extends L.Disposable{constructor(M,g,u,l,o,d,r){super();this.machineId=M,this.userEnv=g,this.environmentMainService=u,this.lifecycleMainService=l,this.logService=o,this.themeMainService=d,this.protocolMainService=r,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){m.ipcMain.on("vscode:createSharedProcessMessageChannel",(M,g)=>this.onWindowConnection(M,g)),m.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(M,g)=>this.onWorkerConnection(M,g)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(M,g){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const u=await this.connect();if(M.sender.isDestroyed())return u.close();M.sender.postMessage("vscode:createSharedProcessMessageChannelResult",g,[u])}onWorkerConnection(M,g){this.logService.trace("SharedProcess: onWorkerConnection",g);const u=new L.DisposableStore,l=d=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${d}')`,g),u.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",g))},o=m.BrowserWindow.fromId(g.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!g.reply.channel){l("unavailable");return}u.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,d=>d.window.win===o)(()=>l("load"))),u.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>l("closed"))),o.webContents.postMessage(g.reply.channel,g.reply.nonce,M.ports)}onWillShutdown(){const M=this.window;!M||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(M.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{M.close()}catch{}this.window=void 0},0))}send(M,...g){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${M}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(M,...g)}catch(u){this.logService.warn(`Error sending IPC message to channel '${M}' of shared process: ${(0,h.toErrorMessage)(u)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(M=>m.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),M()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(M=>m.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),M()}))})()),this._whenIpcReady}createWindow(){const M=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new m.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),M.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=M=>{this.logService.trace("SharedProcess#close prevented"),M.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(M,g)=>this._onDidError.fire({type:2,details:g})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(M,g,u)=>this._onDidError.fire({type:3,details:{reason:u,exitCode:g}})))}async connect(){await this.whenIpcReady;const M=(0,S.assertIsDefined)(this.window);return(0,f.connect)(M)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const M=this.window;return M?!M.isDestroyed()&&!M.webContents.isDestroyed():!1}};y=ue([ne(2,E.IEnvironmentMainService),ne(3,P.ILifecycleMainService),ne(4,k.ILogService),ne(5,t.IThemeMainService),ne(6,w.IProtocolMainService)],y),e.SharedProcess=y}),define(Z[236],x([0,1,9,16,7,14,8,22,21,6]),function(H,e,m,n,R,L,C,S,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class P{constructor(w,t,h){this.storagePath=w,this.logService=t,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new m.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,t){const h=this.storage[w];return(0,L.isUndefinedOrNull)(h)?t:h}setItem(w,t){this.setItems([{key:w,data:t}])}setItems(w){let t=!1;for(const{key:h,data:y}of w)this.storage[h]!==y&&((0,L.isUndefinedOrNull)(y)?(0,L.isUndefined)(this.storage[h])||(this.storage[h]=void 0,t=!0):(this.storage[h]=y,t=!0));t&&this.save()}removeItem(w){(0,L.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=P;let k=class kt{constructor(w,t,h){this.fileStorage=new P(C.URI.file((0,R.join)(w.userDataPath,kt.STATE_FILE)),t,h)}async init(){return this.fileStorage.init()}getItem(w,t){return this.fileStorage.getItem(w,t)}setItem(w,t){this.fileStorage.setItem(w,t)}setItems(w){this.fileStorage.setItems(w)}removeItem(w){this.fileStorage.removeItem(w)}close(){return this.fileStorage.close()}};k.STATE_FILE="storage.json",k=ue([ne(0,S.IEnvironmentMainService),ne(1,E.ILogService),ne(2,f.IFileService)],k),e.StateMainService=k}),define(Z[81],x([0,1,43,2,52,22,5,20,6,98,225]),function(H,e,m,n,R,L,C,S,f,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let k=class extends n.Disposable{constructor(t,h,y){super();this.logService=t,this.environmentService=h,this.lifecycleMainService=y,this.shutdownReason=void 0,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=t.reason,t.join(this.globalStorage.close());for(const[,h]of this.mapWorkspaceToStorage)t.join(h.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const t=new P.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}workspaceStorage(t){let h=this.mapWorkspaceToStorage.get(t.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),h=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,h),(0,m.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),h}createWorkspaceStorage(t){return this.shutdownReason===2?new P.InMemoryStorageMain(this.logService):new P.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}};k=ue([ne(0,f.ILogService),ne(1,R.IEnvironmentService),ne(2,S.ILifecycleMainService)],k),e.StorageMainService=k,e.IGlobalStorageMainService=(0,C.createDecorator)("globalStorageMainService");let I=class extends E.AbstractStorageService{constructor(t,h){super();this.environmentMainService=t,this.storageMainService=h,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};I=ue([ne(0,L.IEnvironmentMainService),ne(1,e.IStorageMainService)],I),e.GlobalStorageMainService=I}),define(Z[237],x([0,1,62,123,232,9,2,18,6,19,201,99,79]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(M,g,u,l,o){let d;for(let r=3;r&&(d&&d.dispose(),d=await new t(M,g,u,l,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[d.tunnelLocalPort]));r--);return d}class t extends C.Disposable{constructor(g,u,l,o,d){super();this.defaultTunnelHost=u,this.suggestedLocalPort=d,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=m.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let g=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(g){g.pause();const u=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),o=l.getSocket().socket,d=l.readEntireBuffer();l.dispose(),d.byteLength>0&&g.write(d.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),o.end()}),g.on("close",()=>o.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),o.destroy()}),o.on("end",()=>g.end()),o.on("close",()=>g.end()),o.on("error",()=>{g.destroy()}),g.pipe(o),o.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),o.end()})}}let h=class extends k.AbstractTunnelService{constructor(g,u,l,o,d){super(u);this.socketFactory=g,this.signService=l,this.productService=o,this.configurationService=d}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,u,l,o,d,r,i){const s=this.getTunnelFromMap(u,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,l,o,d,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${l} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},c=w(a,this.defaultTunnelHost,u,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,l,c),c}}};h=ue([ne(1,f.ILogService),ne(2,I.ISignService),ne(3,E.IProductService),ne(4,S.IConfigurationService)],h),e.BaseTunnelService=h;let y=class extends h{constructor(g,u,l,o){super(R.nodeSocketFactory,g,u,l,o)}};y=ue([ne(0,f.ILogService),ne(1,I.ISignService),ne(2,E.IProductService),ne(3,S.IConfigurationService)],y),e.TunnelService=y;let v=class extends C.Disposable{constructor(g,u,l,o){super();this.logService=g,this.productService=u,this.signService=l,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(g,u,l,o,d,r,i,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${o} on local port ${d}.`),!this._tunnelServices.has(g)){const a=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(g,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(u,l,o,d,r,i,s)}};v=ue([ne(0,f.ILogService),ne(1,E.IProductService),ne(2,I.ISignService),ne(3,S.IConfigurationService)],v),e.SharedTunnelsService=v}),define(Z[82],x([0,1,9,23,4,18,22,20,6,19,56,41]),function(H,e,m,n,R,L,C,S,f,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(t,h,y){return`${y.updateUrl}/api/update/${t}/${h}/${y.commit}`}e.createUpdateURL=I;let w=class{constructor(h,y,v,M,g,u){this.lifecycleMainService=h,this.configurationService=y,this.environmentMainService=v,this.requestService=M,this.logService=g,this.productService=u,this._state=k.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),y=this.getProductQuality(h);if(!y){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(y),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,m.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};w=ue([ne(0,S.ILifecycleMainService),ne(1,L.IConfigurationService),ne(2,C.IEnvironmentMainService),ne(3,P.IRequestService),ne(4,f.ILogService),ne(5,E.IProductService)],w),e.AbstractUpdateService=w}),define(Z[238],x([0,1,12,46,4,2,18,22,20,6,19,56,34,41,82]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends t.AbstractUpdateService{constructor(v,M,g,u,l,o,d){super(v,M,u,l,o,d);this.telemetryService=g,this.disposables=new L.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"error",(v,M)=>M)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(v,M,g)=>({url:M,version:g,productVersion:g}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(v,M,g,u)=>({releaseNotes:M,version:g,productVersion:g,date:u}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(w.State.Idle(1,g))}buildUpdateFeedUrl(v){let M;this.productService.darwinUniversalAssetId?M=this.productService.darwinUniversalAssetId:M=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,t.createUpdateURL)(M,v,this.productService);try{m.autoUpdater.setFeedURL({url:g})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return g}doCheckForUpdates(v){this.setState(w.State.CheckingForUpdates(v)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(w.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],h.prototype,"onRawError",null),ue([n.memoize],h.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateDownloaded",null),h=ue([ne(0,f.ILifecycleMainService),ne(1,C.IConfigurationService),ne(2,I.ITelemetryService),ne(3,S.IEnvironmentMainService),ne(4,k.IRequestService),ne(5,E.ILogService),ne(6,P.IProductService)],h),e.DarwinUpdateService=h}),define(Z[239],x([0,1,45,29,9,4,7,22,20,6,34,41]),function(H,e,m,n,R,L,C,S,f,E,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(h,y,v){if(this.lifecycleMainService=h,this.logService=v,this._state=k.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event,y.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,M=>this.logService.error(M))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,R.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([ne(0,f.ILifecycleMainService),ne(1,S.IEnvironmentMainService),ne(2,E.ILogService)],I);let w=class extends I{constructor(h,y,v,M,g,u){super(v,M,g);this.snap=h,this.snapRevision=y,this.telemetryService=u;const l=(0,n.watch)(C.dirname(this.snap)),o=L.Event.fromNodeEventEmitter(l,"change",(s,a)=>a),d=L.Event.filter(o,s=>s==="current"),i=L.Event.debounce(d,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,m.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((v,M)=>(0,n.realpath)(`${C.dirname(this.snap)}/current`,(g,u)=>g?M(g):v(u))),y=C.basename(h);return this.snapRevision!==y}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=ue([ne(2,f.ILifecycleMainService),ne(3,S.IEnvironmentMainService),ne(4,E.ILogService),ne(5,P.ITelemetryService)],w),e.SnapUpdateService=w}),define(Z[42],x([0,1,12,29,4,44,33,2,10,7,3,17,14,24,161,51,47,22,5,6,19,102,25,80,103]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,M.createDecorator)("workspacesManagementMainService");let i=class extends S.Disposable{constructor(a,c,b,p,D){super();this.environmentMainService=a,this.logService=c,this.backupMainService=b,this.dialogMainService=p,this.productService=D,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new R.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new R.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,c=>(0,n.readFileSync)(c,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,c=>w.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(a,c){if(!!this.isWorkspacePath(a)&&a.scheme===f.Schemas.file)try{const b=c(a.fsPath);return b instanceof Promise?b.then(p=>this.doResolveWorkspace(a,p),p=>{}):this.doResolveWorkspace(a,b)}catch{return}}isWorkspacePath(a){return(0,o.isUntitledWorkspace)(a,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,c){try{const b=this.doParseStoredWorkspace(a,c),p=(0,r.getWorkspaceIdentifier)(a);return{id:p.id,configPath:p.configPath,folders:(0,d.toWorkspaceFolders)(b.folders,p.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:b.remoteAuthority,transient:b.transient}}catch(b){this.logService.warn(b.toString())}}doParseStoredWorkspace(a,c){const b=(0,L.parse)(c);if(b&&Array.isArray(b.folders))b.folders=b.folders.filter(p=>(0,d.isStoredWorkspaceFolder)(p));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return b}async createUntitledWorkspace(a,c){const{workspace:b,storedWorkspace:p}=this.newUntitledWorkspace(a,c),D=b.configPath.fsPath;return await w.Promises.mkdir((0,E.dirname)(D),{recursive:!0}),await w.Promises.writeFile(D,JSON.stringify(p,null,"	")),b}createUntitledWorkspaceSync(a,c){const{workspace:b,storedWorkspace:p}=this.newUntitledWorkspace(a,c),D=b.configPath.fsPath;return(0,n.mkdirSync)((0,E.dirname)(D),{recursive:!0}),(0,w.writeFileSync)(D,JSON.stringify(p,null,"	")),b}newUntitledWorkspace(a=[],c){const b=(Date.now()+Math.round(Math.random()*1e3)).toString(),p=(0,k.joinPath)(this.untitledWorkspacesHome,b),D=(0,k.joinPath)(p,o.UNTITLED_WORKSPACE_NAME),F=[];for(const U of a)F.push((0,d.getStoredWorkspaceFolder)(U.uri,!0,U.name,p,!P.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(D),storedWorkspace:{folders:F,remoteAuthority:c}}}async getWorkspaceIdentifier(a){return(0,r.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,o.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const c=(0,k.originalFSPath)(a.configPath);try{(0,w.rimrafSync)((0,E.dirname)(c));const b=(0,E.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,n.existsSync)(b)&&(0,w.writeFileSync)((0,E.join)(b,"obsolete"),"")}catch(b){this.logService.warn(`Unable to delete untitled workspace ${c} (${b}).`)}}getUntitledWorkspacesSync(){const a=[];try{const c=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(b=>(0,k.joinPath)(this.untitledWorkspacesHome,b,o.UNTITLED_WORKSPACE_NAME));for(const b of c){const p=(0,r.getWorkspaceIdentifier)(b),D=this.resolveLocalWorkspaceSync(b);D?a.push({workspace:p,remoteAuthority:D.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(p)}}catch(c){c.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${c}).`)}return a}async enterWorkspace(a,c,b){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,c,b))return;const D=this.doEnterWorkspace(a,(0,r.getWorkspaceIdentifier)(b));if(!!D)return this._onDidEnterWorkspace.fire({window:a,workspace:D.workspace}),D}async isValidTargetWorkspacePath(a,c,b){if(!b)return!0;if((0,o.isWorkspaceIdentifier)(a.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,b))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(c,b)){const p={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,k.basename)(b)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(p,(0,I.withNullAsUndefined)(m.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,c){if(!a.config)return;a.focus();let b;return a.config.extensionDevelopmentPath||(b=this.backupMainService.registerWorkspaceBackupSync({workspace:c,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,o.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=c,a.config.backupPath=b,{workspace:c,backupPath:b}}};i=ue([ne(0,v.IEnvironmentMainService),ne(1,g.ILogService),ne(2,h.IBackupMainService),ne(3,y.IDialogMainService),ne(4,u.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Z[104],x([0,1,12,23,5,32,25,42]),function(H,e,m,n,R,L,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let f=class{constructor(P,k){this.windowsMainService=P,this.workspacesManagementMainService=k}async getRemoteDiagnostics(P){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(w=>new Promise(t=>{const h=w.remoteAuthority;if(h){const y=`vscode:getDiagnosticInfoResponse${w.id}`,v={includeProcesses:P.includeProcesses,folders:P.includeWorkspaceMetadata?this.getFolderURIs(w):void 0};w.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:y,args:v}),m.ipcMain.once(y,(M,g)=>{g||t({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),t(g)}),setTimeout(()=>{t({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else t(void 0)})))).filter(w=>!!w)}getFolderURIs(P){const k=[],I=P.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(I))k.push(I.uri);else if((0,C.isWorkspaceIdentifier)(I)){const w=this.workspacesManagementMainService.resolveLocalWorkspaceSync(I.configPath);w&&w.folders.forEach(h=>{k.push(h.uri)})}return k}};f=ue([ne(0,L.IWindowsMainService),ne(1,S.IWorkspacesManagementMainService)],f),e.DiagnosticsMainService=f}),define(Z[105],x([0,1,12,30,3,14,8,24,18,50,5,6,100,32,25,42]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let y=class{constructor(M,g,u,l,o){this.logService=M,this.windowsMainService=g,this.urlService=u,this.workspacesManagementMainService=l,this.configurationService=o}async start(M,g){this.logService.trace("Received data from other instance: ",M,g),R.isMacintosh&&m.app.focus({steal:!0});const u=this.parseOpenUrl(M);if(u.length){let l=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(l=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),l.then(()=>{for(const{uri:o,url:d}of u)this.urlService.open(o,{originalUrl:d})})}else return this.startOpenWindow(M,g)}parseOpenUrl(M){return M["open-url"]&&M._urls&&M._urls.length>0?(0,n.coalesce)(M._urls.map(g=>{try{return{uri:C.URI.parse(g),url:g}}catch{return null}})):[]}async startOpenWindow(M,g){const u=(0,E.isLaunchedFromCli)(g)?0:4;let l=[];const o=M.wait&&M.waitMarkerFilePath?C.URI.file(M.waitMarkerFilePath):void 0,d=M.remote||void 0,r={context:u,cli:M,userEnv:g,waitMarkerFileURI:o,remoteAuthority:d};if(M.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(M.extensionDevelopmentPath,r);else if(!M._.length&&!M["folder-uri"]&&!M["file-uri"]){let i=!1;if(M["new-window"]||M["unity-launch"])i=!0;else if(M["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!R.isMacintosh}if(i)l=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,r),l=[s]):l=this.windowsMainService.open({...r,forceEmpty:!0})}}else l=this.windowsMainService.open({...r,forceNewWindow:M["new-window"],preferNewWindow:!M["reuse-window"]&&!M.wait,forceReuseWindow:M["reuse-window"],diffMode:M.diff,addMode:M.add,noRecentEntry:!!M["skip-add-to-recently-opened"],gotoLineMode:M.goto});if(o&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,S.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const M=[];return m.BrowserWindow.getAllWindows().forEach(g=>{const u=this.windowsMainService.getWindowById(g.id);u?M.push(this.codeWindowToInfo(u)):M.push(this.browserWindowToInfo(g))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:M,screenReader:!!m.app.accessibilitySupportEnabled,gpuFeatureStatus:m.app.getGPUFeatureStatus()}}getFolderURIs(M){const g=[],u=M.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(u))g.push(u.uri);else if((0,t.isWorkspaceIdentifier)(u)){const l=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);l&&l.folders.forEach(d=>{g.push(d.uri)})}return g}codeWindowToInfo(M){const g=this.getFolderURIs(M),u=(0,L.assertIsDefined)(M.win);return this.browserWindowToInfo(u,g,M.remoteAuthority)}browserWindowToInfo(M,g=[],u){return{pid:M.webContents.getOSProcessId(),title:M.getTitle(),folderURIs:g,remoteAuthority:u}}};y=ue([ne(0,k.ILogService),ne(1,w.IWindowsMainService),ne(2,I.IURLService),ne(3,h.IWorkspacesManagementMainService),ne(4,f.IConfigurationService)],y),e.LaunchMainService=y}),define(Z[59],x([0,1,45,12,26,122,46,4,33,2,10,7,3,8,86,72,24,152,47,22,5,20,6,19,57,32,25,42]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o,d,r,i,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,u.createDecorator)("nativeHostMainService");let c=class extends E.Disposable{constructor(p,D,F,U,Q,te,ie,ee,$){super();this.sharedProcess=p,this.windowsMainService=D,this.dialogMainService=F,this.lifecycleMainService=U,this.environmentMainService=Q,this.logService=te,this.productService=ie,this.themeMainService=ee,this.workspacesManagementMainService=$,this.onDidOpenWindow=S.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(Y,j)=>j.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new S.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(Y,j,q)=>q),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),S.Event.fromNodeEventEmitter(n.screen,"display-added"),S.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(D=>({id:D.id,workspace:D.openedWorkspace,title:D.win?.getTitle()??"",filename:D.getRepresentedFilename(),dirty:D.isDocumentEdited()}))}async getWindowCount(p){return this.windowsMainService.getWindowCount()}async getActiveWindowId(p){const D=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(D)return D.id}openWindow(p,D,F){return Array.isArray(D)?this.doOpenWindow(p,D,F):this.doOpenEmptyWindow(p,D)}async doOpenWindow(p,D,F=Object.create(null)){D.length>0&&this.windowsMainService.open({context:5,contextWindowId:p,urisToOpen:D,cli:this.environmentMainService.args,forceNewWindow:F.forceNewWindow,forceReuseWindow:F.forceReuseWindow,preferNewWindow:F.preferNewWindow,diffMode:F.diffMode,addMode:F.addMode,gotoLineMode:F.gotoLineMode,noRecentEntry:F.noRecentEntry,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:F.remoteAuthority||void 0})}async doOpenEmptyWindow(p,D){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:p},D)}async toggleFullScreen(p){const D=this.windowById(p);D&&D.toggleFullScreen()}async handleTitleDoubleClick(p){const D=this.windowById(p);D&&D.handleTitleDoubleClick()}async isMaximized(p){const D=this.windowById(p);return D?.win?D.win.isMaximized():!1}async maximizeWindow(p){const D=this.windowById(p);D?.win&&D.win.maximize()}async unmaximizeWindow(p){const D=this.windowById(p);D?.win&&D.win.unmaximize()}async minimizeWindow(p){const D=this.windowById(p);D?.win&&D.win.minimize()}async focusWindow(p,D){D&&typeof D.windowId=="number"&&(p=D.windowId);const F=this.windowById(p);F&&F.focus({force:D?.force??!1})}async setMinimumSize(p,D,F){const U=this.windowById(p);if(U?.win){const[Q,te]=U.win.getSize(),[ie,ee]=U.win.getMinimumSize(),[$,Y]=[D??ie,F??ee],[j,q]=[Math.max(Q,$),Math.max(te,Y)];(ie!==$||ee!==Y)&&U.win.setMinimumSize($,Y),(Q!==j||te!==q)&&U.win.setSize(j,q)}}async saveWindowSplash(p,D){this.themeMainService.saveWindowSplash(p,D)}async installShellCommand(p){const{source:D,target:F}=await this.getShellCommandLink();try{const{symbolicLink:U}=await y.SymlinkSupport.stat(D);if(U&&!U.dangling){const Q=await(0,t.realpath)(D);if(F===Q)return}await y.Promises.unlink(D)}catch(U){if(U.code!=="ENOENT")throw U}try{await y.Promises.symlink(F,D)}catch(U){if(U.code!=="EACCES"&&U.code!=="ENOENT")throw U;const{response:Q}=await this.showMessageBox(p,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const te=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${F}' '${D}'\\" with administrator privileges"`;await(0,L.promisify)(m.exec)(te)}catch{throw new Error((0,v.localize)(3,null,D))}}}async uninstallShellCommand(p){const{source:D}=await this.getShellCommandLink();try{await y.Promises.unlink(D)}catch(F){switch(F.code){case"EACCES":{const{response:U}=await this.showMessageBox(p,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(U===0)try{const Q=`osascript -e "do shell script \\"rm '${D}'\\" with administrator privileges"`;await(0,L.promisify)(m.exec)(Q)}catch{throw new Error((0,v.localize)(7,null,D))}break}case"ENOENT":break;default:throw F}}}async getShellCommandLink(){const p=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),D=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(p))throw new Error((0,v.localize)(8,null,p));return{source:D,target:p}}async showMessageBox(p,D){return this.dialogMainService.showMessageBox(D,this.toBrowserWindow(p))}async showSaveDialog(p,D){return this.dialogMainService.showSaveDialog(D,this.toBrowserWindow(p))}async showOpenDialog(p,D){return this.dialogMainService.showOpenDialog(D,this.toBrowserWindow(p))}toBrowserWindow(p){const D=this.windowById(p);if(D?.win)return D.win}async pickFileFolderAndOpen(p,D){const F=await this.dialogMainService.pickFileFolder(D);F&&this.doOpenPicked(await Promise.all(F.map(async U=>await y.SymlinkSupport.existsDirectory(U)?{folderUri:w.URI.file(U)}:{fileUri:w.URI.file(U)})),D,p)}async pickFolderAndOpen(p,D){const F=await this.dialogMainService.pickFolder(D);F&&this.doOpenPicked(F.map(U=>({folderUri:w.URI.file(U)})),D,p)}async pickFileAndOpen(p,D){const F=await this.dialogMainService.pickFile(D);F&&this.doOpenPicked(F.map(U=>({fileUri:w.URI.file(U)})),D,p)}async pickWorkspaceAndOpen(p,D){const F=await this.dialogMainService.pickWorkspace(D);F&&this.doOpenPicked(F.map(U=>({workspaceUri:w.URI.file(U)})),D,p)}doOpenPicked(p,D,F){this.windowsMainService.open({context:3,contextWindowId:F,cli:this.environmentMainService.args,urisToOpen:p,forceNewWindow:D.forceNewWindow})}async showItemInFolder(p,D){n.shell.showItemInFolder(D)}async setRepresentedFilename(p,D){const F=this.windowById(p);F&&F.setRepresentedFilename(D)}async setDocumentEdited(p,D){const F=this.windowById(p);F&&F.setDocumentEdited(D)}async openExternal(p,D){return I.isLinuxSnap?this.safeSnapOpenExternal(D):n.shell.openExternal(D),!0}safeSnapOpenExternal(p){const D=process.env.GDK_PIXBUF_MODULE_FILE,F=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(p),process.env.GDK_PIXBUF_MODULE_FILE=D,process.env.GDK_PIXBUF_MODULEDIR=F}moveItemToTrash(p,D){return n.shell.trashItem(D)}async isAdmin(){let p;return I.isWindows?p=(await new Promise((D,F)=>{H(["native-is-elevated"],D,F)}))():p=process.getuid()===0,p}async writeElevated(p,D,F,U){const Q=await new Promise((te,ie)=>{H(["@vscode/sudo-prompt"],te,ie)});return new Promise((te,ie)=>{const ee=[`"${this.cliPath}"`];U?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${D.fsPath}"`,`"${F.fsPath}"`);const $={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};Q.exec(ee.join(" "),$,(Y,j,q)=>{j&&this.logService.trace(`[sudo-prompt] received stdout: ${j}`),q&&this.logService.trace(`[sudo-prompt] received stderr: ${q}`),Y?ie(Y):te(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(p,D,F){process.kill(D,F)}async readClipboardText(p,D){return n.clipboard.readText(D)}async writeClipboardText(p,D,F){return n.clipboard.writeText(D,F)}async readClipboardFindText(p){return n.clipboard.readFindText()}async writeClipboardFindText(p,D){return n.clipboard.writeFindText(D)}async writeClipboardBuffer(p,D,F,U){return n.clipboard.writeBuffer(D,Buffer.from(F),U)}async readClipboardBuffer(p,D){return n.clipboard.readBuffer(D)}async hasClipboard(p,D,F){return n.clipboard.has(D,F)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(p,D){const F=this.windowById(p);F&&F.updateTouchBar(D)}async notifyReady(p){const D=this.windowById(p);D&&D.setReady()}async relaunch(p,D){return this.lifecycleMainService.relaunch(D)}async reload(p,D){const F=this.windowById(p);if(F){if((0,s.isWorkspaceIdentifier)(F.openedWorkspace)){const U=F.openedWorkspace.configPath;if(U.scheme===P.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(U))?.transient)return this.openWindow(F.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(F,D?.disableExtensions!==void 0?{_:[],"disable-extensions":D.disableExtensions}:void 0)}}async closeWindow(p){this.closeWindowById(p,p)}async closeWindowById(p,D){const F=this.windowById(D);if(F?.win)return F.win.close()}async quit(p){const D=this.windowsMainService.getLastActiveWindow();D?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&D.win?D.win.close():this.lifecycleMainService.quit()}async exit(p,D){await this.lifecycleMainService.kill(D)}async resolveProxy(p,D){const U=this.windowById(p)?.win?.webContents?.session;if(U)return U.resolveProxy(D)}async openDevTools(p,D){const F=this.windowById(p);F?.win&&F.win.webContents.openDevTools(D)}async toggleDevTools(p){const D=this.windowById(p);D?.win&&D.win.webContents.toggleDevTools()}async sendInputEvent(p,D){const F=this.windowById(p);F?.win&&(D.type==="mouseDown"||D.type==="mouseUp")&&F.win.webContents.sendInputEvent(D)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(p,D,F,U){if(!I.isWindows)return;const Q=await new Promise((te,ie)=>{H(["@vscode/windows-registry"],te,ie)});try{return Q.GetStringRegKey(D,F,U)}catch{return}}windowById(p){if(typeof p=="number")return this.windowsMainService.getWindowById(p)}};ue([C.memoize],c.prototype,"cliPath",null),c=ue([ne(1,i.IWindowsMainService),ne(2,M.IDialogMainService),ne(3,l.ILifecycleMainService),ne(4,g.IEnvironmentMainService),ne(5,o.ILogService),ne(6,d.IProductService),ne(7,r.IThemeMainService),ne(8,a.IWorkspacesManagementMainService)],c),e.NativeHostMainService=c}),define(Z[240],x([0,1,12,26,33,2,10,3,87,150,75,104,47,22,5,105,6,59,53,19,54,67]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let o=class Mt{constructor(r,i,s,a,c,b,p,D,F,U){this.userEnv=r,this.environmentMainService=i,this.launchMainService=s,this.logService=a,this.diagnosticsService=c,this.diagnosticsMainService=b,this.dialogMainService=p,this.nativeHostMainService=D,this.protocolMainService=F,this.productService=U,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){m.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[i,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(i,s);this.safeSend(r,"vscode:issueSystemInfoResponse",a)}),m.ipcMain.on("vscode:listProcesses",async r=>{const i=[];try{const s=await this.launchMainService.getMainProcessId();i.push({name:(0,E.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(c=>{(0,P.isRemoteDiagnosticError)(c)?i.push({name:c.hostName,rootProcess:c}):c.processes&&i.push({name:c.hostName,rootProcess:c.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(r,"vscode:listProcessesResponse",i)}),m.ipcMain.on("vscode:issueReporterClipboard",async r=>{const i={title:this.productService.nameLong,message:(0,E.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",s.response===0)}}),m.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const i=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",i)}),m.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,E.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),m.ipcMain.on("vscode:workbenchCommand",(r,i)=>{const{id:s,from:a,args:c}=i;let b;switch(a){case"issueReporter":b=this.issueReporterParentWindow;break;case"processExplorer":b=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}b&&b.webContents.send("vscode:runAction",{id:s,from:a,args:c})}),m.ipcMain.on("vscode:openExternal",(r,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),m.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),m.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),m.ipcMain.on("vscode:windowsInfoRequest",async r=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",i.windows)})}safeSend(r,i,...s){r.sender.isDestroyed()||r.sender.send(i,...s)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=m.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new L.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:r.styles.backgroundColor,title:(0,E.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:M.default}),this.issueReporterWindow.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=m.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new L.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:r.styles.backgroundColor,title:(0,E.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:M.default}),this.processExplorerWindow.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,i,s,a){const c=new m.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:s.title,backgroundColor:s.backgroundColor||Mt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,l.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop,experimentalDarkMode:!0});return c.setMenuBarVisibility(!1),c}async getSystemStatus(){const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,i)}getWindowPosition(r,i,s){let a;const c=m.screen.getAllDisplays();if(c.length===1)a=c[0];else{if(S.isMacintosh){const D=m.screen.getCursorScreenPoint();a=m.screen.getDisplayNearestPoint(D)}!a&&r&&(a=m.screen.getDisplayMatching(r.getBounds())),a||(a=m.screen.getPrimaryDisplay()||c[0])}const b={width:i,height:s},p=a.bounds;return b.x=p.x+p.width/2-b.width/2,b.y=p.y+p.height/2-b.height/2,p.width>0&&p.height>0&&(b.x<p.x&&(b.x=p.x),b.y<p.y&&(b.y=p.y),b.x>p.x+p.width&&(b.x=p.x),b.y>p.y+p.height&&(b.y=p.y),b.width>p.width&&(b.width=p.width),b.height>p.height&&(b.height=p.height)),b}async getPerformanceInfo(){try{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,i)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};o.DEFAULT_BACKGROUND_COLOR="#1E1E1E",o=ue([ne(1,w.IEnvironmentMainService),ne(2,h.ILaunchMainService),ne(3,y.ILogService),ne(4,P.IDiagnosticsService),ne(5,k.IDiagnosticsMainService),ne(6,I.IDialogMainService),ne(7,v.INativeHostMainService),ne(8,u.IProtocolMainService),ne(9,g.IProductService)],o),e.IssueMainService=o}),define(Z[241],x([0,1,23,18,22,20,6,59,19,56,34,41,82]),function(H,e,m,n,R,L,C,S,f,E,P,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends I.AbstractUpdateService{constructor(h,y,v,M,g,u,l,o){super(h,y,M,g,u,o);this.telemetryService=v,this.nativeHostMainService=l}buildUpdateFeedUrl(h){return(0,I.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(k.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},m.CancellationToken.None).then(E.asJson).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(y))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const v=h?y.message||y:void 0;this.setState(k.State.Idle(1,v))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(k.State.Idle(1))}};w=ue([ne(0,L.ILifecycleMainService),ne(1,n.IConfigurationService),ne(2,P.ITelemetryService),ne(3,R.IEnvironmentMainService),ne(4,E.IRequestService),ne(5,C.ILogService),ne(6,S.INativeHostMainService),ne(7,f.IProductService)],w),e.LinuxUpdateService=w}),define(Z[242],x([0,1,45,29,26,9,23,46,7,8,119,24,18,22,21,20,6,59,19,56,34,41,82]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function d(a,c=1e3){for(;!a();)await(0,L.timeout)(c)}let r;function i(){return typeof r=="undefined"&&(r=n.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends o.AbstractUpdateService{constructor(c,b,p,D,F,U,Q,te,ie){super(c,b,D,F,U,ie);this.telemetryService=p,this.fileService=Q,this.nativeHostMainService=te}get cachePath(){const c=f.join((0,R.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(c,{recursive:!0}).then(()=>c)}initialize(){super.initialize()}buildUpdateFeedUrl(c){let b="win32";return process.arch!=="ia32"&&(b+=`-${process.arch}`),i()===1?b+="-archive":this.productService.target==="user"&&(b+="-user"),(0,o.createUpdateURL)(b,c,this.productService)}doCheckForUpdates(c){!this.url||(this.setState(l.State.CheckingForUpdates(c)),this.requestService.request({url:this.url},C.CancellationToken.None).then(g.asJson).then(b=>{const p=i();return!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c}),this.setState(l.State.Idle(p)),Promise.resolve(null)):p===1?(this.setState(l.State.AvailableForDownload(b)),Promise.resolve(null)):(this.setState(l.State.Downloading(b)),this.cleanup(b.version).then(()=>this.getUpdatePackagePath(b.version).then(D=>k.Promises.exists(D).then(F=>{if(F)return Promise.resolve(D);const U=b.url,Q=b.hash,te=`${D}.tmp`;return this.requestService.request({url:U},C.CancellationToken.None).then(ie=>this.fileService.writeFile(E.URI.file(te),ie.stream)).then(Q?()=>(0,P.checksum)(te,b.hash):()=>{}).then(()=>k.Promises.rename(te,D)).then(()=>D)})).then(D=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:D},F&&b.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(b)):this.setState(l.State.Ready(b))})))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c});const p=c?b.message||b:void 0;this.setState(l.State.Idle(i(),p))}))}async doDownloadUpdate(c){c.update.url&&this.nativeHostMainService.openExternal(void 0,c.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(c){const b=await this.cachePath;return f.join(b,`CodeSetup-${this.productService.quality}-${c}.exe`)}async cleanup(c=null){const b=c?U=>!new RegExp(`${this.productService.quality}-${c}\\.exe$`).test(U):()=>!0,p=await this.cachePath,F=(await k.Promises.readdir(p)).filter(b).map(async U=>{try{await k.Promises.unlink(f.join(p,U))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const c=this.state.update;this.setState(l.State.Updating(c));const b=await this.cachePath;this.availableUpdate.updateFilePath=f.join(b,`CodeSetup-${this.productService.quality}-${c.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,m.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const D=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,Q)=>{H(["windows-mutex"],U,Q)});d(()=>F.isActive(D)).then(()=>this.setState(l.State.Ready(c)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,m.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([S.memoize],s.prototype,"cachePath",null),s=ue([ne(0,h.ILifecycleMainService),ne(1,I.IConfigurationService),ne(2,u.ITelemetryService),ne(3,w.IEnvironmentMainService),ne(4,g.IRequestService),ne(5,y.ILogService),ne(6,t.IFileService),ne(7,v.INativeHostMainService),ne(8,M.IProductService)],s),e.Win32UpdateService=s}),define(Z[243],x([0,1,12,9,23,39,4,33,2,10,7,65,3,8,157,51,18,47,22,50,21,20,6,19,54,209,81,34,212,57,67,32,25,42,101]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o,d,r,i,s,a,c,b,p,D,F,U,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var te;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.NAVIGATING=1]="NAVIGATING",ee[ee.READY=2]="READY"})(te||(te={}));let ie=class extends f.Disposable{constructor($,Y,j,q,N,V,J,B,K,T,O,W,A,_,z){super();this.logService=Y,this.environmentMainService=j,this.fileService=q,this.globalStorageMainService=N,this.configurationService=V,this.themeMainService=J,this.workspacesManagementMainService=B,this.backupMainService=K,this.telemetryService=T,this.dialogMainService=O,this.lifecycleMainService=W,this.productService=A,this.protocolMainService=_,this.windowsMainService=z,this._onWillLoad=this._register(new C.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new C.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new C.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new C.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[X,se]=this.restoreWindowState($.state);this.windowState=X,this.logService.trace("window#ctor: using window state",X);const le=this.windowState.mode===0||this.windowState.mode===3,re=this.configurationService.getValue("window"),ae={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:p.WindowMinimumSize.WIDTH,minHeight:p.WindowMinimumSize.HEIGHT,show:!le,title:this.productService.nameLong,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,p.zoomLevelToZoomFactor)(re?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?ae.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(ae.icon=(0,P.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(ae.fullscreenable=!1),I.isMacintosh&&(ae.acceptFirstMouse=!0,re?.clickThroughInactive===!1&&(ae.acceptFirstMouse=!1));const fe=I.isMacintosh&&re?.nativeTabs===!0;fe&&(ae.tabbingIdentifier=this.productService.nameShort);const he=(0,p.getTitleBarStyle)(this.configurationService)==="custom";if(he&&(ae.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(ae.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new m.BrowserWindow(ae),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&he&&this._win.setSheetOffset(22),I.isMacintosh&&se&&(!fe||m.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(we=>typeof we=="number")){const we=this.windowState;this._win.setBounds({width:we.width,height:we.height,x:we.x,y:we.y})}le&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename($){I.isMacintosh?this._win.setRepresentedFilename($):this.representedFilename=$}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited($){I.isMacintosh&&this._win.setDocumentEdited($),this.documentEdited=$}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus($){I.isMacintosh&&$?.force&&m.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise($=>{if(this.isReady)return $(this);this.whenReadyCallbacks.push($)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise($=>{function Y(){j.dispose(),q.dispose(),$()}const j=this.onDidClose(()=>Y()),q=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Y,j)=>this.onWindowError(2,j)),this._win.webContents.on("did-fail-load",(Y,j,q)=>this.onWindowError(3,{reason:q,exitCode:j})),this._win.webContents.on("will-prevent-unload",Y=>{Y.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!0),m.app.emit("browser-window-maximize",Y,this._win)}),this._win.on("unmaximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!1),m.app.emit("browser-window-unmaximize",Y,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",R.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",R.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Y=>this.onDidDeleteUntitledWorkspace(Y)));const $=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:$},async(Y,j)=>{const q=await this.getMarketplaceHeaders();j({cancel:!1,requestHeaders:Object.assign(Y.requestHeaders,q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError($,Y){switch($){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Y?.reason||"<unknown>"}, code: ${Y?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Y?.reason||"<unknown>"}, code: ${Y?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:$,reason:Y?.reason,code:Y?.exitCode}),$){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if($===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(j.response!==1){const q=j.response===0;this.destroyWindow(q)}}else if($===2){let j;Y?j=(0,t.localize)(6,null,Y.reason,Y.exitCode??"<unknown>"):j=(0,t.localize)(5,null);const N=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(8,null))],message:j,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(N)}break}}destroyWindow($){if(this._onDidDestroy.fire(),this._win?.destroy(),$&&this.config){let Y,j;(0,F.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?Y={folderUri:this.openedWorkspace.uri}:(0,F.isWorkspaceIdentifier)(this.openedWorkspace)?Y={workspaceUri:this.openedWorkspace.configPath}:j=!0;const[q]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Y?[Y]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});q.focus()}}onDidDeleteUntitledWorkspace($){this.openedWorkspace?.id===$.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const $=this.getMenuBarVisibility();$!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=$,this.setMenuBarVisibility($));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Y?.endsWith("/")&&(Y=Y.substr(0,Y.length-1));const j=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||j!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=j;const q=Y||"",N=j?`${j},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${N}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:N,pacScript:""})}}addTabbedWindow($){I.isMacintosh&&$.win&&this._win.addTabbedWindow($.win)}load($,Y=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration($,Y),this.readyState===0?this.currentConfig=$:this.pendingLoadConfig=$,this.readyState=1,this._win.loadURL(E.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",H).toString(!0));const j=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:$.workspace,reason:Y.isReload?3:j?2:1})}updateConfiguration($,Y){const j=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(j){const q=(0,g.isLaunchedFromCli)(j)&&!(0,g.isLaunchedFromCli)($.userEnv),N=this.isExtensionDevelopmentHost;(q||N)&&($.userEnv={...j,...$.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign($.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&($["disable-extensions"]=Y.disableExtensions),$.fullscreen=this.isFullScreen,$.maximized=this._win.isMaximized(),$.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),$.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update($)}async reload($){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspaceBeforeReload(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&$&&(Y.verbose=$.verbose,Y.debugId=$.debugId,Y.extensionEnvironment=$.extensionEnvironment,Y["inspect-extensions"]=$["inspect-extensions"],Y["inspect-brk-extensions"]=$["inspect-brk-extensions"],Y["extensions-dir"]=$["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:$?.["disable-extensions"]})}async validateWorkspaceBeforeReload($){if((0,F.isWorkspaceIdentifier)($.workspace)){const Y=$.workspace.configPath;if(Y.scheme===E.Schemas.file&&!await this.fileService.exists(Y))return}else if((0,F.isSingleFolderWorkspaceIdentifier)($.workspace)){const Y=$.workspace.uri;if(Y.scheme===E.Schemas.file&&!await this.fileService.exists(Y))return}return $.workspace}serializeWindowState(){if(!this._win)return(0,Q.defaultWindowState)();if(this.isFullScreen){let j;try{j=m.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,Q.defaultWindowState)();return{mode:3,display:j?j.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const $=Object.create(null);let Y;if(!I.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?$.mode=0:$.mode=1,Y===1||Y===0){let j;Y===1?j=this.getBounds():j=this._win.getNormalBounds(),$.x=j.x,$.y=j.y,$.width=j.width,$.height=j.height}return $}restoreWindowState($){(0,k.mark)("code/willRestoreCodeWindowState");let Y=!1;if($)try{const j=m.screen.getAllDisplays();Y=j.length>1,$=this.validateWindowState($,j)}catch(j){this.logService.warn(`Unexpected error validating window state: ${j}
${j.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[$||(0,Q.defaultWindowState)(),Y]}validateWindowState($,Y){if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,$),typeof $.x!="number"||typeof $.y!="number"||typeof $.width!="number"||typeof $.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if($.width<=0||$.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const N=this.getWorkingArea(Y[0]);if(N){let V=function(){!$||typeof $.x!="number"||typeof $.y!="number"||!N||($.x<N.x&&($.x=N.x),$.y<N.y&&($.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),V(),$.width>N.width&&($.width=N.width),$.height>N.height&&($.height=N.height),$.x>N.x+N.width-128&&($.x=N.x+N.width-$.width),$.y>N.y+N.height-128&&($.y=N.y+N.height-$.height),V()}return $}if($.display&&$.mode===3){const N=Y.find(V=>V.id===$.display);if(N&&typeof N.bounds?.x=="number"&&typeof N.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,Q.defaultWindowState)(3);return V.x=N.bounds.x,V.y=N.bounds.y,V}}let j,q;try{j=m.screen.getDisplayMatching({x:$.x,y:$.y,width:$.width,height:$.height}),q=this.getWorkingArea(j)}catch{}if(j&&q&&$.x+$.width>q.x&&$.y+$.height>q.y&&$.x<q.x+q.width&&$.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),$}getWorkingArea($){if($.workArea.width>0&&$.workArea.height>0)return $.workArea;if($.bounds.width>0&&$.bounds.height>0)return $.bounds}getBounds(){const[$,Y]=this._win.getPosition(),[j,q]=this._win.getSize();return{x:$,y:Y,width:j,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen($){this.useNativeFullScreen()?this.setNativeFullScreen($):this.setSimpleFullScreen($),this.sendWhenReady($?"vscode:enterFullScreen":"vscode:leaveFullScreen",R.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen($){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen($)}setSimpleFullScreen($){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen($),this._win.webContents.focus()}useNativeFullScreen(){const $=this.configurationService.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let $=(0,p.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf($)<0&&($="classic"),$}setMenuBarVisibility($,Y=!0){I.isMacintosh||($==="toggle"&&Y&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),$==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility($)}):this.doSetMenuBarVisibility($))}doSetMenuBarVisibility($){const Y=this.isFullScreen;switch($){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(m.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady($,Y,...j){this.isReady?this.send($,...j):this.ready().then(()=>{Y.isCancellationRequested||this.send($,...j)})}send($,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${$}' for window that is destroyed`);return}try{this._win.webContents.send($,...Y)}catch(j){this.logService.warn(`Error sending IPC message to channel '${$}' of window ${this._id}: ${(0,L.toErrorMessage)(j)}`)}}}updateTouchBar($){!I.isMacintosh||this.touchBarGroups.forEach((Y,j)=>{const q=$[j];Y.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!I.isMacintosh){for(let $=0;$<10;$++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new m.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup($=[]){const Y=this.createTouchBarGroupSegments($),j=new m.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",R.CancellationToken.None,{id:j.segments[q].id,from:"touchbar"})}});return j}createTouchBarGroupSegments($=[]){return $.map(j=>{let q;j.icon&&!c.ThemeIcon.isThemeIcon(j.icon)&&j.icon?.dark?.scheme===E.Schemas.file&&(q=m.nativeImage.createFromPath(w.URI.revive(j.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let N;return typeof j.title=="string"?N=j.title:N=j.title.value,{id:j.id,label:q?void 0:N,icon:q}})}dispose(){super.dispose(),this._win=null}};ie=ue([ne(1,o.ILogService),ne(2,M.IEnvironmentMainService),ne(3,u.IFileService),ne(4,s.IGlobalStorageMainService),ne(5,y.IConfigurationService),ne(6,b.IThemeMainService),ne(7,U.IWorkspacesManagementMainService),ne(8,h.IBackupMainService),ne(9,a.ITelemetryService),ne(10,v.IDialogMainService),ne(11,l.ILifecycleMainService),ne(12,d.IProductService),ne(13,r.IProtocolMainService),ne(14,D.IWindowsMainService)],ie),e.CodeWindow=ie}),define(Z[68],x([0,1,12,30,9,4,33,2,10,3,17,8,24,160,5,20,6,38,81,80,25,42]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let o=class He extends S.Disposable{constructor(r,i,s,a,c){super();this.stateMainService=r,this.logService=i,this.workspacesManagementMainService=s,this.lifecycleMainService=a,this.globalStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new L.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new R.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],s=[];for(let a of r)if((0,g.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&this.indexOfWorkspace(i,a.workspace)===-1&&i.push(a);else if((0,g.isRecentFolder)(a))this.indexOfFolder(i,a.folderUri)===-1&&i.push(a);else{const c=this.indexOfFile(s,a.fileUri)>=0,b=a.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,P.basename)(a.fileUri))>=0;!c&&!b&&(s.push(a),E.isWindows&&a.fileUri.scheme===f.Schemas.file&&m.app.addRecentDocument(a.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>He.MAX_TOTAL_RECENT_ENTRIES&&(i.length=He.MAX_TOTAL_RECENT_ENTRIES),s.length>He.MAX_TOTAL_RECENT_ENTRIES&&(s.length=He.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),E.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=b=>{const p=this.location(b);for(const D of r)if(P.extUriBiasedIgnorePathCase.isEqual(D,p))return!1;return!0},s=await this.getRecentlyOpened(),a=s.workspaces.filter(i),c=s.files.filter(i);(a.length!==s.workspaces.length||c.length!==s.files.length)&&(await this.saveRecentlyOpened({files:c,workspaces:a}),this._onDidChangeRecentlyOpened.fire(),E.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),m.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const i=[],s=[];if(r){const c=r.config?.workspace;(0,u.isWorkspaceIdentifier)(c)&&!this.workspacesManagementMainService.isUntitledWorkspace(c)?i.push({workspace:c,remoteAuthority:r.remoteAuthority}):(0,u.isSingleFolderWorkspaceIdentifier)(c)&&i.push({folderUri:c.uri,remoteAuthority:r.remoteAuthority})}const a=r?.config?.filesToOpenOrCreate;if(a)for(let c of a){const b=c.fileUri;b&&this.indexOfFile(s,b)===-1&&s.push({fileUri:b})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(r,i){let s=await this.getRecentlyOpenedFromStorage();for(let a of s.workspaces){let c=(0,g.isRecentFolder)(a)?this.indexOfFolder(r,a.folderUri):this.indexOfWorkspace(r,a.workspace);c>=0?r[c].label=r[c].label||a.label:r.push(a)}for(let a of s.files){let c=this.indexOfFile(i,a.fileUri);c>=0?i[c].label=i[c].label||a.label:i.push(a)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let r;const i=this.globalStorageMainService.get(He.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{r=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}else r=this.stateMainService.getItem(He.legacyRecentlyOpenedStorageKey),r&&(this.stateMainService.removeItem(He.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(He.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(r),0,1));return(0,g.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(He.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,g.toStoreData)(r)),0,1)}location(r){return(0,g.isRecentFolder)(r)?r.folderUri:(0,g.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(s=>(0,g.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(s=>(0,g.isRecentFolder)(s)&&P.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(r,i){return r.findIndex(s=>P.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!E.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!E.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let c of m.app.getJumpListSettings().removedItems){const b=c.args;if(b){const p=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(b);p&&i.push(k.URI.parse(p[2]))}}await this.removeRecentlyOpened(i);let s=!1;const a=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,He.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(c=>{const b=(0,g.isRecentWorkspace)(c)?c.workspace:c.folderUri,{title:p,description:D}=this.getWindowsJumpListLabel(b,c.label);let F;return k.URI.isUri(b)?F=`--folder-uri "${b.toString()}"`:(s=!0,F=`--file-uri "${b.configPath.toString()}"`),{type:"task",title:p.substr(0,255),description:D.substr(0,255),program:process.execPath,args:F,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&r.push({type:"custom",name:s?(0,w.localize)(2,null):(0,w.localize)(3,null),items:a})}r.push({type:"recent"});try{m.app.setJumpList(r)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,C.splitName)(i).name,description:i};if(k.URI.isUri(r))return{title:(0,P.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,w.localize)(4,null),description:""};let s=(0,P.basename)(r.configPath);return s.endsWith(u.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,C.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!E.isMacintosh)return;m.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let s=0;for(let c=0;c<r.workspaces.length&&s<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;c++){const b=this.location(r.workspaces[c]);if(b.scheme===f.Schemas.file){const p=(0,P.originalFSPath)(b);await I.Promises.exists(p)&&(i.push(p),s++)}}const a=[];for(let c=0;c<r.files.length&&s<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;c++){const b=this.location(r.files[c]);if(b.scheme===f.Schemas.file){const p=(0,P.originalFSPath)(b);if(He.COMMON_FILES_FILTER.includes((0,P.basename)(b))||i.includes(p))continue;await I.Promises.exists(p)&&(a.push(p),s++)}}a.reverse().forEach(c=>m.app.addRecentDocument(c)),i.reverse().forEach(c=>m.app.addRecentDocument(c))}};o.MAX_TOTAL_RECENT_ENTRIES=500,o.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",o.legacyRecentlyOpenedStorageKey="openedPathsList",o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o=ue([ne(0,v.IStateMainService),ne(1,y.ILogService),ne(2,l.IWorkspacesManagementMainService),ne(3,h.ILifecycleMainService),ne(4,M.IGlobalStorageMainService)],o),e.WorkspacesHistoryMainService=o}),define(Z[244],x([0,1,12,9,23,33,3,8,151,18,22,20,6,194,59,19,38,34,41,67,32,68]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let d=class It{constructor(s,a,c,b,p,D,F,U,Q,te,ie){this.updateService=s,this.configurationService=a,this.windowsMainService=c,this.environmentMainService=b,this.telemetryService=p,this.workspacesHistoryMainService=D,this.stateMainService=F,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=te,this.productService=ie,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(C.isMacintosh||(0,g.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(It.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(D,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(D,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(D,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(D,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const c=this.productService.reportIssueUrl;c&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(c,"openReportIssues"));const b=this.productService.licenseUrl;b&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(C.language){const D=b.indexOf("?")>0?"&":"?";this.openUrl(`${b}${D}lang=${C.language}`,"openLicenseUrl")}else this.openUrl(b,"openLicenseUrl")});const p=this.productService.privacyStatementUrl;p&&b&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(p,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!C.isMacintosh)return!1;let s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(It.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!C.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!C.isMacintosh||(this.noActiveWindow=!m.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=m.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){m.Menu.setApplicationMenu(C.isMacintosh?new m.Menu:null);return}const a=new m.Menu;let c;if(C.isMacintosh){const p=new m.Menu;c=new m.MenuItem({label:this.productService.nameShort,submenu:p}),this.setMacApplicationMenu(p),a.append(c)}if(C.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const p=new m.Menu;p.append(new m.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),m.app.dock.setMenu(p)}if(this.shouldDrawMenu("File")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:p});this.setMenuById(p,"File"),a.append(D)}if(this.shouldDrawMenu("Edit")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:p});this.setMenuById(p,"Edit"),a.append(D)}if(this.shouldDrawMenu("Selection")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:p});this.setMenuById(p,"Selection"),a.append(D)}if(this.shouldDrawMenu("View")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:p});this.setMenuById(p,"View"),a.append(D)}if(this.shouldDrawMenu("Go")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:p});this.setMenuById(p,"Go"),a.append(D)}if(this.shouldDrawMenu("Run")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:p});this.setMenuById(p,"Run"),a.append(D)}if(this.shouldDrawMenu("Terminal")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:p});this.setMenuById(p,"Terminal"),a.append(D)}let b;if(this.shouldDrawMenu("Window")){const p=new m.Menu;b=new m.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:p,role:"window"}),this.setMacWindowMenu(p)}if(b&&a.append(b),this.shouldDrawMenu("Help")){const p=new m.Menu,D=new m.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:p,role:"help"});this.setMenuById(p,"Help"),a.append(D)}a.items&&a.items.length>0?m.Menu.setApplicationMenu(a):m.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const a=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),c=this.getUpdateMenuItems();let b;if(this.shouldDrawMenu("Preferences")){const ee=new m.Menu;this.setMenuById(ee,"Preferences"),b=new m.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ee})}const p=new m.Menu,D=new m.MenuItem({label:f.localize(12,null),role:"services",submenu:p}),F=new m.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new m.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new m.MenuItem({label:f.localize(15,null),role:"unhide"}),te=new m.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!m.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ie=[a];ie.push(...c),b&&ie.push(r(),b),ie.push(r(),D,r(),F,U,Q,r(),te),ie.forEach(ee=>s.append(ee))}shouldDrawMenu(s){if(!C.isMacintosh&&(0,g.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(C.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(C.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,a){a.forEach(c=>{if((0,w.isMenubarMenuItemSeparator)(c))s.append(r());else if((0,w.isMenubarMenuItemSubmenu)(c)){const b=new m.Menu,p=new m.MenuItem({label:this.mnemonicLabel(c.label),submenu:b});this.setMenu(b,c.submenu.items),s.append(p)}else(0,w.isMenubarMenuItemRecentAction)(c)?s.append(this.createOpenRecentMenuItem(c)):(0,w.isMenubarMenuItemAction)(c)&&(c.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),C.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[c.id]?s.append(new m.MenuItem(this.likeAction(c.id,{label:this.mnemonicLabel(c.label),click:this.fallbackMenuHandlers[c.id]}))):s.append(this.createMenuItem(c.label,c.id,!1,c.checked)):s.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)):s.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)))})}setMenuById(s,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(s,this.menubarMenus[a].items)}insertCheckForUpdatesItems(s){const a=this.getUpdateMenuItems();a.length&&(a.forEach(c=>s.append(c)),s.append(r()))}createOpenRecentMenuItem(s){const a=S.URI.revive(s.uri),c=s.id,b=c==="openRecentFile"?{fileUri:a}:c==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new m.MenuItem(this.likeAction(c,{label:s.label,click:(p,D,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[b],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(s){return!!(s&&(!C.isMacintosh&&(s.ctrlKey||s.shiftKey)||C.isMacintosh&&(s.metaKey||s.altKey)))}createRoleMenuItem(s,a,c){const b={label:this.mnemonicLabel(s),role:c,enabled:!0};return new m.MenuItem(this.withKeybinding(a,b))}setMacWindowMenu(s){const a=new m.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),c=new m.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),b=new m.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),p=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),D=[];this.currentEnableNativeTabs&&(D.push(r()),D.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),D.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),D.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),D.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),D.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,c,r(),p,...D,r(),b].forEach(F=>s.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new m.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new m.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new m.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new m.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new m.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new m.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new m.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,a,c,b){const p=this.mnemonicLabel(s),D=typeof a=="function"?a:(ie,ee,$)=>{const Y=ie?ie.userSettingsLabel:null;let j=a;Array.isArray(a)&&(j=this.isOptionClick($)?a[1]:a[0]),Y&&$.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:Y}):this.runActionInRenderer({type:"commandId",commandId:j})},F=typeof c=="boolean"?c:this.windowsMainService.getWindowCount()>0,U=typeof b=="boolean"?b:!1,Q={label:p,click:D,enabled:F};U&&(Q.type="checkbox",Q.checked=U);let te;return typeof a=="string"?te=a:Array.isArray(a)&&(te=a[0]),C.isMacintosh&&(te==="editor.action.clipboardCutAction"?Q.role="cut":te==="editor.action.clipboardCopyAction"?Q.role="copy":te==="editor.action.clipboardPasteAction"&&(Q.role="paste"),te==="undo"?Q.click=this.makeContextAwareClickHandler(D,{inDevTools:ie=>ie.undo(),inNoWindow:()=>m.Menu.sendActionToFirstResponder("undo:")}):te==="redo"?Q.click=this.makeContextAwareClickHandler(D,{inDevTools:ie=>ie.redo(),inNoWindow:()=>m.Menu.sendActionToFirstResponder("redo:")}):te==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(D,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>m.Menu.sendActionToFirstResponder("selectAll:")}))),new m.MenuItem(this.withKeybinding(te,Q))}makeContextAwareClickHandler(s,a){return(c,b,p)=>{const D=m.BrowserWindow.getFocusedWindow();if(!D)return a.inNoWindow();if(D.webContents.isDevToolsFocused()&&D.webContents.devToolsWebContents)return a.inDevTools(D.webContents.devToolsWebContents);s(c,b||D,p)}}runActionInRenderer(s){let a=m.BrowserWindow.getFocusedWindow();if(!a){const b=this.windowsMainService.getLastActiveWindow();b?.isMinimized()&&(a=b.win)}const c=a?this.windowsMainService.getWindowById(a.id):void 0;if(c){if(this.logService.trace("menubar#runActionInRenderer",s),C.isMacintosh&&!this.environmentMainService.isBuilt&&!c.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const b={id:s.commandId,from:"menu"};c.sendWhenReady("vscode:runAction",R.CancellationToken.None,b)}else{const b={userSettingsLabel:s.userSettingsLabel};c.sendWhenReady("vscode:runKeybinding",R.CancellationToken.None,b)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,a){const c=typeof s=="string"?this.keybindings[s]:void 0;if(c?.label){if(c.isNative!==!1)a.accelerator=c.label,a.userSettingsLabel=c.userSettingsLabel;else if(typeof a.label=="string"){const b=a.label.indexOf("[");b>=0?a.label=`${a.label.substr(0,b)} [${c.label}]`:a.label=`${a.label} [${c.label}]`}}else a.accelerator=void 0;return a}likeAction(s,a,c=!a.accelerator){c&&(a=this.withKeybinding(s,a));const b=a.click;return a.click=(p,D,F)=>{this.reportMenuActionTelemetry(s),b&&b(p,D,F)},a}openUrl(s,a){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:o})}mnemonicLabel(s){return(0,L.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};d.lastKnownMenubarStorageKey="lastKnownMenubarData",d=ue([ne(0,M.IUpdateService),ne(1,E.IConfigurationService),ne(2,u.IWindowsMainService),ne(3,P.IEnvironmentMainService),ne(4,v.ITelemetryService),ne(5,l.IWorkspacesHistoryMainService),ne(6,y.IStateMainService),ne(7,k.ILifecycleMainService),ne(8,I.ILogService),ne(9,t.INativeHostMainService),ne(10,h.IProductService)],d),e.Menubar=d;function r(){return new m.MenuItem({type:"separator"})}}),define(Z[245],x([0,1,5,20,6,244]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,m.createDecorator)("menubarMainService");let C=class{constructor(f,E,P){this.instantiationService=f,this.lifecycleMainService=E,this.logService=P,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(L.Menubar)}async updateMenubar(f,E){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(E,f)}};C=ue([ne(0,m.IInstantiationService),ne(1,n.ILifecycleMainService),ne(2,R.ILogService)],C),e.MenubarMainService=C}),define(Z[246],x([0,1,12,29,26,30,23,4,28,43,33,2,10,7,65,3,36,17,14,8,158,51,18,47,22,21,5,20,6,53,19,54,78,38,67,243,102,226,25,103,68,42,57]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o,d,r,i,s,a,c,b,p,D,F,U,Q,te,ie,ee,$,Y,j,q,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(K){return(0,$.isWorkspaceIdentifier)(K?.workspace)}function J(K){return(0,$.isSingleFolderWorkspaceIdentifier)(K?.workspace)}let B=class st extends k.Disposable{constructor(T,O,W,A,_,z,X,se,le,re,ae,fe,he,we,Re,ke){super();this.machineId=T,this.initialUserEnv=O,this.logService=W,this.stateMainService=A,this.environmentMainService=_,this.lifecycleMainService=z,this.backupMainService=X,this.configurationService=se,this.workspacesHistoryMainService=le,this.workspacesManagementMainService=re,this.instantiationService=ae,this.dialogMainService=fe,this.fileService=he,this.productService=we,this.protocolMainService=Re,this.themeMainService=ke,this._onDidOpenWindow=this._register(new S.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new S.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new S.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new S.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const O=new k.DisposableStore;if(O.add(S.Event.any(T.onDidClose,T.onDidDestroy)(()=>O.dispose())),T.config.extensionDevelopmentPath)for(const W of T.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(W));T.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,O){let W=this.environmentMainService.args;const A=O?.remoteAuthority||void 0,_=!0,z=O?.forceReuseWindow,X=!z;return this.open({...T,cli:W,forceEmpty:_,forceNewWindow:X,forceReuseWindow:z,remoteAuthority:A})}openExistingWindow(T,O){T.focus(),this.handleWaitMarkerFile(O,[T])}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const O=[],W=[],A=[],_=[],z=[];let X,se=0;const le=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",le);for(const he of le)J(he)?T.addMode?O.push(he):W.push(he):V(he)?A.push(he):he.fileUri?(X||(X={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),X.filesToOpenOrCreate.push(he)):he.backupPath?z.push({backupFolder:(0,w.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):se++;T.diffMode&&X&&X.filesToOpenOrCreate.length>=2&&(X.filesToDiff=X.filesToOpenOrCreate.slice(0,2),X.filesToOpenOrCreate=[]),X&&T.waitMarkerFileURI&&(X.filesToWait={paths:[...X.filesToDiff,...X.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(_.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(..._),z.push(...this.backupMainService.getEmptyWindowBackupPaths())):z.length=0;const{windows:re,filesOpenedInWindow:ae}=this.doOpen(T,A,W,z,se,X,O);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${W.length}, emptyToRestore: ${z.length}, emptyToOpen: ${se})`),re.length>1)if(ae)ae.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let we=!0,Re=!0;if(he){const ke=re.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ke.length&&(ke[0].focus(),we=!1,Re=!1)}if(we)for(let ke=re.length-1;ke>=0;ke--){const ve=re[ke];if(!(ve.openedWorkspace&&_.some(be=>ve.openedWorkspace&&be.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&z.some(be=>ve.backupPath&&be.backupFolder===(0,w.basename)(ve.backupPath)))){ve.focus(),Re=!1;break}}Re&&re[re.length-1].focus()}const fe=X&&X.filesToDiff.length>0;if(!re.some(he=>he.isExtensionDevelopmentHost)&&!fe&&!T.noRecentEntry){const he=[];for(const we of le)V(we)&&!we.transient?he.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):J(we)?he.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&he.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(T,re),re}handleWaitMarkerFile(T,O){const W=T.waitMarkerFileURI;T.context===0&&W&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(W)}catch{}})()}doOpen(T,O,W,A,_,z,X){const se=[];let le;function re(ve,be){se.push(ve),be&&(le=ve,z=void 0)}let{openFolderInNewWindow:ae,openFilesInNewWindow:fe}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&X.length>0){const ve=X[0].remoteAuthority,be=this.getLastActiveWindowForAuthority(ve);be&&re(this.doAddFoldersToExistingWindow(be,X.map(Ie=>Ie.workspace.uri)))}const he=W.length+O.length+A.length;if(z&&he===0){const ve=z.filesToOpenOrCreate[0]||z.filesToDiff[0],be=this.getWindows().filter(We=>z&&(0,v.isEqualAuthority)(We.remoteAuthority,z.remoteAuthority));let Ie;ve?.fileUri&&!fe&&((T.context===4||T.context===0||T.context===1)&&(Ie=(0,ie.findWindowOnFile)(be,ve.fileUri,We=>We.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(We.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(be))),Ie?(0,$.isWorkspaceIdentifier)(Ie.openedWorkspace)?O.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,$.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?W.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):re(this.doOpenFilesInExistingWindow(T,Ie,z),!0):re(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const we=(0,L.distinct)(O,ve=>ve.workspace.id);if(we.length>0){const ve=(0,L.coalesce)(we.map(be=>(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),be.workspace.configPath)));if(ve.length>0){const be=ve[0],Ie=(0,v.isEqualAuthority)(z?.remoteAuthority,be.remoteAuthority)?z:void 0;re(this.doOpenFilesInExistingWindow(T,be,Ie),!!Ie),ae=!0}we.forEach(be=>{if(ve.some(ze=>ze.openedWorkspace&&ze.openedWorkspace.id===be.workspace.id))return;const Ie=be.remoteAuthority,We=(0,v.isEqualAuthority)(z?.remoteAuthority,Ie)?z:void 0;re(this.doOpenFolderOrWorkspace(T,be,ae,We),!!We),ae=!0})}const Re=(0,L.distinct)(W,ve=>v.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Re.length>0){const ve=(0,L.coalesce)(Re.map(be=>(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),be.workspace.uri)));if(ve.length>0){const be=ve[0],Ie=(0,v.isEqualAuthority)(z?.remoteAuthority,be.remoteAuthority)?z:void 0;re(this.doOpenFilesInExistingWindow(T,be,Ie),!!Ie),ae=!0}Re.forEach(be=>{if(ve.some(ze=>(0,$.isSingleFolderWorkspaceIdentifier)(ze.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(ze.openedWorkspace.uri,be.workspace.uri)))return;const Ie=be.remoteAuthority,We=(0,v.isEqualAuthority)(z?.remoteAuthority,Ie)?z:void 0;re(this.doOpenFolderOrWorkspace(T,be,ae,We),!!We),ae=!0})}const ke=(0,L.distinct)(A,ve=>ve.backupFolder);if(ke.length>0&&ke.forEach(ve=>{const be=ve.remoteAuthority,Ie=(0,v.isEqualAuthority)(z?.remoteAuthority,be)?z:void 0;re(this.doOpenEmpty(T,!0,be,Ie,ve),!!Ie),ae=!0}),se.length===0||z){z&&!_&&_++;const ve=z?z.remoteAuthority:T.remoteAuthority;for(let be=0;be<_;be++)re(this.doOpenEmpty(T,ae,ve,z),!!z),ae=!0}return{windows:(0,L.distinct)(se),filesOpenedInWindow:le}}doOpenFilesInExistingWindow(T,O,W){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),O.focus();const A={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToWait:W?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",C.CancellationToken.None,A),O}doAddFoldersToExistingWindow(T,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),T.focus();const W={foldersToAdd:O};return T.sendWhenReady("vscode:addFolders",C.CancellationToken.None,W),T}doOpenEmpty(T,O,W,A,_){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!_,remoteAuthority:W,filesToOpen:A,forceNewWindow:O});let z;return!O&&typeof T.contextWindowId=="number"&&(z=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:W,forceNewWindow:O,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:A,windowToUse:z,emptyWindowBackupInfo:_})}doOpenFolderOrWorkspace(T,O,W,A,_){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:A}),!W&&!_&&typeof T.contextWindowId=="number"&&(_=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:A,windowToUse:_})}getPathsToOpen(T){let O,W=!1,A=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(T),W=!0):T.forceEmpty?O=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(O=this.doExtractPathsFromCLI(T.cli),O.length===0&&O.push(Object.create(null)),W=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),A=!0),!T.addMode&&W){const _=O.filter(z=>J(z));if(_.length>1){const z=_[0].remoteAuthority;if(_.every(X=>(0,v.isEqualAuthority)(X.remoteAuthority,z))){const X=this.workspacesManagementMainService.createUntitledWorkspaceSync(_.map(se=>({uri:se.workspace.uri})));O.push({workspace:X,remoteAuthority:z}),O=O.filter(se=>!J(se))}}}return T.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(_=>V(_)||J(_)||_.backupPath)),O}doExtractPathsFromAPI(T){const O=[],W={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const A of(0,L.coalesce)(T.urisToOpen||[])){const _=this.resolveOpenable(A,W);if(_)_.label=A.label,O.push(_);else{const z=this.resourceFromOpenable(A),X={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:z.scheme===I.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:z.scheme===I.Schemas.file?(0,u.localize)(3,null,(0,P.getPathLabel)(z.fsPath,this.environmentMainService)):(0,u.localize)(4,null,z.toString()),noLink:!0};this.dialogMainService.showMessageBox(X,(0,M.withNullAsUndefined)(m.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(T){const O=[],W={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},A=T["folder-uri"];if(A)for(const X of A){const se=this.cliArgToUri(X);if(se){const le=this.resolveOpenable({folderUri:se},W);le&&O.push(le)}}const _=T["file-uri"];if(_)for(const X of _){const se=this.cliArgToUri(X);if(se){const le=this.resolveOpenable((0,$.hasWorkspaceFileExtension)(X)?{workspaceUri:se}:{fileUri:se},W);le&&O.push(le)}}const z=T._;for(const X of z){const se=W.remoteAuthority?this.doResolvePathRemote(X,W):this.doResolveFilePath(X,W);se&&O.push(se)}return O}cliArgToUri(T){try{const O=g.URI.parse(T);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${T}, ${O.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];T!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const W=[];for(const A of O)if(A.workspace){const _=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});V(_)&&W.push(_)}else if(A.folderUri){const _=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});J(_)&&W.push(_)}else T!=="folders"&&A.backupPath&&W.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return W}}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}resolveOpenable(T,O=Object.create(null)){let W=this.resourceFromOpenable(T);return W.scheme===I.Schemas.file?((0,Q.isFileToOpen)(T)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(W.fsPath,O)):this.doResolveRemoteOpenable(T,O)}doResolveRemoteOpenable(T,O){let W=this.resourceFromOpenable(T);const A=(0,F.getRemoteAuthority)(W)||O.remoteAuthority;if(W=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(W)),(0,Q.isFileToOpen)(T)){if(O.gotoLineMode){const{path:_,line:z,column:X}=(0,f.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:_}),selection:z?{startLineNumber:z,startColumn:X||1}:void 0,remoteAuthority:A}}return{fileUri:W,remoteAuthority:A}}else if((0,Q.isWorkspaceToOpen)(T))return{workspace:(0,Y.getWorkspaceIdentifier)(W),remoteAuthority:A};return{workspace:(0,Y.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:A}}resourceFromOpenable(T){return(0,Q.isWorkspaceToOpen)(T)?T.workspaceUri:(0,Q.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,O){let W,A;O.gotoLineMode&&({path:T,line:W,column:A}=(0,f.parseLineAndColumnAware)(T)),T=(0,f.sanitizeFilePath)((0,w.normalize)(T),(0,y.cwd)());try{const _=(0,n.statSync)(T);if(_.isFile()){if(!O.forceOpenWorkspaceAsFile){const z=this.workspacesManagementMainService.resolveLocalWorkspaceSync(g.URI.file(T));if(z)return z.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:z.id,configPath:z.configPath},type:i.FileType.File,exists:!0,remoteAuthority:z.remoteAuthority,transient:z.transient}}return{fileUri:g.URI.file(T),type:i.FileType.File,exists:!0,selection:W?{startLineNumber:W,startColumn:A||1}:void 0}}else{if(_.isDirectory())return{workspace:(0,Y.getSingleFolderWorkspaceIdentifier)(g.URI.file(T),_),type:i.FileType.Directory,exists:!0};if(!h.isWindows&&T==="/dev/null")return{fileUri:g.URI.file(T),type:i.FileType.File,exists:!0}}}catch{const z=g.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([z]),O.ignoreFileNotFound)return{fileUri:z,type:i.FileType.File,exists:!1}}}doResolvePathRemote(T,O){const W=T.charCodeAt(0),A=O.remoteAuthority;let _,z;O.gotoLineMode&&({path:T,line:_,column:z}=(0,f.parseLineAndColumnAware)(T)),W!==47&&((0,f.isWindowsDriveLetter)(W)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,f.toSlashes)(T)),T=`/${T}`);const X=g.URI.from({scheme:I.Schemas.vscodeRemote,authority:A,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,$.hasWorkspaceFileExtension)(T))return O.forceOpenWorkspaceAsFile?{fileUri:X,selection:_?{startLineNumber:_,startColumn:z||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,Y.getWorkspaceIdentifier)(X),remoteAuthority:A};if(O.gotoLineMode||w.posix.basename(T).indexOf(".")!==-1)return{fileUri:X,selection:_?{startLineNumber:_,startColumn:z||1}:void 0,remoteAuthority:A}}return{workspace:(0,Y.getSingleFolderWorkspaceIdentifier)(X),remoteAuthority:A}}shouldOpenNewWindow(T){const O=this.configurationService.getValue("window"),W=O?.openFoldersInNewWindow||"default",A=O?.openFilesInNewWindow||"off";let _=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(W==="on"||W==="off")&&(_=W==="on");let z=!1;return T.forceNewWindow||T.forceReuseWindow?z=!!T.forceNewWindow&&!T.forceReuseWindow:(h.isMacintosh?T.context===1&&(z=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!T.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(z=A==="on")),{openFolderInNewWindow:!!_,openFilesInNewWindow:z}}openExtensionDevelopmentHostWindow(T,O){const W=(0,ie.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(W)return this.lifecycleMainService.reload(W,O.cli),W.focus(),[W];let A=O.cli["folder-uri"]||[],_=O.cli["file-uri"]||[],z=O.cli._;if(!z.length&&!A.length&&!_.length&&!O.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ae=re&&(re.workspace||re.folderUri);ae&&(g.URI.isUri(ae)?ae.scheme===I.Schemas.file?z=[ae.fsPath]:A=[ae.toString()]:ae.configPath.scheme===I.Schemas.file?z=[(0,v.originalFSPath)(ae.configPath)]:_=[ae.configPath.toString()])}let X=O.remoteAuthority;for(const re of T)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=g.URI.parse(re),fe=(0,F.getRemoteAuthority)(ae);fe&&(X?(0,v.isEqualAuthority)(fe,X)||this.logService.error("more than one extension development path authority"):X=fe)}z=z.filter(re=>{const ae=g.URI.file(re);return(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,v.isEqualAuthority)((0,F.getRemoteAuthority)(ae),X)}),A=A.filter(re=>{const ae=this.cliArgToUri(re);return ae&&!!(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,v.isEqualAuthority)((0,F.getRemoteAuthority)(ae),X):!1}),_=_.filter(re=>{const ae=this.cliArgToUri(re);return ae&&!!(0,ie.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,v.isEqualAuthority)((0,F.getRemoteAuthority)(ae),X):!1}),O.cli._=z,O.cli["folder-uri"]=A,O.cli["file-uri"]=_;const se=!z.length&&!A.length&&!_.length,le={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:se,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:X};return this.open(le)}openInBrowserWindow(T){const O=this.configurationService.getValue("window"),W={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,w.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:b.default,isInitialStartup:T.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:m.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme()};let A;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(A=T.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const _=A.config;!W.extensionDevelopmentPath&&_&&!!_.extensionDevelopmentPath&&(W.extensionDevelopmentPath=_.extensionDevelopmentPath,W.verbose=_.verbose,W["inspect-brk-extensions"]=_["inspect-brk-extensions"],W.debugId=_.debugId,W.extensionEnvironment=_.extensionEnvironment,W["inspect-extensions"]=_["inspect-extensions"],W["extensions-dir"]=_["extensions-dir"])}else{const _=this.windowsStateHandler.getNewWindowState(W);(0,t.mark)("code/willCreateCodeWindow");const z=A=this.instantiationService.createInstance(te.CodeWindow,{state:_,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(z)}st.WINDOWS.push(z),this._onDidOpenWindow.fire(z),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,E.once)(z.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(z)),(0,E.once)(z.onDidClose)(()=>this.onWindowClosed(z)),(0,E.once)(z.onDidDestroy)(()=>this._onDidDestroyWindow.fire(z));const X=(0,M.assertIsDefined)(z.win?.webContents);X.removeAllListeners("devtools-reload-page"),X.on("devtools-reload-page",()=>this.lifecycleMainService.reload(z)),this.lifecycleMainService.registerWindow(z)}return W.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(_=>{_||this.doOpenInBrowserWindow(A,W,T)}):this.doOpenInBrowserWindow(A,W,T),A}doOpenInBrowserWindow(T,O,W){if(!O.extensionDevelopmentPath)if((0,$.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,$.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const A=W.emptyWindowBackupInfo&&W.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,O.remoteAuthority)}T.load(O)}onWindowClosed(T){const O=st.WINDOWS.indexOf(T);st.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=m.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,v.isEqualAuthority)(O.remoteAuthority,T)))}doGetLastActiveWindow(T){const O=Math.max.apply(Math,T.map(W=>W.lastFocusTime));return T.find(W=>W.lastFocusTime===O)}sendToFocused(T,...O){const W=this.getFocusedWindow()||this.getLastActiveWindow();W&&W.sendWhenReady(T,C.CancellationToken.None,...O)}sendToAll(T,O,W){for(const A of this.getWindows())W&&W.indexOf(A.id)>=0||A.sendWhenReady(T,C.CancellationToken.None,O)}getWindows(){return st.WINDOWS}getWindowCount(){return st.WINDOWS.length}getWindowById(T){const O=this.getWindows().filter(W=>W.id===T);return(0,L.firstOrDefault)(O)}getWindowByWebContents(T){const O=m.BrowserWindow.fromWebContents(T);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ue([ne(2,c.ILogService),ne(3,U.IStateMainService),ne(4,r.IEnvironmentMainService),ne(5,a.ILifecycleMainService),ne(6,l.IBackupMainService),ne(7,o.IConfigurationService),ne(8,j.IWorkspacesHistoryMainService),ne(9,q.IWorkspacesManagementMainService),ne(10,s.IInstantiationService),ne(11,d.IDialogMainService),ne(12,i.IFileService),ne(13,p.IProductService),ne(14,D.IProtocolMainService),ne(15,N.IThemeMainService)],B),e.WindowsMainService=B}),define(Z[247],x([0,1,51,32,68,42]),function(H,e,m,n,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(f,E,P,k){this.workspacesManagementMainService=f,this.windowsMainService=E,this.workspacesHistoryMainService=P,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,E){const P=this.windowsMainService.getWindowById(f);if(P)return this.workspacesManagementMainService.enterWorkspace(P,this.windowsMainService.getWindows(),E)}createUntitledWorkspace(f,E,P){return this.workspacesManagementMainService.createUntitledWorkspace(E,P)}deleteUntitledWorkspace(f,E){return this.workspacesManagementMainService.deleteUntitledWorkspace(E)}getWorkspaceIdentifier(f,E){return this.workspacesManagementMainService.getWorkspaceIdentifier(E)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,E){return this.workspacesHistoryMainService.addRecentlyOpened(E)}removeRecentlyOpened(f,E){return this.workspacesHistoryMainService.removeRecentlyOpened(E)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};C=ue([ne(0,L.IWorkspacesManagementMainService),ne(1,n.IWindowsMainService),ne(2,R.IWorkspacesHistoryMainService),ne(3,m.IBackupMainService)],C),e.WorkspacesMainService=C}),define(Z[248],x([0,1,12,29,26,16,39,15,28,43,44,33,2,10,7,3,14,8,31,72,126,37,129,89,220,139,51,230,18,63,168,75,104,47,231,92,166,22,50,97,174,195,175,227,93,176,177,21,190,77,74,5,76,240,205,105,20,6,192,245,59,19,78,235,79,38,224,81,206,34,208,210,66,41,214,238,241,239,242,100,215,216,217,218,222,32,246,223,25,80,68,247,42,221]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o,d,r,i,s,a,c,b,p,D,F,U,Q,te,ie,ee,$,Y,j,q,N,V,J,B,K,T,O,W,A,_,z,X,se,le,re,ae,fe,he,we,Re,ke,ve,be,Ie,We,ze,qe,Ue,ot,at,et,Ze,ht,Ge,Ye,G,oe,ce,ge,Se,Ae,_e,Qe,Ve,Te,je,Ke,xe,tt,Dt,Pt,Lt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends I.Disposable{constructor(de,pe,ye,me,Pe,Le,Me,Ce,Ee,De){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ye,this.logService=me,this.environmentMainService=Pe,this.lifecycleMainService=Le,this.configurationService=Me,this.stateMainService=Ce,this.fileService=Ee,this.productService=De,this.configureSession(),this.registerListeners()}configureSession(){const de=Ee=>Ee?.startsWith(`${w.Schemas.vscodeWebview}://`),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);m.session.defaultSession.setPermissionRequestHandler((Ee,De,Fe,Ne)=>de(Ne.requestingUrl)?Fe(pe.has(De)):Fe(!1)),m.session.defaultSession.setPermissionCheckHandler((Ee,De,Fe,Ne)=>de(Ne.requestingUrl)?pe.has(De):!1);const ye=new Set([w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemoteResource,"devtools"]),me=Ee=>{for(let De=Ee;De;De=De.parent)if(De.url.startsWith(`${w.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ee=>Ee.resourceType==="xhr"||me(Ee.frame),Le=Ee=>{const De=Ee.frame;if(!De||!this.windowsMainService)return!1;const Fe=m.BrowserWindow.getAllWindows();for(const Ne of Fe)if(De.processId===Ne.webContents.mainFrame.processId)return!0;return!1},Me=(Ee,De)=>{if(Ee.path!=="/index.html")return!0;const Fe=De.frame;if(!Fe||!this.windowsMainService)return!1;for(const Ne of this.windowsMainService.getWindows())if(Ne.win&&Fe.processId===Ne.win.webContents.mainFrame.processId)return!0;return!1};m.session.defaultSession.webRequest.onBeforeRequest((Ee,De)=>{const Fe=v.URI.parse(Ee.url);return Fe.scheme===w.Schemas.vscodeWebview&&!Me(Fe,Ee)?(this.logService.error("Blocked vscode-webview request",Ee.url),De({cancel:!0})):Fe.scheme===w.Schemas.vscodeFileResource&&!Le(Ee)?(this.logService.error("Blocked vscode-file request",Ee.url),De({cancel:!0})):Fe.path.endsWith(".svg")&&!ye.has(Fe.scheme)?De({cancel:!Pe(Ee)}):De({cancel:!1})}),m.session.defaultSession.webRequest.onHeadersReceived((Ee,De)=>{const Fe=Ee.responseHeaders,Ne=Fe["content-type"]||Fe["Content-Type"];if(Ne&&Array.isArray(Ne)){const Xe=v.URI.parse(Ee.url);if(Xe.path.endsWith(".svg")&&ye.has(Xe.scheme))return Fe["Content-Type"]=["image/svg+xml"],De({cancel:!1,responseHeaders:Fe});if(!Xe.path.includes(w.Schemas.vscodeRemoteResource)&&Ne.some(it=>it.toLowerCase().includes("image/svg")))return De({cancel:!Pe(Ee)})}return De({cancel:!1})});const Ce=m.session.defaultSession;typeof Ce.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ce.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,S.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,S.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,S.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),m.app.on("accessibility-support-changed",(ye,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),m.app.on("activate",(ye,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),m.app.on("web-contents-created",(ye,me)=>{me.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),me.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let de=[],pe;m.app.on("open-file",(ye,me)=>{this.logService.trace("app#open-file: ",me),ye.preventDefault(),de.push(this.getWindowOpenableFromPathSync(me)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),m.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),m.ipcMain.handle("vscode:fetchShellEnv",ye=>{const me=this.windowsMainService?.getWindowByWebContents(ye.sender);let Pe,Le;return me?.config?(Pe=me.config,Le={...process.env,...me.config.userEnv}):(Pe=this.environmentMainService.args,Le=process.env),this.resolveShellEnvironment(Pe,Le,!1)}),m.ipcMain.handle("vscode:writeNlsFile",(ye,me,Pe)=>{const Le=this.validateNlsPath([me]);if(!Le||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,L.VSBuffer.fromString(Pe))}),m.ipcMain.handle("vscode:readNlsFile",async(ye,...me)=>{const Pe=this.validateNlsPath(me);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),m.ipcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),m.ipcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),m.ipcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(de){let pe;for(const ye of de)typeof ye=="string"&&(typeof pe!="string"?pe=ye:pe=(0,t.join)(pe,ye));if(!(typeof pe!="string"||!(0,t.isAbsolute)(pe)||!(0,f.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return v.URI.file(pe)}onUnexpectedError(de){if(de){const pe={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(pe))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;h.isWindows&&de&&m.app.setAppUserModelId(de);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!m.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&m.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ee){this.logService.error(Ee)}const pe=new o.Server;this.lifecycleMainService.onWillShutdown(Ee=>{Ee.reason===2&&pe.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:me,sharedProcessReady:Pe,sharedProcessClient:Le}=this.setupSharedProcess(ye),Me=await this.initServices(ye,me,Pe);if(this.environmentMainService.driverHandle){const Ee=await(0,Q.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ee)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Ee=>this.initChannels(Ee,pe,Le));const Ce=Me.invokeFunction(Ee=>this.openFirstWindow(Ee,pe));Me.invokeFunction(Ee=>this.afterWindowOpen(Ee,me)),this.environmentMainService.args.trace&&Me.invokeFunction(Ee=>this.stopTracingEventually(Ee,Ce))}async resolveMachineId(){let de=this.stateMainService.getItem(Ue.machineIdKey);return(!de||h.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,g.getMachineId)(),this.stateMainService.setItem(Ue.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(ve.SharedProcess,de,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new d.Client(Pe,"main")})(),me=(async()=>(await pe.whenReady(),ye))();return{sharedProcess:pe,sharedProcessReady:me,sharedProcessClient:ye}}async initServices(de,pe,ye){const me=new z.ServiceCollection;switch(process.platform){case"win32":me.set(Ze.IUpdateService,new A.SyncDescriptor(oe.Win32UpdateService));break;case"linux":h.isLinuxSnap?me.set(Ze.IUpdateService,new A.SyncDescriptor(G.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(Ze.IUpdateService,new A.SyncDescriptor(Ye.LinuxUpdateService));break;case"darwin":me.set(Ze.IUpdateService,new A.SyncDescriptor(Ge.DarwinUpdateService));break}me.set(Ve.IWindowsMainService,new A.SyncDescriptor(Te.WindowsMainService,[de,this.userEnv])),me.set(U.IDialogMainService,new A.SyncDescriptor(U.DialogMainService)),me.set(le.ILaunchMainService,new A.SyncDescriptor(le.LaunchMainService)),me.set(F.IDiagnosticsMainService,new A.SyncDescriptor(F.DiagnosticsMainService)),me.set(D.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(ye.then(Le=>Le.getChannel("diagnostics"))))),me.set(X.IIssueMainService,new A.SyncDescriptor(X.IssueMainService,[this.userEnv])),me.set(te.IEncryptionMainService,new A.SyncDescriptor(ie.EncryptionMainService,[de])),me.set(se.IKeyboardLayoutMainService,new A.SyncDescriptor(se.KeyboardLayoutMainService)),me.set(we.INativeHostMainService,new A.SyncDescriptor(we.NativeHostMainService,[pe])),me.set(b.ICredentialsMainService,new A.SyncDescriptor(Lt.CredentialsNativeMainService)),me.set(_e.IWebviewManagerService,new A.SyncDescriptor(Qe.WebviewMainService)),me.set(xe.IWorkspacesService,new A.SyncDescriptor(Dt.WorkspacesMainService)),me.set(Pt.IWorkspacesManagementMainService,new A.SyncDescriptor(Pt.WorkspacesManagementMainService)),me.set(tt.IWorkspacesHistoryMainService,new A.SyncDescriptor(tt.WorkspacesHistoryMainService)),me.set(he.IMenubarMainService,new A.SyncDescriptor(he.MenubarMainService)),me.set(j.IExtensionUrlTrustService,new A.SyncDescriptor(q.ExtensionUrlTrustService)),me.set(N.IExtensionHostStarter,new A.SyncDescriptor(V.WorkerMainProcessExtensionHostStarter)),me.set(ze.IStorageMainService,new A.SyncDescriptor(ze.StorageMainService)),me.set(ze.IGlobalStorageMainService,new A.SyncDescriptor(ze.GlobalStorageMainService)),h.isWindows?me.set(J.IExternalTerminalMainService,new A.SyncDescriptor(B.WindowsExternalTerminalService)):h.isMacintosh?me.set(J.IExternalTerminalMainService,new A.SyncDescriptor(B.MacExternalTerminalService)):h.isLinux&&me.set(J.IExternalTerminalMainService,new A.SyncDescriptor(B.LinuxExternalTerminalService));const Pe=new a.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(s.IBackupMainService,Pe),me.set(ce.IURLService,new A.SyncDescriptor(Se.NativeURLService)),(0,et.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,l.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("telemetryAppender"))),Me=new ot.TelemetryAppenderClient(Le),Ce=(0,qe.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ee=(0,et.getPiiPathsFromEnvironment)(this.environmentMainService),De={appenders:[Me],commonProperties:Ce,piiPaths:Ee,sendErrorTelemetry:!0};me.set(Ue.ITelemetryService,new A.SyncDescriptor(at.TelemetryService,[De]))}else me.set(Ue.ITelemetryService,et.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(me)}initChannels(de,pe,ye){const me=l.ProxyChannel.fromService(de.get(le.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me);const Pe=l.ProxyChannel.fromService(de.get(F.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Pe);const Le=this.fileService.getProvider(w.Schemas.file);(0,y.assertType)(Le instanceof W.DiskFileSystemProvider);const Me=new O.DiskFileSystemProviderChannel(Le,this.logService,this.environmentMainService);pe.registerChannel(K.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ye.then($e=>$e.registerChannel(K.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const Ce=new ht.UpdateChannel(de.get(Ze.IUpdateService));pe.registerChannel("update",Ce);const Ee=l.ProxyChannel.fromService(de.get(X.IIssueMainService));pe.registerChannel("issue",Ee);const De=l.ProxyChannel.fromService(de.get(te.IEncryptionMainService));pe.registerChannel("encryption",De);const Fe=l.ProxyChannel.fromService(de.get(b.ICredentialsMainService));pe.registerChannel("credentials",Fe);const Ne=l.ProxyChannel.fromService(de.get(be.ISignService));pe.registerChannel("sign",Ne);const Xe=l.ProxyChannel.fromService(de.get(se.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=de.get(we.INativeHostMainService);const it=l.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",it),ye.then($e=>$e.registerChannel("nativeHost",it));const vt=l.ProxyChannel.fromService(de.get(xe.IWorkspacesService));pe.registerChannel("workspaces",vt);const Be=l.ProxyChannel.fromService(de.get(he.IMenubarMainService));pe.registerChannel("menubar",Be);const dt=l.ProxyChannel.fromService(de.get(ce.IURLService));pe.registerChannel("url",dt);const ct=l.ProxyChannel.fromService(de.get(j.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",ct);const lt=l.ProxyChannel.fromService(de.get(_e.IWebviewManagerService));pe.registerChannel("webview",lt);const ut=this._register(new We.StorageDatabaseChannel(this.logService,de.get(ze.IStorageMainService)));pe.registerChannel("storage",ut),ye.then($e=>$e.registerChannel("storage",ut));const ft=l.ProxyChannel.fromService(de.get(J.IExternalTerminalMainService));pe.registerChannel("externalTerminal",ft);const nt=new fe.LogLevelChannel(de.get(ae.ILogService));pe.registerChannel("logLevel",nt),ye.then($e=>$e.registerChannel("logLevel",nt));const rt=new fe.LoggerChannel(de.get(ae.ILoggerService));pe.registerChannel("logger",rt),ye.then($e=>$e.registerChannel("logger",rt));const gt=new p.ElectronExtensionHostDebugBroadcastChannel(de.get(Ve.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",gt);const Oe=l.ProxyChannel.fromService(de.get(N.IExtensionHostStarter));pe.registerChannel(N.ipcExtensionHostStarterChannelName,Oe)}openFirstWindow(de,pe){const ye=this.windowsMainService=de.get(Ve.IWindowsMainService),me=de.get(ce.IURLService),Pe=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:v.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const $e=this.getWindowOpenableFromProtocolLink(Oe.uri);return $e?(Le.push($e),!1):!0}),Ce=this,Ee=this.environmentMainService,De=this.productService,Fe=this.logService;me.registerHandler({async handleURL(Oe,$e){if(Fe.trace("app#handleURL: ",Oe.toString(!0),$e),Oe.scheme===De.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:v.URI.parse(Oe.query).path,query:""})),Ce.shouldBlockURI(Oe))return!0;const yt=Ce.getWindowOpenableFromProtocolLink(Oe);if(Fe.trace("app#handleURL: windowOpenableFromProtocolLink = ",yt),yt){const[St]=ye.open({context:5,cli:{...Ee.args},urisToOpen:[yt],gotoLineMode:!0});return St.focus(),!0}if(h.isMacintosh&&ye.getWindowCount()===0){const[St]=ye.open({context:5,cli:{...Ee.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Oe)});return await St.ready(),me.open(Oe,$e)}return!1}});const Ne=this._register(new je.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Xe=new l.StaticRouter(Oe=>Ne.getActiveClientId().then($e=>Oe===$e)),it=new ge.URLHandlerRouter(Xe),vt=pe.getChannel("urlHandler",it);me.registerHandler(new ge.URLHandlerChannelClient(vt)),this._register(new Ae.ElectronURLListener(Me,me,ye,this.environmentMainService,this.productService));const Be=this.environmentMainService.args,dt=global.macOpenFiles,ct=(0,$.isLaunchedFromCli)(process.env)?0:4,lt=Be._.length,ut=!!Be["folder-uri"],ft=!!Be["file-uri"],nt=Be["skip-add-to-recently-opened"]===!0,rt=Be.wait&&Be.waitMarkerFilePath?v.URI.file(Be.waitMarkerFilePath):void 0,gt=Be.remote||void 0;return Le.length>0?ye.open({context:ct,cli:Be,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Be["new-window"]&&!lt&&!ut&&!ft?ye.open({context:ct,cli:Be,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0,remoteAuthority:gt}):dt.length&&!lt&&!ut&&!ft?ye.open({context:1,cli:Be,urisToOpen:dt.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:nt,waitMarkerFileURI:rt,initialStartup:!0}):ye.open({context:ct,cli:Be,forceNewWindow:Be["new-window"]||!lt&&Be["unity-launch"],diffMode:Be.diff,noRecentEntry:nt,waitMarkerFileURI:rt,gotoLineMode:Be.goto,initialStartup:!0,remoteAuthority:gt})}shouldBlockURI(de){return!!(de.authority===w.Schemas.file&&h.isWindows&&m.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,k.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===w.Schemas.file){const pe=v.URI.file(de.fsPath);return(0,Ke.hasWorkspaceFileExtension)(pe)?{workspaceUri:pe}:{fileUri:pe}}else if(de.authority===w.Schemas.vscodeRemote){const pe=de.path.indexOf(t.posix.sep,1);if(pe!==-1){const ye=de.path.substring(1,pe),me=de.path.substring(pe),Pe=v.URI.from({scheme:w.Schemas.vscodeRemote,authority:ye,path:me,query:de.query,fragment:de.fragment});return(0,Ke.hasWorkspaceFileExtension)(me)?{workspaceUri:Pe}:/:[\d]+$/.test(me)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,Ke.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,pe){this.lifecycleMainService.phase=3;let ye=!1;(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const me=de.get(Ue.ITelemetryService);this._register(pe.onDidError(({type:Me,details:Ce})=>{let Ee;switch(Me){case 1:Ee="SharedProcess: detected unresponsive window";break;case 2:Ee=`SharedProcess: crashed (detail: ${Ce?.reason??"<unknown>"}, code: ${Ce?.exitCode??"<unknown>"})`;break;case 3:Ee=`SharedProcess: failed to load (detail: ${Ce?.reason??"<unknown>"}, code: ${Ce?.exitCode??"<unknown>"})`;break}(0,S.onUnexpectedError)(new Error(Ee)),me.publicLog2("sharedprocesserror",{type:Me,reason:Ce?.reason,code:Ce?.exitCode,visible:pe.isVisible(),shuttingdown:ye})}));const Pe=this.productService.win32MutexName;if(h.isWindows&&Pe)try{const Me=H.__$__nodeRequire("windows-mutex").Mutex,Ce=new Me(Pe);(0,E.once)(this.lifecycleMainService.onWillShutdown)(()=>Ce.release())}catch(Me){this.logService.error(Me)}m.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Me,Ce)=>{Ce({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const Le=de.get(Ze.IUpdateService);(Le instanceof oe.Win32UpdateService||Le instanceof Ye.LinuxUpdateService||Le instanceof Ge.DarwinUpdateService)&&Le.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ce=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,P.stripComments)(Ce))["enable-crash-reporter"]===void 0){const Fe=(0,et.getTelemetryLevel)(this.configurationService)>=1,Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,M.generateUuid)()}"`,"}"],Xe=Ce.substring(0,Ce.length-2).concat(`,
`,Ne.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,L.VSBuffer.fromString(Xe))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(de,pe,ye){try{return await(0,Y.getResolvedShellEnv)(this.logService,de,pe)}catch(me){const Pe=(0,C.toErrorMessage)(me);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ye=de.get(U.IDialogMainService);let me=!1;const Pe=async Me=>{if(me)return;me=!0;const Ce=await m.contentTracing.stopRecording(`${(0,f.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ce}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ce),buttons:[(0,k.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(m.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Pe(!0),3e4);Promise.all(pe.map(Me=>Me.ready())).then(()=>{clearTimeout(Le),Pe(!1)})}};pt=ue([ne(2,_.IInstantiationService),ne(3,ae.ILogService),ne(4,ee.IEnvironmentMainService),ne(5,re.ILifecycleMainService),ne(6,c.IConfigurationService),ne(7,Ie.IStateMainService),ne(8,T.IFileService),ne(9,Re.IProductService)],pt),e.CodeApplication=pt}),define(Z[255],x([0,1,12,29,30,9,39,15,28,43,33,10,7,65,3,36,27,24,37,58,248,11,18,199,207,22,50,171,21,188,77,74,182,76,20,95,6,193,96,53,19,54,196,99,237,56,234,79,204,38,236,66,57,213]),function(H,e,m,n,R,L,C,S,f,E,P,k,I,w,t,h,y,v,M,g,u,l,o,d,r,i,s,a,c,b,p,D,F,U,Q,te,ie,ee,$,Y,j,q,N,V,J,B,K,T,O,W,A,_,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class X{main(){try{this.startup()}catch(re){console.error(re.message),m.app.exit(1)}}async startup(){(0,S.setUnexpectedErrorHandler)(ve=>console.error(ve));const[re,ae,fe,he,we,Re,ke]=this.createServices();try{try{await this.initServices(fe,he,we)}catch(ve){throw this.handleStartupDataDirError(fe,ke.nameLong,ve),ve}await re.invokeFunction(async ve=>{const be=ve.get(ie.ILogService),Ie=ve.get(Q.ILifecycleMainService),We=ve.get(c.IFileService),ze=await this.claimInstance(be,fe,Ie,re,ke,!0);return v.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(qe=>{be.warn(`Error writing main lockfile: ${qe.stack}`)}),Re.logger=new $.SpdLogLogger("main",(0,I.join)(fe.logsPath,"main.log"),!0,!1,Re.getLevel()),(0,E.once)(Ie.onWillShutdown)(qe=>{We.dispose(),he.dispose(),qe.join(v.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),re.createInstance(u.CodeApplication,ze,ae).startup()})}catch(ve){re.invokeFunction(this.quit,ve)}}createServices(){const re=new U.ServiceCollection,ae={_serviceBrand:void 0,...Y.default};re.set(j.IProductService,ae);const fe=new i.EnvironmentMainService(this.resolveArgs(),ae),he=this.patchEnvironment(fe);re.set(i.IEnvironmentMainService,fe);const we=new te.BufferLogService,Re=new ie.MultiplexLogService([new ie.ConsoleMainLogger((0,ie.getLogLevel)(fe)),we]);process.once("exit",()=>Re.dispose()),re.set(ie.ILogService,Re);const ke=new b.FileService(Re);re.set(c.IFileService,ke);const ve=new p.DiskFileSystemProvider(Re);ke.registerProvider(k.Schemas.file,ve),re.set(ie.ILoggerService,new ee.LoggerService(Re,ke));const be=new d.ConfigurationService(fe.settingsResource,ke);re.set(o.IConfigurationService,be),re.set(Q.ILifecycleMainService,new D.SyncDescriptor(Q.LifecycleMainService));const Ie=new A.StateMainService(fe,Re,ke);return re.set(W.IStateMainService,Ie),re.set(B.IRequestService,new D.SyncDescriptor(K.RequestMainService)),re.set(z.IThemeMainService,new D.SyncDescriptor(z.ThemeMainService)),re.set(T.ISignService,new D.SyncDescriptor(O.SignService)),re.set(V.ITunnelService,new D.SyncDescriptor(J.TunnelService)),re.set(q.IProtocolMainService,new D.SyncDescriptor(N.ProtocolMainService)),[new F.InstantiationService(re,!0),he,fe,be,Ie,we,ae]}patchEnvironment(re){const ae={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const he=process.env[fe];typeof he=="string"&&(ae[fe]=he)}),Object.assign(process.env,ae),ae}initServices(re,ae,fe){return L.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.localHistoryHome.fsPath,re.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),ae.initialize(),fe.init()])}async claimInstance(re,ae,fe,he,we,Re){let ke;try{(0,w.mark)("code/willStartMainServer"),ke=await(0,g.serve)(ae.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,E.once)(fe.onWillShutdown)(()=>ke.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,we.nameLong,ve),ve;let be;try{be=await(0,g.connect)(ae.mainIPCHandle,"main")}catch(qe){if(!Re||t.isWindows||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,we.nameShort),(0,l.localize)(1,null),we.nameLong),qe;try{(0,n.unlinkSync)(ae.mainIPCHandle)}catch(Ue){throw re.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(re,ae,fe,he,we,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const qe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(qe),be.dispose(),new Error(qe)}let Ie;!ae.args.wait&&!ae.args.status&&(Ie=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,we.nameShort),(0,l.localize)(3,null),we.nameLong)},1e4));const We=M.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0}),ze=M.ProxyChannel.toService(be.getChannel("diagnostics"),{disableMarshalling:!0});if(ae.args.status)return he.invokeFunction(async()=>{const qe=new r.DiagnosticsService(_.NullTelemetryService,we),Ue=await We.getMainProcessInfo(),ot=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),at=await qe.getDiagnostics(Ue,ot);throw console.log(at),new S.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(We,re),re.trace("Sending env to running instance..."),await We.start(ae.args,process.env),be.dispose(),Ie&&clearTimeout(Ie),new S.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new S.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ke}handleStartupDataDirError(re,ae,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const he=(0,R.coalesce)([re.userDataPath,re.extensionsPath,g.XDG_RUNTIME_DIR]).map(we=>(0,P.getPathLabel)(we,re));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,C.toErrorMessage)(fe),he.join(`
`)),ae)}}showStartupWarningDialog(re,ae,fe){m.dialog.showMessageBoxSync({title:fe,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,l.localize)(6,null))],message:re,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,ae){if(t.isWindows){const fe=await re.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((he,we)=>{H(["windows-foreground-love"],he,we)})).allowSetForegroundWindow(fe)}catch(he){ae.error(he)}}}quit(re,ae){const fe=re.get(ie.ILogService),he=re.get(Q.ILifecycleMainService);let we=0;ae&&(ae.isExpected?ae.message&&fe.trace(ae.message):(we=1,ae.stack?fe.error(ae.stack):fe.error(`Startup error: ${ae.toString()}`))),he.kill(we)}resolveArgs(){const re=this.validatePaths((0,s.parseMainProcessArgv)(process.argv));if(re.wait&&!re.waitMarkerFilePath){const ae=(0,a.createWaitMarkerFile)(re.verbose);ae&&((0,s.addArg)(process.argv,"--waitMarkerFilePath",ae),re.waitMarkerFilePath=ae)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const ae=this.doValidatePaths(re._,re.goto);re._=ae}return re}doValidatePaths(re,ae){const fe=(0,h.cwd)(),he=re.map(ke=>{let ve=String(ke),be;ae&&(be=(0,f.parseLineAndColumnAware)(ve),ve=be.path),ve&&(ve=this.preparePath(fe,ve));const Ie=(0,f.sanitizeFilePath)(ve,fe),We=(0,I.basename)(Ie);return We&&!(0,f.isValidBasename)(We)?null:ae&&be?(be.path=Ie,this.toPath(be)):Ie}),we=t.isWindows||t.isMacintosh,Re=(0,R.distinct)(he,ke=>ke&&we?ke.toLowerCase():ke||"");return(0,R.coalesce)(Re)}preparePath(re,ae){return t.isWindows&&(ae=(0,y.rtrim)(ae,'"')),ae=(0,y.trim)((0,y.trim)(ae," "),"	"),t.isWindows&&(ae=(0,I.resolve)(re,ae),ae=(0,y.rtrim)(ae,".")),ae}toPath(re){const ae=[re.path];return typeof re.line=="number"&&ae.push(String(re.line)),typeof re.column=="number"&&ae.push(String(re.column)),ae.join(":")}}new X().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dfd34e8260c270da74b5c2d86d61aee4b6d56977/core/vs/code/electron-main/main.js.map
